#!/usr/bin/perl
#
# Watchdog de fcgi_fpm.pl
#
# Ejecucion como cron:
# * * * * * /usr/bin/perl /var/www/prontus/web/cgi-cpn/fcgi_fpm/fcgi_fpm_watchdog.pl <workers>
#
# Donde:
#   workers es opcional y corresponde al numero de workers a forkear. Por defecto es 1.
#
# Versiones:
# 1.0 2021-11-04 ALD - Primera version.
#
# TODO:
#   - Escribir eventos en un log.
#   - Detectar problemas de funcionamiento y matar el manager y todos sus forks.

use strict;
use utf8;

BEGIN {
    use FindBin qw($Bin);
    my $pathLibsProntus = $Bin;
    unshift(@INC,$pathLibsProntus);
    $pathLibsProntus =~ s/\/[^\/]+\/?$//;
    # Para dejar disponibles las librerias de prontus
    unshift(@INC,$pathLibsProntus);
}

##libs##
use lib_stdlog;
lib_stdlog::set_stdlog($0, 51200);
use prontus_varglb;
prontus_varglb::init();

use File::Copy;
use glib_fildir_03;
use lib_utils;
##/libs##

main: {
    my %conf = %{lib_utils::getHash("$prontus_varglb::DIR_SERVER/$prontus_varglb::DIR_CGI_CPAN/fcgi_fpm/fcgi.cfg")};

    my $proc_name = $prontus_varglb::FCGI_CONFIG{'fcgi_proc_name'};
    # Asigna valor de configuracion si existe
    if (defined($conf{'procs_id'})) {
        $proc_name = $prontus_varglb::FCGI_CONFIG{'fcgi_proc_name'} . '-' .$conf{'procs_id'};
    }
    my $bin_proc = 0;
    if (defined($conf{'front_proc'})) {
        $bin_proc = $conf{'front_proc'};
    }

    my $proc_name_bin = '';
    if ($bin_proc) {
        $proc_name_bin = $proc_name . '-front';
    }

    my $scriptCmd = "perl $prontus_varglb::DIR_SERVER/$prontus_varglb::DIR_CGI_CPAN/fcgi_fpm/fcgi_fpm.pl";

    for (my $i = 0; $i < 12; $i++) {
        my $res = `ps aux`;
        if ($res !~ /\Q$proc_name\E/) {
            print STDERR "Starting $proc_name\n";
            if ($res !~ /\Q$scriptCmd\E/) {
               system "$scriptCmd > /dev/null 2>&1 &";
            }
        }
        if ($bin_proc && $res !~ /\Q$proc_name_bin\E/) {
            print STDERR "Starting $proc_name_bin\n";
            if ($res !~ /\Q$scriptCmd front\E/) {
               system "$scriptCmd front > /dev/null 2>&1 &";
            }
        }
        sleep 5;
    }
}
