#!/usr/bin/perl
#
# Watchdog para el script que rutea las friendly urls.
#
# Uso (ejecutar como cron cada 1 minuto):
# * * * * * /usr/bin/perl /var/www/<host>/web/cgi-cpn/fcgi_fpm/route_friendly_watchdog.pl
# Ejemplo:
# * * * * * /usr/bin/perl /var/www/csa/web/cgi-cpn/fcgi_fpm/route_friendly_watchdog.pl
#
# Versiones
# 1.0 2022-01-06 ALD - Primera version.
#

use strict;
use utf8;

BEGIN {
    use FindBin qw($Bin);
    my $pathLibsProntus = $Bin;
    unshift(@INC,$pathLibsProntus);
    $pathLibsProntus =~ s/\/[^\/]+\/?$//;
    # Para dejar disponibles las librerias de prontus
    unshift(@INC,$pathLibsProntus);
}

##libs##
use lib_stdlog;
lib_stdlog::set_stdlog($0, 51200);
use prontus_varglb;
prontus_varglb::init();

use File::Copy;
use glib_fildir_03;
use lib_utils;
##/libs##

main: {
    my %conf = %{lib_utils::getHash("$prontus_varglb::DIR_SERVER/$prontus_varglb::DIR_CGI_CPAN/fcgi_fpm/fcgi.cfg")};
    my $procName = $prontus_varglb::FCGI_CONFIG{'f5_proc_name'};
    # Asigna valor de configuracion si existe
    if (defined($conf{'procs_id'})) {
        $procName = $prontus_varglb::FCGI_CONFIG{'f5_proc_name'} . '-' .$conf{'procs_id'};
    }

    my $scriptCmd = "perl $prontus_varglb::DIR_SERVER/$prontus_varglb::DIR_CGI_CPAN/fcgi_fpm/route_friendly_fcgi.pl";


    for (my $i = 0; $i < 30; $i++) {
        my $res = `ps aux`;
        if ($res !~ /\Q$procName\E/) {
            print STDERR "Starting $procName\n";
            system "$scriptCmd > /dev/null 2>&1 &";
        }
        sleep 2;
    }
}
