#!/usr/bin/perl

# --------------------------------------------------------------
# Prontus CMS
# http://www.prontus.cl
# by Altavoz.net
#
# licensed under LGPL license.
# http://www.prontus.cl/license.html
# --------------------------------------------------------------

package lib_form;
use strict;
use utf8;

# Servidor SMTP.
our $SERVER_SMTP = '';
our $SEPARADOR = ';';
our $DELIMITADOR = '"';
our $MAX_COLS = 7;
our $MAX_ROWS = 50;

# ------------------------------------------------------------------------- #
# Envia un mensaje de correo electronico.
# &envia_mail($to,$from,$subj,$body,$filename,$filedata)
sub envia_mail {
    my ($to, $from, $replyto, $subj, $body, $filename, $filedata, $encode_html) = @_;
    $encode_html = 0 if (!defined($encode_html));
    my $resp;

    if ($filename) {
        $resp = lib_mail::mail_multipart($from, $to, $replyto, $subj, $body, $filename, $filedata, $encode_html, $lib_form::SERVER_SMTP);
    } else {
        $resp = lib_mail::mail_text($from, $to, $replyto, $subj, $body, $encode_html, $lib_form::SERVER_SMTP);
    }
    return $resp;

} # envia_mail

# --------------------------------------------------------------------------------------------------
sub add_to_csv {
    my $data = $_[0];
    $data = glib_str_03::trim($data); # Elimina espacios para que no molesten.
    # Convierte comillas para que no arruinen el archivo csv.
    $data =~ s/\"/\'\'/gs;
    # Elimina retornos de carro para que no arruinen el archivo csv.
    $data =~ s/\r//gs;
    return "$DELIMITADOR$data$DELIMITADOR$SEPARADOR";
}
# --------------------------------------------------------------------------------------------------
sub array_to_csv {
    my @arr = @_;
    my $total = $#arr;
    my $row = '';
    for(my $i = 0; $i <= $total; $i++) {
        $row = $row . lib_form::add_to_csv($arr[$i]);
    }
    return $row;
}

# ------------------------------------------------------------------------- #
# Aborta y sale con un mensaje de error.
sub aborta {
    print "Content-type: text/html\n\n";
    print "\n<html><head><title>Error</title></head><body><p>".$_[0]."</p></body></html>";
    exit;
} # aborta

1;
