#!/usr/bin/perl

# ---------------------------------------------------------------
# Prontus CMS
# http://www.prontus.cl
# by Altavoz.net
#
# licensed under LGPL license.
# http://www.prontus.cl/license.html
# ---------------------------------------------------------------

# -------------------------------COMENTARIO GLOBAL---------------
# ---------------------------------------------------------------
# PROPOSITO.
# -----------
# Funciones para controlar maximo de instancias de un script en ejecucion
# ---------------------------------------------------------------

# ---------------------------------------------------------------
# DECLARACIONES GLOBALES.
# ------------------------

package lib_maxrunning;

use strict;
use utf8;

# Retorna las copias de del script que se encuentran corriendo.
sub myselfRunning {
    # al usar modperl o fcgi la cantidad de procesos esta limitada de otra forma
    if (defined($Prontus::modperl) || $prontus_varglb::FCGI_MODE) {
        return 0;
    } else {
        my $res = qx/ps axww | grep $0 | grep -v ' grep ' | grep -v 'nice' | grep -v 'editor' | grep -v 'sh -c' | grep -v 'tail' | grep -v execIfMaster | wc -l/;
        $res =~ s/\D//gs;
        return $res;
    }
}

# Retorna las copias de del script que se encuentran corriendo.
sub myselfRunningArgs {
    # al usar modperl o fcgi la cantidad de procesos esta limitada de otra forma
    if (defined($Prontus::modperl) || $prontus_varglb::FCGI_MODE) {
        return 0;
    } else {
        my $args = join('| grep ', @ARGV);
        my $res = qx/ps axww | grep $0 | grep $args | grep -v ' grep ' | grep -v 'nice' | grep -v 'editor' | grep -v 'sh -c' | grep -v 'tail' | grep -v execIfMaster | wc -l/;
        $res =~ s/\D//gs;
        return $res;
    }
}

# Aborta si hay mas de $max copias corriendo.
sub maxExcedido {
    my $max = $_[0];
    # max excedido, abortar
    return (&myselfRunning() > $max);
}

# Deterimna si un pid esta corriendo o no
# retorna la informacion del PID
sub isRunningPid {
    my $result = `ps -ww -p $_[0] -o args=`;
    return $result;
}

1;
