package lib_profile;

use utf8;
use strict;
use warnings;

our %GROUPS = (
    'art_publish' => {
        'prontus_art_banco' => 1,
        'prontus_art_borrar' => 1,
        'prontus_art_check_url' => 1,
        'prontus_art_copy' => 1,
        'prontus_art_get_versions' => 1,
        'prontus_art_ficha' => 1,
        'prontus_art_quick_edit' => 1,
        'prontus_art_repair' => 1,
        'prontus_art_sbmit' => 1,
        'prontus_art_sbmit_ajax' => 1,
        'prontus_art_upload' => 1,
        'prontus_art_view_xml' => 1,
        'prontus_check_friendly' => 1,
        'prontus_buscar_relacionados' => 1,
        'prontus_urlf5_guardar' => 1,
        'prontus_urlf5_make_art_url' => 1,
        'prontus_dam_update_art' => 1,
        'prontus_editor_imag' => 1,
        'prontus_editor_imag_guardar' => 1,
        'prontus_audio_check' => 1,
        'prontus_audio_xcode' => 1,
        'prontus_audio_xcode_status' => 1,
        'prontus_qtfaststart_check' => 1,
        'prontus_videocut' => 1,
        'prontus_videogetsnapshot' => 1,
        'prontus_videoxcode' => 1,
        'prontus_videoxcodestatus' => 1,
        'prontus_s3_download' => 1,
        'prontus_s3_download_check' => 1,
        'facebook_posting' => 1,
        'twitter_posting' => 1,
        'youtube_posting' => 1,
        'mam_save' => 1,
        'mam_list' => 1,
        'mam_delete' => 1,
    },
    'snp' => {
        'prontus_snp_admin' => 1,
        'prontus_snp_get_notif' => 1,
        'prontus_snp_send_artic_push' => 1,
        'prontus_snp_send_push' => 1,
    },
    'seo' => { # la configuración es parte de config.
        'prontus_seo_monitoreo' => 1,
        'prontus_seo_robots' => 1,
        'prontus_get_facebook_preview' => 1,
        'prontus_get_google_pagespeed' => 1,
        'prontus_get_google_preview' => 1,
        'prontus_get_google_stats' => 1,
        'prontus_port_seo_get' => 1,
        'prontus_port_seo_save' => 1,
        'prontus_schema_admin' => 1,
        'prontus_schema_save' => 1,
        'prontus_tax_seo' => 1,
        'prontus_tax_seo_save' => 1,
        'prontus_validar_robots' => 1,
    },
    'elasticsearch' => { # estadísticas de elasticsearch
        'prontus_admin_stats_es' => 1,
        'prontus_admin_get_stats_es' => 1,
        'prontus_admin_elasticsearch_reindex' => 1,
    },
    'form_view' => {
        'prontus_form_download' => 1,
        'prontus_form_list' => 1,
    },
    'form_delete' => {
        'prontus_form_delete' => 1
    },
    'art_list' => {
        'prontus_art_list' => 1,
        'prontus_port_art_list' => 1,
    },
    'taxs' => {
        'prontus_tax_admin' => 1,
        'prontus_tax_borrar' => 1,
        'prontus_tax_export' => 1,
        'prontus_tax_guardar' => 1,
        'prontus_tax_guardarpos' => 1,
        'prontus_tax_import' => 1,
        'prontus_tax_mostrar' => 1,
        'prontus_urlf5_tax_ficha' => 1,
    },
    'tags' => {
        'prontus_tags_admin' => 1,
        'prontus_tags_borrar' => 1,
        'prontus_tags_cambia_st' => 1,
        'prontus_tags_export' => 1,
        'prontus_tags_guardar' => 1,
        'prontus_tags_import' => 1,
        'prontus_tags_resumen' => 1,
        'prontus_tags_search' => 1,
        'prontus_urlf5_tag_ficha' => 1,
    },
    'multitag' => {
        'prontus_multitag_admin' => 1,
        'prontus_multitag_export' => 1,
        'prontus_multitag_genera_select' => 1,
        'prontus_multitag_import' => 1,
        'prontus_multitag_limpia_cache' => 1,
        'prontus_multitag_load_data' => 1,
        'prontus_multitag_mant_borrar' => 1,
        'prontus_multitag_mant_guardar' => 1,
        'prontus_multitag_mant_limpia_cache' => 1,
    },
    'ports' => {
        'prontus_port_admin' => 1,
        'prontus_port_art_list' => 1,
        'prontus_cfg_get' => 1,
        'prontus_port_borra_busqueda' => 1,
        'prontus_port_carga_busquedas' => 1,
        'prontus_port_check_md5sum' => 1,
        'prontus_port_guardar' => 1,
        'prontus_port_preview' => 1,
    },
    'pltport' => {
        'prontus_pltport_borrar' => 1,
        'prontus_pltport_duplicar' => 1,
        'prontus_pltport_intercambiar' => 1,
        'prontus_port_get_versions' => 1,
    },
    'urlf5' => {
        'prontus_urlf5_admin' => 1,
        'prontus_urlf5_borrar' => 1,
        'prontus_urlf5_guardar' => 1,
        'prontus_urlf5_import' => 1,
        'prontus_urlf5_get_list' => 1,
        'prontus_urlf5_make_art_url' => 1,
        'prontus_urlf5_tax_ficha' => 1,
        'prontus_urlf5_tax_ficha' => 1,
    },
    'config' => {
        'prontus_admin_conf_art' => 1,
        'prontus_admin_conf_bd' => 1,
        'prontus_admin_conf_buscador' => 1,
        'prontus_admin_conf_cache' => 1,
        'prontus_admin_conf_cloudflare' => 1,
        'prontus_admin_conf_dropbox' => 1,
        'prontus_admin_conf_elasticsearch' => 1,
        'prontus_admin_conf_list' => 1,
        'prontus_admin_conf_port' => 1,
        'prontus_admin_conf_redes' => 1,
        'prontus_admin_conf_sitemap' => 1,
        'prontus_admin_conf_tag' => 1,
        'prontus_admin_conf_tax' => 1,
        'prontus_admin_conf_usr' => 1,
        'prontus_admin_conf_var' => 1,
        'prontus_admin_conf_xcoding' => 1,
        'prontus_admin_conf_pplayer' => 1,
        'prontus_admin_conf_oidc' => 1,
        'prontus_admin_conf_snp' => 1,
        'prontus_xcoding_getformatos' => 1,
        'prontus_xcoding_guardarformatos' => 1,
        'prontus_admin_conf_seo' => 1,
        'prontus_cfg_save' => 1,
        'prontus_get_youtube_tokens' => 1,
    },
    'system' => {
        'prontus_admin_crons' => 1,
        'prontus_admin_plataforma' => 1,
        'prontus_admin_logs' => 1,
        'prontus_admin_get_log' => 1,
        'prontus_admin_get_stats_es' => 1,
        'prontus_alert_save' => 1,
    },
    'maintenance' => {
        'prontus_art_regen' => 1,
        'prontus_admin_regen' => 1,
        'prontus_dam_regen' => 1,
        'prontus_admin_bd' => 1,
        'prontus_set_bd' => 1,
        'prontus_regenerabd' => 1,
        'prontus_admin_reindex' => 1,
        'prontus_indexer_webstart' => 1,
        'prontus_admin_purge' => 1,
        'prontus_admin_reindex' => 1,
        'prontus_admin_elasticsearch_reindex' => 1,
        'prontus_admin_stats_es' => 1,
        'prontus_cloudflare_purge' => 1,
        'prontus_admin_calendar' => 1,
        'prontus_port_regen' => 1,
        'prontus_regenera_taxport_web' => 1,
        'prontus_regenera_tagport_web' => 1,
        'prontus_regen_check_process' => 1,
        'prontus_update_calendar' => 1,
        'prontus_update' => 1,
    },
    'users' => {
        'prontus_usr_admin' => 1,
        'prontus_usr_borrar' => 1,
        'prontus_usr_chgpass_sbmit' => 1,
        'prontus_usr_ficha' => 1,
        'prontus_usr_sbmit' => 1,
        'prontus_usr_list' => 1,
    },
    'profile' => {
        'prontus_profile_admin' => 1,
        'prontus_profile_borrar' => 1,
        'prontus_profile_ficha' => 1,
        'prontus_profile_sbmit' => 1,
    },
    'editor' => {
        'prontus_edit_borrar' => 1,
        'prontus_edit_copy' => 1,
        'prontus_edit_file' => 1,
        'prontus_edit_guardar' => 1,
        'prontus_edit_main' => 1,
        'prontus_edit_upload' => 1,
        'prontus_list_tree' => 1,
    },
    'multimedia' => {
        'prontus_dam_search' => 1,
        'prontus_dam_asset_list' => 1,
        'prontus_dam_regen' => 1,
    },
    'plugins' => {
        'prontus_admin_plugins' => 1,
    },
    'edics' => {
        'prontus_edi_borrar' => 1,
        'prontus_edi_guardar' => 1,
        'prontus_edi_toggle_vigencia' => 1,
    },
    'fid_editor' => {
        'prontus_fid_admin' => 1,
        'prontus_fid_guardar' => 1,
        'prontus_fid_get_config' => 1,
        'prontus_fid_guardar_json' => 1,
        'prontus_fid_guardar_plantilla' => 1,
    },
    's3_explorer' => {
        'prontus_s3_browser' => 1,
        'prontus_s3_delete' => 1,
        'prontus_s3_list' => 1,
    },
    # estando vacio no hay restriccion x cgi, es solo un permiso.
    # ocultan opciones de menus y enlaces a opciones
    # el contorl de acceso a cgi se define de la forma anterior
    'art_view_all' => {'allow' => 1},
    'art_edit_others' => {'allow' => 1},
    'art_view_others' => {'allow' => 1},
    'art_alta' => {'allow' => 1},
    'art_index' => {'allow' => 1},
    'port_view_all' => {'allow' => 1},
    'ports_vobo' => {'allow' => 1},
    'ports_art_vobo' => {'allow' => 1},
    'manage' => {'allow' => 1},
    'category' => {'allow' => 1},
    'cms_publish' => {'allow' => 1},
);

# hash usado para armar la ficha de edición de perfil
our @GROUP_DESCRIPTORS = (
    {'meta' => 'group_art_publish', 'access' => 'cms_publish,art_publish,art_list'},
    {'meta' => 'group_art_alta', 'access' => 'art_alta'},
    {'meta' => 'group_art_index', 'access' => 'art_index'},
    {'meta' => 'group_art_edit_others', 'access' => 'art_edit_others'},
    {'meta' => 'group_art_view_others', 'access' => 'art_view_others'},
    {'meta' => 'group_art_view_all', 'access' => 'art_view_all'},
    {'meta' => 'group_prontus_form_view', 'access' => 'form_view'},
    {'meta' => 'group_prontus_form_delete', 'access' => 'form_delete'},
    {'meta' => 'group_port_edit', 'access' => 'cms_publish,ports'},
    {'meta' => 'group_edics', 'access' => 'edics'},
    {'meta' => 'group_pltport', 'access' => 'pltport'},
    {'meta' => 'group_port_publish', 'access' => 'ports_vobo'},
    {'meta' => 'group_port_publish_art', 'access' => 'ports_art_vobo'},
    {'meta' => 'group_port_view_all', 'access' => 'port_view_all'},
    {'meta' => 'group_tax_publish', 'access' => 'cms_publish,category,taxs'},
    {'meta' => 'group_tag_publish', 'access' => 'cms_publish,category,tags'},
    {'meta' => 'group_multitag_publish', 'access' => 'cms_publish,category,multitag'},
    {'meta' => 'group_seo', 'access' => 'seo'},
    {'meta' => 'group_admin_config', 'access' => 'manage,config'},
    {'meta' => 'group_admin_maintenance', 'access' => 'manage,maintenance'},
    {'meta' => 'group_admin_system', 'access' => 'manage,system'},
    {'meta' => 'group_admin_fid_editor', 'access' => 'manage,fid_editor'},
    {'meta' => 'group_admin_urlf5', 'access' => 'manage,urlf5'},
    {'meta' => 'group_admin_s3', 'access' => 'manage,s3_explorer'},
    {'meta' => 'group_admin_users', 'access' => 'manage,users'},
    {'meta' => 'group_admin_profiles', 'access' => 'manage,profile'},
    {'meta' => 'group_multimedia', 'access' => 'multimedia'},
    {'meta' => 'group_editor', 'access' => 'editor'},
    {'meta' => 'group_plugins', 'access' => 'plugins'},
    {'meta' => 'group_snp', 'access' => 'cms_publish,snp'}
);

# carga información de perfiles en variables globales.
sub load_profiles {
    my $profile_id = $_[0];

    my $prontus_id = $prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'PRONTUS_SSO_MANAGER_ID'};
    if ($prontus_varglb::FCGI_MODE) {
        # esta corriendo como servicio fpm
        if ($prontus_varglb::PROFILES_LOADED{$prontus_id}) {
            #mantenemos los perfiles en memoria
            # no se necesita recargar y se retorna
            return;
        } else {
            # no se han cargado los perfiles en memoria
            # forzamos la carga de todos los perfiles para que se haga 1 vez por proceso
            $profile_id = 0;
        }
    } else {
        # borramos los datos previamente cargados
        $prontus_varglb::PROFILES{$prontus_id} = ();
    }

    my $profiles_table = lib_utils::get_table('profiles', $prontus_id);
    my $sql = "select profiles_id, profiles_nom, profiles_desc, profiles_permissions from $profiles_table";
    my @params;
    if ($profile_id) {
        $sql .= " where profiles_id = ?";
        @params = ($profile_id);
    }
    my ($perfil_id, $nombre, $descripcion, $permisos);
    my ($bd, $msg_err_bd) = lib_bd::conectar_prontus_bd();
    my $salida = glib_dbi_03::ejecutar_sql_bind_param($bd, $sql, \@params, \($perfil_id, $nombre, $descripcion, $permisos));
    while ($salida->fetch) {
        $prontus_varglb::PROFILES{$prontus_id}{$perfil_id}{'name'} = $nombre;
        $prontus_varglb::PROFILES{$prontus_id}{$perfil_id}{'description'} = $descripcion;
        $prontus_varglb::PROFILES{$prontus_id}{$perfil_id}{'groups_permissions'} = $permisos;
    }
    $salida->finish;
    if ($prontus_varglb::FCGI_MODE && !$profile_id) {
        $prontus_varglb::PROFILES_LOADED{$prontus_id} = 1;
    }
}

sub register_cgi {
    my ($group, $cgi) = @_;
    # elimina extension
    $cgi =~ s/\.\w+$//;
    $GROUPS{$group}{$cgi} = 1;
}

sub get_groups {
    return @GROUP_DESCRIPTORS;
}

sub html_profiler {
    my $html = $_[0];
    # tratamos el html como latin1 ya que no vamos a insertar nuevo texto
    # ylas regex son mas rapidas
    utf8::encode($html);
    my %groups = &get_profile_permissions();

    foreach my $group (keys %GROUPS) {
        if (!exists $groups{$group}) { # si el grupo no existe en los del usuario, se borra del html.
            $html =~ s/%%profile_group_$group%%.*?%%\/profile_group_$group%%//sg;
            $group = uc $group;
            $html =~ s/<!--PROFILE_GROUP_$group-->.*?<!--\/PROFILE_GROUP_$group-->//sg;
        } else {
            $html =~ s|%%/?profile_group_$group%%||g;
            $group = uc $group;
            $html =~ s|<!--/?PROFILE_GROUP_$group-->||g;
        }
    }
    $html =~ s/<!--PROFILE_GROUP_[A-Z0-9]+-->.*?<!--\/PROFILE_GROUP_[A-Z0-9]+-->//sg;
    utf8::decode($html);

    return $html;
}


# guarda los permisos asignados a un perfil
sub save_profile_permissions {
    my ($new_profiles, $profile_id) = @_;

    my $profiles_table = lib_utils::get_table('profiles', $prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'PRONTUS_SSO_MANAGER_ID'});
    my $sql = "update $profiles_table set profiles_permissions = ? where profiles_id = ?";
    my @params = ($new_profiles, $profile_id);
    my ($bd, $msg_err_bd) = lib_bd::conectar_prontus_bd();
    my $salida = glib_dbi_03::ejecutar_sql_param($bd, $sql, \@params);

    lib_prontus::send_signal('clear_vars');
    return 1;
}

sub save_profile {
    my ($profile_name, $profile_description, $permissions, $profile_id) = @_;

    my $profiles_table = lib_utils::get_table('profiles', $prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'PRONTUS_SSO_MANAGER_ID'});
    my $sql = "insert into $profiles_table (profiles_id, profiles_nom, profiles_desc, profiles_permissions) values (?, ?, ?, ?) on duplicate key update profiles_nom = ?, profiles_desc = ?, profiles_permissions = ?";
    my @params = ( $profile_id, $profile_name, $profile_description, $permissions, $profile_name, $profile_description, $permissions);
    my ($bd, $msg_err_bd) = lib_bd::conectar_prontus_bd();
    my $salida = glib_dbi_03::ejecutar_sql_param($bd, $sql, \@params);

    lib_prontus::send_signal('clear_vars');
    return 1;
}

# Borra un perfil de la db;
sub delete_profile {
    my $profile_id = $_[0];
    # no se puede borrar el perfil id 1.
    if ($profile_id < 2) {
        return 0;
    }
    my $profiles_table = lib_utils::get_table('profiles', $prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'PRONTUS_SSO_MANAGER_ID'});
    my $sql = "delete from $profiles_table where profiles_id = ?";
    my @params = ($profile_id);
    my ($bd, $msg_err_bd) = lib_bd::conectar_prontus_bd();
    my $salida = glib_dbi_03::ejecutar_sql_param($bd, $sql, \@params);

    lib_prontus::send_signal('clear_vars');
    return 1;
}

sub get_name {
    my $profile_id = $_[0];

    return 'admin' if ($profile_id eq '1' || $profile_id eq 'A');

    if (&check_exists($profile_id)) {
        my $prontus_id = $prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'PRONTUS_SSO_MANAGER_ID'};
        return $prontus_varglb::PROFILES{$prontus_id}{$profile_id}{'name'};
    }

    return '';
}

sub get_profile_permissions {
    my $profile_id = $_[0];
    # si no pasan un id, usamos el id del usuario logueado.
    $profile_id = $prontus_auth::USERS_PERFIL if !$profile_id;

    my (%grupos, @grupos_array);
    # usuario no logueado
    if (!$profile_id) {
        return %grupos;
    }
    # admin
    elsif ($profile_id == 1) {
        return %GROUPS;
    } else {
        my $prontus_id = $prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'PRONTUS_SSO_MANAGER_ID'};
        @grupos_array = split /,/, $prontus_varglb::PROFILES{$prontus_id}{$profile_id}{'groups_permissions'};
        %grupos = map { $_ => 1 } @grupos_array;

        return %grupos;
    }
}

sub check_exists {
    my $perfil_id = $_[0];

    &load_profiles();
    my $prontus_id = $prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'PRONTUS_SSO_MANAGER_ID'};
    if (!exists $prontus_varglb::PROFILES{$prontus_id}{$perfil_id}) {
        return 0;
    }

    return 1;
}

sub check_in_use {
    my $profile_id = $_[0];
    my $prontus_id = $prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'PRONTUS_SSO_MANAGER_ID'};
    foreach my $user_id (keys %{$prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}}) {
        if ($prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_PERFIL'} == $profile_id) {
            return 1;
        }
    }

    return 0;
}

# chequea si existe acceso para el perfil dado.
# params
# grupo de permisos solicitado según el perfil
# si el profile_id es 1 (admin) retorna siempre true.
#
# retorna
# bool
sub check_profile_access {
    my @permisos_necesarios = @_;

    # bypass si es perfil admin (control total)
    return 1 if ($prontus_auth::USERS_PERFIL == 1);

    my %groups = &get_profile_permissions();
    # obtenemos del sistema el nombre de la CGI actual
    # $0 es el nombre del archivo ejecutándose.
    my $current_cgi = '';
    if ($prontus_varglb::FCGI_MODE) {
        $ENV{'REQUEST_URI'} =~ /([a-zA-Z0-9_]+)\.[a-z]+\??/;
        $current_cgi = $1;
    } elsif ($0 =~ /([a-zA-Z0-9_]+)\.[a-z]+$/) {
        $current_cgi = $1;
    } else {
        # no pudo obtener el nombre de la cgi
        # se deniega el acceso
        return 0;
    }

    foreach my $group (@permisos_necesarios) {
        if (exists $groups{$group}) {
            # permiso sin restriccion x cgi. si el usuario lo tiene, pasa.
            if ($GROUPS{$group}{'allow'}) {
                return 1;
            }
            # tiene permiso para la cgi
            elsif ($GROUPS{$group}{$current_cgi}) {
                return 1;
            }
        }
    }
    return 0; # no tiene acceso.
}

1;
