#!/usr/bin/perl

# --------------------------------------------------------------
# Prontus CMS
# http://www.prontus.cl
# by Altavoz.net
#
# licensed under LGPL license.
# http://www.prontus.cl/license.html
# --------------------------------------------------------------

#-------------------------------COMENTARIO GLOBAL---------------
#---------------------------------------------------------------
# PROPOSITO.
#-----------
# Funciones para crear las tablas de prontus
#-------------------------------BEGIN LIBRERIA------------------
#---------------------------------------------------------------
# DECLARACIONES GLOBALES.
#------------------------

package lib_setbd;

use strict;
use utf8;

sub crear_tabla_secc {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('secc');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
                secc_id int(5) not null auto_increment,
                secc_nom char(128) not null default '',
                secc_mostrar tinyint unsigned not null default 1,
                secc_port varchar(255) not null default '',
                secc_orden int(5) not null default 0,
                secc_nom4vistas text,
                primary key  (secc_id),
                index (secc_nom),
                index (secc_mostrar),
                index (secc_orden)
                )
                CHARACTER SET utf8mb4
                COLLATE utf8mb4_unicode_ci
                ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla secc:" . $base->errstr, 1);
        $msg_ret = "db_create_secc";
    } else {
        $msg_ret = "db_exists_secc";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

sub crear_tabla_temas {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('temas');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
                temas_id int(5) not null auto_increment,
                temas_nom char(128) not null default '',
                temas_idsecc int(5) not null default '0',
                temas_mostrar tinyint unsigned not null default 1,
                temas_port varchar(255) not null default '',
                temas_orden int(5) not null default 0,
                temas_nom4vistas text,
                primary key (temas_id),
                index (temas_idsecc),
                index (temas_nom),
                index (temas_mostrar),
                index (temas_orden)
                )
                CHARACTER SET utf8mb4
                COLLATE utf8mb4_unicode_ci
                ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla temas:" . $base->errstr, 1);
        $msg_ret = "db_create_temas";
    } else {
        $msg_ret = "db_exists_temas";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

sub crear_tabla_subtemas {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('subtemas');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
                subtemas_id int(5) not null auto_increment,
                subtemas_nom char(128) not null default '',
                subtemas_idtemas int(5) not null default '0',
                subtemas_mostrar tinyint unsigned not null default 1,
                subtemas_port varchar(255) not null default '',
                subtemas_orden int(5) not null default 0,
                subtemas_nom4vistas text,
                primary key  (subtemas_id),
                index (subtemas_idtemas),
                index (subtemas_nom),
                index (subtemas_mostrar),
                index (subtemas_orden)
                )
                CHARACTER SET utf8mb4
                COLLATE utf8mb4_unicode_ci
                ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla subtemas:" . $base->errstr, 1);
        $msg_ret = "db_create_subtemas";
    } else {
        $msg_ret = "db_exists_subtemas";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

sub crear_tabla_tags {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('tags');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
                tags_id int(10) not null auto_increment,
                tags_tag char(255) not null default '',
                tags_mostrar tinyint unsigned not null default 1,
                tags_nom4vistas text,
                tags_port varchar(255) not null default '',
                primary key (tags_id),
                unique (tags_tag),
                index (tags_tag),
                index (tags_mostrar)
                )
                CHARACTER SET utf8mb4
                COLLATE utf8mb4_unicode_ci
                ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla tags:" . $base->errstr, 1);
        $msg_ret = "db_create_tags";
    } else {
        $msg_ret = "db_exists_tags";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

sub crear_tabla_tagsart {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('tagsart');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
                tagsart_idtags int(10) NOT NULL default 0,
                tagsart_idart bigint unsigned not null default 0,
                primary key (tagsart_idart, tagsart_idtags),
                index (tagsart_idart),
                index (tagsart_idtags)
                )
                CHARACTER SET utf8mb4
                COLLATE utf8mb4_unicode_ci
                ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla tagsart:" . $base->errstr, 1);
        $msg_ret = "db_create_tagsart";
    } else {
        $msg_ret = "db_exists_tagsart";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

sub crear_tabla_asset {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('asset');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
                asset_art_id bigint unsigned not null default 0,
                asset_file char(150) not null default '',
                asset_type enum('foto', 'video', 'audio') not null,
                asset_placement char(40) not null default '',
                asset_search_wordkey varchar(255) not null,
                asset_search_texto varchar(255) not null,
                asset_search_foto varchar(512) not null,
                asset_art_fid varchar(30) not null,
                asset_art_file varchar(30) not null,
                asset_art_wfoto int unsigned not null default 0,
                asset_art_hfoto int unsigned not null default 0,
                asset_pix int unsigned not null default 0,
                asset_original tinyint not null default 0,
                primary key (asset_file, asset_art_id),
                fulltext wk (asset_search_wordkey),
                index (asset_art_id),
                index (asset_file),
                index (asset_original),
                index (asset_pix),
                index (asset_placement),
                index (asset_type)
                )
                CHARACTER SET utf8mb4
                COLLATE utf8mb4_unicode_ci
                ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla asset:" . $base->errstr, 1);
        $msg_ret = "db_create_asset";
    } else {
        $msg_ret = "db_exists_asset";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

sub crear_tabla_art {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('art');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
                art_id bigint unsigned not null default 0,

                art_idsecc1 int(5) unsigned not null default 0,
                art_idtemas1 int(5) unsigned not null default 0,
                art_idsubtemas1 int(5) unsigned not null default 0,

                art_idsecc2 int(5) unsigned not null default 0,
                art_idtemas2 int(5) unsigned not null default 0,
                art_idsubtemas2 int(5) unsigned not null default 0,

                art_idsecc3 int(5) unsigned not null default 0,
                art_idtemas3 int(5) unsigned not null default 0,
                art_idsubtemas3 int(5) unsigned not null default 0,

                art_autor char(64) not null default '',
                art_titu char(255) not null default '',
                art_baja char(200) not null default '',

                art_fechap int(8) unsigned zerofill not null default 0,
                art_horap smallint(4) unsigned zerofill not null default 0,
                art_fechaphorap bigint(12) unsigned zerofill not null default 0,

                art_dirfecha int(8) unsigned zerofill not null default 0,
                art_extension char(4) not null default '' ,
                art_tipoficha char(64) not null default '' ,
                art_alta tinyint unsigned not null default 0,
                art_idusr int(5) unsigned not null default 0,

                art_fechae int(8) unsigned zerofill not null default 99999999,
                art_horae smallint(4) unsigned zerofill not null default 0,
                art_fechaehorae bigint(12) unsigned zerofill not null default 999999990000,
                art_soloportadas tinyint not null default 1,

                art_fecha_inicio int unsigned not null default 0,
                art_fecha_fin int unsigned not null default 0,

                art_modtime bigint unsigned not null default 0,
                art_disk_size bigint unsigned not null default 0,
                art_media_size bigint unsigned not null default 0,
                art_asset_size bigint unsigned not null default 0,
                art_imag_size bigint unsigned not null default 0,
                art_total_size bigint unsigned not null default 0,
                art_s3_media_size bigint unsigned not null default 0,
                art_s3_asset_size bigint unsigned not null default 0,
                art_s3_size bigint unsigned not null default 0,
                art_s3 tinyint unsigned not null default 0,
                art_indexar tinyint unsigned not null default 1,
                art_priorizar tinyint unsigned not null default 0,

                primary key (art_id),
                fulltext (art_autor),
                fulltext (art_titu),
                fulltext (art_baja),
                index (art_autor),
                index (art_baja),
                index (art_dirfecha),
                index (art_fecha_fin),
                index (art_fecha_inicio),
                index (art_fechae),
                index (art_fechaehorae),
                index (art_fechap),
                index (art_fechaphorap),
                index (art_idsecc1),
                index (art_idsecc2),
                index (art_idsecc3),
                index (art_idsubtemas1),
                index (art_idsubtemas2),
                index (art_idsubtemas3),
                index (art_idtemas1),
                index (art_idtemas2),
                index (art_idtemas3),
                index (art_idusr),
                index (art_indexar),
                index (art_modtime),
                index (art_s3_size),
                index (art_s3),
                index (art_soloportadas),
                index (art_tipoficha),
                index (art_titu)
            )
            CHARACTER SET utf8mb4
            COLLATE utf8mb4_unicode_ci
            ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla art:" . $base->errstr, 1);
        $msg_ret = "db_create_art";

    } else {
        $msg_ret = "db_exists_art";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

sub crear_tabla_art_publicar {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('art_publicar');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
                    art_id bigint unsigned not null default 0,
                    art_fechaphorap bigint unsigned not null default 0,
                    primary key (art_id),
                    index (art_fechaphorap)
                )
                ENGINE = InnoDB
                CHARACTER SET utf8mb4
                COLLATE utf8mb4_unicode_ci
                COMMENT='Almacena ids de artículos a publicar en fecha futura.'";

        $base->do($sql) || return ("Error al crear la tabla art_publicar:" . $base->errstr, 1);
        $msg_ret = "db_create_art_publicar";

    } else {
        $msg_ret = "db_exists_art_publicar";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

sub crear_tabla_art_despublicar {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('art_despublicar');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
                    art_id bigint unsigned not null default 0,
                    art_fechaehorae bigint unsigned not null default 0,
                    primary key (art_id),
                    index (art_fechaehorae)
                )
                ENGINE = InnoDB
                CHARACTER SET utf8mb4
                COLLATE utf8mb4_unicode_ci
                COMMENT='Almacena ids de artículos a despublicar en fecha futura.'";

        $base->do($sql) || return ("Error al crear la tabla art_despublicar:" . $base->errstr, 1);
        $msg_ret = "db_create_art_despublicar";

    } else {
        $msg_ret = "db_exists_art_despublicar";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

sub crear_tabla_urlf5 {
    my $base  = $_[0];
    my $largo  = $_[1];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('urlf5');
    if (!&existe_tabla($base, $table_name)) {
        # type: tax, tag, port, list,
        # subtype: seccion, tema, subtema
        # subtypeid: seccion_id, tema_id, subtema_id
        # file: <plantilla> (relativo)
        # friendly: /url
        # esta tabla se crea con ascii para aumentar la candidad de caracteres de urlf5_url
        # cuidado al hacer join con otra tabla, preferir sacar los datos de forma manual
        $sql = "create table $table_name (
                urlf5_id int(18) unsigned auto_increment not null,
                urlf5_type char(17) not null default '' ,
                urlf5_subtype char(10) not null default '',
                urlf5_subtypeid bigint unsigned not null default 0,
                urlf5_file varchar($largo) not null default '',
                urlf5_url varchar($largo) not null default '',
                urlf5_prontus char(32) not null default '',

                primary key (urlf5_id),
                unique index (urlf5_url),
                index (urlf5_subtypeid),
                index (urlf5_type),
                index (urlf5_file)
            )
            CHARACTER SET ascii
            COLLATE ascii_general_ci
            ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla urlf5:" . $base->errstr, 1);
        $msg_ret = "db_create_urlf5";

    } else {
        $msg_ret = "db_exists_urlf5";
        $hay_error = 1;
    }

    return ($msg_ret, $hay_error);
}

sub crear_tabla_multitag_s {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('multitag_s');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
                multitag_s_id int unsigned not null auto_increment,
                multitag_s_nombre varchar(128) not null,
                multitag_s_nom4vistas text,
                multitag_s_friendly char(64) not null default '',
                multitag_s_estado tinyint unsigned not null default 1,
                primary key (multitag_s_id),
                index (multitag_s_friendly),
                index (multitag_s_estado)
            )
            CHARACTER SET utf8mb4
            COLLATE utf8mb4_unicode_ci
            ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla multitag_s:" . $base->errstr, 1);
        $msg_ret = "db_create_multitag_s";
    } else {
        $msg_ret = "db_exists_multitag_s";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

sub crear_tabla_multitag_t {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('multitag_t');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
                multitag_t_id int unsigned not null auto_increment,
                multitag_t_nombre varchar(128) not null,
                multitag_t_nom4vistas text,
                multitag_t_friendly char(64) not null default '',
                multitag_t_estado tinyint unsigned not null default 1,
                primary key (multitag_t_id),
                index (multitag_t_friendly),
                index (multitag_t_estado)
            )
            CHARACTER SET utf8mb4
            COLLATE utf8mb4_unicode_ci
            ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla multitag_t:" . $base->errstr, 1);
        $msg_ret = "db_create_multitag_t";
    } else {
        $msg_ret = "db_exists_multitag_t";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

sub crear_tabla_multitag_st {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('multitag_st');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
                multitag_st_id int unsigned not null auto_increment,
                multitag_st_nombre varchar(128) not null,
                multitag_st_nom4vistas text,
                multitag_st_friendly char(64) not null default '',
                multitag_st_estado tinyint unsigned not null default 1,
                primary key (multitag_st_id),
                index (multitag_st_friendly),
                index (multitag_st_estado)
            )
            CHARACTER SET utf8mb4
            COLLATE utf8mb4_unicode_ci
            ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla multitag_st:" . $base->errstr, 1);
        $msg_ret = "db_create_multitag_st";
    } else {
        $msg_ret = "db_exists_multitag_st";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

# los campos _ID y _ART_ID, NO deben ser primary key sino solo podria existir 1 articulo por tag
sub crear_tabla_multitag_art_s {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('multitag_art_s');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
                multitag_art_s_id int unsigned not null,
                multitag_art_s_art_id bigint unsigned not null default 0,
                unique (multitag_art_s_art_id, multitag_art_s_id),
                index (multitag_art_s_id),
                index (multitag_art_s_art_id)
            )
            CHARACTER SET utf8mb4
            COLLATE utf8mb4_unicode_ci
            ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla multitag_art_s:" . $base->errstr, 1);
        $msg_ret = "db_create_multitag_art_s";
    } else {
        $msg_ret = "db_exists_multitag_art_s";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

# los campos _ID y _ART_ID, NO deben ser primary key sino solo podria existir 1 articulo por tag
sub crear_tabla_multitag_art_t {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('multitag_art_t');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
                multitag_art_t_id int unsigned not null,
                multitag_art_t_art_id bigint unsigned not null default 0,
                unique (multitag_art_t_art_id, multitag_art_t_id),
                index (multitag_art_t_id),
                index (multitag_art_t_art_id)
            )
            CHARACTER SET utf8mb4
            COLLATE utf8mb4_unicode_ci
            ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla multitag_art_t:" . $base->errstr, 1);
        $msg_ret = "db_create_multitag_art_t";
    } else {
        $msg_ret = "db_exists_multitag_art_t";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

# los campos _ID y _ART_ID, NO deben ser primary key sino solo podria existir 1 articulo por tag
sub crear_tabla_multitag_art_st {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('multitag_art_st');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
                multitag_art_st_id int unsigned not null,
                multitag_art_st_art_id bigint unsigned not null default 0,
                unique (multitag_art_st_art_id, multitag_art_st_id),
                index (multitag_art_st_id),
                index (multitag_art_st_art_id)
            )
            CHARACTER SET utf8mb4
            COLLATE utf8mb4_unicode_ci
            ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla multitag_art_st:" . $base->errstr, 1);
        $msg_ret = "db_create_multitag_art_st";
    } else {
        $msg_ret = "db_exists_multitag_art_st";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

sub crear_tabla_users {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('users');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
            users_id int unsigned not null auto_increment,
            users_nom varchar(64) not null default '',
            users_usr char(32) not null default '',
            users_psw varchar(255) not null,
            users_profile_id int unsigned not null,
            users_email char(255) not null default '',
            users_lang varchar(6) not null default 'es',
            users_exp_days int unsigned not null default 0,
            users_fec_exp int unsigned not null default 0,
            users_fec_creacion datetime not null default current_timestamp,
            users_fec_last_login datetime,
            users_renew_psw int unsigned not null default 1,
            users_2fa int unsigned not null default 0,
            users_oidc tinyint unsigned not null default 0,
            users_deleted tinyint unsigned not null default 0,
            primary key (users_id),
            unique (users_usr),
            index (users_deleted),
            index (users_email)
        )
        CHARACTER SET utf8mb4
        COLLATE utf8mb4_unicode_ci
        ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla users:" . $base->errstr, 1);
        $msg_ret = "db_create_users";
    } else {
        $msg_ret = "db_exists_users";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}


sub crear_tabla_oidc {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('oidc_users');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
            oidc_idusers int(11) not null comment 'id del usuario en la tabla users.',
            oidc_token text comment 'información del usuario desde el (access/id) token oidc.',
            oidc_timestamp datetime not null comment 'ts en que se almacenó el token.',
            oidc_expiration datetime not null comment 'ts de expiración del token.',
            oidc_refresh_token varchar(255) default null comment 'token de refresh encriptado.',
            primary key (oidc_idusers)
            )
            ENGINE=InnoDB
            DEFAULT CHARSET=utf8mb4
            COLLATE utf8mb4_unicode_ci";
        $base->do($sql) || return ("Error al crear la tabla oidc_users:" . $base->errstr, 1);
        $msg_ret = "db_create_oidc_users";
    } else {
        $msg_ret = "db_exists_oidc_users";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

sub crear_tabla_perfiles {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('profiles');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
            profiles_id int unsigned not null auto_increment,
            profiles_nom varchar(32) not null default '',
            profiles_desc varchar(255) not null,
            profiles_permissions text,
            primary key (profiles_id)
        )
        CHARACTER SET utf8mb4
        COLLATE utf8mb4_unicode_ci
        ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla profiles:" . $base->errstr, 1);
        $msg_ret = "db_create_profiles";
    } else {
        $msg_ret = "db_exists_profiles";
        $hay_error = 1;
    }

    $sql = "select count(*) from $table_name";
    my $count_profiles = $base->selectrow_array($sql);

    # tabla vacia hay que cargar los datos
    if ($count_profiles < 1) {
        $sql = "insert into $table_name values(1, 'Administrador', 'Administrador del CMS', ''),(2, 'Editor', 'Editor de contenidos', 'cms_publish,art_publish,art_list,art_alta,art_index,art_edit_others,art_view_others,art_view_all,form_view,cms_publish,ports,edics,pltport,ports_vobo,ports_art_vobo,cms_publish,category,taxs,cms_publish,category,tags,cms_publish,category,multitag,multimedia'),(3, 'Redactor', 'Redactor de contenidos', 'cms_publish,art_publish,art_list,form_view,cms_publish,ports,multimedia')";
        my $res = $base->do($sql);
        if (!$res) {
            $msg_ret = "db_update_error_profiles";
            lib_stdlog::print_err("$msg_ret: sql[$sql][$!]\n");
            $hay_error = 1;
        }
    }

    return ($msg_ret, $hay_error);
}

sub crear_tabla_old_psw {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('old_psw');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
            old_psw_id int unsigned not null auto_increment,
            users_id int unsigned not null,
            users_psw varchar(255) not null default '',
            psw_epoch int(11) unsigned not null,
            primary key (old_psw_id),
            index (users_id)
        )
        CHARACTER SET utf8mb4
        COLLATE utf8mb4_unicode_ci
        ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla old_psw:" . $base->errstr, 1);
        $msg_ret = "db_create_old_psw";
    } else {
        $msg_ret = "db_exists_old_psw";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

sub crear_tabla_port_users {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('port_users');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
            port_user_id int unsigned not null default 0,
            port_template varchar(64) not null default '',
            port_prontus_id varchar(32) not null default '',
            primary key (port_user_id,port_template, port_prontus_id),
            index (port_user_id)
        )
        CHARACTER SET utf8mb4
        COLLATE utf8mb4_unicode_ci
        ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla port_users:" . $base->errstr, 1);
        $msg_ret = "db_create_port_users";
    } else {
        $msg_ret = "db_exists_port_users";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

sub crear_tabla_art_users {
    my $base  = $_[0];
    my ($msg_ret, $hay_error) = ('', 0);
    my $sql;
    my $table_name = lib_utils::get_table('art_users');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table $table_name (
            art_user_id int unsigned not null default 0,
            art_template varchar(64) not null default '',
            art_prontus_id varchar(32) not null default '',
            primary key (art_user_id,art_template, art_prontus_id),
            index (art_user_id)
        )
        CHARACTER SET utf8mb4
        COLLATE utf8mb4_unicode_ci
        ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla art_users:" . $base->errstr, 1);
        $msg_ret = "db_create_art_users";
    } else {
        $msg_ret = "db_exists_art_users";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

sub crear_tabla_prontus_users {
    my $base  = $_[0];
    my ($msg_ret, $hay_error);
    my $sql;
    my $table_name = lib_utils::get_table('prontus_users');
    if (!&existe_tabla($base, $table_name)) {
        $sql = "create table if not exists $table_name (
            prontus_user_id int unsigned not null default 0,
            prontus_id varchar(32) not null default '',
            primary key (prontus_user_id, prontus_id),
            index (prontus_user_id),
            index (prontus_id)
        )
        CHARACTER SET utf8mb4
        COLLATE utf8mb4_unicode_ci
        ENGINE = InnoDB;";

        $base->do($sql) || return ("Error al crear la tabla prontus_users:" . $base->errstr, 1);
        $msg_ret = "db_create_prontus_users";
    } else {
        $msg_ret = "db_exists_prontus_users";
        $hay_error = 1;
    }
    return ($msg_ret, $hay_error);
}

sub existe_tabla {
    my $base  = $_[0];
    my $tabla = $_[1];

    my $nom = 0;
    my $sql = "show tables";
    my @tablas = @{$base->selectcol_arrayref($sql)};

    foreach my $table (@tablas) {
        if ($table eq $tabla) {
            return $table;
        }
    }
    return '';
}

1;
