#!/usr/bin/perl

# ---------------------------------------------------------------
# Prontus CMS
# http://www.prontus.cl
# by Altavoz.net
#
# licensed under LGPL license.
# http://www.prontus.cl/license.html
# ---------------------------------------------------------------

use utf8;
use strict;
package prontus_auth;
use Digest::MD5;
use Crypt::Eksblowfish::Bcrypt;

our $PSW_MAX_LENGTH = 32;
our $PSW_MIN_LENGTH = 8;
our $PSW_TO_REMEMBER = 0;
our $PSW_COMPARE_PREVIOUS = 0;
our $USERS_USR_ID = '';
our $USERS_USR = '';
our $USERS_PSW = '';
our $USERS_NOM = '';
our $USERS_PERFIL = '';
our $USERS_EMAIL = '';
our $USERS_LANG = '';
our $USERS_EXP_DAYS = 0;
our $USERS_FEC_EXP = 0;
our $USERS_RENEW_PSW = 0;
our $USERS_2FA = 0;
our $EXTERNAL_PROCESS = '';

eval {require prontus_auth_custom;};

# ---------------------------------------------------------------
# Valida un usuario y clave para hacer login en Prontus.
# parámetros:
#   $usr (el username, columna USERS_USR de la tabla USERS)
#   $psw (la clave, columna USERS_PSW de la tabla USERS)
# retorna:
#   0: user no valido normal
#   1: user valido normal
#   2: no se usa, pero no se reutilizo el valor, era $user4log = 'sys-admin' if ($login_result == 2);
#   3: password expiró
sub check_valid_login {
    my ($usr, $psw) = @_;

    my $user_id = $prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'USR_ID_REL'}{$usr};
    if (defined($prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_DELETED'}) &&
        $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_DELETED'} > 0) {
        return 0;
    }

    my $flag_file = "$prontus_varglb::DIR_SERVER$prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'DIR_DBM'}/users/prontus_flag_admin.txt";
    if (defined($prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}) &&
        defined($prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_PSW'})) {

        $USERS_NOM = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_NOM'};
        $USERS_USR = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_USR'};
        $USERS_PSW = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_PSW'};
        $USERS_PERFIL = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_PERFIL'};
        $USERS_EMAIL = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_EMAIL'};
        $USERS_LANG = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_LANG'};
        $USERS_EXP_DAYS = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_EXP_DAYS'};
        $USERS_FEC_EXP = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_FEC_EXP'};
        $USERS_RENEW_PSW = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_RENEW_PSW'};
        $USERS_2FA = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_2FA'};
        $USERS_USR_ID = $user_id;

        if (&check_password($psw, $USERS_PSW, $USERS_USR_ID)) {
            return 3 if (&is_passwd_expired());
            if ($user_id eq '1' && !-f $flag_file) {
                # si admin logea correctamente desactivamos el reset
                &glib_fildir_03::write_file("$prontus_varglb::DIR_SERVER$prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'DIR_DBM'}/users/prontus_flag_admin.txt", 'No server domain, please try later.');
            }
            return 1;
        }
    }

    # si no esta presente este archivo, permite entrar con admin/prontus y luego obliga a cambiar la pass
    if ($user_id eq '1' && $psw eq 'prontus') {
        if (!(-f $flag_file)) {
            # Resetear clave admin
            $USERS_PSW = &encrypt_password('prontus');
            $USERS_EXP_DAYS = 0;
            $USERS_FEC_EXP = 0;

            $user_id = 1;
            $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_PSW'} = $USERS_PSW;
            $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_PERFIL'} = 1;
            $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_EXP_DAYS'} = $USERS_EXP_DAYS;
            $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_FEC_EXP'} = $USERS_FEC_EXP;
            $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_RENEW_PSW'} = 1;
            $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_2FA'} = 0;

            # guardamos los datos
            lib_users::save_user_data($user_id);

            # desactivamos el reset
            glib_fildir_03::write_file("$prontus_varglb::DIR_SERVER$prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'DIR_DBM'}/users/prontus_flag_admin.txt", 'No server domain, please try later.');
            return 1;
        }
    }
    return 0;
}

# Valida un usuario de Prontus con sesión ya generada usando OpenID Connect.
# Parámetros:
#   $usr el username (campo USERS_USR de la tabla USERS
# retorna:
#   0: user no valido
#   1: user valido
sub check_valid_oidc_login {
    my $usr = shift;

    my $user_id = $prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'USR_ID_REL'}{$usr};
    if (defined($prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_DELETED'}) &&
        $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_DELETED'} > 0) {
        return 0;
    }

    if (defined($prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id})) {
        $USERS_NOM = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_NOM'};
        $USERS_USR = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_USR'};
        $USERS_PSW = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_PSW'};
        $USERS_PERFIL = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_PERFIL'};
        $USERS_EMAIL = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_EMAIL'};
        $USERS_LANG = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_LANG'};
        $USERS_EXP_DAYS = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_EXP_DAYS'};
        $USERS_FEC_EXP = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_FEC_EXP'};
        $USERS_RENEW_PSW = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_RENEW_PSW'};
        $USERS_2FA = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_2FA'};
        $USERS_USR_ID = $user_id;

        # debe existir una sesión para el usuario en la tabla OIDC_USERS, y no debe haber expirado.
        my ($result_code, $msg) = &lib_oidc::existe_sesion_oidc($USERS_USR_ID);
        if ($result_code) {
            return 1;
        }
    }
    return 0;
}

# ---------------------------------------------------------------
sub check_valid_hash_psw {
    my ($username, $hash_psw) = @_;
    # Devuelve el password encriptado que corresponda. Si es nuevo, lo devuelve completo, ya que en la cookie
    # se almacena solo el hash.
    my $crypted_pass = &check_if_new_hash($username, $hash_psw);
    my $user_id = $prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'USR_ID_REL'}{$username};

    if (defined($prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}) &&
        defined($prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_PSW'}) &&
        ($crypted_pass eq $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_PSW'})) {

        $USERS_NOM = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_NOM'};
        $USERS_USR = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_USR'};
        $USERS_PSW = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_PSW'};
        $USERS_PERFIL = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_PERFIL'};
        $USERS_EMAIL = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_EMAIL'};
        $USERS_LANG = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_LANG'};
        $USERS_EXP_DAYS = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_EXP_DAYS'} + 0;
        $USERS_FEC_EXP = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_FEC_EXP'} + 0;
        $USERS_RENEW_PSW = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_RENEW_PSW'};
        $USERS_USR_ID = $user_id;

        return 3 if (&is_passwd_expired());
        return 1;
    }
    return 0;
}

# ---------------------------------------------------------------
sub is_passwd_expired {
    # la clave de admin no expira
    if ($USERS_PERFIL == 1) {
        return 0;
    }
    # si definieron que no expira, no expira
    if ($USERS_EXP_DAYS < 1) {
        return 0;
    }

    if ($USERS_FEC_EXP ne '' && time > $USERS_FEC_EXP) {
        return 1;
    } else {
        return 0;
    }
}

# ---------------------------------------------------------------
sub check_if_new_hash {
    my $username = $_[0];
    my $hash = $_[1];
    my $user_id = $prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'USR_ID_REL'}{$username};

    if (defined($prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}) &&
        defined($prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_PSW'})) {

        if ($prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_PSW'} =~ /^\$2a\$\d{2}\$([A-Za-z0-9+\\.\/]{22})([A-Za-z0-9+\\.\/]{31})/) {
            if ($hash eq $2) {
                return $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_PSW'};
            }
        }
    }
    return $hash;
}

# ---------------------------------------------------------------
sub check_password {
    my $input_password = $_[0];
    my $stored_password = $_[1];
    my $user_id = $_[2];

    return 0 if (length($stored_password) < 6);

    if (length($stored_password) == 60) {
        # REF: https://gist.github.com/gcrawshaw/1071698/fe4a2ac69d845a65a093a23c4899fd9d80d5c466
        # Obtener el SALT, son 22 caracteres en base64.
        if ($stored_password =~ /^\$2a\$\d{2}\$([A-Za-z0-9+\\.\/]{22})/) {
            my $match = &encrypt_password($input_password, $1); # Se usa el mismo salt para encriptar la contraseña ingresada por el usuario.
            my $bad = 0;

            # Se compara letra por letra para incrementar la seguridad.
            for (my $x = 0; $x < length $match; $x++) {
                $bad++ if substr($match, $x, 1) ne substr($stored_password, $x, 1);
            }

            return ($bad == 0);
        }
    }

    my $crypted_pass;
    if (length($stored_password) == 32) {
        $crypted_pass = Digest::MD5::md5_hex($input_password);
    }
    if ($crypted_pass eq $stored_password) {
        # actualizamos la clave si es posible
        my $aux = $PSW_COMPARE_PREVIOUS;
        $PSW_COMPARE_PREVIOUS = 0;
        &save_new_password($user_id, $input_password);
        $PSW_COMPARE_PREVIOUS = $aux;

        return 1;
    }

    return 0;
}

# ---------------------------------------------------------------
sub encrypt_password {
    my ($password, $salt) = @_;

    $salt = $salt || &generate_salt();
    my $settings = '$2a$10$' . $salt;

    return Crypt::Eksblowfish::Bcrypt::bcrypt($password, $settings);
}

# ---------------------------------------------------------------
sub generate_salt {
    my $itoa64 = "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
    my $salt = '';
    $salt .= substr($itoa64,int(rand(64)),1) while length($salt) < 16;

    return Crypt::Eksblowfish::Bcrypt::en_base64($salt);
}

# ---------------------------------------------------------------
# Para el nuevo tipo de contraseña se usa solo el hash, no todo el string.
sub get_hash_for_session {
    my $hash = $_[0];

    return $hash if (length $hash < 60);

    # $2a$10$ => version 2a of BCrypt and 10 rounds of computations (7 bytes)
    # salt 22 bytes
    # hash 31 bytes
    if ($hash =~ /^\$2a\$\d{2}\$([A-Za-z0-9+\\.\/]{22})([A-Za-z0-9+\\.\/]{31})/) {
        return $2; # devuelve solo el hash, ultimos 31 caracteres.
    } else {
        return $hash;
    }
}

# ---------------------------------------------------------------
sub save_new_password {
    #  si el usuario ya existe validar que la clave es distinta a las anteriores
    my ($user_id, $new_psw, $new_mail) = @_;
    my $old_users_psw = $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_PSW'};

    if ($PSW_COMPARE_PREVIOUS) {
        my @stored = lib_users::list_old_passwords($user_id);
        push (@stored, $old_users_psw) if ($old_users_psw ne '');
        for (my $i = 0; $i < scalar @stored; $i++) {
            if ($stored[$i] =~ /^\s+$/ ) { next; }
            if (&check_password($new_psw, $stored[$i], $user_id)) {
                return (0, lib_lang::get_message('auth_psw_repeated'));
            }
        }
    }

    if ($new_mail) {
        $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_EMAIL'} = $new_mail;
    }

    my $new_psw_hash = &encrypt_password($new_psw);
    $USERS_PSW = $new_psw_hash;
    $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_PSW'} = $USERS_PSW;

    # si la contraseña expira se debe mantener o actualizar la expiracion
    if ($prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_EXP_DAYS'} > 0) {
        # solo perfiles de administrador pueden actualizar la expiracion de contraseñas o usuarios que tienen permitido renovar
        if ($USERS_PERFIL == 1 || $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_RENEW_PSW'}) {
            $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_FEC_EXP'} = time + (int($prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_EXP_DAYS'}) * 86400);
        }
    } else {
        $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_FEC_EXP'} = 0;
    }

    my ($new_id, $error) = lib_users::save_user_data($user_id);
    if (!$new_id) {
        lib_stdlog::print_err($error, "\n");
        return (0, lib_lang::get_message('auth_error_db'));
    }

    lib_users::store_old_passwords($user_id, $old_users_psw) if ($user_id ne 'new_user');

    if ($EXTERNAL_PROCESS ne '') {
        lib_stdlog::print_err("save_new_password exec[$EXTERNAL_PROCESS $prontus_varglb::PRONTUS_ID]\n");
        system("$EXTERNAL_PROCESS $prontus_varglb::PRONTUS_ID $prontus_varglb::USER_DATA{$prontus_varglb::PRONTUS_ID}{$user_id}{'USERS_USR'} $new_psw_hash 1>/dev/null 2>/dev/null &");
    }
    return ($new_id, '');
}

# ---------------------------------------------------------------
sub is_user_valido {
    my $usr = $_[0];

    if (defined($prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'USR_ID_REL'}{$usr}))  {
        $USERS_USR_ID = $prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'USR_ID_REL'}{$usr};
        return 1;
    }
    return 0;
}

# ---------------------------------------------------------------
sub is_valid_password {
    my $psw = $_[0];

    if ($psw =~ /^\s+$/) {
        return lib_lang::get_message('auth_psw_empty');
    }

    my $psw_length = length($psw);
    if ($psw_length > $PSW_MAX_LENGTH || $psw_length < $PSW_MIN_LENGTH) {
        return lib_lang::get_interpolated_message('auth_psw_min_max_length', $PSW_MIN_LENGTH, $PSW_MAX_LENGTH);
    }

    if (lc $psw eq 'prontus') {
        return lib_lang::get_interpolated_message('auth_psw_invalid_prontus', $psw);
    }

    if ($psw !~ /([a-z].*[A-Z])|([A-Z].*[a-z])/) {
        return lib_lang::get_message('auth_psw_requirements');
    }

    if ($psw !~ /([0-9])/) {
        return lib_lang::get_message('auth_psw_requirements');
    }

    if ($psw !~ /([\!%&@#\$\^\*\?_\.])/) {
        return lib_lang::get_message('auth_psw_requirements');
    }
    return '';
}

sub get_psw_max_length {
    return $PSW_MAX_LENGTH;
}

sub get_psw_min_length {
    return $PSW_MIN_LENGTH;
}

1;
