#!/usr/bin/perl

# ---------------------------------------------------------------
# Prontus CMS
# http://www.prontus.cl
# by Altavoz.net
#
# licensed under LGPL license.
# http://www.prontus.cl/license.html
# ---------------------------------------------------------------
use utf8;
use strict;

BEGIN {
    use FindBin qw($Bin);
    my $pathLibsProntus = $Bin;
    unshift(@INC,$pathLibsProntus);
}

##libs##
use lib_stdlog;
lib_stdlog::set_stdlog($0, 51200);
use prontus_varglb;
prontus_varglb::init();

use File::Copy;
use JSON;
use Session;
use glib_cgi_05;
use glib_fildir_03;
use lib_cookies;
use lib_lang;
use mime_types;
##/libs##

main: {
    # Rescatar parametros recibidos
    glib_cgi_05::new();

    my $file = glib_cgi_05::param('_file');
    if (substr($file, -1) eq '/') {
        $file = $file.'index.html';
    }

    my $language = lib_lang::get_language();
    lib_lang::load_translation_table($language);

    my %cookies = lib_cookies::get_cookies();
    my $prontus_id;

    $file = &valida_file($file, $prontus_varglb::DIR_SERVER);

    foreach my $cookie_id (keys %cookies) {
        if ($cookie_id =~ /^SESSION_(.*?)$/) {
            $prontus_id = $1;

            if ($prontus_id ne '') {
                my $sess_obj = Session->new('prontus_id' => $prontus_id,
                                            'document_root' => $prontus_varglb::DIR_SERVER)
                            || &print_error_wrapper(lib_lang::get_interpolated_message('global_error_session_obj', $Session::ERR));

                # El usuario está logueado.
                if ($sess_obj->{id_session} ne '' && $sess_obj->{username} ne '') {
                    $file =~ /\.(\w+)$/s;
                    my $ext = $1;
                    my $content_type = "Content-Type: mime_types::ext_2_type($ext)\n\n";
                    # lib_stdlog::print_err("file[$file] ext[$ext] content_type[$content_type]\n");

                    if ($content_type ne '') {
                        my $buffer = glib_fildir_03::read_file_bin($file);

                        print "Content-Type: $content_type\n\n";
                        print $buffer;

                        exit;
                    } else {
                        &print_error_wrapper(lib_lang::get_message("file_wrapper_invalid_filetype"));
                    }
                }
            }
        }
    }

    &print_error_wrapper(lib_lang::get_message("file_wrapper_invalid_session"));
}

sub valida_file {
    my $file = $_[0];
    my $dir_server = $_[1];

    $file =~ s/\.\.//sg;
    if ($file eq '') {
        &print_error_wrapper(lib_lang::get_message("file_wrapper_unspecified_file"));
    }

    $file = "/$file" if ($file !~ /^\//s);
    $file = "$dir_server$file";

    if (!-f $file) {
        &print_error_wrapper(lib_lang::get_message("file_wrapper_invalid_file"));
    }

    return $file;
}

sub print_error_wrapper {
    my $msg = $_[0];
    lib_stdlog::print_err($msg , "\n");

    print "Status: 404 Not Found\n\n";
    print " ";
    exit;
}
