#!/usr/bin/perl

# ---------------------------------------------------------------
# Prontus CMS
# http://www.prontus.cl
# by Altavoz.net
#
# licensed under LGPL license.
# http://www.prontus.cl/license.html
# ---------------------------------------------------------------
# -------------------------------COMENTARIO GLOBAL---------------
# ---------------------------------------------------------------
# PROPOSITO .
# -----------
# Genera contraseñas aleatorias. Las caracteres de las contraseñas
# generadas seran alfanumericos (A-Za-z0-9)
#
# Funcionamiento
#
# La salida del script es en formato JSON, las contraseñas generadas
# iran dentro de un objeto "passwords"
# ---------------------------------------------------------------
# INVOCACIONES ACEPTADAS.
# ------------------------
# Via web
# ---------------------------------------------------------------
# ---------------------------------------------------------------
# TABLAS UTILIZADAS.
# -------------------
#
# -------------------------------BEGIN SCRIPT---------------
# ---------------------------------------------------------------
# DIRECTIVAS DE COMPILACION.
# ------------------------
use utf8;
use strict;

BEGIN {
    use FindBin qw($Bin);
    my $pathLibsProntus = $Bin;
    unshift(@INC,$pathLibsProntus);
}

##libs##
use lib_stdlog;
lib_stdlog::set_stdlog($0, 51200);
use prontus_varglb;
prontus_varglb::init();

use File::Copy;
use JSON;
use glib_fildir_03;
use glib_html_03;
use lib_lang;
use lib_utils;
use prontus_auth;
##/libs##

main: {
    lib_utils::setUp();
    my $strLength = int((prontus_auth::get_psw_max_length() + prontus_auth::get_psw_min_length())/2);

    # validador regex password
    my $passCorrecta = 0;
    #expresión regular correcta
    my $regexCorrecta = '^(?=.*[A-Z])(?=.*[1-9])(?=.*[!%&@#$?_.*])\S{8,32}$';

    my @characters = (('A'..'Z'), ('a'..'z'), ('!','%','&','@','#','$','^','?','_','.','*'), (0..9));
    my $size = $#characters + 1;
    my $pwd = '';
    do{
        $pwd = '';
        for (1..$strLength) {
            $pwd .= $characters[int(rand($size))];
        }
        if ($pwd =~ /$regexCorrecta/) {
            $passCorrecta = 1;
        }

    } while(!$passCorrecta);

    my $resp->{'status'} = 1;
    $resp->{'msg'}    = 'OK';
    $resp->{'pwd'}    = $pwd;

    glib_html_03::print_json_result_hash($resp);
}
