#!/usr/bin/perl
package prontus_webp_convert;

use strict;
use warnings;

# Los modulos se cargan en apache_startup.pl
# use Apache2::RequestRec ();
# use Apache2::RequestIO ();
# use Apache2::SubRequest ();
# use Apache2::Const ();

# use Apache2::RequestUtil ();
# use Apache2::ServerUtil ();

# Toma variables definidas en apache_startup.pl
my $rootDir   = $My::documentRoot;

sub handler {
    my $r = shift;
    my $uri = $r->uri();

    my $file = "$rootDir$uri";
    # elimina / y \ repetidos para evitar redirecciones externas y normalizar urls
    $file =~ s/[\/\\]+/\//g;
    # deduce los paths reales de las imagenes para realizar la conversion
    $file =~ m|(/.+/[^/]+/site/artic/\d+/imag/[\w]+)/([\w\-\.]+)\.([\w]+)|;
    # patron para buscar la foto original
    my $path = "$1\_$2.*";
    # el archivo de destino es el webp que hay que crear
    my $destino = "$1\_$2.$3";
    # print STDERR "PRONTUS_WEBP_CONVERT [$file][$destino][$path]\n";

    # busca cual es la foto original y usa la primera que encuentra
    my @files = glob($path);
    if ($files[0]) {
        my $cmd = "convert $files[0] $destino";
        system($cmd);
    }

    # si se creo la foto devuelve un redirect interno, sino apache no reconoce que ahora si existe el archivo
    if (-f $destino) {
        $r->internal_redirect($uri);
    } else {
        return Apache2::Const::NOT_FOUND;
    }
}

1;
