#!/usr/bin/perl

# -------------------------------COMENTARIO GLOBAL---------------
# ---------------------------------------------------------------
# PROPOSITO.
# -----------
# Convierte tablas de bd prontus en un sql a version 12.3
# ---------------------------------------------------------------
# MAIN.
# ---------------------------------------------------------------

use strict;
use utf8;

BEGIN {
	use FindBin qw($Bin);
	unshift(@INC,$Bin); # Para dejar disponibles las librerias
	my $pathLibsProntus = $Bin;
	$pathLibsProntus =~ s/\/[^\/]+\/?$//;
	unshift(@INC,$pathLibsProntus);
}

##libs##
use lib_stdlog;
lib_stdlog::set_stdlog($0, 51200);
use prontus_varglb;
prontus_varglb::init();

use File::Copy;
use JSON;
use glib_fildir_03;
use lib_lang;
use lib_utils;
##/libs##

main:{
    lib_utils::setUp();

	my $filename = $ARGV[0];

    my $file = glib_fildir_03::read_file($filename);

    $file =~ s/(DROP TABLE[^;]+)/lc($1)/iesg;
    $file =~ s/(create table[^;]+)/lc($1)/iesg;
    $file =~ s/(LOCK TABLE[^;]+)/lc($1)/iesg;
    $file =~ s/(UNLOCK[^;]+)/lc($1)/iesg;
    $file =~ s/(INSERT INTO.+?VALUES)/lc($1)/iesg;
    $file =~ s/(\*!40000 [^;]+)/lc($1)/iesg;

    $filename =~ s/\.sql/_12_3\.sql/;

    print "saved: $filename \n";
	glib_fildir_03::write_file($filename, $file);

}
