#!/usr/bin/perl
# --------------------------------------------------------------
# Prontus CMS
# http://www.prontus.cl
# by Altavoz.net
#
# licensed under LGPL license.
# http://www.prontus.cl/license.html
# --------------------------------------------------------------
use strict;
use utf8;

BEGIN {
    use FindBin qw($Bin);
    my $pathLibsProntus = $Bin;
    unshift(@INC,$pathLibsProntus);
    $pathLibsProntus =~ s/\/[^\/]+$//;
    unshift(@INC,$pathLibsProntus);
}

##libs##
use lib_stdlog;
lib_stdlog::set_stdlog($0, 51200);
use prontus_varglb;
prontus_varglb::init();

use File::Copy;
use JSON;
use glib_cgi_05;
use glib_fildir_03;
use glib_hrfec_03;
use glib_str_03;
use lib_lang;
use lib_parser;
use lib_platform;
use lib_utils;
##/libs##


main: {
    lib_utils::setUp();
    my ($perfil, $id_usr, $pagina);

    my $purge = $lib_prontus::DISABLE_PURGE_CACHE;
    $lib_prontus::DISABLE_PURGE_CACHE = 1; # deshabilitar purge.

    # Rescatar parametros recibidos.
    glib_cgi_05::new();
    $prontus_varglb::PRONTUS_ID = glib_cgi_05::param('_prontus_id');

    $prontus_varglb::PRONTUS_ID =~ s/[^\w\-]+//g;
    if ($prontus_varglb::PRONTUS_ID eq '' || $prontus_varglb::PRONTUS_ID eq 'prontus') {
        lib_platform::salir("Error: Directorio del publicador no es válido. Debe indicar el nombre del Prontus a chequear, ejemplo: _prontus_id=prontus_noticias");
    }

    $pagina = lib_utils::load_cpan_core_plt("core/prontus_check_install.html");
    $pagina = lib_utils::set_coreplt_ppal_simple($pagina);

    my $PRONTUS_DIR_CREADO_POR_CGI = 0;
    # En este caso no debe existir la carpeta del prontus asi q se intenta crear.
    if (! -d "$prontus_varglb::DIR_SERVER/$prontus_varglb::PRONTUS_ID") {
        if ( ! (glib_fildir_03::check_dir("$prontus_varglb::DIR_SERVER/$prontus_varglb::PRONTUS_ID")) ) {
            lib_platform::salir("Error: Directorio del publicador no existe y no fue posible crearlo.");
        } else {
            $PRONTUS_DIR_CREADO_POR_CGI = 1;
        }
    } else {
        lib_platform::salir("Error: Directorio $prontus_varglb::PRONTUS_ID ya existe.");
    }

    # Cargar variables para emular carga de arch. de config
    $prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'DIR_SITE'} = "/$prontus_varglb::PRONTUS_ID$prontus_varglb::DIR_SITE";
    $prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'DIR_DBM'} = "/$prontus_varglb::PRONTUS_ID$prontus_varglb::DIR_PATH_CPAN/data";
    $prontus_varglb::CONFIG{$prontus_varglb::PRONTUS_ID}{'DIR_CPAN'}  = "/$prontus_varglb::PRONTUS_ID$prontus_varglb::DIR_PATH_CPAN";

    $pagina =~ s/%%accion%%/Probando escritura y eliminación de archivos en $prontus_varglb::PRONTUS_ID :/gi;
    my $tmp_result = lib_platform::check_write();
    $pagina =~ s/%%resultados%%/$tmp_result/gi;
    $pagina =~ s/%%linea_check_error%%.*%%\/linea_check_error%%//gis;

    # Si la invocacion vino del wizard es porque el dir prontus no existia
    # y lo tuve q crear para el test asi q ahora lo borro.
    if ($PRONTUS_DIR_CREADO_POR_CGI) {
        glib_fildir_03::borra_dir("$prontus_varglb::DIR_SERVER/$prontus_varglb::PRONTUS_ID");
        if (-d "$prontus_varglb::DIR_SERVER/$prontus_varglb::PRONTUS_ID") {
            lib_platform::salir("Error: no fue posible eliminar directorio $prontus_varglb::PRONTUS_ID");
        }
    }

    # restablece valor de purge original
    $lib_prontus::DISABLE_PURGE_CACHE = $purge;

    lib_utils::print_html($pagina);
}
