#!/usr/bin/perl

# ---------------------------------------------------------------
# Prontus CMS
# http://www.prontus.cl
# by Altavoz.net
#
# licensed under LGPL license.
# http://www.prontus.cl/license.html
# ---------------------------------------------------------------
use strict;
use utf8;

BEGIN {
    use FindBin qw($Bin);
    my $pathLibsProntus = $Bin;
    unshift(@INC,$pathLibsProntus);
    $pathLibsProntus =~ s/\/[^\/]+$//;
    unshift(@INC,$pathLibsProntus); # Para dejar disponibles las librerias de prontus
}

##libs##
use lib_stdlog;
lib_stdlog::set_stdlog($0, 51200);
use prontus_varglb;
prontus_varglb::init();

use File::Copy;
use JSON;
use glib_cgi_05;
use glib_fildir_03;
use glib_html_03;
use lib_lang;
use lib_utils;
##/libs##

main: {
    lib_utils::setUp();
    glib_cgi_05::new();
    my $prontus_id = glib_cgi_05::param('_prontus_id');
    my $path_prontus = "$prontus_varglb::DIR_SERVER/$prontus_id";
    my $resp;

    $resp->{'status'} = 1;
    $resp->{'msg'} = "";

    if (-d $path_prontus) {
        $resp->{'status'} = 0;
        $resp->{'msg'} = lib_lang::get_message("wizard_check_instancia_prontus_exists");
    }

    glib_html_03::print_json_result_hash($resp);
}
