#!/usr/bin/perl

# --------------------------------------------------------------
# Prontus CMS
# http://www.prontus.cl
# by Altavoz.net
#
# licensed under LGPL license.
# http://www.prontus.cl/license.html
# --------------------------------------------------------------

# Realiza una revision en el sistema para ver si los modulos perl
# requeridos por Prontus estan presentes.

use strict;
use utf8;

BEGIN {
    use FindBin qw($Bin);
    my $pathLibsProntus = $Bin;
    unshift(@INC,$pathLibsProntus);
    $pathLibsProntus =~ s/\/[^\/]+$//;
    unshift(@INC,$pathLibsProntus);
}

##libs##
use lib_stdlog;
lib_stdlog::set_stdlog($0, 51200);
use prontus_varglb;
prontus_varglb::init();

use JSON;
use glib_fildir_03;
use glib_str_03;
use lib_lang;
use lib_parser;
use lib_platform;
use lib_utils;
##/libs##

main: {
    lib_utils::setUp();

    my $pagina = lib_utils::load_cpan_core_plt("core/prontus_check_platform.html");
    $pagina = lib_utils::set_coreplt_ppal_simple($pagina);

    my $ambiente_web = 1;
    $pagina = lib_platform::check_perl($pagina);
    $pagina = lib_platform::check_unzip($ambiente_web, $pagina);
    $pagina = lib_platform::check_modules($ambiente_web, $pagina);
    $pagina = lib_platform::check_ffmpeg($ambiente_web, $pagina);

    my $version = $prontus_varglb::RAMA_INSTALADA;
    $version =~ s/\./_/;
    my $url_manual_desa = $prontus_varglb::URL_MANUAL . '/prontus_desarrollo_v' . $version;
    $pagina =~ s/%%url_manual_desa%%/$url_manual_desa/ig;

    lib_utils::print_html($pagina);
}
