#!/usr/bin/perl

# ---------------------------------------------------------------
# Prontus CMS
# http://www.prontus.cl
# by Altavoz.net
#
# licensed under LGPL license.
# http://www.prontus.cl/license.html
# ---------------------------------------------------------------
use strict;
use utf8;

BEGIN {
    use FindBin qw($Bin);
    my $pathLibsProntus = $Bin;
    unshift(@INC,$pathLibsProntus);
    $pathLibsProntus =~ s/\/[^\/]+$//;
    unshift(@INC,$pathLibsProntus); # Para dejar disponibles las librerias de prontus
}

##libs##
use lib_stdlog;
lib_stdlog::set_stdlog($0, 51200);
use prontus_varglb;
prontus_varglb::init();

use File::Copy;
use HTTP::Request;
use JSON;
use LWP::UserAgent;
use glib_cgi_05;
use glib_fildir_03;
use glib_hrfec_03;
use glib_html_03;
use lib_lang;
use lib_prontus;
use lib_utils;
use wizard_lib;
##/libs##

# borra un modelo descargado.
main:{
    lib_utils::setUp();
    glib_cgi_05::new();
    my $modelid = glib_cgi_05::param('modelid');

    # Valida que el modelo exista
    if (!&wizard_lib::backup_model($modelid)) {
        my $resp;

        $resp->{'status'} = 0;
        $resp->{'msg'} = lib_lang::get_message("wizard_models_delete_could_not_backup");

        glib_html_03::print_json_result_hash($resp);
    }

    # Chequea modelo online
    my $nodisponible = 0;
    my $urlCFG = "$wizard_lib::URL_MODELS/$modelid/$modelid.cfg";

    lib_stdlog::print_err(lib_lang::get_interpolated_message("wizard_models_delete_checking", $urlCFG));

    my ($buffercfg, $msg_err) = lib_prontus::get_url($urlCFG, 30);

    if ($msg_err || $buffercfg eq '') {
        lib_stdlog::print_err(lib_lang::get_interpolated_message("wizard_models_delete_config_not_found", "$wizard_lib::URL_MODELS/$modelid/$modelid.cfg"));
        $nodisponible = 1;
    }

    my $dirmodel = "$prontus_varglb::DIR_SERVER$wizard_lib::MODELS_DIR/$modelid";
    lib_stdlog::print_err(lib_lang::get_interpolated_message("wizard_models_delete_deleting", $dirmodel));
    glib_fildir_03::borra_dir($dirmodel);

    my $resp;

    $resp->{'status'} = 1;
    $resp->{'msg'} = '';
    $resp->{'nodisponible'} = $nodisponible;

    glib_html_03::print_json_result_hash($resp);
}
