#!/usr/bin/perl

# ---------------------------------------------------------------
# Prontus CMS
# http://www.prontus.cl
# by Altavoz.net
#
# licensed under LGPL license.
# http://www.prontus.cl/license.html
# ---------------------------------------------------------------
use strict;
use utf8;

BEGIN {
    use FindBin qw($Bin);
    my $pathLibsProntus = $Bin;
    unshift(@INC,$pathLibsProntus);
    $pathLibsProntus =~ s/\/[^\/]+$//;
    unshift(@INC,$pathLibsProntus); # Para dejar disponibles las librerias de prontus
}

##libs##
use lib_stdlog;
lib_stdlog::set_stdlog($0, 51200);
use prontus_varglb;
prontus_varglb::init();

use File::Copy;
use HTTP::Request;
use JSON;
use LWP::UserAgent;
use glib_cgi_05;
use glib_fildir_03;
use glib_hrfec_03;
use glib_html_03;
use lib_lang;
use lib_prontus;
use lib_utils;
use wizard_lib;
##/libs##

main:{
    lib_utils::setUp();
    glib_cgi_05::new();
    my $modelid = glib_cgi_05::param('modelid');
    my $res = qx/ps auxww |grep 'wizard_models_download_real.cgi '|grep -v grep/; # con un espacio, para no confundir con tail de error log.

    if ($res ne '') {
        my $resp;

        $resp->{'status'} = 0;
        $resp->{'msg'} = lib_lang::get_message('wizard_models_download_wait');

        glib_html_03::print_json_result_hash($resp);
    }

    # Se chequea si existe el modelo online
    my $nodisponible = 0;
    my $urlCFG = "$wizard_lib::URL_MODELS/$modelid/$modelid.cfg";
    my ($buffercfg, $msg_err) = lib_prontus::get_url($urlCFG, 30);

    lib_stdlog::print_err(lib_lang::get_interpolated_message("wizard_models_download_checking", $urlCFG));

    if ($msg_err || $buffercfg eq '') {
        my $resp;

        $resp->{'status'} = 0;
        $resp->{'msg'} = "CFG de modelo no encontrado o invalido [$wizard_lib::URL_MODELS/$modelid/$modelid.cfg]\n";

        lib_stdlog::print_err($resp->{'msg'});

        glib_html_03::print_json_result_hash($resp);
    }

    # En el caso que no exista el directorio de los modelos
    glib_fildir_03::check_dir("$prontus_varglb::DIR_SERVER$wizard_lib::MODELS_DIR");

    # Se respalda el modelo si es que existe.
    my $dirmodel = "$prontus_varglb::DIR_SERVER$wizard_lib::MODELS_DIR/$modelid";

    if (-d $dirmodel) {
        if (! &wizard_lib::backup_model($modelid)) {
            my $resp;

            $resp->{'status'} = 0;
            $resp->{'msg'} = lib_lang::get_message("wizard_models_delete_could_not_backup");

            glib_html_03::print_json_result_hash($resp);
        }
    }

    my $STATUS_FILE = "$prontus_varglb::DIR_SERVER/$wizard_lib::INF_DIR/progress.txt";
    glib_fildir_03::write_file($STATUS_FILE, 0);

    my $cmd = "/usr/bin/perl $prontus_varglb::DIR_SERVER/$prontus_varglb::DIR_CGI_CPAN/wizard/wizard_models_download_real.pl $modelid >/dev/null 2>&1 &";

    lib_stdlog::print_err("cmd[$cmd]\n");

    system ($cmd);

    my $resp;

    $resp->{'status'} = 1;
    $resp->{'msg'} = '';

    glib_html_03::print_json_result_hash($resp);
}
