#!/usr/bin/perl

# ---------------------------------------------------------------
# Prontus CMS
# http://www.prontus.cl
# by Altavoz.net
#
# licensed under LGPL license.
# http://www.prontus.cl/license.html
# ---------------------------------------------------------------
use strict;
use utf8;

BEGIN {
    use FindBin qw($Bin);
    my $pathLibsProntus = $Bin;
    unshift(@INC,$pathLibsProntus);
    $pathLibsProntus =~ s/\/[^\/]+$//;
    unshift(@INC,$pathLibsProntus); # Para dejar disponibles las librerias de prontus
}

##libs##
use lib_stdlog;
lib_stdlog::set_stdlog($0, 51200);
use prontus_varglb;
prontus_varglb::init();

use File::Copy;
use JSON;
use Time::HiRes;
use glib_cgi_05;
use glib_fildir_03;
use glib_html_03;
use lib_lang;
use lib_utils;
use wizard_lib;
##/libs##

main:{
    lib_utils::setUp();
    glib_cgi_05::new();
    my $type = glib_cgi_05::param('type');
    my $res = qx/ps auxww |grep 'wizard_models_download_real.pl '|grep -v grep/;
    my $resp;

    my $STATUS_FILE = "$prontus_varglb::DIR_SERVER/" . wizard_lib::get_inf_dir() ."/progress.txt";
    if ($res ne '') {
        $resp->{'status'} = 1; # ocupado.
        $resp->{'msg'} = '';

        if (-s $STATUS_FILE) {
            my $progress = '';

            for (my $i = 0; $i < 5; $i++) {
                $progress = glib_fildir_03::read_file($STATUS_FILE);

                if ($progress ne ''){
                    last;
                }

                Time::HiRes::usleep(50000);
            }

            if ($progress eq '100') {
                if ($type eq 'update') {
                    $resp->{'msg'} = lib_lang::get_message("wizard_updating_label");
                } else {
                    $resp->{'msg'} = lib_lang::get_message("wizard_installing_label");
                }
            } elsif ($progress =~ /(\d+)/) {
                $resp->{'msg'} = lib_lang::get_interpolated_message("wizard_downloading_label", $1);
            } else {
                $resp->{'status'} = 0; # error.
                $resp->{'msg'} = $progress;
            }
        }
    } else {
        $resp->{'status'} = 2; # disponible.
        $resp->{'msg'} = '';

        if (-f $STATUS_FILE) {
            my $progress = '';

            for (my $i = 0; $i < 5; $i++) {
                $progress = glib_fildir_03::read_file($STATUS_FILE);

                if ($progress ne ''){
                    last;
                }

                Time::HiRes::usleep(50000);
            }

            if ($progress !~ /(\d+)/) {
                $resp->{'status'} = 0; # error.
                $resp->{'msg'} = $progress;
            }

            unlink $STATUS_FILE;
        }
    }

    glib_html_03::print_json_result_hash($resp);
}
