<?php
define('PRONTUS', true);
/**
 * Invoca la API Graph para hacer un post a Facebook.
 * Este script debe correr por CLI para funcionar.
*/
###################################
if (sizeof($argv) < 2) {
    exit;
}

# Capturo los argumentos
$file_url = $argv[1]; // la friendly url relativa
$bajada_fb = base64_decode($argv[2]); // el mensaje
$imagen_fb = base64_decode($argv[3]); // la imagen eventual
$prontus_id = $argv[4]; // usado dentro de config.php
$protocol = $argv[5]; // protocolo de la url
$server_name = $argv[6]; // dominio del sitio
$document_root = $argv[7]; // usado dentro de config.php

# Archivo de configuracion
require_once dirname(__FILE__) . '/config.php';

# Libreria SDK Facebook
require_once dirname(__FILE__) . '/php-graph-sdk-5.7.0/src/Facebook/autoload.php';

# Clase
use Facebook\FacebookRequest;

###################################

# Obtengo el nombre del usuario mediante el cual posteo en la página.
$page_id = PAGE_ID;
$account_access_token = ACCESS_TOKEN;
$url_accounts = "https://graph.facebook.com/me/?access_token=".$account_access_token;
$buffer = file_get_contents($url_accounts);
$jsonArray = json_decode($buffer, true);
$account_name = $jsonArray['name'];

$file_url = $protocol.'://' . $server_name . $file_url;

# Crear el objeto
$fb = new Facebook\Facebook(array(
    'app_id' => APP_ID,
    'app_secret' => APP_SECRET,
    'default_graph_version' => 'v6.0'
));

$api_resp = '';
$msg_err = '';

# Intenta postear en facebook
try {
    # Toma el accessToken del config.php
    $accessToken = ACCESS_TOKEN;
    # Crea el arreglo con los datos del post
    $linkData = [
        'link' => $file_url,
        //'name => $titular_fb, # deprecated
        'message' => $bajada_fb,
        //'description' => $bajada_fb, # deprecated
    ];

    // publicar la imagen no funciona desde sitios locales, debe hacerse desde un ambiente abierto a la internet.
    if ($imagen_fb != 'none') {
        $linkData['full_picture'] = $protocol.'://' . $server_name . $imagen_fb;
    }
    # Obtiene el Objeto respuesta del post.
    $obj = $fb->post("/$page_id/feed", $linkData, $accessToken);
    # Obtener el decodedBody, que tiene el ID compuesto
    $array_response = $obj->getDecodedBody();
    /**
     * array_response: Array
     * (
     *    [id] => 280702052520649_391603008097219
     * )
     */
    # Obtener solo el campo id compuesto
    $api_resp = $array_response['id'];

    $content = '';

    if ($api_resp != '') {
        $api_resp_arr = explode("_", $api_resp);
        $content = 'El status de Facebook (' . $account_name . ') ha sido Actualizado, ID del post creado: ' . $api_resp_arr[1];
        $response = array('status'=>1, 'msg'=>$content, 'time'=>date('d/m/Y h:i:s'));
    } else {
        $content = 'Ocurrió un error al publicar en el muro: ' . $msg_error;
        $response = array('status'=>0, 'msg'=> $content, 'time'=>date('d/m/Y h:i:s'));
    }

    echo json_encode($response);
} catch (Facebook\Exceptions\FacebookResponseException $e) {
    # When Graph returns an error
    $msg_error = 'Graph returned an error: ' . $e->getMessage();
    echo json_encode(array('status'=>0, 'msg'=>$msg_error, 'time'=>date('d/m/Y h:i:s'), 'img'=>$imagen_fb));
} catch (Facebook\Exceptions\FacebookSDKException $e) {
    # When validation fails or other local issues
    $msg_error = 'Facebook SDK returned an error: ' . $e->getMessage();
    echo json_encode(array('status'=>0, 'msg'=>$msg_error, 'time'=>date('d/m/Y h:i:s')));
}
