var Captcha = {

    nameCGI: 'prontus_captcha.cgi',
    defaultImageWidth: '130',
    defaultImageHeight: '45',
    refreshingCaptcha: false,

    properties: {
        type: '',
        pathCGI: 'cgi-cpn',
        idContent: '#prontus_captcha_content'
    },

    generate: function(prop) {
        if (typeof jQuery === 'undefined') {
            showModalAlert({
                title: ProntusL10n.get('global_error_title'),
                type: 'red',
                msg: ProntusL10n.get('captcha_msg_system')
            });
            return;
        }
        if (typeof prop === 'undefined') {
            prop = {};
        }
        $.extend(Captcha.properties, prop);

        if (Captcha.properties.type) {

            $.ajax({
                url: '/'+Captcha.properties.pathCGI+'/'+Captcha.nameCGI,
                data: {_type: Captcha.properties.type, _captcha_length:8},
                dataType: 'json',
                error: function(jqXHR, textStatus, errorThrown) {
                    console.error(jqXHR, textStatus, errorThrown);
                    showModalAlert({
                        title: ProntusL10n.get('global_error_title'),
                        type: 'red',
                        msg: ProntusL10n.get('captcha_msg_cgi')
                    });
                },
                success: function(data) {
                    if(typeof data !== 'undefined') {
                        if(data.msg == 'captcha_ok') {
                            var relpathimg = data.path + data.img;
                            var imagen = '<img src="'+relpathimg+'" alt="captcha" width="'+Captcha.defaultImageWidth+'" height="'+Captcha.defaultImageHeight+'" />';
                            var input1 = '<input type="hidden" name="_captcha_img" value="'+data.img+'"/>';
                            var input2 = '<input type="hidden" name="_captcha_code" value="'+data.code+'"/>';
                            $(Captcha.properties.idContent).html(imagen+"\n"+input1+"\n"+input2);
                        } else if(typeof data.msg === 'undefined') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: 'red',
                                msg: ProntusL10n.get('captcha_msg_cgi')
                            });

                        } else {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: 'red',
                                msg: data.msg
                            });
                        }
                    }
                }
            });
        } else {
            showModalAlert({
                title: ProntusL10n.get('global_error_title'),
                type: 'red',
                msg: ProntusL10n.get('captcha_msg_type')
            });
            return;
        }
    },

    // -------------------------------------------------------------------------
    // Si onlyTypes se evalua como verdadero, en vez de imprimir el contenido de
    // los atributos, se imprime solo el tipo.
    setRefreshCaptcha: function() {
        setTimeout(function() {
            var imagen = $(Captcha.properties.idContent).find('img').attr('src');
            $.ajax({
                url: imagen,
                type: 'HEAD',
                cache: false,
                error: function() {
                    Captcha.generate();
                },
                success: function() {
                    Captcha.setRefreshCaptcha();
                }
            });
        }, 250);
    }
};
