// Editor de FIDs
(function (window) {
    var _self = null;
    var EditorFid = {
        debug: 0,
        validEvents: ['click', 'hover'],
        config: {
            name: '',
            filename: '',
            plt: '',
            fid_no_editable: 0,
            panels: [],
            fields: []
        },
        lastPanelId: 0,
        lastFieldId: 0,
        lastTabsId: 0,
        isNew: false,
        init: function () {
            _self = this;
            _self.methods.initFid();
            _self.methods.bindEvents();

            $('#edit_fid').off('change').on('change', function () {
                _self.methods.initFid();
                _self.methods.bindEvents();
            });
        },
        actions: {
            generarPlantilla: function() {
                showModalConfirm({
                    msg: ProntusL10n.get('fid_editor_save_confirm'),
                    type: 'red',
                    icon: "glyphicon glyphicon-question-sign",
                    btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                    okTitle: ProntusL10n.get('fid_editor_save_ok'),
                    cbBtnOK: function () {
                        var json = JSON.stringify(_self.config);
                        $.ajax({
                            url: "/{0}/prontus_fid_guardar_plantilla.cgi".format(Admin.dir_cgi_cpn),
                            data: {
                                _prontus_id: Admin.prontus_id,
                                accion: 'guardar_plantilla',
                                filename: _self.config.filename,
                                json: json,
                                plt: _self.config.plt
                            },
                            dataType: 'json',
                            type: 'POST',
                            success: function (response) {
                                if (response.status == 1) {
                                    $('#edit_fid option[value="' + _self.config.filename + '"]').remove();
                                    $('#edit_fid').change();

                                    _self.methods.initFid();
                                    window.location.reload(true);
                                } else {
                                    showModalAlert({
                                        title: ProntusL10n.get('admin_error'),
                                        msg: response.msg,
                                        type: "red",
                                        icon: "glyphicon glyphicon-exclamation-sign",
                                        cbBtnOK: function () {}
                                    });
                                }
                            },
                            error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                                showModalAlert({
                                    title: ProntusL10n.get('admin_error'),
                                    msg: ProntusL10n.get('fid_editor_save_error', errorThrown),
                                    type: "red",
                                    icon: "glyphicon glyphicon-exclamation-sign",
                                    cbBtnOK: function () {}
                                });
                            }
                        });
                    },
                    cbBtnCancel: function () {
                    }
                });
                return;
            },
            getFidJson: function (filename, callback) {
                _self.ui.showLoading();
                $.ajax({
                    url: "/{0}/prontus_fid_get_config.cgi".format(Admin.dir_cgi_cpn),
                    data: {
                        _prontus_id: Admin.prontus_id,
                        filename: filename
                    },
                    dataType: 'json',
                    success: function (response) {
                        if (response.status == 1) {
                            _self.ui.hideLoading();
                            if (typeof callback == 'function') {
                                callback(response.config);
                                _self.ui.enableCmbPanels();
                            }
                        } else {
                            _self.ui.hideLoading();
                            showModalAlert({
                                title: ProntusL10n.get('admin_error'),
                                msg: ProntusL10n.get('fid_editor_no_fid_config', response.msg),
                                type: "red",
                                icon: "glyphicon glyphicon-exclamation-sign",
                                cbBtnOK: function () {}
                            });
                        }
                    },
                    error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                        _self.ui.hideLoading();
                        showModalAlert({
                            title: ProntusL10n.get('admin_error'),
                            msg: ProntusL10n.get('fid_editor_no_fid_config', errorThrown),
                            type: "red",
                            icon: "glyphicon glyphicon-exclamation-sign",
                            cbBtnOK: function () {}
                        });
                    }
                });
            },
            guardarFidJson: function () {
                if (_self.config.panels.length > 0 && _self.config.filename != '') {
                    var json = JSON.stringify(_self.config);
                    _self.ui.showLoading();
                    $.ajax({
                        url: "/{0}/prontus_fid_guardar_json.cgi".format(Admin.dir_cgi_cpn),
                        data: {
                            _prontus_id: Admin.prontus_id,
                            json: json,
                            filename: _self.config.filename
                        },
                        dataType: 'json',
                        type: 'POST',
                        success: function (response) {
                            if (response.status == 1) {
                                _self.ui.hideAlert();
                                _self.ui.hideLoading();
                            } else {
                                _self.ui.hideLoading();
                                _self.actions.agregarNuevoFid();
                            }
                            _self.ui.enableCmbPanels();
                        },
                        error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                            _self.ui.hideLoading();
                            showModalAlert({
                                title: ProntusL10n.get('admin_error'),
                                msg: ProntusL10n.get('fid_editor_cant_save', errorThrown),
                                type: "red",
                                icon: "glyphicon glyphicon-exclamation-sign",
                                cbBtnOK: function () {}
                            });
                        }
                    })
                } else {
                    if (!_self.isNew) {
                        _self.ui.hideLoading();
                        showModalAlert({
                            title: ProntusL10n.get('fid_editor_empty_title'),
                            msg: ProntusL10n.get('fid_editor_empty_msg'),
                            type: "red",
                            icon: "glyphicon glyphicon-exclamation-sign",
                            cbBtnOK: function () {}
                        });
                    }
                }
            },
            agregarNuevoFid: function (datos) {
                _self.helper.log('agregarNuevoFid');

                if (typeof datos == 'undefined') {
                    datos = {};
                }
                // vaciamos la config para empezar con FID vacío.
                _self.config = {panels: [], fields: []};
                _self.ui.setModal({
                    title: ProntusL10n.get('fid_editor_new'),
                    templateId: 'fid',
                    saveMethod: 'actions.guardarNuevoFid',
                    saveButtonName: ProntusL10n.get('global_save_label'),
                    show: true
                }, datos);
                // solo mostramos el div para marcar un fid como no editable al actualizarlo.
                $('#div-fid-editable').remove();
            },
            editarFid: function () {
                _self.helper.log('editarFid');

                if (_self.config.filename) {
                    _self.ui.setModal({
                        title: ProntusL10n.get('fid_editor_edit'),
                        templateId: 'fid',
                        saveMethod: 'actions.actualizarFid',
                        saveButtonName: ProntusL10n.get('global_save_label'),
                        show: true
                    }, {
                        nombre: _self.config.name,
                        archivo: _self.config.filename,
                        plantilla: _self.config.plt,
                        fid_no_editable: _self.config.fid_no_editable
                    });
                    $('#mensaje-crear-editar-fid').html(ProntusL10n.get('fid_editor_edit_msg'));
                    $('#div-fid-editable').on('change', '#fid_no_editable', function() {
                        _self.config.fid_no_editable = $('#fid_no_editable').prop('checked') ? 1 : 0;
                    });
                }
            },
            guardarNuevoFid: function () {
                // console.log('guardarNuevoFid');
                var fid_nombre = $('#fid_nombre').val();
                var fid_archivo = $('#fid_archivo').val();
                var fid_plantilla = $('#fid_plantilla').val();

                $.ajax({
                    url: "/{0}/prontus_fid_guardar.cgi".format(Admin.dir_cgi_cpn),
                    data: {
                        _prontus_id: Admin.prontus_id,
                        accion: 'guardar',
                        fid_nombre: fid_nombre,
                        fid_plantilla: fid_plantilla,
                        fid_archivo: fid_archivo
                    },
                    dataType: 'json',
                    type: 'POST',
                    success: function (response) {

                        if (response.status == 1) {
                            if (fid_archivo.substring(0, 4) != 'fid_') {
                                fid_archivo = 'fid_' + fid_archivo;
                            }
                            _self.config.name = fid_nombre;
                            _self.config.plt = response.plantilla;
                            _self.config.filename = fid_archivo;

                            // Si es nuevo, guardar el JSON para generar los archivos.
                            if (_self.isNew) {
                                // console.log('isNew');
                                _self.actions.guardarFidJson();
                                _self.isNew = false;
                                _self.ui.enableCmbPanels();
                            }

                            // Agregarlo a la lista y cargarlo.
                            var name = fid_nombre + ' (' + fid_archivo + ')';
                            $('#edit_fid').append('<option value="' + fid_archivo + '">' + name + '</option>');
                            $('#edit_fid').val(fid_archivo);

                            $('#fid_plantilla').val(response.plantilla);

                            _self.methods.initFid();
                            _self.ui.hideModal();
                        } else {
                            showModalAlert({
                                title: ProntusL10n.get('admin_error'),
                                msg: response.msg,
                                type: "red",
                                icon: "glyphicon glyphicon-exclamation-sign",
                                cbBtnOK: function () {}
                            });
                        }
                    },
                    error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                        showModalAlert({
                            title: ProntusL10n.get('admin_error'),
                            msg: ProntusL10n.get('fid_editor_cant_save', errorThrown),
                            type: "red",
                            icon: "glyphicon glyphicon-exclamation-sign",
                            cbBtnOK: function () {}
                        });
                    }
                });
            },
            actualizarFid: function () {
                var fid_nombre = $('#fid_nombre').val();
                var fid_archivo = _self.config.filename; // el fid no se cambia.
                var fid_plantilla = $('#fid_plantilla').val();
                var fid_no_editable = $('#fid_no_editable').prop('checked') ? 1 : 0;

                $.ajax({
                    url: "/{0}/prontus_fid_guardar.cgi".format(Admin.dir_cgi_cpn),
                    data: {
                        _prontus_id: Admin.prontus_id,
                        accion: 'actualizar',
                        fid_nombre: fid_nombre,
                        fid_plantilla: fid_plantilla,
                        fid_archivo: fid_archivo,
                        fid_no_editable: fid_no_editable
                    },
                    dataType: 'json',
                    type: 'POST',
                    success: function (response) {
                        _self.ui.hideAlert();
                        _self.ui.hideLoading();
                        if (response.refresh == 1) {
                            window.location.reload(true);
                        }

                        if (response.status == 1) {
                            // Agregarlo a la lista y cargarlo.
                            var name = fid_nombre + '(' + fid_archivo + ')';
                            $('#edit_fid option[value="' + fid_archivo + '"]').text(name);

                            _self.config.name = fid_nombre;
                            _self.config.plt = response.plantilla;
                            $('#fid_plantilla').val(response.plantilla);
                            _self.ui.hideModal();
                            _self.ui.enableCmbPanels();
                        } else {
                            showModalAlert({
                                title: ProntusL10n.get('admin_error'),
                                msg: response.msg,
                                type: "red",
                                icon: "glyphicon glyphicon-exclamation-sign",
                                cbBtnOK: function () {}
                            });
                        }
                    },
                    error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                        _self.ui.hideLoading();
                        showModalAlert({
                            title: ProntusL10n.get('admin_error'),
                            msg: ProntusL10n.get('fid_editor_cant_save', errorThrown),
                            type: "red",
                            icon: "glyphicon glyphicon-exclamation-sign",
                            cbBtnOK: function () {}
                        });
                    }
                });
            },
            borrarFid: function (_file) {
                if (_self.config.filename) {
                    showModalConfirm({
                        msg: ProntusL10n.get('fid_editor_delete_msg'),
                        type: 'red',
                        icon: "glyphicon glyphicon-question-sign",
                        btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                        okTitle: ProntusL10n.get('fid_editor_delete_ok'),
                        cbBtnOK: function () {
                            $.ajax({
                                url: "/{0}/prontus_fid_guardar.cgi".format(Admin.dir_cgi_cpn),
                                data: {
                                    _prontus_id: Admin.prontus_id,
                                    accion: 'borrar',
                                    fid_archivo: _self.config.filename
                                },
                                dataType: 'json',
                                type: 'POST',
                                success: function (response) {
                                    if (response.status == 1) {
                                        $('#edit_fid option[value="' + _self.config.filename + '"]').remove();
                                        $('#edit_fid').change();

                                        // si no quedan FIDs, bloqueamos el drag & drop de los inputs y paneles.
                                        if ($('edit fid option').length == 0) {
                                            _self.ui.disableCmbPanels();
                                            _self.config = {};
                                            _self.config.panels = [];
                                            _self.config.fields = [];
                                        }
                                        _self.methods.initFid();
                                    } else {
                                        showModalAlert({
                                            title: ProntusL10n.get('admin_error'),
                                            msg: response.msg,
                                            type: "red",
                                            icon: "glyphicon glyphicon-exclamation-sign",
                                            cbBtnOK: function () {}
                                        });
                                    }
                                },
                                error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                                    showModalAlert({
                                        title: ProntusL10n.get('admin_error'),
                                        msg: ProntusL10n.get('fid_editor_cant_save', errorThrown),
                                        type: "red",
                                        icon: "glyphicon glyphicon-exclamation-sign",
                                        cbBtnOK: function () {}
                                    });
                                }
                            });
                        },
                        cbBtnCancel: function () {}
                    });
                }
            }
        },
        fields: {
            currentFieldId: false,
            currentPanelId: false,
            uniqueFieldType: [
                'tax',
                'taxmanual',
                'tags',
                'multitags',
                'bajada',
                'cuerpo',
                'autor',
                'galeria'
            ],
            panel: {
                actions: {
                    save: function () {
                        // Validacion.
                        if (!_self.fields.panel.actions.validate()) return false;

                        var panelName = $('#fid_panel_nombre').val();
                        var panelContentHtml = _self.ui.getPanelContent(panelName);

                        $('#panel' + _self.fields.currentPanelId).html(panelContentHtml);

                        var parentId = $('#panel' + _self.fields.currentPanelId).attr("data-parent");

                        // Iniciar sortable en el panel agregado para arrastrar y ordenar componentes
                        _self.ui.installPanelSortable(_self.fields.currentPanelId);

                        // Reinstall tabs sortable.
                        for (var x = 0; x < _self.config.panels.length; x++) {
                            var panel = _self.config.panels[x];

                            // Reinicia sortble de tabs para evitar glitch.
                            if (panel.type == 'tabs') {
                                _self.ui.installFidStructureSortable('#panel' + panel.id + ' .panel-tabs', panel.id);
                            }
                        }

                        // Reinicia sortable principal para evitar glitch.
                        _self.ui.installFidStructureSortable('#fid-structure');

                        // Actualizar listado de panels.
                        _self.fields.addPanelToArray({
                            id: _self.fields.currentPanelId,
                            name: panelName,
                            type: 'panel',
                            parentId: parentId,
                            order: $('#panel' + _self.fields.currentPanelId).index()
                        });

                        _self.methods.bindEvents(true, '#panel' + _self.fields.currentPanelId);

                        // Actualizar orden.
                        _self.fields.panel.methods.updatePanelsOrder();

                        // Limpiar modal.
                        $('#fid_panel_nombre').val('');
                        _self.ui.hideModal();
                        _self.fields.currentPanelId = false;
                    },
                    cancel: function () {
                        // Quitar el panel
                        _self.ui.hideModal();
                        $('#fid_panel_nombre').val('');
                        $('#panel' + _self.fields.currentPanelId).remove();
                        _self.fields.currentPanelId = false;
                    },
                    update: function (_ui) {
                        var panelId = $('#fid_field_id').val();
                        var panelArrayIndex = _self.fields.getPanelArrayIndex(panelId);

                        // Validacion.
                        if (!_self.fields.panel.actions.validate()) return false;

                        var panelName = $('#fid_panel_nombre').val();

                        $('#panel' + panelId + ' .panel-name').text(panelName);

                        _self.methods.bindEvents(true, '#panel' + panelId);

                        _self.fields.updatePanelInArray({
                            name: panelName,
                        }, panelArrayIndex);

                        _self.methods.limpiarInputs('panel');
                        _self.ui.hideModal();

                        _self.ui.showAlert();
                    },
                    remove: function (ui) {
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_panel_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_panel_ok'),
                            cbBtnOK: function () {
                                var panelId = ui.helper.parents('.panel-container').attr('data-id');
                                // Eliminar campos del panel.
                                _self.fields.delFieldsFromPanel(panelId);
                                // Eliminar panel
                                _self.fields.delPanelFromArray(panelId);
                                $('#panel' + panelId).remove();
                                _self.fields.panel.methods.updatePanelsOrder();
                            },
                            cbBtnCancel: function () {}
                        });
                    },
                    edit: function (ui) {
                        var panelId = ui.helper.parents('.panel-container').attr('data-id');
                        var fieldData = _self.fields.getPanelFromArray(panelId);

                        _self.ui.setModal({
                            title: ProntusL10n.get('fid_editor_edit_panel'),
                            description: ProntusL10n.get('fid_editor_configure_panel_help'),
                            templateId: 'panel',
                            closeMethod: 'fields.panel.actions.cancel',
                            saveMethod: 'fields.panel.actions.update',
                            show: true
                        }, {
                            panel_nombre: fieldData.name,
                            field_id: panelId
                        });
                    },
                    validate: function () {
                        var panelName = $('#fid_panel_nombre').val();
                        var rgxp = /^[\w_\- ]+$/;

                        if (panelName == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_panel_name_required')
                            });

                            return false;
                        } else if (!rgxp.test(panelName)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_panel_name_alpha')
                            });

                            return false;
                        }

                        return true;
                    }
                },
                methods: {
                    updateFieldsOrder: function (panelId) {
                        $('#panel' + panelId + ' .panel-fields').find('.field-container').each(function (index, value) {
                            var id = $(value).attr("data-id");

                            _self.helper.log('panel ' + panelId + ': updateOrder');

                            for (var x = 0; x < _self.config.fields.length; x++) {
                                if (_self.config.fields[x].id == id) {
                                    _self.config.fields[x].order = index;
                                }
                            }
                        });
                    },
                    updatePanelsOrder: function () {
                        $('#fid-structure .panel-container').each(function (index, value) {
                            var id = $(value).attr("data-id");
                            _self.helper.log('updatePanelsOrder: ' + id);

                            for (var x = 0; x < _self.config.panels.length; x++) {
                                if (_self.config.panels[x].id == id) {
                                    _self.config.panels[x].order = index;
                                }
                            }
                        });
                    }
                }
            },
            input: {
                actions: {
                    save: function () {
                        // Validacion.
                        if (!_self.fields.input.actions.validate()) return false;

                        var type = 'input';
                        var nombreInput = $('#fid_input_nombre').val();
                        var marcaInput = $('#fid_input_marca').val();
                        var clasesInput = $('#fid_input_clases').val();
                        var fieldContent = _self.ui.getInputContent(nombreInput, marcaInput, clasesInput);

                        $('#field' + _self.fields.currentFieldId).html(fieldContent);

                        var panelId = $('#field' + _self.fields.currentFieldId).parents('.panel-container').attr("data-id");

                        _self.fields.addFieldToArray({
                            id: _self.fields.currentFieldId,
                            panelId: panelId,
                            name: nombreInput,
                            placeholder: marcaInput,
                            clases: clasesInput,
                            type: type,
                            order: $('#field' + _self.fields.currentFieldId).index()
                        });

                        _self.methods.bindEvents(true, '#field' + _self.fields.currentFieldId);

                        // Actualizar orden.
                        _self.fields.panel.methods.updateFieldsOrder(panelId);

                        // Limpiar modal.
                        _self.methods.limpiarInputs('input');
                        _self.ui.hideModal();
                        _self.fields.currentFieldId = false;
                    },
                    cancel: function () {
                        _self.ui.hideModal();
                        _self.methods.limpiarInputs('input');
                        $('#field' + _self.fields.currentFieldId).remove();

                        _self.fields.currentFieldId = false;
                    },
                    remove: function (ui) {
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_field_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_field_ok'),
                            cbBtnOK: function () {
                                var fieldId = ui.helper.parents('.field-container').attr('data-id');
                                // Eliminar del arreglo.
                                _self.fields.delFieldFromArray('', fieldId);
                                // Eliminar de la interfaz.
                                _self.ui.delFieldFromPanel(fieldId);
                                _self.ui.showAlert();
                            },
                            cbBtnCancel: function () {}
                        });
                    },
                    update: function (_ui) {
                        var fieldId = $('#fid_field_id').val();
                        var fieldArrayIndex = _self.fields.getFieldArrayIndex(fieldId);

                        // Validacion.
                        if (!_self.fields.input.actions.validate(fieldId)) return false;

                        var nombreInput = $('#fid_input_nombre').val();
                        var marcaInput = $('#fid_input_marca').val();
                        var clasesInput = $('#fid_input_clases').val();
                        var fieldContent = _self.ui.getInputContent(nombreInput, marcaInput, clasesInput);

                        $('#field' + fieldId + ' .row').replaceWith(fieldContent);

                        _self.methods.bindEvents(true, '#field' + fieldId);

                        _self.fields.updateFieldInArray({
                            name: nombreInput,
                            placeholder: marcaInput,
                            clases: clasesInput
                        }, fieldArrayIndex);

                        _self.methods.limpiarInputs('input');
                        _self.ui.hideModal();

                        _self.ui.showAlert();
                    },
                    edit: function (ui) {
                        var fieldId = ui.helper.parents('.field-container').attr('data-id');
                        var fieldData = _self.fields.getFieldFromArray(fieldId);

                        _self.ui.setModal({
                            title: ProntusL10n.get('fid_editor_edit_input'),
                            description: ProntusL10n.get('fid_editor_configure_input_help'),
                            templateId: 'input',
                            closeMethod: 'fields.input.actions.cancel',
                            saveMethod: 'fields.input.actions.update',
                            show: true
                        }, {
                            input_nombre: fieldData.name,
                            input_marca: fieldData.placeholder,
                            input_clases: fieldData.clases,
                            field_id: fieldId
                        });
                    },
                    validate: function (fieldId) {
                        _self.helper.log('input: validate');

                        var nombreInput = $('#fid_input_nombre').val();
                        var marcaInput = $('#fid_input_marca').val();
                        var clasesInput = $('#fid_input_clases').val();
                        var rgxp1 = /^[\w_\- ]+$/;
                        var rgxp2 = /^[a-zA-Z0-9_]+$/;
                        var rgxp3 = /^[a-zA-Z0-9_-\s]*$/;

                        if (nombreInput == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_field_name_required')
                            });

                            return false;
                        } else if (marcaInput == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_tag_name_required')
                            });

                            return false;
                        } else if (!rgxp1.test(nombreInput)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_field_name_alpha')
                            });

                            return false;
                        } else if (!rgxp2.test(marcaInput)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_tag_name_alpha')
                            });

                            return false;
                        } else if (!rgxp3.test(clasesInput)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_css_class_alpha')
                            });
                            return false;
                        }

                        if (typeof fieldId != 'undefined') {
                            var fieldData = _self.fields.getFieldFromArray(fieldId);
                            // Si esta actualizando el nombre de la marca será igual al guardado.
                            // Se debe validar de manera especial si la marca ingresada es distinta.
                            if (fieldData.placeholder != marcaInput) {
                                if (_self.fields.checkPlaceholder(marcaInput)) {
                                    showModalAlert({
                                        title: ProntusL10n.get('global_error_title'),
                                        type: "red",
                                        msg: ProntusL10n.get('fid_editor_field_tag_exists', marcaInput)
                                    });

                                    return false;
                                }
                            }
                        } else {
                            if (_self.fields.checkPlaceholder(marcaInput)) {
                                showModalAlert({
                                    title: ProntusL10n.get('global_error_title'),
                                    type: "red",
                                    msg: ProntusL10n.get('fid_editor_field_tag_exists', marcaInput)
                                });

                                return false;
                            }
                        }

                        return true;
                    }
                }
            },
            checkbox: {
                actions: {
                    save: function () {
                        // Validacion.
                        if (!_self.fields.checkbox.actions.validate()) return false;

                        var type = 'checkbox';
                        var nombreInput = $('#fid_checkbox_nombre').val();
                        var marcaInput = $('#fid_checkbox_marca').val();
                        var valorInput = $('#fid_checkbox_valor').val();

                        // Ajustar el placeholder. Debe comenzar con chk_
                        if (marcaInput.substring(0, 4) != 'chk_') {
                            marcaInput = 'chk_' + marcaInput;
                        }

                        var fieldContent = _self.ui.getCheckBoxContent(nombreInput, marcaInput);

                        $('#field' + _self.fields.currentFieldId).html(fieldContent);

                        var panelId = $('#field' + _self.fields.currentFieldId).parents('.panel-container').attr("data-id");

                        _self.fields.addFieldToArray({
                            id: _self.fields.currentFieldId,
                            panelId: panelId,
                            name: nombreInput,
                            placeholder: marcaInput,
                            value: valorInput,
                            type: type,
                            order: $('#field' + _self.fields.currentFieldId).index()
                        });

                        _self.methods.bindEvents(true, '#field' + _self.fields.currentFieldId);

                        // Actualizar orden.
                        _self.fields.panel.methods.updateFieldsOrder(panelId);

                        // Limpiar modal.
                        _self.methods.limpiarInputs('checkbox');
                        _self.ui.hideModal();
                        _self.fields.currentFieldId = false;
                    },
                    cancel: function () {
                        _self.ui.hideModal();
                        _self.methods.limpiarInputs('checkbox');
                        $('#field' + _self.fields.currentFieldId).remove();

                        _self.fields.currentFieldId = false;
                    },
                    remove: function (ui) {
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_field_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_field_ok'),
                            cbBtnOK: function () {
                                var fieldId = ui.helper.parents('.field-container').attr('data-id');
                                // Eliminar del arreglo.
                                _self.fields.delFieldFromArray('', fieldId);
                                // Eliminar de la interfaz.
                                _self.ui.delFieldFromPanel(fieldId);
                                _self.ui.showAlert();
                            },
                            cbBtnCancel: function () {
                            }
                        });
                    },
                    update: function (_ui) {
                        var fieldId = $('#fid_field_id').val();
                        var fieldArrayIndex = _self.fields.getFieldArrayIndex(fieldId);

                        // Validacion.
                        if (!_self.fields.checkbox.actions.validate(fieldId)) return false;

                        var nombreInput = $('#fid_checkbox_nombre').val();
                        var marcaInput = $('#fid_checkbox_marca').val();
                        var valorInput = $('#fid_checkbox_valor').val();

                        // Ajustar el placeholder. Debe comenzar con chk_
                        if (marcaInput.substring(0, 4) != 'chk_') {
                            marcaInput = 'chk_' + marcaInput;
                        }

                        var fieldContent = _self.ui.getCheckBoxContent(nombreInput, marcaInput);

                        $('#field' + fieldId + ' .row').replaceWith(fieldContent);

                        _self.methods.bindEvents(true, '#field' + fieldId);

                        _self.fields.updateFieldInArray({
                            name: nombreInput,
                            placeholder: marcaInput,
                            value: valorInput
                        }, fieldArrayIndex);

                        _self.methods.limpiarInputs('checkbox');
                        _self.ui.hideModal();

                        _self.ui.showAlert();
                    },
                    edit: function (ui) {
                        var fieldId = ui.helper.parents('.field-container').attr('data-id');
                        var fieldData = _self.fields.getFieldFromArray(fieldId);

                        _self.ui.setModal({
                            title: ProntusL10n.get('fid_editor_edit_checkbox'),
                            description: ProntusL10n.get('fid_editor_configure_checkbox_help'),
                            templateId: 'checkbox',
                            closeMethod: 'fields.checkbox.actions.cancel',
                            saveMethod: 'fields.checkbox.actions.update',
                            show: true
                        }, {
                            checkbox_nombre: fieldData.name,
                            checkbox_marca: fieldData.placeholder,
                            checkbox_valor: fieldData.value,
                            field_id: fieldId
                        });
                    },
                    validate: function (fieldId) {
                        _self.helper.log('checkbox: validate');

                        var nombreInput = $('#fid_checkbox_nombre').val();
                        var marcaInput = $('#fid_checkbox_marca').val();
                        var valorInput = $('#fid_checkbox_valor').val();
                        var rgxp1 = /^[\w_\- ]+$/;
                        var rgxp2 = /^[a-zA-Z0-9_]+$/;

                        // Ajustar el placeholder. Debe comenzar con chk_
                        if (marcaInput.substring(0, 4) != 'chk_') {
                            marcaInput = 'chk_' + marcaInput;
                        }

                        if (nombreInput == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_field_name_required')
                            });

                            return false;
                        } else if (marcaInput == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_tag_name_required')
                            });

                            return false;
                        } else if (valorInput == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_field_value_required')
                            });

                            return false;
                        } else if (!rgxp1.test(nombreInput)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_field_name_alpha')
                            });

                            return false;
                        } else if (!rgxp2.test(marcaInput)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_tag_name_alpha')
                            });

                            return false;
                        }

                        if (typeof fieldId != 'undefined') {
                            var fieldData = _self.fields.getFieldFromArray(fieldId);
                            // Si esta actualizando el nombre de la marca será igual al guardado.
                            // Se debe validar de manera especial si la marca ingresada es distinta.
                            if (fieldData.placeholder != marcaInput) {
                                if (_self.fields.checkPlaceholder(marcaInput)) {
                                    showModalAlert({
                                        title: ProntusL10n.get('global_error_title'),
                                        type: "red",
                                        msg: ProntusL10n.get('fid_editor_field_tag_exists', marcaInput)
                                    });

                                    return false;
                                }
                            }
                        } else {
                            if (_self.fields.checkPlaceholder(marcaInput)) {
                                showModalAlert({
                                    title: ProntusL10n.get('global_error_title'),
                                    type: "red",
                                    msg: ProntusL10n.get('fid_editor_field_tag_exists', marcaInput)
                                });

                                return false;
                            }
                        }

                        return true;
                    }
                }
            },
            textarea: {
                actions: {
                    save: function () {
                        // Validacion.
                        if (!_self.fields.textarea.actions.validate()) return false;

                        var type = 'textarea';
                        var nombreInput = $('#fid_textarea_nombre').val();
                        var marcaInput = $('#fid_textarea_marca').val();
                        var fieldContent = _self.ui.getTextAreaContent(nombreInput, marcaInput);

                        $('#field' + _self.fields.currentFieldId).html(fieldContent);

                        var panelId = $('#field' + _self.fields.currentFieldId).parents('.panel-container').attr("data-id");

                        _self.fields.addFieldToArray({
                            id: _self.fields.currentFieldId,
                            panelId: panelId,
                            name: nombreInput,
                            placeholder: marcaInput,
                            type: type,
                            order: $('#field' + _self.fields.currentFieldId).index()
                        });

                        // Actualizar eventos.
                        _self.methods.bindEvents(true, '#field' + _self.fields.currentFieldId);

                        // Actualizar orden.
                        _self.fields.panel.methods.updateFieldsOrder(panelId);

                        // Limpiar modal.
                        _self.methods.limpiarInputs('textarea');
                        _self.ui.hideModal();
                        _self.fields.currentFieldId = false;
                    },
                    cancel: function () {
                        _self.ui.hideModal();
                        _self.methods.limpiarInputs('textarea');
                        $('#field' + _self.fields.currentFieldId).remove();

                        _self.fields.currentFieldId = false;
                    },
                    remove: function (ui) {
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_field_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_field_ok'),
                            cbBtnOK: function () {
                                var fieldId = ui.helper.parents('.field-container').attr('data-id');
                                // Eliminar del arreglo.
                                _self.fields.delFieldFromArray('', fieldId);
                                // Eliminar de la interfaz.
                                _self.ui.delFieldFromPanel(fieldId);
                                _self.ui.showAlert();
                            },
                            cbBtnCancel: function () {}
                        });
                    },
                    update: function (_ui) {
                        var fieldId = $('#fid_field_id').val();
                        var fieldArrayIndex = _self.fields.getFieldArrayIndex(fieldId);

                        // Validacion.
                        if (!_self.fields.textarea.actions.validate(fieldId)) return false;

                        var nombreInput = $('#fid_textarea_nombre').val();
                        var marcaInput = $('#fid_textarea_marca').val();
                        var fieldContent = _self.ui.getTextAreaContent(nombreInput, marcaInput);

                        $('#field' + fieldId + ' .row').replaceWith(fieldContent);

                        _self.methods.bindEvents(true, '#field' + fieldId);

                        _self.fields.updateFieldInArray({
                            name: nombreInput,
                            placeholder: marcaInput
                        }, fieldArrayIndex);

                        _self.methods.limpiarInputs('textarea');
                        _self.ui.hideModal();

                        _self.ui.showAlert();
                    },
                    edit: function (ui) {
                        var fieldId = ui.helper.parents('.field-container').attr('data-id');
                        var fieldData = _self.fields.getFieldFromArray(fieldId);

                        _self.ui.setModal({
                            title: ProntusL10n.get('fid_editor_edit_textarea'),
                            description: ProntusL10n.get('fid_editor_configure_textarea_help'),
                            templateId: 'textarea',
                            closeMethod: 'fields.textarea.actions.cancel',
                            saveMethod: 'fields.textarea.actions.update',
                            show: true
                        }, {
                            textarea_nombre: fieldData.name,
                            textarea_marca: fieldData.placeholder,
                            field_id: fieldId
                        });
                    },
                    validate: function (fieldId) {
                        var nombreInput = $('#fid_textarea_nombre').val();
                        var marcaInput = $('#fid_textarea_marca').val();
                        var rgxp1 = /^[\w_\- ]+$/;
                        var rgxp2 = /^[a-zA-Z0-9_]+$/;

                        if (nombreInput == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_field_name_required')
                            });

                            return false;
                        } else if (marcaInput == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_tag_name_required')
                            });

                            return false;
                        } else if (!rgxp1.test(nombreInput)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_field_name_alpha')
                            });

                            return false;
                        } else if (!rgxp2.test(marcaInput)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_tag_name_alpha')
                            });

                            return false;
                        }

                        if (typeof fieldId != 'undefined') {
                            var fieldData = _self.fields.getFieldFromArray(fieldId);
                            // Si esta actualizando el nombre de la marca será igual al guardado.
                            // Se debe validar de manera especial si la marca ingresada es distinta.
                            if (fieldData.placeholder != marcaInput) {
                                if (_self.fields.checkPlaceholder(marcaInput)) {
                                    showModalAlert({
                                        title: ProntusL10n.get('global_error_title'),
                                        type: "red",
                                        msg: ProntusL10n.get('fid_editor_field_tag_exists', marcaInput)
                                    });

                                    return false;
                                }
                            }
                        } else {
                            if (_self.fields.checkPlaceholder(marcaInput)) {
                                showModalAlert({
                                    title: ProntusL10n.get('global_error_title'),
                                    type: "red",
                                    msg: ProntusL10n.get('fid_editor_field_tag_exists', marcaInput)
                                });

                                return false;
                            }
                        }

                        return true;
                    }
                }
            },
            combobox: {
                actions: {
                    save: function () {
                        if (!_self.fields.combobox.actions.validate()) return false;

                        var type = 'combobox';
                        var nombreInput = $('#fid_combobox_nombre').val();
                        var marcaInput = $('#fid_combobox_marca').val();

                        // Ajustar el placeholder. Debe comenzar con cmb_
                        if (marcaInput.substring(0, 4) != 'cmb_') {
                            marcaInput = 'cmb_' + marcaInput;
                        }

                        var fieldContent = _self.ui.getComboBoxContent(nombreInput, marcaInput);

                        var cmbOptions = [];
                        var cmbValues = $('input[name="combobox-values[]"]');
                        var cmbNames = $('input[name="combobox-names[]"]');

                        for (var x = 0; x < cmbValues.length; x++) {
                            var value = $(cmbValues[x]).val();
                            var name = $(cmbNames[x]).val();

                            if (value != '' && name != '') {
                                cmbOptions.push({
                                    value: value,
                                    name: name
                                });
                            }
                        }

                        $('#field' + _self.fields.currentFieldId).html(fieldContent);

                        var panelId = $('#field' + _self.fields.currentFieldId).parents('.panel-container').attr("data-id");

                        _self.fields.addFieldToArray({
                            id: _self.fields.currentFieldId,
                            panelId: panelId,
                            name: nombreInput,
                            options: cmbOptions,
                            placeholder: marcaInput,
                            type: type,
                            order: $('#field' + _self.fields.currentFieldId).index()
                        });

                        _self.methods.bindEvents(true, '#field' + _self.fields.currentFieldId);

                        // Actualizar orden.
                        _self.fields.panel.methods.updateFieldsOrder(panelId);

                        // Limpiar modal.
                        _self.methods.limpiarInputs('combobox');
                        _self.ui.hideModal();
                        _self.fields.currentFieldId = false;

                        var htmlString = $('#fidElement_combobox_option').html();
                        $('#combobox-options').html(htmlString);
                    },
                    cancel: function () {
                        _self.ui.hideModal();
                        _self.methods.limpiarInputs('combobox');
                        $('#field' + _self.fields.currentFieldId).remove();

                        var htmlString = $('#fidElement_combobox_option').html();
                        $('#combobox-options').html(htmlString);

                        _self.fields.currentFieldId = false;
                    },
                    edit: function (ui) {
                        var fieldId = ui.helper.parents('.field-container').attr('data-id');
                        var fieldData = _self.fields.getFieldFromArray(fieldId);

                        _self.ui.setModal({
                            title: ProntusL10n.get('fid_editor_edit_combobox'),
                            description: ProntusL10n.get('fid_editor_configure_combobox_help'),
                            templateId: 'combobox',
                            closeMethod: 'fields.combobox.actions.cancel',
                            saveMethod: 'fields.combobox.actions.update',
                            show: true
                        }, {
                            combobox_nombre: fieldData.name,
                            combobox_marca: fieldData.placeholder,
                            field_id: fieldId
                        }, function () {
                            // Agregar options una vez que finalice el armado del modal.
                            $('#combobox-options').empty();
                            for (var x = 0; x < fieldData.options.length; x++) {
                                _self.fields.combobox.actions.addOption(undefined, fieldData.options[x].value, fieldData.options[x].name);
                            }
                        });
                    },
                    remove: function (ui) {
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_field_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_field_ok'),
                            cbBtnOK: function () {
                                var fieldId = ui.helper.parents('.field-container').attr('data-id');
                                // Eliminar del arreglo.
                                _self.fields.delFieldFromArray('', fieldId);
                                // Eliminar de la interfaz.
                                _self.ui.delFieldFromPanel(fieldId);
                                _self.ui.showAlert();
                            },
                            cbBtnCancel: function () {
                            }
                        });
                    },
                    update: function (_ui) {
                        var fieldId = $('#fid_field_id').val();
                        var fieldArrayIndex = _self.fields.getFieldArrayIndex(fieldId);

                        // Validacion.
                        if (!_self.fields.combobox.actions.validate(fieldId)) return false;

                        var nombreInput = $('#fid_combobox_nombre').val();
                        var marcaInput = $('#fid_combobox_marca').val();

                        // Ajustar el placeholder. Debe comenzar con cmb_
                        if (marcaInput.substring(0, 4) != 'cmb_') {
                            marcaInput = 'cmb_' + marcaInput;
                        }

                        var fieldContent = _self.ui.getComboBoxContent(nombreInput, marcaInput);

                        var cmbOptions = [];
                        var cmbValues = $('input[name="combobox-values[]"]');
                        var cmbNames = $('input[name="combobox-names[]"]');

                        for (var x = 0; x < cmbValues.length; x++) {
                            var value = $(cmbValues[x]).val();
                            var name = $(cmbNames[x]).val();

                            if (value != '' && name != '') {
                                cmbOptions.push({
                                    value: value,
                                    name: name
                                });
                            }
                        }

                        $('#field' + fieldId + ' .row').replaceWith(fieldContent);

                        _self.methods.bindEvents(true, '#field' + fieldId);

                        _self.fields.updateFieldInArray({
                            name: nombreInput,
                            placeholder: marcaInput,
                            options: cmbOptions
                        }, fieldArrayIndex);

                        _self.methods.limpiarInputs('combobox');
                        var htmlString = $('#fidElement_combobox_option').html();
                        $('#combobox-options').html(htmlString);
                        _self.ui.hideModal();

                        _self.ui.showAlert();
                    },
                    validate: function (fieldId) {
                        var nombreInput = $('#fid_combobox_nombre').val();
                        var marcaInput = $('#fid_combobox_marca').val();
                        var rgxp1 = /^[\w_\- ]+$/;
                        var rgxp2 = /^[a-zA-Z0-9_]+$/;

                        // Ajustar el placeholder. Debe comenzar con cmb_
                        if (marcaInput.substring(0, 4) != 'cmb_') {
                            marcaInput = 'cmb_' + marcaInput;
                        }

                        if (nombreInput == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_field_name_required')
                            });

                            return false;
                        } else if (marcaInput == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_tag_name_required')
                            });

                            return false;
                        } else if (!rgxp1.test(nombreInput)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_field_name_alpha')
                            });

                            return false;
                        } else if (!rgxp2.test(marcaInput)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_tag_name_alpha')
                            });

                            return false;
                        }

                        if (typeof fieldId != 'undefined') {
                            var fieldData = _self.fields.getFieldFromArray(fieldId);
                            // Si esta actualizando el nombre de la marca será igual al guardado.
                            // Se debe validar de manera especial si la marca ingresada es distinta.
                            if (fieldData.placeholder != marcaInput) {
                                if (_self.fields.checkPlaceholder(marcaInput)) {
                                    showModalAlert({
                                        title: ProntusL10n.get('global_error_title'),
                                        type: "red",
                                        msg: ProntusL10n.get('fid_editor_field_tag_exists', marcaInput)
                                    });

                                    return false;
                                }
                            }
                        } else {
                            if (_self.fields.checkPlaceholder(marcaInput)) {
                                showModalAlert({
                                    title: ProntusL10n.get('global_error_title'),
                                    type: "red",
                                    msg: ProntusL10n.get('fid_editor_field_tag_exists', marcaInput)
                                });

                                return false;
                            }
                        }

                        return true;
                    },
                    addOption: function (_ui, value, name) {
                        var htmlString = $('#fidElement_combobox_option').html();

                        if (typeof value == 'undefined') value = '';
                        if (typeof name == 'undefined') name = '';

                        htmlString = htmlString.replace(/__value__/, value);
                        htmlString = htmlString.replace(/__name__/, name);

                        $('#combobox-options').append(htmlString);
                        _self.methods.bindEvents(true, '#combobox-options');
                    },
                    removeOption: function (ui) {
                        ui.helper.parents('tr').remove();
                    }
                }
            },
            video: {
                actions: {
                    save: function () {
                        // Validacion.
                        if (!_self.fields.video.actions.validate()) return false;

                        var panelName = $('#fid_video_nombre').val();
                        var videoId = $('#fid_video_id').val();
                        var panelContentHtml = _self.ui.getVideoContent(panelName, videoId);

                        $('#panel' + _self.fields.currentPanelId).html(panelContentHtml);

                        // Actualizar listado de panels.
                        _self.fields.addPanelToArray({
                            id: _self.fields.currentPanelId,
                            name: panelName,
                            type: 'video',
                            videoId: videoId,
                            order: $('#panel' + _self.fields.currentPanelId).index()
                        });

                        _self.methods.bindEvents(true, '#panel' + _self.fields.currentPanelId);

                        // Actualizar orden.
                        _self.fields.panel.methods.updatePanelsOrder();

                        // Limpiar modal.
                        $('#fid_video_nombre').val('');
                        $('#fid_video_id').val('');
                        _self.ui.hideModal();
                        _self.fields.currentPanelId = false;
                    },
                    cancel: function () {
                        // Quitar el panel
                        _self.ui.hideModal();
                        $('#fid_video_nombre').val('');
                        $('#fid_video_id').val('');
                        $('#panel' + _self.fields.currentPanelId).remove();
                        _self.fields.currentPanelId = false;
                    },
                    update: function (_ui) {
                        var panelId = $('#fid_field_id').val();
                        var panelArrayIndex = _self.fields.getPanelArrayIndex(panelId);

                        // Validacion.
                        if (!_self.fields.video.actions.validate(panelId)) return false;

                        var panelName = $('#fid_video_nombre').val();
                        var videoId = $('#fid_video_id').val();

                        $('#panel' + panelId + ' .video-name').text(panelName);
                        $('#panel' + panelId + ' .video-id').text(videoId);

                        _self.methods.bindEvents(true, '#panel' + panelId);

                        _self.fields.updatePanelInArray({
                            name: panelName,
                            videoId: videoId
                        }, panelArrayIndex);

                        _self.methods.limpiarInputs('video');
                        _self.ui.hideModal();
                        _self.ui.showAlert();
                    },
                    edit: function (ui) {
                        var panelId = ui.helper.parents('.panel-container').attr('data-id');
                        var fieldData = _self.fields.getPanelFromArray(panelId);

                        _self.ui.setModal({
                            title: ProntusL10n.get('fid_editor_edit_video'),
                            description: ProntusL10n.get('fid_editor_configure_video_help'),
                            templateId: 'video',
                            closeMethod: 'fields.video.actions.cancel',
                            saveMethod: 'fields.video.actions.update',
                            show: true
                        }, {
                            video_nombre: fieldData.name,
                            video_id: fieldData.videoId,
                            field_id: panelId
                        });
                    },
                    validate: function (panelId) {
                        var panelName = $('#fid_video_nombre').val();
                        var videoId = $('#fid_video_id').val();
                        var rgxp = /^[\w_\- ]+$/;
                        var rgxp2 = /^\d+$/;

                        if (panelName == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_video_name_required')
                            });

                            return false;
                        } else if (videoId == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_video_id_required')
                            });

                            return false;
                        } else if (!rgxp.test(panelName)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_video_name_alpha')
                            });

                            return false;
                        } else if (!rgxp2.test(videoId)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_video_id_number')
                            });

                            return false;
                        }

                        if (typeof panelId != 'undefined') {
                            var panelData = _self.fields.getPanelFromArray(panelId);

                            if (panelData.videoId != videoId) {
                                if (_self.fields.checkVideo(videoId)) {
                                    showModalAlert({
                                        title: ProntusL10n.get('global_error_title'),
                                        type: "red",
                                        msg: ProntusL10n.get('fid_editor_video_id_exists')
                                    });

                                    return false;
                                }
                            }
                        } else {
                            if (_self.fields.checkVideo(videoId)) {
                                showModalAlert({
                                    title: ProntusL10n.get('global_error_title'),
                                    type: "red",
                                    msg: ProntusL10n.get('fid_editor_video_id_exists')
                                });

                                return false;
                            }
                        }

                        return true;
                    },
                    remove: function (ui) {
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_field_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_field_ok'),
                            cbBtnOK: function () {
                                var panelId = ui.helper.parents('.panel-container').attr('data-id');
                                // Eliminar panel
                                _self.fields.delPanelFromArray(panelId);
                                _self.fields.panel.methods.updatePanelsOrder();

                                $('#panel' + panelId).remove();
                            },
                            cbBtnCancel: function () {}
                        });
                    }
                }
            },
            audio: {
                actions: {
                    save: function () {
                        // Validacion.
                        if (!_self.fields.audio.actions.validate()) return false;

                        var panelName = $('#fid_audio_nombre').val();
                        var audioId = $('#fid_audio_id').val();
                        var panelContentHtml = _self.ui.getAudioContent(panelName, audioId);

                        $('#panel' + _self.fields.currentPanelId).html(panelContentHtml);

                        // Actualizar listado de panels.
                        _self.fields.addPanelToArray({
                            id: _self.fields.currentPanelId,
                            name: panelName,
                            type: 'audio',
                            audioId: audioId,
                            order: $('#panel' + _self.fields.currentPanelId).index()
                        });

                        _self.methods.bindEvents(true, '#panel' + _self.fields.currentPanelId);

                        // Actualizar orden.
                        _self.fields.panel.methods.updatePanelsOrder();

                        // Limpiar modal.
                        $('#fid_audio_nombre').val('');
                        $('#fid_audio_id').val('');
                        _self.ui.hideModal();
                        _self.fields.currentPanelId = false;
                    },
                    cancel: function () {
                        // Quitar el panel
                        _self.ui.hideModal();
                        $('#fid_audio_nombre').val('');
                        $('#fid_audio_id').val('');
                        $('#panel' + _self.fields.currentPanelId).remove();
                        _self.fields.currentPanelId = false;
                    },
                    update: function (_ui) {
                        var panelId = $('#fid_field_id').val();
                        var panelArrayIndex = _self.fields.getPanelArrayIndex(panelId);

                        // Validacion.
                        if (!_self.fields.audio.actions.validate(panelId)) return false;

                        var panelName = $('#fid_audio_nombre').val();
                        var audioId = $('#fid_audio_id').val();

                        $('#panel' + panelId + ' .audio-name').text(panelName);
                        $('#panel' + panelId + ' .audio-id').text(audioId);

                        _self.methods.bindEvents(true, '#panel' + panelId);

                        _self.fields.updatePanelInArray({
                            name: panelName,
                            audioId: audioId
                        }, panelArrayIndex);

                        _self.methods.limpiarInputs('audio');
                        _self.ui.hideModal();
                        _self.ui.showAlert();
                    },
                    edit: function (ui) {
                        var panelId = ui.helper.parents('.panel-container').attr('data-id');
                        var fieldData = _self.fields.getPanelFromArray(panelId);

                        _self.ui.setModal({
                            title: ProntusL10n.get('fid_editor_edit_audio'),
                            description: ProntusL10n.get('fid_editor_configure_audio_help'),
                            templateId: 'audio',
                            closeMethod: 'fields.audio.actions.cancel',
                            saveMethod: 'fields.audio.actions.update',
                            show: true
                        }, {
                            audio_nombre: fieldData.name,
                            audio_id: fieldData.audioId,
                            field_id: panelId
                        });
                    },
                    validate: function (panelId) {
                        var panelName = $('#fid_audio_nombre').val();
                        var audioId = $('#fid_audio_id').val();
                        var rgxp = /^[\w_\- ]+$/; // TODO: problema con tildes.
                        var rgxp2 = /^\d+$/;

                        if (panelName == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_audio_name_required')
                            });

                            return false;
                        } else if (audioId == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_audio_id_required')
                            });

                            return false;
                        } else if (!rgxp.test(panelName)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_audio_name_alpha')
                            });

                            return false;
                        } else if (!rgxp2.test(audioId)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_audio_id_number')
                            });

                            return false;
                        }

                        if (typeof panelId != 'undefined') {
                            var panelData = _self.fields.getPanelFromArray(panelId);

                            if (panelData.audioId != audioId) {
                                if (_self.fields.checkAudio(audioId)) {
                                    showModalAlert({
                                        title: ProntusL10n.get('global_error_title'),
                                        type: "red",
                                        msg: ProntusL10n.get('fid_editor_audio_id_exists')
                                    });

                                    return false;
                                }
                            }
                        } else {
                            if (_self.fields.checkAudio(audioId)) {
                                showModalAlert({
                                    title: ProntusL10n.get('global_error_title'),
                                    type: "red",
                                    msg: ProntusL10n.get('fid_editor_audio_id_exists')
                                });

                                return false;
                            }
                        }

                        return true;
                    },
                    remove: function (ui) {
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_field_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_field_ok'),
                            cbBtnOK: function () {
                                var panelId = ui.helper.parents('.panel-container').attr('data-id');
                                // Eliminar panel
                                _self.fields.delPanelFromArray(panelId);
                                _self.fields.panel.methods.updatePanelsOrder();

                                $('#panel' + panelId).remove();
                            },
                            cbBtnCancel: function () {}
                        });
                    }
                }
            },
            adjunto: {
                actions: {
                    save: function () {
                        // Validacion.
                        if (!_self.fields.adjunto.actions.validate()) return false;

                        var type = 'adjunto';
                        var nombreInput = $('#fid_adjunto_nombre').val();
                        var marcaInput = $('#fid_adjunto_marca').val();

                        // Ajustar el placeholder. Debe comenzar con asocfile_
                        if (marcaInput.substring(0, 9) != 'asocfile_') {
                            marcaInput = 'asocfile_' + marcaInput;
                        }

                        var fieldContent = _self.ui.getAdjuntoContent(nombreInput, marcaInput);

                        $('#field' + _self.fields.currentFieldId).html(fieldContent);

                        var panelId = $('#field' + _self.fields.currentFieldId).parents('.panel-container').attr("data-id");

                        _self.fields.addFieldToArray({
                            id: _self.fields.currentFieldId,
                            panelId: panelId,
                            name: nombreInput,
                            placeholder: marcaInput,
                            type: type,
                            order: $('#field' + _self.fields.currentFieldId).index()
                        });

                        _self.methods.bindEvents(true, '#field' + _self.fields.currentFieldId);

                        // Actualizar orden.
                        _self.fields.panel.methods.updateFieldsOrder(panelId);

                        // Limpiar modal.
                        _self.methods.limpiarInputs('adjunto');
                        _self.ui.hideModal();
                        _self.fields.currentFieldId = false;
                    },
                    cancel: function () {
                        _self.ui.hideModal();
                        _self.methods.limpiarInputs('adjunto');
                        $('#field' + _self.fields.currentFieldId).remove();

                        _self.fields.currentFieldId = false;
                    },
                    remove: function (ui) {
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_field_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_field_ok'),
                            cbBtnOK: function () {
                                var fieldId = ui.helper.parents('.field-container').attr('data-id');
                                // Eliminar del arreglo.
                                _self.fields.delFieldFromArray('', fieldId);
                                // Eliminar de la interfaz.
                                _self.ui.delFieldFromPanel(fieldId);
                                _self.ui.showAlert();
                            },
                            cbBtnCancel: function () {}
                        });
                    },
                    update: function (_ui) {
                        var fieldId = $('#fid_field_id').val();
                        var fieldArrayIndex = _self.fields.getFieldArrayIndex(fieldId);

                        // Validacion.
                        if (!_self.fields.adjunto.actions.validate(fieldId)) return false;

                        var nombreInput = $('#fid_adjunto_nombre').val();
                        var marcaInput = $('#fid_adjunto_marca').val();

                        // Ajustar el placeholder. Debe comenzar con asocfile_
                        if (marcaInput.substring(0, 9) != 'asocfile_') {
                            marcaInput = 'asocfile_' + marcaInput;
                        }

                        var fieldContent = _self.ui.getAdjuntoContent(nombreInput, marcaInput);

                        $('#field' + fieldId + ' .row').replaceWith(fieldContent);

                        _self.methods.bindEvents(true, '#field' + fieldId);

                        _self.fields.updateFieldInArray({
                            name: nombreInput,
                            placeholder: marcaInput
                        }, fieldArrayIndex);

                        _self.methods.limpiarInputs('adjunto');
                        _self.ui.hideModal();

                        _self.ui.showAlert();
                    },
                    edit: function (ui) {
                        var fieldId = ui.helper.parents('.field-container').attr('data-id');
                        var fieldData = _self.fields.getFieldFromArray(fieldId);

                        _self.ui.setModal({
                            title: ProntusL10n.get('fid_editor_edit_asocfile'),
                            description: ProntusL10n.get('fid_editor_configure_asocfile_help'),
                            templateId: 'adjunto',
                            closeMethod: 'fields.adjunto.actions.cancel',
                            saveMethod: 'fields.adjunto.actions.update',
                            show: true
                        }, {
                            adjunto_nombre: fieldData.name,
                            adjunto_marca: fieldData.placeholder,
                            field_id: fieldId
                        });
                    },
                    validate: function (fieldId) {
                        _self.helper.log('adjunto: validate');

                        var nombreInput = $('#fid_adjunto_nombre').val();
                        var marcaInput = $('#fid_adjunto_marca').val();
                        var rgxp1 = /^[\w_\- ]+$/;
                        var rgxp2 = /^[a-zA-Z0-9_]+$/;

                        // Ajustar el placeholder. Debe comenzar con asocfile_
                        if (marcaInput.substring(0, 9) != 'asocfile_') {
                            marcaInput = 'asocfile_' + marcaInput;
                        }

                        if (nombreInput == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_field_name_required')
                            });

                            return false;
                        } else if (marcaInput == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_tag_name_required')
                            });

                            return false;
                        } else if (!rgxp1.test(nombreInput)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_field_name_alpha')
                            });

                            return false;
                        } else if (!rgxp2.test(marcaInput)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_tag_name_alpha')
                            });

                            return false;
                        }

                        if (typeof fieldId != 'undefined') {
                            var fieldData = _self.fields.getFieldFromArray(fieldId);
                            // Si esta actualizando el nombre de la marca será igual al guardado.
                            // Se debe validar de manera especial si la marca ingresada es distinta.
                            if (fieldData.placeholder != marcaInput) {
                                if (_self.fields.checkPlaceholder(marcaInput)) {
                                    showModalAlert({
                                        title: ProntusL10n.get('global_error_title'),
                                        type: "red",
                                        msg: ProntusL10n.get('fid_editor_field_tag_exists', marcaInput)
                                    });

                                    return false;
                                }
                            }
                        } else {
                            if (_self.fields.checkPlaceholder(marcaInput)) {
                                showModalAlert({
                                    title: ProntusL10n.get('global_error_title'),
                                    type: "red",
                                    msg: ProntusL10n.get('fid_editor_field_tag_exists', marcaInput)
                                });

                                return false;
                            }
                        }

                        return true;
                    }
                }
            },
            foto: {
                actions: {
                    save: function () {
                        // Validacion.
                        if (!_self.fields.foto.actions.validate()) return false;

                        var type = 'foto';
                        var nombreInput = $('#fid_foto_nombre').val();
                        var marcaInput = $('#fid_foto_marca').val();
                        var anchoInput = $('#fid_foto_ancho').val();
                        var altoInput = $('#fid_foto_alto').val();

                        // Ajustar el placeholder. Debe comenzar con fotofija_
                        if (marcaInput.substring(0, 9) != 'fotofija_') {
                            marcaInput = 'fotofija_' + marcaInput;
                        }

                        var fieldContent = _self.ui.getFotoContent(nombreInput, marcaInput, anchoInput, altoInput);

                        $('#field' + _self.fields.currentFieldId).html(fieldContent);

                        var panelId = $('#field' + _self.fields.currentFieldId).parents('.panel-container').attr("data-id");

                        _self.fields.addFieldToArray({
                            id: _self.fields.currentFieldId,
                            panelId: panelId,
                            name: nombreInput,
                            placeholder: marcaInput,
                            width: anchoInput,
                            height: altoInput,
                            type: type,
                            order: $('#field' + _self.fields.currentFieldId).index()
                        });

                        // Actualizar eventos.
                        _self.methods.bindEvents(true, '#field' + _self.fields.currentFieldId);

                        // Actualizar orden.
                        _self.fields.panel.methods.updateFieldsOrder(panelId);

                        // Limpiar modal.
                        _self.methods.limpiarInputs('foto');
                        _self.ui.hideModal();
                        _self.fields.currentFieldId = false;
                    },
                    cancel: function () {
                        _self.ui.hideModal();
                        _self.methods.limpiarInputs('foto');
                        $('#field' + _self.fields.currentFieldId).remove();

                        _self.fields.currentFieldId = false;
                    },
                    remove: function (ui) {
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_field_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_field_ok'),
                            cbBtnOK: function () {
                                var fieldId = ui.helper.parents('.field-container').attr('data-id');
                                // Eliminar del arreglo.
                                _self.fields.delFieldFromArray('', fieldId);
                                // Eliminar de la interfaz.
                                _self.ui.delFieldFromPanel(fieldId);
                                _self.ui.showAlert();
                            },
                            cbBtnCancel: function () {
                            }
                        });
                    },
                    update: function (_ui) {
                        var fieldId = $('#fid_field_id').val();
                        var fieldArrayIndex = _self.fields.getFieldArrayIndex(fieldId);

                        // Validacion.
                        if (!_self.fields.foto.actions.validate(fieldId)) return false;

                        var nombreInput = $('#fid_foto_nombre').val();
                        var marcaInput = $('#fid_foto_marca').val();
                        var anchoInput = $('#fid_foto_ancho').val();
                        var altoInput = $('#fid_foto_alto').val();

                        // Ajustar el placeholder. Debe comenzar con fotofija_
                        if (marcaInput.substring(0, 9) != 'fotofija_') {
                            marcaInput = 'fotofija_' + marcaInput;
                        }

                        var fieldContent = _self.ui.getFotoContent(nombreInput, marcaInput, anchoInput, altoInput);

                        $('#field' + fieldId + ' .row').replaceWith(fieldContent);

                        _self.methods.bindEvents(true, '#field' + fieldId);

                        _self.fields.updateFieldInArray({
                            name: nombreInput,
                            placeholder: marcaInput,
                            width: anchoInput,
                            height: altoInput
                        }, fieldArrayIndex);

                        _self.methods.limpiarInputs('foto');
                        _self.ui.hideModal();

                        _self.ui.showAlert();
                    },
                    edit: function (ui) {
                        var fieldId = ui.helper.parents('.field-container').attr('data-id');
                        var fieldData = _self.fields.getFieldFromArray(fieldId);

                        _self.ui.setModal({
                            title: ProntusL10n.get('fid_editor_edit_photo'),
                            description: ProntusL10n.get('fid_editor_configure_photo_help'),
                            templateId: 'foto',
                            closeMethod: 'fields.foto.actions.cancel',
                            saveMethod: 'fields.foto.actions.update',
                            show: true
                        }, {
                            foto_nombre: fieldData.name,
                            foto_marca: fieldData.placeholder,
                            foto_ancho: fieldData.width,
                            foto_alto: fieldData.height,
                            field_id: fieldId
                        });
                    },
                    validate: function (fieldId) {
                        var nombreInput = $('#fid_foto_nombre').val();
                        var marcaInput = $('#fid_foto_marca').val();
                        var anchoInput = $('#fid_foto_ancho').val();
                        var altoInput = $('#fid_foto_alto').val();
                        var rgxp1 = /^[\w_\- ]+$/;
                        var rgxp2 = /^[a-zA-Z0-9_]+$/;
                        var rgxp3 = /^\d+$/;

                        // Ajustar el placeholder. Debe comenzar con fotofija_
                        if (marcaInput.substring(0, 9) != 'fotofija_') {
                            marcaInput = 'fotofija_' + marcaInput;
                        }

                        if (nombreInput == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_field_name_required')
                            });

                            return false;
                        } else if (marcaInput == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_tag_name_required')
                            });

                            return false;
                        } else if (!rgxp1.test(nombreInput)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_field_name_alpha')
                            });

                            return false;
                        } else if (!rgxp2.test(marcaInput)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_tag_name_alpha')
                            });

                            return false;
                        } else if (!rgxp3.test(anchoInput)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: "El ancho de la foto debe ser numérico."
                            });

                            return false;
                        } else if (!rgxp3.test(altoInput)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: "El alto de la foto debe ser numérico."
                            });

                            return false;
                        }

                        if (typeof fieldId != 'undefined') {
                            var fieldData = _self.fields.getFieldFromArray(fieldId);
                            // Si esta actualizando el nombre de la marca será igual al guardado.
                            // Se debe validar de manera especial si la marca ingresada es distinta.
                            if (fieldData.placeholder != marcaInput) {
                                if (_self.fields.checkPlaceholder(marcaInput)) {
                                    showModalAlert({
                                        title: ProntusL10n.get('global_error_title'),
                                        type: "red",
                                        msg: ProntusL10n.get('fid_editor_field_tag_exists', marcaInput)
                                    });

                                    return false;
                                }
                            }
                        } else {
                            if (_self.fields.checkPlaceholder(marcaInput)) {
                                showModalAlert({
                                    title: ProntusL10n.get('global_error_title'),
                                    type: "red",
                                    msg: ProntusL10n.get('fid_editor_field_tag_exists', marcaInput)
                                });

                                return false;
                            }
                        }

                        return true;
                    }
                }
            },
            galeria: {
                actions: {
                    save: function () {
                        // Validacion.
                        if (!_self.fields.galeria.actions.validate()) return false;

                        var lowWidth = $('#fid_galeria_low_width').val();
                        var lowHeight = $('#fid_galeria_low_height').val();
                        var highWidth = $('#fid_galeria_high_width').val();
                        var highHeight = $('#fid_galeria_high_height').val();
                        var galeriaContentHtml = _self.ui.getGaleriaContent();

                        $('#panel' + _self.fields.currentPanelId).html(galeriaContentHtml);

                        // Actualizar listado de panels.
                        _self.fields.addPanelToArray({
                            id: _self.fields.currentPanelId,
                            name: ProntusL10n.get('fid_editor_gallery'),
                            type: 'galeria',
                            lowWidth: lowWidth,
                            lowHeight: lowHeight,
                            highWidth: highWidth,
                            highHeight: highHeight,
                            order: $('#panel' + _self.fields.currentPanelId).index()
                        });

                        _self.methods.bindEvents(true, '#panel' + _self.fields.currentPanelId);

                        // Actualizar orden.
                        _self.fields.panel.methods.updatePanelsOrder();

                        _self.ui.disableUniqueField('galeria');

                        // Limpiar modal.
                        _self.methods.limpiarInputs('galeria');
                        _self.ui.hideModal();
                        _self.fields.currentPanelId = false;
                    },
                    cancel: function () {
                        _self.ui.hideModal();
                        _self.methods.limpiarInputs('galeria');
                        $('#panel' + _self.fields.currentPanelId).remove();

                        _self.fields.currentPanelId = false;
                    },
                    edit: function (ui) {
                        var panelId = ui.helper.parents('.panel-container').attr('data-id');
                        var fieldData = _self.fields.getPanelFromArray(panelId);

                        _self.ui.setModal({
                            title: ProntusL10n.get('fid_editor_edit_gallery'),
                            description: ProntusL10n.get('fid_editor_configure_gallery_help'),
                            templateId: 'galeria',
                            closeMethod: 'fields.galeria.actions.cancel',
                            saveMethod: 'fields.galeria.actions.update',
                            show: true
                        }, {
                            galeria_low_width: fieldData.lowWidth,
                            galeria_low_height: fieldData.lowHeight,
                            galeria_high_width: fieldData.highWidth,
                            galeria_high_height: fieldData.highHeight,
                            field_id: panelId
                        });
                    },
                    update: function (_ui) {
                        var panelId = $('#fid_field_id').val();
                        var panelArrayIndex = _self.fields.getPanelArrayIndex(panelId);
                        var lowWidth = $('#fid_galeria_low_width').val();
                        var lowHeight = $('#fid_galeria_low_height').val();
                        var highWidth = $('#fid_galeria_high_width').val();
                        var highHeight = $('#fid_galeria_high_height').val();

                        // Validacion.
                        if (!_self.fields.galeria.actions.validate()) return false;

                        _self.fields.updatePanelInArray({
                            lowWidth: lowWidth,
                            lowHeight: lowHeight,
                            highWidth: highWidth,
                            highHeight: highHeight,
                        }, panelArrayIndex);

                        _self.methods.limpiarInputs('galeria');
                        _self.ui.hideModal();

                        _self.ui.showAlert();
                    },
                    remove: function (ui) {
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_gallery_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_gallery_ok'),
                            cbBtnOK: function () {
                                var panelId = ui.helper.parents('.panel-container').attr('data-id');
                                // Eliminar panel
                                _self.fields.delPanelFromArray(panelId);

                                _self.ui.enableUniqueField('galeria');

                                $('#panel' + panelId).remove();

                                _self.fields.panel.methods.updatePanelsOrder();
                            },
                            cbBtnCancel: function () {}
                        });
                    },
                    validate: function () {
                        var lowWidth = $('#fid_galeria_low_width').val();
                        var lowHeight = $('#fid_galeria_low_height').val();
                        var highWidth = $('#fid_galeria_high_width').val();
                        var highHeight = $('#fid_galeria_high_height').val();
                        var rgxp = /^\d+$/;

                        if (!rgxp.test(lowWidth) || !rgxp.test(lowHeight) || !rgxp.test(highWidth) || !rgxp.test(highHeight)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_gallery_size_number')
                            });

                            return false;
                        }

                        return true;
                    }
                }
            },
            tabs: {
                actions: {
                    save: function () {
                        // Validacion.
                        if (!_self.fields.tabs.actions.validate()) return false;

                        var tabsNombre = $('#fid_tabs_nombre').val();
                        var contentHtml = _self.ui.getTabsContent(tabsNombre);

                        $('#panel' + _self.fields.currentPanelId).html(contentHtml);

                        // Actualizar listado de panels.
                        _self.fields.addPanelToArray({
                            id: _self.fields.currentPanelId,
                            name: tabsNombre,
                            type: 'tabs',
                            order: $('#panel' + _self.fields.currentPanelId).index()
                        });

                        _self.methods.bindEvents(true, '#panel' + _self.fields.currentPanelId);

                        // Actualizar orden.
                        _self.fields.panel.methods.updatePanelsOrder();

                        _self.ui.installFidStructureSortable('#panel' + _self.fields.currentPanelId + ' .panel-tabs', _self.fields.currentPanelId);

                        // Limpiar modal.
                        _self.methods.limpiarInputs('tabs');
                        _self.ui.hideModal();
                        _self.fields.currentPanelId = false;
                    },
                    cancel: function () {
                        _self.ui.hideModal();
                        _self.methods.limpiarInputs('tabs');
                        $('#panel' + _self.fields.currentPanelId).remove();

                        _self.fields.currentPanelId = false;
                    },
                    edit: function (ui) {
                        var panelId = ui.helper.parents('.panel-container').attr('data-id');
                        var fieldData = _self.fields.getPanelFromArray(panelId);

                        _self.ui.setModal({
                            title: ProntusL10n.get('fid_editor_edit_tab'),
                            description: ProntusL10n.get('fid_editor_configure_tabs_help'),
                            templateId: 'tabs',
                            closeMethod: 'fields.tabs.actions.cancel',
                            saveMethod: 'fields.tabs.actions.update',
                            show: true
                        }, {
                            tabs_nombre: fieldData.name,
                            field_id: panelId
                        });
                    },
                    update: function (_ui) {
                        var tabsNombre = $('#fid_tabs_nombre').val();

                        // Validacion.
                        if (!_self.fields.tabs.actions.validate()) return false;

                        _self.methods.bindEvents(true, '#panel' + panelId);

                        _self.fields.updatePanelInArray({
                            name: tabsNombre,
                        }, panelArrayIndex);

                        _self.methods.limpiarInputs('tabs');
                        _self.ui.hideModal();

                        _self.ui.showAlert();
                    },
                    remove: function (ui) {
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_tab_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_tab_ok'),
                            cbBtnOK: function () {
                                var panelId = ui.helper.parents('.panel-container').attr('data-id');
                                // Eliminar panel
                                _self.fields.delPanelFromArray(panelId);

                                _self.ui.enableUniqueField('tabs');

                                $('#panel' + panelId).remove();

                                _self.fields.panel.methods.updatePanelsOrder();
                            },
                            cbBtnCancel: function () {}
                        });
                    },
                    validate: function () {
                        var tabsNombre = $('#fid_tabs_nombre').val();
                        var rgxp = /^[\w_\- ]+$/;

                        if (tabsNombre == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_panel_name_required')
                            });

                            return false;
                        } else if (!rgxp.test(tabsNombre)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_panel_name_alpha')
                            });

                            return false;
                        }

                        return true;
                    }
                }
            },
            vtxt: {
                actions: {
                    save: function () {
                        if (!_self.fields.vtxt.actions.validate()) return false;
                        var type = 'vtxt';
                        var nombreInput = $('#fid_vtxt_nombre').val();
                        var idInput = $('#fid_vtxt_id').val();
                        var fieldContent = _self.ui.getVtxtContent(nombreInput, idInput);

                        $('#field' + _self.fields.currentFieldId).html(fieldContent);

                        var panelId = $('#field' + _self.fields.currentFieldId).parents('.panel-container').attr("data-id");

                        _self.fields.addFieldToArray({
                            id: _self.fields.currentFieldId,
                            panelId: panelId,
                            name: nombreInput,
                            vtxtId: idInput,
                            type: type,
                            order: $('#field' + _self.fields.currentFieldId).index()
                        });

                        _self.methods.bindEvents(true, '#field' + _self.fields.currentFieldId);

                        // Actualizar orden.
                        _self.fields.panel.methods.updateFieldsOrder(panelId);

                        // Limpiar modal.
                        _self.methods.limpiarInputs('vtxt');
                        _self.ui.hideModal();
                        _self.fields.currentFieldId = false;
                    },
                    remove: function (ui) {
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_field_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_field_ok'),
                            cbBtnOK: function () {
                                var fieldId = ui.helper.parents('.field-container').attr('data-id');
                                // Eliminar del arreglo.
                                _self.fields.delFieldFromArray('', fieldId);
                                // Eliminar de la interfaz.
                                _self.ui.delFieldFromPanel(fieldId);
                                _self.ui.showAlert();
                            },
                            cbBtnCancel: function () {}
                        });
                    },
                    update: function (_ui) {
                        var fieldId = $('#fid_field_id').val();
                        var fieldArrayIndex = _self.fields.getFieldArrayIndex(fieldId);

                        // Validacion.
                        if (!_self.fields.vtxt.actions.validate(fieldId)) return false;

                        var nombreInput = $('#fid_vtxt_nombre').val();
                        var idInput = $('#fid_vtxt_id').val();
                        var fieldContent = _self.ui.getVtxtContent(nombreInput, idInput);

                        $('#field' + fieldId + ' .row').replaceWith(fieldContent);

                        _self.methods.bindEvents(true, '#field' + fieldId);

                        _self.fields.updateFieldInArray({
                            name: nombreInput,
                            vtxtId: idInput
                        }, fieldArrayIndex);

                        _self.methods.limpiarInputs('vtxt');
                        _self.ui.hideModal();

                        _self.ui.showAlert();
                    },
                    edit: function (ui) {
                        var fieldId = ui.helper.parents('.field-container').attr('data-id');
                        var fieldData = _self.fields.getFieldFromArray(fieldId);

                        _self.ui.setModal({
                            title: ProntusL10n.get('fid_editor_edit_vtxt'),
                            description: ProntusL10n.get('fid_editor_configure_vtxt_help'),
                            templateId: 'vtxt',
                            closeMethod: 'fields.vtxt.actions.cancel',
                            saveMethod: 'fields.vtxt.actions.update',
                            show: true
                        }, {
                            vtxt_nombre: fieldData.name,
                            vtxt_id: fieldData.vtxtId,
                            field_id: fieldId
                        });
                    },
                    cancel: function () {
                        _self.ui.hideModal();

                        _self.methods.limpiarInputs('vtxt');
                        $('#field' + _self.fields.currentFieldId).remove();

                        _self.fields.currentFieldId = false;
                    },
                    validate: function (fieldId) {
                        var nombreInput = $('#fid_vtxt_nombre').val();
                        var idInput = $('#fid_vtxt_id').val();
                        var rgxp1 = /^[\w_\- ]+$/;
                        var rgxp2 = /^[\d]+$/;

                        if (idInput == '') {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_vtxt_id_required')
                            });

                            return false;
                        } else if (nombreInput != '' && !rgxp1.test(nombreInput)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_field_name_alpha')
                            });

                            return false;
                        } else if (!rgxp2.test(idInput)) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: "red",
                                msg: ProntusL10n.get('fid_editor_vtxt_id_number')
                            });

                            return false;
                        }

                        if (typeof fieldId != 'undefined') {
                            var fieldData = _self.fields.getFieldFromArray(fieldId);
                            // Si esta actualizando el nombre de la marca será igual al guardado.
                            // Se debe validar de manera especial si la marca ingresada es distinta.
                            if (fieldData.vtxtId != idInput) {
                                if (_self.fields.checkVtxt(idInput)) {
                                    showModalAlert({
                                        title: ProntusL10n.get('global_error_title'),
                                        type: "red",
                                        msg: ProntusL10n.get('fid_editor_vtxt_id_exists')
                                    });

                                    return false;
                                }
                            }
                        } else {
                            if (_self.fields.checkVtxt(idInput)) {
                                showModalAlert({
                                    title: ProntusL10n.get('global_error_title'),
                                    type: "red",
                                    msg: ProntusL10n.get('fid_editor_vtxt_id_exists')
                                });
                            }
                        }

                        return true;
                    }
                }
            },
            tax: {
                actions: {
                    remove: function (ui) {
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_field_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_field_ok'),
                            cbBtnOK: function () {
                                var fieldId = ui.helper.parents('.field-container').attr('data-id');
                                // Eliminar del arreglo.
                                _self.fields.delFieldFromArray('tax');
                                // Eliminar de la interfaz.
                                _self.ui.delFieldFromPanel(fieldId);

                                // Dejarlo disponible.
                                _self.ui.enableUniqueField('tax');

                                _self.ui.showAlert();
                            },
                            cbBtnCancel: function () {}
                        });
                    }
                }
            },
            taxmanual: {
                actions: {
                    remove: function (ui) {
                        _self.helper.log('taxmanual remove');
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_field_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_field_ok'),
                            cbBtnOK: function () {
                                var fieldId = ui.helper.parents('.field-container').attr('data-id');
                                // Eliminar del arreglo.
                                _self.fields.delFieldFromArray('taxmanual');
                                // Eliminar de la interfaz.
                                _self.ui.delFieldFromPanel(fieldId);

                                // Dejarlo disponible.
                                _self.ui.enableUniqueField('taxmanual');

                                _self.ui.showAlert();
                            },
                            cbBtnCancel: function () {}
                        });
                    }
                }
            },
            macro: {
                actions: {
                    save: function () {
                        var type = 'macro';
                        var macroFile = $('#fid_macro_file').val();
                        var fieldContent = _self.ui.getMacroContent(macroFile);

                        $('#field' + _self.fields.currentFieldId).html(fieldContent);

                        var panelId = $('#field' + _self.fields.currentFieldId).parents('.panel-container').attr("data-id");

                        _self.fields.addFieldToArray({
                            id: _self.fields.currentFieldId,
                            panelId: panelId,
                            file: macroFile,
                            type: type,
                            order: $('#field' + _self.fields.currentFieldId).index()
                        });

                        _self.methods.bindEvents(true, '#field' + _self.fields.currentFieldId);

                        // Actualizar orden.
                        _self.fields.panel.methods.updateFieldsOrder(panelId);

                        // Limpiar modal.
                        _self.methods.limpiarInputs('macro');
                        _self.ui.hideModal();
                        _self.fields.currentFieldId = false;
                    },
                    cancel: function () {
                        _self.ui.hideModal();
                        _self.methods.limpiarInputs('macro');
                        $('#field' + _self.fields.currentFieldId).remove();

                        _self.fields.currentFieldId = false;
                    },
                    remove: function (ui) {
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_field_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_field_ok'),
                            cbBtnOK: function () {
                                var fieldId = ui.helper.parents('.field-container').attr('data-id');
                                // Eliminar del arreglo.
                                _self.fields.delFieldFromArray('', fieldId);
                                // Eliminar de la interfaz.
                                _self.ui.delFieldFromPanel(fieldId);
                                _self.ui.showAlert();
                            },
                            cbBtnCancel: function () {}
                        });
                    },
                    update: function (_ui) {
                        var fieldId = $('#fid_field_id').val();
                        var fieldArrayIndex = _self.fields.getFieldArrayIndex(fieldId);

                        var macroFile = $('#fid_macro_file').val();
                        var fieldContent = _self.ui.getMacroContent(macroFile);

                        $('#field' + fieldId + ' .row').replaceWith(fieldContent);

                        _self.methods.bindEvents(true, '#field' + fieldId);

                        _self.fields.updateFieldInArray({
                            file: macroFile,
                        }, fieldArrayIndex);

                        _self.methods.limpiarInputs('macro');
                        _self.ui.hideModal();

                        _self.ui.showAlert();
                    },
                    edit: function (ui) {
                        var fieldId = ui.helper.parents('.field-container').attr('data-id');
                        var fieldData = _self.fields.getFieldFromArray(fieldId);

                        _self.ui.setModal({
                            title: ProntusL10n.get('fid_editor_edit_macro'),
                            description: ProntusL10n.get('fid_editor_configure_macro_help'),
                            templateId: 'macro',
                            closeMethod: 'fields.macro.actions.cancel',
                            saveMethod: 'fields.macro.actions.update',
                            show: true
                        }, {
                            macro_file: fieldData.file,
                            field_id: fieldId
                        });
                    },
                    validate: function () {}
                }
            },
            bajada: {
                actions: {
                    remove: function (ui) {
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_field_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_field_ok'),
                            cbBtnOK: function () {
                                var fieldId = ui.helper.parents('.field-container').attr('data-id');
                                // Eliminar del arreglo.
                                _self.fields.delFieldFromArray('bajada');
                                // Eliminar de la interfaz.
                                _self.ui.delFieldFromPanel(fieldId);

                                // Dejarlo disponible.
                                _self.ui.enableUniqueField('bajada');

                                _self.ui.showAlert();
                            },
                            cbBtnCancel: function () {}
                        });
                    }
                }
            },
            cuerpo: {
                actions: {
                    remove: function (ui) {
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_field_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_field_ok'),
                            cbBtnOK: function () {
                                var fieldId = ui.helper.parents('.field-container').attr('data-id');
                                // Eliminar del arreglo.
                                _self.fields.delFieldFromArray('cuerpo');
                                // Eliminar de la interfaz.
                                _self.ui.delFieldFromPanel(fieldId);

                                // Dejarlo disponible.
                                _self.ui.enableUniqueField('cuerpo');

                                _self.ui.showAlert();
                            },
                            cbBtnCancel: function () {}
                        });
                    }
                }
            },
            tags: {
                actions: {
                    remove: function (ui) {
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_field_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_field_ok'),
                            cbBtnOK: function () {
                                var fieldId = ui.helper.parents('.field-container').attr('data-id');
                                // Eliminar del arreglo.
                                _self.fields.delFieldFromArray('tags');
                                // Eliminar de la interfaz.
                                _self.ui.delFieldFromPanel(fieldId);

                                // Dejarlo disponible.
                                _self.ui.enableUniqueField('tags');

                                _self.ui.showAlert();
                            },
                            cbBtnCancel: function () {}
                        });
                    }
                }
            },
            multitags: {
                actions: {
                    remove: function (ui) {
                        showModalConfirm({
                            msg: ProntusL10n.get('fid_editor_delete_field_msg'),
                            type: 'red',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            okTitle: ProntusL10n.get('fid_editor_delete_field_ok'),
                            cbBtnOK: function () {
                                var fieldId = ui.helper.parents('.field-container').attr('data-id');
                                // Eliminar del arreglo.
                                _self.fields.delFieldFromArray('multitags');
                                // Eliminar de la interfaz.
                                _self.ui.delFieldFromPanel(fieldId);

                                // Dejarlo disponible.
                                _self.ui.enableUniqueField('multitags');

                                _self.ui.showAlert();
                            },
                            cbBtnCancel: function () {}
                        });
                    }
                }
            },
            addFieldToArray: function (vars) {
                _self.config.fields.push(vars);
            },
            updateFieldInArray: function (vars, index) {
                _self.config.fields[index] = $.extend({}, _self.config.fields[index], vars);
            },
            delFieldFromArray: function (type, id) {
                var newArray = [];

                for (var x = 0; x < _self.config.fields.length; x++) {
                    // Si es un campo unico (ej. tax, tags, bajada) no cuenta con placeholder, se elimina haciendo
                    // match del tipo.
                    if (_self.fields.checkUniqueField(type)) {
                        _self.helper.log('delFieldFromArray: ' + type);
                        if (_self.config.fields[x].type != type) {
                            newArray.push(_self.config.fields[x]);
                        }
                    } else {
                        _self.helper.log('delFieldFromArray: ' + id);
                        if (_self.config.fields[x].id != id) {
                            newArray.push(_self.config.fields[x]);
                        }
                    }
                }

                _self.config.fields = newArray;
            },
            getFieldFromArray: function (id) {
                for (var x = 0; x < _self.config.fields.length; x++) {
                    if (_self.config.fields[x].id == id) {
                        return _self.config.fields[x];
                    }
                }

                return false;
            },
            getFieldArrayIndex: function (id) {
                for (var x = 0; x < _self.config.fields.length; x++) {
                    if (_self.config.fields[x].id == id) {
                        return x;
                    }
                }

                return false;
            },
            addPanelToArray: function (vars) {
                _self.config.panels.push(vars);
            },
            getPanelFromArray: function (id) {
                for (var x = 0; x < _self.config.panels.length; x++) {
                    if (_self.config.panels[x].id == id) {
                        return _self.config.panels[x];
                    }
                }

                return false;
            },
            getPanelArrayIndex: function (id) {
                for (var x = 0; x < _self.config.panels.length; x++) {
                    if (_self.config.panels[x].id == id) {
                        return x;
                    }
                }

                return false;
            },
            updatePanelInArray: function (vars, index) {
                _self.config.panels[index] = $.extend({}, _self.config.panels[index], vars);
            },
            delPanelFromArray: function (id) {
                var newArray = [];

                for (var x = 0; x < _self.config.panels.length; x++) {
                    if (_self.config.panels[x].id != id) {
                        newArray.push(_self.config.panels[x]);
                    }
                }

                _self.config.panels = newArray;
            },
            delFieldsFromPanel: function (panelId) {
                var newArray = [];

                for (var x = 0; x < _self.config.fields.length; x++) {
                    if (_self.config.fields[x].panelId != panelId) {
                        newArray.push(_self.config.fields[x]);
                    } else {
                        if (_self.fields.checkUniqueField(_self.config.fields[x].type)) {
                            _self.ui.enableUniqueField(_self.config.fields[x].type);
                        }
                    }
                }

                _self.config.fields = newArray;
            },
            checkPlaceholder: function (placeholder) {
                for (var x = 0; x < _self.config.fields.length; x++) {
                    if (typeof _self.config.fields[x].placeholder != 'undefined' && _self.config.fields[x].placeholder == placeholder) {
                        return 1;
                    }
                }

                return 0;
            },
            checkVtxt: function (vtxtId) {
                for (var x = 0; x < _self.config.fields.length; x++) {
                    if (_self.config.fields[x].type == 'vtxt' && _self.config.fields[x].vtxtId == vtxtId) {
                        return 1;
                    }
                }

                return 0;
            },
            checkVideo: function (videoId) {
                for (var x = 0; x < _self.config.panels.length; x++) {
                    if (_self.config.panels[x].type == 'video' && _self.config.panels[x].videoId == videoId) {
                        return 1;
                    }
                }

                return 0;
            },
            checkAudio: function (audioId) {
                for (var x = 0; x < _self.config.panels.length; x++) {
                    if (_self.config.panels[x].type == 'audio' && _self.config.panels[x].audioId == audioId) {
                        return 1;
                    }
                }

                return 0;
            },
            checkUniqueField: function (type) {
                // Verificar si el campo es único para deshabilitarlo del set de elementos
                // ya que puede ser usado una sola vez.
                if ($.inArray(type, _self.fields.uniqueFieldType) > -1) {
                    return 1;
                }

                return 0;
            }
        },
        methods: {
            limpiarInputs: function (type) {
                $('input[id^="fid_' + type + '"]').val('');
            },
            initFid: function () {
                $('#fid-structure').empty();
                _self.lastPanelId = 0;
                _self.lastFieldId = 0;
                _self.lastTabsId = 0;
                _self.fields.currentFieldId = false;
                _self.fields.currentPanelId = false;

                if (_self.config.filename == '' && _self.config.fields.length == 0
                && _self.config.name == '' && _self.config.panels.length == 0
                && _self.config.plt == '') {
                    _self.isNew = true;
                }

                // Reset campos unicos utilizados.
                for (var x = 0; x < _self.fields.uniqueFieldType.length; x++) {
                    _self.ui.enableUniqueField(_self.fields.uniqueFieldType[x]);
                }

                var selectedOption = $('#edit_fid option:selected').val();

                if (typeof selectedOption != 'undefined') {
                    _self.actions.getFidJson(selectedOption, function (config) {
                        _self.config = config;
                        _self.ui.init();
                        _self.methods.bindEvents();
                        _self.isNew = false;
                    });
                } else {
                    // No hay fids.
                    _self.ui.init();
                    _self.methods.bindEvents();
                }
                if (_self.isNew) {
                    _self.ui.disableCmbPanels();
                } else {
                    _self.ui.enableCmbPanels();
                }
            },
            // Bindea todos las acciones a sus respectivos metodos.
            bindEvents: function (force, parentSelector) {
                var selector;

                if (typeof force == 'undefined') force = 0;

                if (!force) {
                    selector = '[data-namespace="editorfid"][data-event]:not([data-bind])';
                } else {
                    selector = '[data-namespace="editorfid"][data-event]';
                }

                if (typeof parentSelector != 'undefined') {
                    selector = parentSelector + ' ' + selector;
                }

                $(selector).each(function () {
                    var method = $(this).attr("data-method");
                    var event = $(this).attr("data-event");

                    // Validar si es un evento válido.
                    if ($.inArray(event, _self.validEvents) >= 0) {
                        if (typeof method != 'undefined') {
                            $(this).attr("data-bind", "true");
                            $(this).off(event).on(event, function (e) {
                                e.preventDefault();
                                _self.helper.execFunction(method, EditorFid, {e: e, helper: $(this)});
                            });
                        }
                    }
                });
            }
        },
        ui: {
            init: function () {
                _self.ui.addPanelsFromConfig();
                _self.ui.addFieldsFromConfig();
                _self.ui.installCmbPanels();

                _self.ui.installFidStructureSortable('#fid-structure');
            },
            installFidStructureSortable: function (selector, parentPanelId) {
                if (typeof parentPanelId == 'undefined') {
                    parentPanelId = "";
                }

                // Acá solo se reciben los paneles.
                _self.helper.log('installFidStructureSortable selector: ' + selector);

                if ($(selector).hasClass('ui-sortable')) {
                    _self.helper.log('destroy sortable');
                    $(selector).sortable('destroy');
                }

                $(selector).sortable({
                    helper: 'clone',
                    handle: '.handle',
                    placeholder: 'panel panel-primary panel-placeholder',
                    start: function () {
                        $(selector).sortable("refreshPositions");
                    },
                    stop: function (_e, ui) {
                        if (!ui.item.hasClass('btn')) {
                            // Actualizar orden.
                            $(selector + ' .panel-container').each(function (index, value) {
                                var id = $(value).attr("data-id");
                                for (var x = 0; x < _self.config.panels.length; x++) {
                                    if (_self.config.panels[x].id == id) {
                                        _self.config.panels[x].order = index;
                                    }
                                }
                            });
                        }
                    },
                    receive: function (_e, ui) {
                        var type = ui.helper.attr("data-type");
                        _self.helper.log("sortable receive type: " + ui.helper.attr("data-type"));

                        if (type == 'panel') {
                            let panelHtml = _self.ui.getPanelContainer(++_self.lastPanelId, '', parentPanelId);
                            _self.fields.currentPanelId = _self.lastPanelId;

                            $(ui.helper).replaceWith(panelHtml);
                            _self.ui.setModal({
                                title: ProntusL10n.get('fid_editor_configure_panel'),
                                description: ProntusL10n.get('fid_editor_configure_panel_help'),
                                templateId: 'panel',
                                closeMethod: 'fields.panel.actions.cancel',
                                saveMethod: 'fields.panel.actions.save',
                                show: true
                            });
                        } else if (type == 'video') {
                            if (parentPanelId) {
                                $(ui.helper).replaceWith('');
                                return;
                            }

                            let panelHtml = _self.ui.getVideoContainer(++_self.lastPanelId, '', parentPanelId);
                            _self.fields.currentPanelId = _self.lastPanelId;

                            $(ui.helper).replaceWith(panelHtml);
                            _self.ui.setModal({
                                title: ProntusL10n.get('fid_editor_configure_video'),
                                description: ProntusL10n.get('fid_editor_configure_video_help'),
                                templateId: 'video',
                                closeMethod: 'fields.video.actions.cancel',
                                saveMethod: 'fields.video.actions.save',
                                show: true
                            });
                        } else if (type == 'audio') {
                            let panelHtml = _self.ui.getAudioContainer(++_self.lastPanelId, '', parentPanelId);
                            _self.fields.currentPanelId = _self.lastPanelId;

                            $(ui.helper).replaceWith(panelHtml);
                            _self.ui.setModal({
                                title: ProntusL10n.get('fid_editor_configure_audio'),
                                description: ProntusL10n.get('fid_editor_configure_audio_help'),
                                templateId: 'audio',
                                closeMethod: 'fields.audio.actions.cancel',
                                saveMethod: 'fields.audio.actions.save',
                                show: true
                            });
                        } else if (type == 'galeria') {
                            if (parentPanelId) {
                                $(ui.helper).replaceWith('');
                                return;
                            }

                            let html = _self.ui.getGaleriaContainer(++_self.lastPanelId, '', parentPanelId);
                            _self.fields.currentPanelId = _self.lastPanelId;

                            $(ui.helper).replaceWith(html);

                            _self.ui.setModal({
                                title: ProntusL10n.get('fid_editor_configure_gallery'),
                                description: ProntusL10n.get('fid_editor_configure_gallery_help'),
                                templateId: 'galeria',
                                closeMethod: 'fields.galeria.actions.cancel',
                                saveMethod: 'fields.galeria.actions.save',
                                show: true
                            });
                        } else if (type == 'tabs') {
                            if (parentPanelId) {
                                $(ui.helper).replaceWith('');
                                return;
                            }

                            let html = _self.ui.getTabsContainer(++_self.lastPanelId);
                            _self.fields.currentPanelId = _self.lastPanelId;

                            $(ui.helper).replaceWith(html);

                            _self.ui.setModal({
                                title: ProntusL10n.get('fid_editor_configure_tabs'),
                                description: ProntusL10n.get('fid_editor_configure_tabs_help'),
                                templateId: 'tabs',
                                closeMethod: 'fields.tabs.actions.cancel',
                                saveMethod: 'fields.tabs.actions.save',
                                show: true
                            });
                        } else {
                            // Si no es un panel, audio o video lo elimina.
                            $(ui.helper).replaceWith('');
                        }
                    }
                });
            },
            disableUniqueField: function (type) {
                const selector = 'select option[value="' + type + '"]';
                $(selector).attr("disabled", true);

                $('.btn[data-type="' + type + '"]').attr("disabled", true);
            },
            enableUniqueField: function (type) {
                const selector = 'select option[value="' + type + '"]';
                $(selector).removeAttr("disabled");

                $('.btn[data-type="' + type + '"]').removeAttr("disabled");
            },
            disableCmbPanels: function() {
                $('#btnPanelDrag').draggable({ disabled: true }).addClass('disabled');
                $('#btnControlDrag').draggable({ disabled: true }).addClass('disabled');
            },
            enableCmbPanels: function() {
                $('#btnPanelDrag').draggable({ disabled: false }).removeClass('disabled');
                $('#btnControlDrag').draggable({ disabled: false }).removeClass('disabled');
            },
            installCmbPanels: function () {
                $('#btnPanelDrag').draggable({
                    helper: 'clone',
                    connectToSortable: '#fid-structure, .panel-tabs'
                });
                // inicializamos el selector al elemento Panel, para que coincida con el botón arrastrable mostrado.
                $('#cmbPanels').val('panel');
                // inicializamos el selector al elemento Input, para que coincida con el botón arrastrable mostrado.
                $('#cmbControls').val('input');

                $('#btnControlDrag').draggable({
                    helper: 'clone',
                    connectToSortable: '.panel-fields'
                });

                $('#cmbPanels').off('change').on('change', function (_e) {
                    const type = $('#cmbPanels option:selected').val();
                    const name = $('#cmbPanels option:selected').text();
                    const description = $('#cmbPanels option:selected').data('description');

                    $('#btnPanelDrag').removeAttr("disabled");
                    $('#btnPanelDrag').attr("data-type", type);
                    $('#btnPanelDrag .type-name abbr').text(name);
                    $('#btnPanelDrag .type-name abbr').attr('title', description);
                });

                $('#cmbControls').off('change').on('change', function (_e) {
                    const type = $('#cmbControls option:selected').val();
                    const name = $('#cmbControls option:selected').text();
                    const description = $('#cmbControls option:selected').data('description');

                    $('#btnControlDrag').removeAttr("disabled");
                    $('#btnControlDrag').attr("data-type", type);
                    $('#btnControlDrag .type-name abbr').text(name);
                    $('#btnControlDrag .type-name abbr').attr('title', description);
                });
            },
            addPanelsFromConfig: function () {
                let childPanels = {};
                let parentPanels = [];
                let x;

                for (x = 0; x < _self.config.panels.length; x++) {
                    let parentId = _self.config.panels[x].parentId;
                    if (parentId > 0) {
                        if (!Array.isArray(childPanels[parentId])) {
                            childPanels[parentId] = [];
                        }

                        childPanels[parentId].push(_self.config.panels[x]);
                    } else {
                        parentPanels.push(_self.config.panels[x]);
                    }
                }

                _self.ui.addPanels(parentPanels, '#fid-structure');

                const panelsWithChilds = Object.keys(childPanels);

                for (x = 0; x < panelsWithChilds.length; x++) {
                    let panels = childPanels[panelsWithChilds[x]];

                    _self.ui.addPanels(panels, '#panel' + panelsWithChilds[x] + ' .panel-tabs');
                }

            },
            addPanels: function (panels, selector) {
                if (panels.length > 0) {
                    panels = _self.helper.sortArrayOrder(panels);

                    for (let x = 0; x < panels.length; x++) {
                        let panel = panels[x];
                        let htmlContentString;
                        let htmlContainerString;

                        // Distintos tipos de paneles.
                        if (panel.type == 'video') {
                            htmlContentString = _self.ui.getVideoContent(panel.name, panel.videoId);
                            htmlContainerString = _self.ui.getVideoContainer(panel.id, htmlContentString, panel.parentId);
                        } else if (panel.type == 'audio') {
                            htmlContentString = _self.ui.getAudioContent(panel.name, panel.audioId);
                            htmlContainerString = _self.ui.getAudioContainer(panel.id, htmlContentString, panel.parentId);
                        } else if (panel.type == 'galeria') {
                            htmlContentString = _self.ui.getGaleriaContent();
                            htmlContainerString = _self.ui.getGaleriaContainer(panel.id, htmlContentString, panel.parentId);

                            _self.ui.disableUniqueField('galeria');
                        } else if (panel.type == 'tabs') {
                            htmlContentString = _self.ui.getTabsContent(panel.name);
                            htmlContainerString = _self.ui.getTabsContainer(panel.id, htmlContentString);
                        } else {
                            htmlContentString = _self.ui.getPanelContent(panel.name);
                            htmlContainerString = _self.ui.getPanelContainer(panel.id, htmlContentString, panel.parentId);
                        }

                        // Guarda el mayor para empezar de ahí + 1.
                        if (panel.id > _self.lastPanelId) {
                            _self.lastPanelId = panel.id;
                        }

                        _self.ui.addToFidStructure(htmlContainerString, selector);

                        if (panel.type == 'tabs') {
                            _self.ui.installFidStructureSortable('#panel' + panel.id + ' .panel-tabs', panel.id);
                        } else {
                            _self.ui.installPanelSortable(panel.id);
                        }
                    }
                }
            },
            addFieldsFromConfig: function () {
                _self.ui.addFields(_self.config.fields);
            },
            addFields: function (fields) {
                // Tienen que haber paneles y campos.
                if (fields.length > 0) {
                    fields = _self.helper.sortArrayOrder(fields);

                    for (let x = 0; x < fields.length; x++) {
                        let field = fields[x];
                        let htmlContentString = _self.ui.getFieldContentByType(field);
                        let htmlContainerString = _self.ui.getFieldContainer(field.id, field.type, htmlContentString);

                        if (_self.fields.checkUniqueField(field.type)) {
                            _self.ui.disableUniqueField(field.type);
                        }

                        // Guarda el mayor para empezar de ahí + 1.
                        if (field.id > _self.lastFieldId) {
                            _self.lastFieldId = field.id;
                        }

                        _self.ui.addToPanelFields(field.panelId, htmlContainerString);
                    }
                }
            },
            delFieldFromPanel: function (id) {
                _self.helper.log('delFieldFromPanel: ' + id);
                $('#field' + id).remove();
            },
            installPanelSortable: function (id) {
                // TODO: Conectar con los otros panels.
                _self.helper.log('installPanelSortable: ' + id);
                // $('#panel' + id).find('.panel-fields').sortable({
                $('#panel' + id + ' .panel-fields').sortable({
                    handle: '.handle',
                    placeholder: 'list-group-item list-group-item-info field-placeholder',
                    start: function () {
                        $('#panel' + id + ' .panel-fields').sortable("refreshPositions");
                    },
                    receive: function (_e, ui) {
                        var type = ui.helper.attr("data-type");

                        // TODO: Meter dentro de funciones cada tipo.
                        if (type == 'input') {
                            let panelHtml = _self.ui.getFieldContainer(++_self.lastFieldId, type);
                            _self.fields.currentFieldId = _self.lastFieldId;

                            $(ui.helper).replaceWith(panelHtml);

                            _self.ui.setModal({
                                title: ProntusL10n.get('fid_editor_configure_input'),
                                description: ProntusL10n.get('fid_editor_configure_input_help'),
                                templateId: 'input',
                                closeMethod: 'fields.input.actions.cancel',
                                saveMethod: 'fields.input.actions.save',
                                show: true
                            });
                        } else if (type == 'textarea') {
                            let panelHtml = _self.ui.getFieldContainer(++_self.lastFieldId, type);
                            _self.fields.currentFieldId = _self.lastFieldId;

                            $(ui.helper).replaceWith(panelHtml);

                            _self.ui.setModal({
                                title: ProntusL10n.get('fid_editor_configure_textarea'),
                                description: ProntusL10n.get('fid_editor_configure_textarea_help'),
                                templateId: 'textarea',
                                closeMethod: 'fields.textarea.actions.cancel',
                                saveMethod: 'fields.textarea.actions.save',
                                show: true
                            });
                        } else if (type == 'checkbox') {
                            let panelHtml = _self.ui.getFieldContainer(++_self.lastFieldId, type);
                            _self.fields.currentFieldId = _self.lastFieldId;

                            $(ui.helper).replaceWith(panelHtml);

                            _self.ui.setModal({
                                title: ProntusL10n.get('fid_editor_configure_checkbox'),
                                description: ProntusL10n.get('fid_editor_configure_checkbox_help'),
                                templateId: 'checkbox',
                                closeMethod: 'fields.checkbox.actions.cancel',
                                saveMethod: 'fields.checkbox.actions.save',
                                show: true
                            });
                        } else if (type == 'combobox') {
                            let panelHtml = _self.ui.getFieldContainer(++_self.lastFieldId, type);
                            _self.fields.currentFieldId = _self.lastFieldId;

                            $(ui.helper).replaceWith(panelHtml);

                            _self.ui.setModal({
                                title: ProntusL10n.get('fid_editor_configure_combobox'),
                                description: ProntusL10n.get('fid_editor_configure_combobox_help'),
                                templateId: 'combobox',
                                closeMethod: 'fields.combobox.actions.cancel',
                                saveMethod: 'fields.combobox.actions.save',
                                show: true
                            });
                        } else if (type == 'foto') {
                            let panelHtml = _self.ui.getFieldContainer(++_self.lastFieldId, type);
                            _self.fields.currentFieldId = _self.lastFieldId;

                            $(ui.helper).replaceWith(panelHtml);

                            _self.ui.setModal({
                                title: ProntusL10n.get('fid_editor_configure_photo'),
                                description: ProntusL10n.get('fid_editor_configure_photo_help'),
                                templateId: 'foto',
                                closeMethod: 'fields.foto.actions.cancel',
                                saveMethod: 'fields.foto.actions.save',
                                show: true
                            });
                        } else if (type == 'adjunto') {
                            let panelHtml = _self.ui.getFieldContainer(++_self.lastFieldId, type);
                            _self.fields.currentFieldId = _self.lastFieldId;

                            $(ui.helper).replaceWith(panelHtml);

                            _self.ui.setModal({
                                title: ProntusL10n.get('fid_editor_configure_asocfile'),
                                description: ProntusL10n.get('fid_editor_configure_asocfile_help'),
                                templateId: 'adjunto',
                                closeMethod: 'fields.adjunto.actions.cancel',
                                saveMethod: 'fields.adjunto.actions.save',
                                show: true
                            });
                        } else if (type == 'vtxt') {
                            let panelHtml = _self.ui.getFieldContainer(++_self.lastFieldId, type);
                            _self.fields.currentFieldId = _self.lastFieldId;

                            $(ui.helper).replaceWith(panelHtml);

                            _self.ui.setModal({
                                title: ProntusL10n.get('fid_editor_configure_vtxt'),
                                description: ProntusL10n.get('fid_editor_configure_vtxt_help'),
                                templateId: 'vtxt',
                                closeMethod: 'fields.vtxt.actions.cancel',
                                saveMethod: 'fields.vtxt.actions.save',
                                show: true
                            });
                        } else if (type == 'tax') {
                            let taxContent = _self.ui.getTaxContent();
                            let panelHtml = _self.ui.getFieldContainer(++_self.lastFieldId, type, taxContent);
                            _self.fields.currentFieldId = _self.lastFieldId;

                            $(ui.helper).replaceWith(panelHtml);

                            _self.methods.bindEvents(true, '#field' + _self.fields.currentFieldId);

                            _self.fields.addFieldToArray({
                                id: _self.fields.currentFieldId,
                                panelId: id,
                                type: type,
                                order: $('#field' + _self.fields.currentFieldId).index()
                            });

                            _self.ui.disableUniqueField('tax');

                            // Actualizar orden.
                            _self.fields.panel.methods.updateFieldsOrder(id);
                        } else if (type == 'taxmanual') {
                            let taxContent = _self.ui.getTaxManualContent();
                            let panelHtml = _self.ui.getFieldContainer(++_self.lastFieldId, type, taxContent);
                            _self.fields.currentFieldId = _self.lastFieldId;

                            $(ui.helper).replaceWith(panelHtml);

                            _self.methods.bindEvents(true, '#field' + _self.fields.currentFieldId);

                            _self.fields.addFieldToArray({
                                id: _self.fields.currentFieldId,
                                panelId: id,
                                type: type,
                                order: $('#field' + _self.fields.currentFieldId).index()
                            });

                            _self.ui.disableUniqueField('taxmanual');

                            // Actualizar orden.
                            _self.fields.panel.methods.updateFieldsOrder(id);
                        } else if (type == 'tags') {
                            let tagsContent = _self.ui.getTagsContent();
                            let panelHtml = _self.ui.getFieldContainer(++_self.lastFieldId, type, tagsContent);
                            _self.fields.currentFieldId = _self.lastFieldId;

                            $(ui.helper).replaceWith(panelHtml);

                            _self.methods.bindEvents(true, '#field' + _self.fields.currentFieldId);

                            _self.fields.addFieldToArray({
                                id: _self.fields.currentFieldId,
                                panelId: id,
                                type: type,
                                order: $('#field' + _self.fields.currentFieldId).index()
                            });

                            _self.ui.disableUniqueField('tags');

                            // Actualizar orden.
                            _self.fields.panel.methods.updateFieldsOrder(id);
                        } else if (type == 'multitags') {
                            let tagsContent = _self.ui.getMultiTagsContent();
                            let panelHtml = _self.ui.getFieldContainer(++_self.lastFieldId, type, tagsContent);
                            _self.fields.currentFieldId = _self.lastFieldId;

                            $(ui.helper).replaceWith(panelHtml);

                            _self.methods.bindEvents(true, '#field' + _self.fields.currentFieldId);

                            _self.fields.addFieldToArray({
                                id: _self.fields.currentFieldId,
                                panelId: id,
                                type: type,
                                order: $('#field' + _self.fields.currentFieldId).index()
                            });

                            _self.ui.disableUniqueField('multitags');

                            // Actualizar orden.
                            _self.fields.panel.methods.updateFieldsOrder(id);
                        } else if (type == 'bajada') {
                            let tagsContent = _self.ui.getBajadaContent();
                            let panelHtml = _self.ui.getFieldContainer(++_self.lastFieldId, type, tagsContent);
                            _self.fields.currentFieldId = _self.lastFieldId;

                            $(ui.helper).replaceWith(panelHtml);

                            _self.methods.bindEvents(true, '#field' + _self.fields.currentFieldId);

                            _self.fields.addFieldToArray({
                                id: _self.fields.currentFieldId,
                                panelId: id,
                                type: type,
                                order: $('#field' + _self.fields.currentFieldId).index()
                            });

                            _self.ui.disableUniqueField('bajada');

                            // Actualizar orden.
                            _self.fields.panel.methods.updateFieldsOrder(id);
                        } else if (type == 'cuerpo') {
                            let tagsContent = _self.ui.getCuerpoContent();
                            let panelHtml = _self.ui.getFieldContainer(++_self.lastFieldId, type, tagsContent);
                            _self.fields.currentFieldId = _self.lastFieldId;

                            $(ui.helper).replaceWith(panelHtml);

                            _self.methods.bindEvents(true, '#field' + _self.fields.currentFieldId);

                            _self.fields.addFieldToArray({
                                id: _self.fields.currentFieldId,
                                panelId: id,
                                type: type,
                                order: $('#field' + _self.fields.currentFieldId).index()
                            });

                            _self.ui.disableUniqueField('cuerpo');

                            // Actualizar orden.
                            _self.fields.panel.methods.updateFieldsOrder(id);
                        } else if (type == 'macro') {
                            let panelHtml = _self.ui.getFieldContainer(++_self.lastFieldId, type);
                            _self.fields.currentFieldId = _self.lastFieldId;

                            $(ui.helper).replaceWith(panelHtml);

                            _self.ui.setModal({
                                title: ProntusL10n.get('fid_editor_configure_macro'),
                                description: ProntusL10n.get('fid_editor_configure_macro_help'),
                                templateId: 'macro',
                                closeMethod: 'fields.macro.actions.cancel',
                                saveMethod: 'fields.macro.actions.save',
                                show: true
                            });
                        }
                    },
                    stop: function (_e, ui) {
                        if (!ui.item.hasClass('btn')) {
                            let panelId = ui.item.parents('.panel-container').attr("data-id");
                            // Actualizar orden.
                            $('#panel' + panelId + ' .panel-fields').find('.field-container').each(function (index, value) {
                                let _id = $(value).attr("data-id");
                                for (let x = 0; x < _self.config.fields.length; x++) {
                                    if (_self.config.fields[x].id == _id) {
                                        _self.config.fields[x].order = index;
                                    }
                                }
                            });
                        }
                    }
                });
            },
            addToFidStructure: function (htmlString, selector) {
                $(selector).append(htmlString);
            },
            addToPanelFields: function (panelId, htmlString) {
                _self.helper.log('addToPanel: ' + panelId);
                $('#panel' + panelId + ' .panel-fields').append(htmlString);
            },
            getPanelContainer: function (id, content, parentPanelId) {
                var htmlString = $('#fidElement_panel_container').html();
                htmlString = htmlString.replace(/__id__/g, id);
                htmlString = htmlString.replace(/__parentPanelId__/g, parentPanelId);

                if (typeof content != 'undefined') {
                    htmlString = htmlString.replace(/__content__/g, content);
                } else {
                    htmlString = htmlString.replace(/__content__/g, '');
                }

                return htmlString;
            },
            getVideoContainer: function (id, content, parentPanelId) {
                var htmlString = $('#fidElement_video_container').html();
                htmlString = htmlString.replace(/__id__/g, id);
                htmlString = htmlString.replace(/__parentPanelId__/g, parentPanelId);

                if (typeof content != 'undefined') {
                    htmlString = htmlString.replace(/__content__/g, content);
                } else {
                    htmlString = htmlString.replace(/__content__/g, '');
                }

                return htmlString;
            },
            getVideoContent: function (nombre, id) {
                var htmlString = $('#fidElement_video_content').html();
                htmlString = htmlString.replace(/__nombre__/, nombre);
                htmlString = htmlString.replace(/__id__/, id);

                return htmlString;
            },
            getGaleriaContainer: function (id, content, parentPanelId) {
                var htmlString = $('#fidElement_galeria_container').html();
                htmlString = htmlString.replace(/__id__/g, id);
                htmlString = htmlString.replace(/__parentPanelId__/g, parentPanelId);

                if (typeof content != 'undefined') {
                    htmlString = htmlString.replace(/__content__/g, content);
                } else {
                    htmlString = htmlString.replace(/__content__/g, '');
                }

                return htmlString;
            },
            getGaleriaContent: function () {
                var htmlString = $('#fidElement_galeria_content').html();

                return htmlString;
            },
            getAudioContainer: function (id, content, parentPanelId) {
                var htmlString = $('#fidElement_audio_container').html();
                htmlString = htmlString.replace(/__id__/g, id);
                htmlString = htmlString.replace(/__parentPanelId__/g, parentPanelId);

                if (typeof content != 'undefined') {
                    htmlString = htmlString.replace(/__content__/g, content);
                } else {
                    htmlString = htmlString.replace(/__content__/g, '');
                }

                return htmlString;
            },
            getAudioContent: function (nombre, id) {
                var htmlString = $('#fidElement_audio_content').html();
                htmlString = htmlString.replace(/__nombre__/, nombre);
                htmlString = htmlString.replace(/__id__/, id);

                return htmlString;
            },
            getTabsContainer: function (id, content) {
                var htmlString = $('#fidElement_tabs_container').html();
                htmlString = htmlString.replace(/__id__/g, id);

                if (typeof content != 'undefined') {
                    htmlString = htmlString.replace(/__content__/g, content);
                } else {
                    htmlString = htmlString.replace(/__content__/g, '');
                }

                return htmlString;
            },
            getTabsContent: function (name) {
                var htmlString = $('#fidElement_tabs_content').html();
                htmlString = htmlString.replace(/__nombre__/, name);

                return htmlString;
            },
            getPanelContent: function (name) {
                var htmlString = $('#fidElement_panel_content').html();
                htmlString = htmlString.replace(/__nombre__/, name);

                return htmlString;
            },
            getFieldContainer: function (id, type, content) {
                var htmlString = $('#fidElement_field_container').html();
                htmlString = htmlString.replace(/__id__/g, id);
                htmlString = htmlString.replace(/__type__/g, type);

                if (typeof content != 'undefined') {
                    htmlString = htmlString.replace(/__content__/g, content);
                } else {
                    htmlString = htmlString.replace(/__content__/g, '');
                }

                return htmlString;
            },
            getFieldContentByType: function (field) {
                var htmlString = '';

                if (field.type == 'input') {
                    htmlString = _self.ui.getInputContent(field.name, field.placeholder, field.clases);
                } else if (field.type == 'textarea') {
                    htmlString = _self.ui.getTextAreaContent(field.name, field.placeholder, field.clases);
                } else if (field.type == 'checkbox') {
                    htmlString = _self.ui.getCheckBoxContent(field.name, field.placeholder);
                } else if (field.type == 'adjunto') {
                    htmlString = _self.ui.getAdjuntoContent(field.name, field.placeholder);
                } else if (field.type == 'vtxt') {
                    htmlString = _self.ui.getVtxtContent(field.name, field.vtxtId);
                } else if (field.type == 'tax') {
                    htmlString = _self.ui.getTaxContent();
                } else if (field.type == 'taxmanual') {
                    htmlString = _self.ui.getTaxManualContent();
                } else if (field.type == 'tags') {
                    htmlString = _self.ui.getTagsContent();
                } else if (field.type == 'multitags') {
                    htmlString = _self.ui.getMultiTagsContent();
                } else if (field.type == 'bajada') {
                    htmlString = _self.ui.getBajadaContent();
                } else if (field.type == 'cuerpo') {
                    htmlString = _self.ui.getCuerpoContent();
                } else if (field.type == 'combobox') {
                    htmlString = _self.ui.getComboBoxContent(field.name, field.placeholder);
                } else if (field.type == 'macro') {
                    htmlString = _self.ui.getMacroContent(field.file);
                } else if (field.type == 'foto') {
                    htmlString = _self.ui.getFotoContent(field.name, field.placeholder, field.width, field.height);
                }

                return htmlString;
            },
            // TODO: Agrupar estas funciones en un objecto literal.
            // get de contenidos segun tipo.
            getInputContent: function (name, placeholder, clases) {
                var htmlString = $('#fidElement_input_content').html();
                if (clases ==  null) {
                    clases = '';
                }

                htmlString = htmlString.replace(/__nombre__/, name);
                htmlString = htmlString.replace(/__marca__/, placeholder);
                htmlString = htmlString.replace(/__clases__/, clases);
                htmlString = htmlString.replace(/__tipo__/, 'INPUT');

                return htmlString;
            },
            getCheckBoxContent: function (name, placeholder) {
                var htmlString = $('#fidElement_checkbox_content').html();

                htmlString = htmlString.replace(/__nombre__/, name);
                htmlString = htmlString.replace(/__marca__/, placeholder);
                htmlString = htmlString.replace(/__tipo__/, 'CHECKBOX');

                return htmlString;
            },
            getAdjuntoContent: function (name, placeholder) {
                var htmlString = $('#fidElement_adjunto_content').html();

                htmlString = htmlString.replace(/__nombre__/, name);
                htmlString = htmlString.replace(/__marca__/, placeholder);
                htmlString = htmlString.replace(/__tipo__/, 'ADJUNTO');

                return htmlString;
            },
            getTextAreaContent: function (name, placeholder) {
                var htmlString = $('#fidElement_textarea_content').html();

                htmlString = htmlString.replace(/__nombre__/, name);
                htmlString = htmlString.replace(/__marca__/, placeholder);
                htmlString = htmlString.replace(/__tipo__/, 'TEXTAREA');

                return htmlString;
            },
            getFotoContent: function (name, placeholder, ancho, alto) {
                var htmlString = $('#fidElement_foto_content').html();
                var size = ancho + 'x' + alto;

                htmlString = htmlString.replace(/__nombre__/, name);
                htmlString = htmlString.replace(/__marca__/, placeholder);
                htmlString = htmlString.replace(/__tipo__/, 'FOTO');
                htmlString = htmlString.replace(/__size__/, size);

                return htmlString;
            },
            getVtxtContent: function (name, id) {
                var htmlString = $('#fidElement_vtxt_content').html();
                var placeholder = 'vtxt_cuerpo' + id;

                htmlString = htmlString.replace(/__nombre__/, name);
                htmlString = htmlString.replace(/__marca__/, placeholder);
                htmlString = htmlString.replace(/__tipo__/, 'VTXT');

                return htmlString;
            },
            getComboBoxContent: function (name, placeholder) {
                var htmlString = $('#fidElement_combobox_content').html();

                htmlString = htmlString.replace(/__nombre__/, name);
                htmlString = htmlString.replace(/__marca__/, placeholder);
                htmlString = htmlString.replace(/__tipo__/, 'COMBOBOX');

                return htmlString;
            },
            getTaxContent: function () {
                var htmlString = $('#fidElement_tax_content').html();

                return htmlString;
            },
            getTaxManualContent: function () {
                var htmlString = $('#fidElement_taxmanual_content').html();

                return htmlString;
            },
            getTagsContent: function () {
                var htmlString = $('#fidElement_tags_content').html();

                return htmlString;
            },
            getMultiTagsContent: function () {
                var htmlString = $('#fidElement_multitags_content').html();

                return htmlString;
            },
            getBajadaContent: function () {
                var htmlString = $('#fidElement_bajada_content').html();

                return htmlString;
            },
            getCuerpoContent: function () {
                var htmlString = $('#fidElement_cuerpo_content').html();

                return htmlString;
            },
            getMacroContent: function (file) {
                var htmlString = $('#fidElement_macro_content').html();

                htmlString = htmlString.replace(/__file__/, file);

                return htmlString;
            },
            setModal: function (options, values, callback) {
                $('#formModal').empty();

                var html = $('#modalTemplate_' + options.templateId).html();
                $('#formModal').html(html);

                // Setea valores por defecto.
                if (typeof values != 'undefined') {
                    var keys = Object.keys(values);

                    for (var x = 0; x < keys.length; x++) {
                        $('#fid_' + keys[x]).val(values[keys[x]]);
                    }
                }

                if (typeof options.title != 'undefined') {
                    $('#modalEditorFid .modal-title').text(options.title);
                }

                if (typeof options.description != 'undefined') {
                    $('#modalEditorFid .modal-description').text(options.description);
                }

                if (typeof options.saveButtonName != 'undefined') {
                    $('#btnGuardarModal').text(options.saveButtonName);
                } else {
                    $('#btnGuardarModal').text('Aplicar');
                }

                // Cambiar metodos de los botones.
                if (typeof options.saveMethod != 'undefined') {
                    $('#btnGuardarModal').attr("data-method", options.saveMethod);

                    // Asigna al evento submit del formulario la funcion de guardardo
                    // para que cuando se presione enter se gatille dicha funcion.
                    $('#formModal').off('submit').on('submit', function (e) {
                        e.preventDefault();
                        _self.helper.log('formModal on.submit: ' + options.saveMethod);
                        _self.helper.execFunction(options.saveMethod, EditorFid, {e: e, helper: $(this)});
                    });
                }

                if (typeof options.closeMethod != 'undefined') {
                    $('#btnCerrarModal').removeAttr('data-dismiss');
                    $('#btnCerrarModal').attr("data-method", options.closeMethod);
                } else {
                    $('#btnCerrarModal').attr('data-dismiss', 'modal');
                    $('#btnCerrarModal').removeAttr('data-method');
                }

                if (typeof callback == 'function') {
                    callback();
                }

                _self.methods.bindEvents(true, '#modalEditorFid');

                if (typeof options.show != 'undefined' && options.show === true) {
                    _self.ui.showModal();
                }
            },
            showModal: function () {
                var optionExists = ($('#fid_plantilla option[value="' + _self.config.plt + '"]').length > 0);
                if (!optionExists && _self.config.plt) {
                    $('#fid_plantilla').append("<option value='" + _self.config.plt + "'>" + _self.config.plt + "</option>");
                }
                $('#fid_plantilla').val(_self.config.plt);
                $('#modalEditorFid').modal('show');
            },
            hideModal: function () {
                $('#modalEditorFid').modal('hide');
            },
            showAlert: function () {
                $('#fid-alert').show();
            },
            hideAlert: function () {
                $('#fid-alert').hide();
            },
            showLoading: function () {
                $('#modal-loading-mensaje').html(ProntusL10n.get('fid_editor_wait_prepare'));
                $('#modal-loading').modal({backdrop: 'static', keyboard: false});
            },
            hideLoading: function () {
              $('#modal-loading').modal('hide');
            }
        },
        helper: {
            execFunction: function (functionName, context) {
                var args = Array.prototype.slice.call(arguments, 2);
                var namespaces = functionName.split(".");
                var func = namespaces.pop();

                for(var i = 0; i < namespaces.length; i++) {
                    context = context[namespaces[i]];
                }

                if (typeof context[func] == 'undefined') {
                    showModalAlert({
                        title: ProntusL10n.get('global_error_title'),
                        type: 'red',
                        msg: ProntusL10n.get('global_missing_method', functionName)
                    });
                    return;
                }

                return context[func].apply(context, args);
            },
            log: function (msg) {
                if (_self.debug == 1) {
                    console.log('DEBUG', msg);
                }
            },
            sortArrayOrder: function (array) {
                array.sort(_self.helper._compareOrder);

                return array;
            },
            _compareOrder: function (a, b) {
                if (a.order < b.order) {
                    return -1;
                }

                if (a.order > b.order) {
                    return 1;
                }

                return 0;
            }
        }
    };

    $(document).ready(function () {
        EditorFid.init();
    });
})(window);
