(function (window) {
    var _self = null;
    var MediaManager = {
        validEvents: ['click', 'hover'],
        basicInit: function () {
            _self = this;
        },
        init: function () {
            _self = this;
            _self.fotofija.methods.getFotosFijas();
            _self.bancoimg.init();
            _self.upload.methods.initDropZone();
            _self.upload.methods.initDropZoneZip();

            $('.fotofija').each(function () {
                var name = $(this).data('id').substring(9);
                var wfoto = $(this).data('wfoto');
                var hfoto = $(this).data('hfoto');
                var wmax = $(this).find('input[name^="' + Admin.const.fotoFijaMaxWTag + '"]').val();
                var hmax = $(this).find('input[name^="' + Admin.const.fotoFijaMaxHTag + '"]').val();
                MediaManager.fotofija.methods.newInstance(name, wmax, hmax, wfoto, hfoto);
            });

            _self.fotofija.init();
            _self.dam.init();
            // bind globales
            _self.methods.bindEvents();
            _self.galeria.check();
            $('#scroll-banco').tooltip({selector: '[data-toggle="tooltip"]', delay: {  "hide": 500 }, trigger: 'hover'});

            // leemos la ejecucion desde el panel Galería de Fotos del FID
            $('#abrir_subir_imagenes_zip').click(function(e) {
                e.preventDefault();
                $('html,body').stop();
                $('#tab-carga-masiva').tab('show');
                $('#_asignar_galeria').prop('checked', true);
                MediaManager.bancoimg.actions.showFotoUpload();
            });

            // cerramos el menu para asignar fotos al hacer click fuera
            $(document).click(function(event) {
                if($(event.target).closest('.banco-acciones').length) {
                    return;
                } else if(!$(event.target).closest('#fotofijamenu').length) {
                    if($('#fotofijamenu').is(":visible")) {
                        $('.banco-acciones .active').removeClass('active');
                        $('#fotofijamenu').hide();
                    }
                }
            });

            // mostramos la galería como grilla para manipular fácilmente
            $('#galeria-grid-view').click(function() {
                $('#_galeria_prontus_view div.fotofija-container').removeClass('fotofija-container-list');
                $('#_galeria_prontus_view div.fotofija-galeria-inputs').removeClass('fotofija-galeria-inputs-shown').addClass('fotofija-galeria-inputs-hidden');
                $('#_galeria_prontus_view div.botones span.glyphicon.glyphicon-pencil').show();
                return false;
            });

            // mostramos la galería como lista para editar descripciones y créditos fácilmente.
            $('#galeria-list-view').click(function() {
                $('#_galeria_prontus_view div.fotofija-container').addClass('fotofija-container-list');
                $('#_galeria_prontus_view div.fotofija-galeria-inputs').addClass('fotofija-galeria-inputs-shown').removeClass('fotofija-galeria-inputs-hidden');

                // en modo lista es innecesario el boton editar.
                $('#_galeria_prontus_view div.botones span.glyphicon.glyphicon-pencil').hide();

                // buscamos y rellenamos los inputs de descripcion  y credito.
                $('#_galeria_prontus_view div.fotofija-galeria-inputs div.form-group textarea').each(function() {
                    // el valor de id viene despues del texto '_galeria_desc_temporal'
                    var numfoto = parseInt($(this).data('numfoto'));

                    var thearrayid = numfoto - 1;
                    $('#_galeria_desc_temporal'+numfoto).val(_self.galeria.descArr[thearrayid]);

                    // procesamos también los créditos.
                    $('#_galeria_cred_temporal'+numfoto).val(_self.galeria.credArr[thearrayid]);
                    ProntusConf.mv.forEach(function(vista) {
                        $('#_galeria_desc_temporal'+numfoto +'_' + vista).val(_self.galeria.descArrMV[vista][thearrayid]);

                        // procesamos también los créditos.
                        $('#_galeria_cred_temporal'+numfoto +'_' + vista).val(_self.galeria.credArrMV[vista][thearrayid]);
                    });
                });

                $('#_galeria_prontus_view textarea.galeria_desc_temporal_list').blur(function() {
                    var numfoto = parseInt($(this).data('numfoto'), 10);
                    var desc = $('#_galeria_desc_temporal'+numfoto).val();
                    $('#txt_galeria_descripcion_foto' + numfoto).val(desc);

                    _self.galeria.descArr[numfoto - 1] = desc;

                    ProntusConf.mv.forEach(function(vista) {
                        desc = $('#_galeria_desc_temporal'+numfoto+'_' + vista).val();
                        $('#txt_galeria_descripcion_foto' + numfoto+'_' + vista).val(desc);

                        _self.galeria.descArrMV[vista][numfoto - 1] = desc;
                    });

                    _self.galeria.methods.updateDescCred();
                    return false;
                });

                $('#_galeria_prontus_view input.galeria_cred_temporal_list').blur(function() {
                    var numfoto = parseInt($(this).data('numfoto'), 10);
                    var cred = $('#_galeria_cred_temporal'+numfoto).val();
                    $('#txt_galeria_credito_foto' + numfoto).val(cred);

                    _self.galeria.credArr[numfoto - 1] = cred;

                    ProntusConf.mv.forEach(function(vista) {
                        cred = $('#_galeria_cred_temporal'+numfoto +'_' + vista).val();
                        $('#txt_galeria_credito_foto' + numfoto +'_' + vista).val(cred);

                        _self.galeria.credArrMV[vista][numfoto - 1] = cred;
                    });

                    _self.galeria.methods.updateDescCred();
                    return false;
                });

                return false;
            });
            $('#galeria-clean').click(_self.galeria.actions.removeAll);
        },
        upload: {
            fotofijaTargets: [],
            methods: {
                initDropZone: function () {
                    var template = $('#upload_queue_file').html();
                    var options = '';

                    for (let x = 0; x < _self.fotofija.fotosFijas.length; x++) {
                        options += "<option value=\"{0}\">{1}</option>\n".format(_self.fotofija.fotosFijas[x].id, _self.fotofija.fotosFijas[x].label);
                    }

                    template = template.replace(/__options__/g, options);
                    // carga de imagenes
                    $('#upload_img_zone').dropzone({
                        url: '/{0}/prontus_art_upload.cgi'.format(Admin.dir_cgi_cpn),
                        paramName: '_archivo',
                        previewTemplate: template,
                        thumbnailHeight: 60,
                        thumbnailWidth: 60,
                        thumbnailMethod: 'crop',
                        clickable: '#upload_img_button_select',
                        autoProcessQueue: false,
                        autoQueue: true,
                        maxFilesize: Admin.maxFileSizeM,
                        timeout: null,
                        parallelUploads: 20,
                        acceptedFiles: '.jpg,.jpeg,.jpe,.png,.gif,.bmp,.svg,.webp',
                        dictInvalidFileType: ProntusL10n.get('global_invalid_filetype'),
                        params: {_prontus_id: Admin.prontus_id, _type: 'foto', _dir_fecha: $('input[name="_dir_fecha"]').val(), _ts: mainFidJs.TS},
                        success: function (data) {
                            if (data.status == 'success') {
                                var response = JSON.parse(data.xhr.response);
                                if (response.status == 1) {
                                    $(data.previewElement).find('[data-dz-remove]').hide();
                                    $(data.previewElement).find('[data-dz-itemok]').show();
                                    $(data.previewElement).addClass('list-group-item-success');

                                    var idlist = $(data.previewElement).find('select[data-dz-fotofija] option:selected').map(function () {
                                        return this.value;
                                    }).get();

                                    // Listado de campos de tipo fotofija a los cuales se asignara la foto (una sola).
                                    var idlist2 = $(data.previewElement).find('select[data-dz-fotofija] option:selected').map(function () {
                                        for (let x = 0; x < _self.fotofija.fotosFijas.length; x++) {
                                            if (_self.fotofija.fotosFijas[x].id == this.value) {
                                                // Nombre de la fotofija @ Ancho @ Alto
                                                return this.value + '@' + _self.fotofija.fotosFijas[x].maxw + '@' + _self.fotofija.fotosFijas[x].maxh;
                                            }
                                        }
                                    }).get();

                                    if (!mainFidJs.TS) {
                                        data.previewElement.fotoInfo = {
                                            relpath: response.msg,
                                            idlist: idlist,
                                            idlist2: idlist2
                                        };
                                    } else {
                                        var foto_info = response.msg.split(';');

                                        // Guardar info de la foto en el objeto del archivo.
                                        data.previewElement.fotoInfo = {
                                            relpath: foto_info[0],
                                            nomfoto: foto_info[1],
                                            w: foto_info[2],
                                            h: foto_info[3],
                                            idlist: idlist,
                                            idlist2: idlist2
                                        };
                                    }
                                } else {
                                    $(data.previewElement).addClass('list-group-item-danger');
                                    $(data.previewElement).find('[data-dz-errormessage]').text(response.msg);
                                }
                            }

                            Dropzone.forElement('#upload_img_zone').processQueue();
                        },
                        // Hay que esperar que todos los archivos terminen para manejar el termino de la cola.
                        queuecomplete: function () {
                            $('#modal_upload_img').find('.botones button').removeAttr("disabled");
                            $('#modal_upload_img').find('.botones .btn-upload span').removeClass('glyphicon-refresh spinning').addClass('glyphicon-upload');

                            var mydz_q = Dropzone.forElement('#upload_img_zone');
                            var files = mydz_q.getAcceptedFiles();
                            var success = 0;
                            var error = 0;

                            for (var x = 0; x < files.length; x++) {
                                if (files[x].status == 'success') {
                                    if (typeof files[x].previewElement.fotoInfo === 'undefined') {
                                        error++;
                                        continue;
                                    } else {
                                        success++;
                                    }

                                    if (!mainFidJs.TS) { // Es nuevo.
                                        if (typeof files[x].previewElement.fotoInfo.relpath != 'undefined') {
                                            var _upload_new_art = $('#_upload_new_art').val();
                                            var _upload_new_art_fotofija = $('#_upload_new_art_fotofija').val();

                                            if (_upload_new_art === '') {
                                                $('#_upload_new_art').val(files[x].previewElement.fotoInfo.relpath);
                                            } else {
                                                $('#_upload_new_art').val(_upload_new_art + "," + files[x].previewElement.fotoInfo.relpath);
                                            }

                                            if (_upload_new_art_fotofija === '') {
                                                // Se separa por comma cada set de fotosfijas para una foto. A cada set se asignara una foto y se generaran los tamaños correspondientes.
                                                $('#_upload_new_art_fotofija').val(files[x].previewElement.fotoInfo.idlist2.join(','));
                                            } else {
                                                // Se separa con | cada conjunto de fotosfijas.
                                                $('#_upload_new_art_fotofija').val(_upload_new_art_fotofija + '|' + files[x].previewElement.fotoInfo.idlist2.join(','));
                                            }
                                        }
                                    } else { // El articulo ya existe.
                                        if (typeof files[x].previewElement.fotoInfo.idlist != 'undefined' && Array.isArray(files[x].previewElement.fotoInfo.idlist) === true) {
                                            // Asignar fotos a fotofija.
                                            for (var y = 0; y < files[x].previewElement.fotoInfo.idlist.length; y++) {
                                                _self.fotofija.foto.set(
                                                    files[x].previewElement.fotoInfo.idlist[y],
                                                    files[x].previewElement.fotoInfo.relpath,
                                                    files[x].previewElement.fotoInfo.w,
                                                    files[x].previewElement.fotoInfo.h,
                                                    true
                                                );
                                            }
                                        }

                                        // Agregar campos _wfoto y _hfoto al fid.
                                        var html = [
                                            '<input type="hidden" name="_w%%numfoto%%" value="%%wfoto%%">',
                                            '<input type="hidden" name="_h%%numfoto%%" value="%%hfoto%%">',
                                            '<input type="hidden" name="_o%%numfoto%%" value="1">'
                                        ].join("").replace(/%%numfoto%%/g, files[x].previewElement.fotoInfo.nomfoto)
                                        .replace(/%%wfoto%%/g, files[x].previewElement.fotoInfo.w)
                                        .replace(/%%hfoto%%/g, files[x].previewElement.fotoInfo.h);

                                        $("#_mainFidForm").prepend(html);
                                    }
                                } else {
                                    error++;
                                }
                            }

                            if (success > 0) {
                                if (mainFidJs.TS) {
                                    _self.bancoimg.methods.reloadBancoImagenes();
                                    _self.dam.actions.updateDamArt();
                                }

                                $('#upload_status_msg b').text(ProntusL10n.get('mediamanager_uploaded_files', success));
                                $('#upload_status_msg').show();

                                if (!mainFidJs.TS) { // Es nuevo. Se debe guardar para asociar las fotos al articulo.
                                    _self.helper.submitForm();
                                }
                            }

                            mydz_q.files = [];
                            mydz_q.disable();
                            mydz_q.enable();

                            if (error == 0) {
                                $('#upload_img_zone li:gt(0)').remove();
                            } else {
                                $('#upload_img_zone .list-group-item-success').remove();
                            }
                        },
                        error: function(file, errorMessage, xhrObject) {
                            if (file.status === 'canceled') {
                                // usuario cancela carga
                                return;
                            }
                            var msg = ProntusL10n.get('global_upload_error', '1');
                            if (xhrObject && xhrObject.status == '413') {
                                msg = ProntusL10n.get('global_file_too_large');
                            } else if (xhrObject && (xhrObject.status == '500' || xhrObject.status == '502')) {
                                msg = ProntusL10n.get('mediamanager_server_error');
                            } else if (xhrObject && xhrObject.status == '504') {
                                msg = ProntusL10n.get('mediamanager_processing_error');
                            } else if (this.options.maxFilesize && file.size > this.options.maxFilesize * 1048576) {
                                msg = ProntusL10n.get('global_file_too_large');
                                this.removeFile(file);
                            } else if (file.status === 'error' && !file.accepted) {
                                msg = ProntusL10n.get('global_supported_filetypes', this.options.acceptedFiles);
                                this.removeFile(file);
                            }
                            showModalAlert({
                                title: ProntusL10n.get('global_load_error'),
                                type: 'red',
                                msg: msg
                            });
                        }
                    });

                    // Instancia de dropzone.
                    var mydz = Dropzone.forElement('#upload_img_zone');

                    // Evento que se llama cuando se agrega un nuevo archivo a la cola.
                    mydz.on('addedfile', function (file) {
                        var $select = $(file.previewElement).find('select[data-dz-fotofija]');

                        $(file.previewElement).find('.fotofija-options').show();

                        for (let x = 0; x < _self.upload.fotofijaTargets.length; x++) {
                            $select.find('option[value="' + _self.upload.fotofijaTargets[x] + '"]').attr("disabled", "disabled");
                        }

                        $select.off('change').on('change', function() {
                            var selected_values = $(this).val();
                            var not_selected_values = $(this).find('option:not(:selected):enabled').map(function () {if (this.value) { return this.value;}});

                            for (let x = 0; x < not_selected_values.length; x++) {
                                var index = _self.upload.fotofijaTargets.indexOf(not_selected_values[x]);
                                _self.upload.fotofijaTargets.slice(index, 1);
                            }

                            for (let x = 0; x < selected_values.length; x++) {
                                if ($.inArray(selected_values[x], _self.upload.fotofijaTargets) < 0) {
                                    _self.upload.fotofijaTargets.push(selected_values[x]);
                                }
                            }

                            $("#upload_img_zone [data-dz-fotofija]").not(this).each(function () {
                                for (let x = 0; x < _self.upload.fotofijaTargets.length; x++) {
                                    $(this).find('option[value="' + _self.upload.fotofijaTargets[x] + '"]:not(:selected)').attr("disabled", "disabled");
                                }

                                for (let x = 0; x < not_selected_values.length; x++) {
                                    $(this).find('option[value="' + not_selected_values[x] + '"]:disabled').removeAttr("disabled");
                                }
                            });
                        });
                    });

                    // Evento que se llama cuando se quita un archivo de la cola.
                    mydz.on('removedfile', function (file) {
                        var $select = $(file.previewElement).find('select[data-dz-fotofija]');
                        var selected_values = $select.val();

                        for (let x = 0; x < selected_values.length; x++) {
                            var index = _self.upload.fotofijaTargets.indexOf(selected_values[x]);
                            _self.upload.fotofijaTargets.slice(index, 1);
                        }

                        $("#upload_img_zone [data-dz-fotofija]").not($select).each(function () {
                            for (let x = 0; x < selected_values.length; x++) {
                                $(this).find('option[value="' + selected_values[x] + '"]:disabled').removeAttr("disabled");
                            }
                        });
                    });


                    mydz.on('totaluploadprogress', function (a, _b, _c) {
                        var prog = Math.ceil(a);

                        $('#upload_progress_img').width(prog + '%').text(prog + '%');
                    });
                },
                initDropZoneZip: function () {
                    var template = $('#upload_queue_file').html();
                    template = template.replace('__options__', '');
                    // carga de imagenes en zip
                    $('#upload_zip_zone').dropzone({
                        url: '/{0}/prontus_art_upload.cgi'.format(Admin.dir_cgi_cpn),
                        paramName: '_archivo',
                        previewTemplate: template,
                        thumbnailHeight: 60,
                        thumbnailWidth: 60,
                        thumbnailMethod: 'crop',
                        clickable: '#upload_zip_button_select',
                        autoProcessQueue: false,
                        autoQueue: true,
                        maxFiles: 1,
                        maxFilesize: Admin.maxFileSizeM,
                        timeout: null,
                        parallelUploads: 1,
                        acceptedFiles: '.zip',
                        dictInvalidFileType: ProntusL10n.get('global_invalid_filetype'),
                        params: {_prontus_id: Admin.prontus_id, _type: 'foto_zip', _ts: mainFidJs.TS, _dir_fecha: $('input[name="_dir_fecha"]').val()},
                        success: function (data) {
                            if (data.status == 'success') {
                                var response = JSON.parse(data.xhr.response);
                                if (response.status == 1) {
                                    setTimeout(_self.upload.actions.procesaCargaZip, 2000, response.id, data.previewElement);
                                } else {
                                    $().addClass('list-group-item-danger');
                                    $(data.previewElement).find('[data-dz-errormessage]').text(response.msg);
                                    $('#upload_status_msg_zip').hide();
                                }
                            }
                        },
                        // En comparacion con las fotos sueltas, el zip es un solo archivo y no es necesario manejar
                        // todo al termino de la cola.
                        queuecomplete: function () {
                            $('#modal_upload_img').find('.botones button').removeAttr("disabled");
                            $('#modal_upload_img').find('.botones .btn-upload span').removeClass('glyphicon-refresh spinning').addClass('glyphicon-upload');

                            var mydz_q = Dropzone.forElement('#upload_zip_zone');
                            if (mydz_q.files[0] && mydz_q.files[0].accepted == true) {
                                $('#upload_status_msg_zip b').text(ProntusL10n.get('mediamanager_images_uploaded_success'));
                                $('#upload_status_msg_zip').show();
                            }

                            mydz_q.files = [];
                            mydz_q.disable();
                            mydz_q.enable();
                        },
                        error: function(file, errorMessage, xhrObject) {
                            if (file.status === 'canceled') {
                                // usuario cancela carga
                                return;
                            }
                            var msg = ProntusL10n.get('global_upload_error', '2');
                            if (xhrObject && xhrObject.status == '413') {
                                msg = ProntusL10n.get('global_file_too_large');
                            } else if (xhrObject && xhrObject.status == '502') {
                                msg = ProntusL10n.get('mediamanager_server_error');
                            } else if (xhrObject && xhrObject.status == '504') {
                                msg = ProntusL10n.get('mediamanager_processing_error');
                            } else if (this.options.maxFilesize && file.size > this.options.maxFilesize * 1048576) {
                                msg = ProntusL10n.get('global_file_too_large');
                                this.removeFile(file);
                            } else if (file.status === 'error' && !file.accepted) {
                                msg = ProntusL10n.get('global_supported_filetypes', this.options.acceptedFiles);
                                this.removeFile(file);
                            }
                            showModalAlert({
                                title: ProntusL10n.get('global_load_error'),
                                type: 'red',
                                msg: msg
                            });
                        }
                    });

                    var mydz = Dropzone.forElement('#upload_zip_zone');

                    mydz.on('addedfile', function (file) {
                        $(file.previewElement).find('[data-dz-thumbnail]').hide();
                        $(file.previewElement).find('.glyphicon-compressed').show();
                    });

                    mydz.on('totaluploadprogress', function (a) {
                        var prog = Math.ceil(a);
                        $('#upload_progress_img_zip').width(prog + '%').text(prog + '%');
                    });
                }
            },
            actions: {
                procesaCargaZip: function (identifier, previewElement) {
                    // truco para pasar los valores al siguiente llamado ajax
                    var data1 = identifier;
                    var data2 = previewElement;
                    var url = '/' + Admin.prontus_id + '/cpan/procs/galeria/' + identifier + '.json';
                    $.ajax({
                        url: url,
                        dataType: 'json',
                        cache: false,
                        success: function (response) {
                            if (response.status == 1) {
                                if (typeof response.aceptadas === 'undefined' && typeof response.descartadas === 'undefined') {
                                    setTimeout(_self.upload.actions.procesaCargaZip, 2000, data1, data2);
                                    return false;
                                }

                                $(previewElement).find('[data-dz-remove]').hide();
                                $(previewElement).find('[data-dz-itemok]').show();
                                $(previewElement).addClass('list-group-item-success');

                                var fotos, x, y, html, id;
                                fotos = [];

                                if (!mainFidJs.TS) { // El artículo es nuevo.
                                    if (typeof response.aceptadas !== 'undefined') {
                                        fotos = response.aceptadas;
                                        $('#_upload_new_art').val(response.aceptadas.join(','));
                                    } else {
                                        $('#_upload_new_art').val('');
                                    }

                                    if ($('#_asignar_galeria:checked').val() == 1) {
                                        // Generar set de fotofijas para cada foto y asignarlos al campo _upload_new_art_fotofijas.
                                        var upload_new_art_fotofijas = [];
                                        html = _self.galeria.template_foto_input;

                                        for (x = 0; x < fotos.length; x++) {
                                            var sizes = [];
                                            id = x + 1;

                                            for (y = 0; y < _self.galeria.tamanos.length; y++) {
                                                var name = _self.galeria.tamanos[y].name;
                                                name = name.replace('@@', id);
                                                sizes.push(name + '@' + _self.galeria.tamanos[y].w + '@' + _self.galeria.tamanos[y].h + '@' + _self.galeria.tamanos[y].fit);

                                                // Agregar inputs de las fotosfijas vacios para que la cgi pueda asociar las fotos.
                                                var html_tmp = html.replace(/__inputname__/g, name);
                                                html_tmp = html_tmp.replace(/__w__/g, _self.galeria.tamanos[y].w);
                                                html_tmp = html_tmp.replace(/__h__/g, _self.galeria.tamanos[y].h);
                                                html_tmp = html_tmp.replace(/__fit__/g, _self.galeria.tamanos[y].fit);
                                                html_tmp = html_tmp.replace(/__relfoto__/g, '');

                                                $('#_galeria_prontus_inputs').append(html_tmp);
                                            }

                                            upload_new_art_fotofijas.push(sizes);
                                        }

                                        $('#_upload_new_art_fotofija').val(upload_new_art_fotofijas.join('|'));
                                        $('#_upload_new_art_fotofija_galeria').val(1);
                                    }
                                    _self.helper.submitForm();
                                } else {
                                    _self.bancoimg.methods.reloadBancoImagenes();
                                    _self.dam.actions.updateDamArt();

                                    var fotos_descartadas = [];
                                    if (typeof response.aceptadas !== 'undefined') {
                                        fotos = response.aceptadas;
                                    }
                                    if (typeof response.descartadas !== 'undefined') {
                                        fotos_descartadas = response.descartadas;
                                    }

                                    for (x = 0; x < fotos.length; x++) {
                                        // formato path;fotonum;w;hs
                                        var info = fotos[x].split(';');
                                        var fsplit = info[0].split(/\//);

                                        // Agregar campos _wfoto y _hfoto al fid.
                                        html = [
                                            '<input type="hidden" name="_w%%numfoto%%" value="%%wfoto%%">',
                                            '<input type="hidden" name="_h%%numfoto%%" value="%%hfoto%%">'
                                        ].join("").replace(/%%numfoto%%/g, info[1])
                                        .replace(/%%wfoto%%/g, info[2])
                                        .replace(/%%hfoto%%/g, info[3]);

                                        $("#_mainFidForm").prepend(html);

                                        // Agregar fotos a la galeria despues de que el zip se descomprima y procese.
                                        // Es necesario que se guarde el artículo despues de esto.
                                        if ($('#_asignar_galeria:checked').val() == 1) {
                                            id = ++_self.galeria.total;

                                            for (y = 0; y < _self.galeria.tamanos.length; y++) {
                                                if (_self.galeria.tamanos[y].num == 1) {
                                                    _self.galeria.methods.addThumbnail(fsplit[fsplit.length - 1], fsplit[fsplit.length - 1], id);
                                                    _self.galeria.descArr.push('');
                                                    _self.galeria.credArr.push('');
                                                    ProntusConf.mv.forEach(function(vista) {
                                                        _self.galeria.descArrMV[vista].push('');
                                                        _self.galeria.credArrMV[vista].push('');
                                                    });
                                                    _self.galeria.methods.addDescCred(id);
                                                }

                                                _self.galeria.tamanos[y].fotos.push(fsplit[fsplit.length - 1]);
                                                _self.galeria.methods.addInput(id, _self.galeria.tamanos[y], fsplit[fsplit.length - 1]);
                                                _self.galeria.methods.bindBotonesFoto();
                                                _self.methods.bindEvents();
                                                _self.galeria.methods.updateGaleria();
                                            }
                                        }
                                    }
                                    if (fotos_descartadas.length > 0) {
                                        $(previewElement).addClass('list-group-item-danger');
                                        $(previewElement).find('[data-dz-errormessage]').text(ProntusL10n.get('mediamanager_files_discarded', fotos_descartadas.join(', ')));
                                    }
                                } //fin procesamiento
                            } else {
                                $(previewElement).addClass('list-group-item-danger');
                                $(previewElement).find('[data-dz-errormessage]').text(response.msg);
                                $('#upload_status_msg_zip').hide();
                            }
                        }
                    });
                },
                processQueue: function () {
                    var mydz = Dropzone.forElement('#upload_img_zone');

                    if (mydz.getQueuedFiles().length > 0) {
                        $('#upload_progress_img').width('0%').text('');
                        $('#modal_upload_img').find('.botones button').attr("disabled", "disabled");
                        $('#modal_upload_img').find('.botones .btn-upload span').removeClass('glyphicon-upload').addClass('glyphicon-refresh spinning');
                        $('#upload_status_msg b').text(ProntusL10n.get('mediamanager_uploading_files'), mydz.getQueuedFiles().length);
                        $('#upload_status_msg').show();
                        mydz.processQueue();
                    }
                },
                processQueueZip: function () {
                    var mydz = Dropzone.forElement('#upload_zip_zone');

                    if (mydz.getQueuedFiles().length > 0) {
                        $('#upload_progress_zip').width('0%').text('');
                        $('#modal_upload_img').find('.botones button').attr("disabled", "disabled");
                        $('#modal_upload_img').find('.botones .btn-upload span').removeClass('glyphicon-upload').addClass('glyphicon-refresh spinning');
                        $('#upload_status_msg_zip b').text(ProntusL10n.get('mediamanager_uploading_processing'));
                        $('#upload_status_msg_zip').show();
                        mydz.processQueue();
                    }
                },
                closeModal: function () {
                    $('#modal_upload_img').modal('hide');
                    $('#upload_img_zone li:gt(0)').remove();
                    $('#upload_zip_zone li:gt(0)').remove();
                    $('#upload_status_msg').hide();
                    $('#upload_status_msg_zip').hide();

                    _self.upload.fotofijaTargets = [];
                    var mydz = Dropzone.forElement('#upload_img_zone');
                    var mydz2 = Dropzone.forElement('#upload_zip_zone');

                    mydz.files = [];
                    mydz.disable();

                    mydz2.files = [];
                    mydz2.disable();
                },
                clearQueue: function () {
                    $('#upload_img_zone li:gt(0)').remove();
                    $('#upload_status_msg b').text('');
                    $('#upload_status_msg').hide();
                    var mydz = Dropzone.forElement('#upload_img_zone');

                    mydz.disable();
                    mydz.files = [];
                    mydz.enable();
                }
            }
        },
        bancoimg: {
            tmpFotosDelete: {},
            loaded: 0,
            init: function () {
                $('#banco-img .delete-unused').on('click', MediaManager.bancoimg.actions.deleteUnused);
                $('#scroll-banco .item').each(function () {
                    var fotoSrcBanco = $(this).find('input[name^="_path_foto"]').val();
                    if (!window.isSecureContext) {
                        $(this).find('[data-method="actions.copyUrlImg"]').remove();
                    }
                    var $objSinUsar = $(this).find('.sin-usar');

                    $('.content').find('input[name^="' + Admin.const.fotoFijaTag + '"]').each(function () {
                        var fotoSrc = $(this).val();
                        if (fotoSrc && fotoSrc == fotoSrcBanco) {
                            $objSinUsar.remove();
                        }
                    });

                    let fotoSrcPublic = $(this).find('.fotodrag').data('src');
                    $('.VTXT_EDITOR').each(function () {
                        let cuerpo = $(this).val();
                        if (cuerpo.indexOf(fotoSrcPublic) != -1) {
                            $objSinUsar.remove();
                        }
                    });
                });
                _self.bancoimg.methods.initLazyLoad();
            },
            methods: {
                initLazyLoad: function () {
                    var lazyImages = [].slice.call(document.querySelectorAll("div.foto-container > img"));
                    if ("IntersectionObserver" in window) {
                        var lazyImageObserver = new IntersectionObserver(function(entries) {
                            entries.forEach(function(entry) {
                                if (entry.isIntersecting) {
                                    var lazyImage = entry.target;
                                    lazyImage.src = lazyImage.dataset.src;
                                    lazyImageObserver.unobserve(lazyImage);
                                }
                            });
                        });

                        lazyImages.forEach(function(lazyImage) {
                          lazyImageObserver.observe(lazyImage);
                        });
                    }
                },
                closeModalEditor: function () {
                    $('#modal_editor').modal('hide');
                    $('#modal_editor_iframe').attr("src", "");
                },
                reloadBancoImagenes: function (callback) {
                    var url = "/{0}/prontus_art_banco.cgi".format(Admin.dir_cgi_cpn);
                    $.ajax({
                        url: url,
                        dataType: "json",
                        data: { _ts: mainFidJs.TS, _prontus_id: Admin.prontus_id },
                        type: 'POST',
                        success: function (response) {
                            if (response.status == 1) {
                                $('#scroll-banco').html(response.msg);

                                _self.fotofija.methods.initDraggableBanco();
                                _self.bancoimg.methods.addDragImagenes();

                                $('#scroll-banco .item').each(function () {
                                    var name = $(this).find('input[name^="_hidd_foto"]').attr("name").replace('_hidd_', '');
                                    var fotosrcbanco = $(this).find('input[name^="_path_foto"]').val();
                                    var $objSinUsar = $(this).find('.sin-usar');

                                    if (_self.bancoimg.tmpFotosDelete[name] == 1) {
                                        // Marcar como borrado.
                                        _self.bancoimg.actions.deleteFoto({helper: $(this).find('[data-method="bancoimg.actions.deleteFoto"]')});
                                    }

                                    // Solo si esta habilitada la galeria prontus.
                                    if ($('#_galeria_prontus_conf').length > 0) {
                                        $('#_galeria_prontus_inputs').find('input.fotofija-galeria').each(function () {
                                            var fotosrc = $(this).val();
                                            if (fotosrc && fotosrc == fotosrcbanco) {
                                                $objSinUsar.remove();
                                            }
                                        });
                                    }

                                    if (!window.isSecureContext) {
                                        $(this).find('[data-method="actions.copyUrlImg"]').remove();
                                    }

                                    $('.content').find('[id^="recuadro_'+ Admin.const.fotoFijaTag + '"]').each(function () {
                                        var fotosrc = $(this).find('img').attr("src");
                                        if (fotosrc && fotosrc == fotosrcbanco) {
                                            $objSinUsar.remove();
                                        }
                                    });

                                    let fotoSrcPublic = $(this).find('.fotodrag').data('src');
                                    $('.VTXT_EDITOR').each(function () {
                                        let cuerpo = $(this).val();
                                        if (cuerpo.indexOf(fotoSrcPublic) != -1) {
                                            $objSinUsar.remove();
                                        }
                                    });
                                });

                                _self.bancoimg.loaded = 1;
                                _self.bancoimg.tmpFotosDelete = {};
                                _self.methods.bindEvents();
                                _self.bancoimg.methods.initLazyLoad();

                                if (typeof callback == 'function') callback(response);
                            } else {
                                showModalAlert({
                                    title: ProntusL10n.get('global_error_title'),
                                    type: 'red',
                                    msg: response.msg
                                });
                            }
                        }
                    });
                },
                // Activa el handler de Drag&Drop de fotos para Chrome en Mac
                addDragImagenes: function() {
                    if (Fid.isGecko && Fid.isMac) {
                        var elems = document.getElementsByTagName("img");
                        var matchClass = 'fotodrag';

                        for (var i in elems) {
                            if((' ' + elems[i].className + ' ').indexOf(' ' + matchClass + ' ') > -1) {
                                elems[i].addEventListener("dragstart", function(_event) {
                                    _event.dataTransfer.setData('imagen', this.outerHTML);
                                }, false);
                            }
                        }
                    }
                }
            },
            actions: {
                deleteUnused: function (e) {
                    if (e) {
                        e.stopPropagation();
                        e.preventDefault();
                    }

                    $('#modal-loading-mensaje').html('Por favor espere mientas se cargan todas las fotos para borrar');
                    $('#modal-loading').modal({backdrop: 'static', keyboard: false});

                    if (_self.bancoimg.loaded == 0) {
                        _self.bancoimg.methods.reloadBancoImagenes(function () {
                            $('.banco-vermas').remove();
                            _self.bancoimg.actions.deleteUnused();
                        });
                    } else {
                        $('#scroll-banco .item .sin-usar').each(function () {
                            $(this).parent().parent().parent().parent().parent().find('.banco-acciones .deleteFoto').trigger('click');
                        });
                        $('#modal-loading').modal('hide');
                    }
                },
                loadMore: function () {
                    $('.banco-vermas a').hide();
                    $('.banco-vermas .progress-bar').show();

                    _self.bancoimg.methods.reloadBancoImagenes(function () {
                        $('.banco-vermas').remove();
                    });
                },
                deleteFoto: function (ui) {
                    var nomfoto = ui.helper.attr("data-nomfoto");
                    var inputname = 'input[name="_borr_{0}"]'.format(nomfoto);
                    var idfoto = '#{0}'.format(nomfoto);

                    if ($(inputname).is(':checked')) {
                        $(inputname).removeAttr("checked");
                        ui.helper.removeClass('btn-danger').addClass('btn-default');
                        $(idfoto).parents('.item').find('.foto-layer').hide();

                        delete _self.bancoimg.tmpFotosDelete[nomfoto];
                    } else {
                        $(inputname).attr("checked", "checked");
                        ui.helper.removeClass('btn-default').addClass('btn-danger');
                        $(idfoto).parents('.item').find('.foto-layer').show();

                        _self.bancoimg.tmpFotosDelete[nomfoto] = 1;

                        if ($('#_galeria_prontus_conf').length > 0) {
                            _self.galeria.actions.removeByNomFoto(nomfoto);
                        }

                        var fotoSrcBanco = ui.helper.attr("data-relfoto");
                        $('.content').find('input[name^="' + Admin.const.fotoFijaTag + '"]').each(function () {
                            let input = this;
                            var fotoSrc = $(this).val();
                            if (fotoSrc && fotoSrc == fotoSrcBanco) {
                                showModalConfirm({
                                    msg: "Esta imagen se eliminará de las fotos fijas publicada. ¿Estás seguro que deseas eliminar esta imagen?",
                                    type: 'blue',
                                    icon: "glyphicon glyphicon-question-sign",
                                    btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                                    okTitle: 'Eliminar',
                                    cbBtnOK: function () {
                                        $(input).parent().find('.botones button[data-method="fotofija.actions.remove"]').trigger('click');
                                    },
                                    cbBtnCancel: function () {
                                        $(inputname).removeAttr("checked");
                                        ui.helper.removeClass('btn-danger').addClass('btn-default');
                                        $(idfoto).parents('.item').find('.foto-layer').hide();

                                        delete _self.bancoimg.tmpFotosDelete[nomfoto];
                                    }
                                });
                            }
                        });
                    }
                },
                showFotoUpload: function (ui) {
                    if (typeof ui !== 'undefined' && ui.helper.attr("id") == 'subir-imagenes-banco') {
                        $('#tab-subir-imagenes').tab('show');
                    }
                    _self.upload.fotofijaTargets = [];

                    var mydz = Dropzone.forElement('#upload_img_zone');
                    var mydz2 = Dropzone.forElement('#upload_zip_zone');

                    mydz.enable();
                    mydz2.enable();

                    if ($('#_galeria_prontus_conf').length === 0) {
                        $('.asignar-fotos-galeria').hide();
                    }

                    $('#modal_upload_img').modal({
                        backdrop: 'static',
                        keyboard: false,
                        show: true
                    });
                },
                showFotoFijaTarget: function (ui) {
                    var foto = ui.helper.attr("data-relpath");
                    var imgW = ui.helper.attr("data-wfoto");
                    var imgH = ui.helper.attr("data-hfoto");
                    var $dropdown = $('#fotofijamenu');

                    if (ui.helper.hasClass('active')) {
                        ui.helper.removeClass('active');
                        $dropdown.empty();
                        $dropdown.hide();
                        return;
                    }
                    ui.helper.addClass('active');

                    $dropdown.empty();
                    $dropdown.append('<li><a href="#" class="dropdown-item" data-id="todas"><strong>'+ProntusL10n.get('mediamanager_all_label')+'</strong></a></li>');
                    for (var x = 0; x < _self.fotofija.fotosFijas.length; x++) {
                        $dropdown.append('<li><a href="#" class="dropdown-item" data-id="{0}">{1}</a></li>'.format(_self.fotofija.fotosFijas[x].id, _self.fotofija.fotosFijas[x].label));
                    }

                    // analizamos si hay espacio para mostrar el dropdown debajo del botón. De otro modo, lo mostramos arriba.
                    // Invisibly expand the dropdown menu so its true height can be calculated
                    $dropdown.css({
                        visibility: "hidden",
                        display: "block"
                    });

                    var menuRect = ui.helper[0].getBoundingClientRect();
                    var top = (menuRect.top + menuRect.height);
                    var dropdownRect = $dropdown[0].getBoundingClientRect();

                    // calculamos si se puede abrir hacia abajo
                    if ((menuRect.top + menuRect.height + dropdownRect.height) >= window.innerHeight) {
                        top = (menuRect.top - dropdownRect.height - 5);
                    }
                    // si no cabe hacia arriba ni hacia abajo, queda 50 px desde el menu superior
                    if (top < 0) {
                        top = 50;
                    }

                    $dropdown[0].style.top = top + 'px';
                    $dropdown.css({ visibility: "visible", position: "fixed" });
                    $dropdown.show();

                    $dropdown.find('li a').off('click').on('click', function (e) {
                        e.preventDefault();
                        var id = $(this).attr("data-id");
                        if (id != 'todas') {
                            _self.fotofija.foto.set(id, foto, imgW, imgH);
                        } else {
                            for (let i = 0; i < _self.fotofija.fotosFijas.length; i++) {
                                _self.fotofija.foto.set(_self.fotofija.fotosFijas[i].id, foto, imgW, imgH);
                            }
                        }
                        ui.helper.removeClass('active');
                        $dropdown.empty();
                        $dropdown.hide();
                    });
                }
            }
        },
        // Galeria de fotos prontus.
        galeria: {
            tamanos: [],
            totalTamanos: 0,
            descArr: [],
            descArrMV: {},
            credArr: [],
            credArrMV: {},
            sepImg: '|',
            sepTxt: '||==',
            sepMV: '@@',
            sepView: '::',
            total: 0,
            template_foto: '',
            template_foto_input: '',
            template_foto_desccred: '',
            init: function () {
                var conf = $('#_galeria_prontus_conf').val();
                _self.galeria.template_foto = $('#_galeria_foto_tpl').html();
                _self.galeria.template_foto_input = $('#_galeria_foto_input_tpl').html();
                _self.galeria.template_foto_desccred = $('#_galeria_desccred_tpl').html();

                ProntusConf.mv.forEach(function(vista) {
                    _self.galeria.descArrMV[vista] = [];
                    _self.galeria.credArrMV[vista] = [];
                });

                if (conf) {
                    var arrConfig = conf.split('|');

                    if (arrConfig.length < 2) {
                        // No se puede usar.
                        console.log(ProntusL10n.get('mediamanager_gallery_config_error', conf));
                    } else {
                        _self.galeria.totalTamanos = arrConfig.length;
                        var galerias_str = $('#_galeria_prontus_str').val();
                        var fotosGalArr = galerias_str.split('@@');
                        for (var i = 0; i < _self.galeria.totalTamanos; i++) {
                            if (typeof fotosGalArr[i] === 'undefined') {
                                // Se agrega a los inputs segun el tamaño. Se respeta el orden de la configuración.
                                $('#_galeria_prontus_str' + (i + 1)).val(fotosGalArr[fotosGalArr.length - 1]);
                            } else {
                                // Se agrega a los inputs segun el tamaño. Se respeta el orden de la configuración.
                                $('#_galeria_prontus_str' + (i + 1)).val(fotosGalArr[i]);
                            }
                        }

                        for (let x = 0; x < arrConfig.length; x++) {
                            var arrItemConfig = arrConfig[x].split(':');
                            var num = arrItemConfig[0];
                            var name = arrItemConfig[1];
                            var fit = arrItemConfig[2]?'si':'';
                            var tam_foto_w = $('#' + Admin.const.fotoFijaMaxWTag + 'prontus_galeria_temporal' + num).val();
                            var tam_foto_h = $('#' + Admin.const.fotoFijaMaxHTag + 'prontus_galeria_temporal' + num).val();
                            var fotosItemStr = $('#_galeria_prontus_str' + num).val();
                            var fotos = [];

                            if (fotosItemStr !== '') {
                                fotos = fotosItemStr.split(_self.galeria.sepImg);
                            }

                            // Si es el primer elemento, se cuentan las fotos y se asignan al total.
                            if (num == 1) _self.galeria.total = fotos.length;

                            _self.galeria.tamanos.push({
                                num: num,
                                name: name,
                                fit: fit,
                                w: tam_foto_w,
                                h: tam_foto_h,
                                fotos: fotos
                            });
                        }

                        _self.galeria.methods.prepararDescCred();
                        _self.galeria.actions.agregarFotosVista();
                        _self.galeria.methods.bindBotonesFoto();
                        _self.galeria.methods.initDragAndDrop();
                        _self.galeria.methods.initSortable();
                    }
                }
            },
            // Verifica si hay galeria instalada.
            check: function () {
                if ($('#_galeria_prontus_view').length == 0) {
                    $('#_asignar_galeria').hide(); // Esconde boton de asignar fotos a galeria.
                }
            },
            actions: {
                agregarFotosVista: function () {
                    for (var y = 0; y < _self.galeria.tamanos.length; y++) {
                        // El primer tamaño se usa para los thumbnails.
                        if (_self.galeria.tamanos[y].num == 1) {
                            for (var x = 0; x < _self.galeria.tamanos[y].fotos.length; x++) {
                                // se utiliza siempre el segundo tamaño para mostrar la foto con la lupa
                                _self.galeria.methods.addThumbnail(_self.galeria.tamanos[y].fotos[x], _self.galeria.tamanos[1].fotos[x], (x + 1));
                            }
                            _self.galeria.methods.addAllDescCred(_self.galeria.tamanos[y]);
                        }
                        _self.galeria.methods.addAllInputs(_self.galeria.tamanos[y]);
                    }

                    $('#scroll-banco .item').each(function () {
                        var fotosrcbanco = $(this).find('input[name^="_path_foto"]').val();
                        var $objSinUsar = $(this).find('.sin-usar');
                        $('.content').find('[id^="recuadro_'+ Admin.const.fotoFijaTag + '"]').each(function () {
                            var fotosrc = $(this).find('img').attr("src");
                            if (fotosrc && fotosrc == fotosrcbanco) {
                                $objSinUsar.remove();
                            }
                        });

                        $('#_galeria_prontus_inputs').find('input.fotofija-galeria').each(function () {
                            var fotosrc = $(this).val();
                            if (fotosrc && fotosrc == fotosrcbanco) {
                                $objSinUsar.remove();
                            }
                        });

                        let fotoSrcPublic = $(this).find('.fotodrag').data('src');
                        $('.VTXT_EDITOR').each(function () {
                            let cuerpo = $(this).val();
                            if (cuerpo.indexOf(fotoSrcPublic) != -1) {
                                $objSinUsar.remove();
                            }
                        });
                    });

                    _self.methods.bindEvents();
                },
                removeAll: function () {
                    var fotos = $('.foto-galeria');
                    if (fotos.length == 0) {
                        return;
                    }

                    showModalConfirm({
                        msg: ProntusL10n.get('mediamanager_mass_delete_confirm'),
                        type: 'blue',
                        icon: "glyphicon glyphicon-question-sign",
                        btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                        okTitle: ProntusL10n.get('global_delete_title'),
                        cbBtnOK: function () {
                            for (var i=0; i < fotos.length; i++) {
                                var numfoto = $(fotos[i]).data('numfoto');
                                $(fotos[i]).remove();
                                _self.galeria.methods.deleteInput(numfoto);
                            }
                            _self.galeria.methods.reordenaFotos();
                        },
                        cbBtnCancel: function () {
                            // Cancela y no hace nada
                        }
                    });
                },
                remove: function (ui) {
                    var numfoto = ui.helper.parents('.foto-galeria').attr("data-numfoto");
                    showModalConfirm({
                        msg: ProntusL10n.get('mediamanager_delete_confirm'),
                        type: 'blue',
                        icon: "glyphicon glyphicon-question-sign",
                        btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                        okTitle: ProntusL10n.get('global_delete_title'),
                        cbBtnOK: function () {
                            ui.helper.parents('.foto-galeria').remove();
                            _self.galeria.methods.deleteInput(numfoto);
                            _self.galeria.methods.reordenaFotos();
                        },
                        cbBtnCancel: function () {
                            // Cancela y restaura el boton para borrar, hay que buscar cual es la foto que se esta borrando
                            for (var x = 0; x < _self.galeria.tamanos.length; x++) {
                                var name = _self.galeria.tamanos[x].name;
                                name = name.replace('@@', numfoto);
                                var nomfoto = $('input[name="' + name + '"]').val();
                                nomfoto = (nomfoto.split('/').pop()).substr(0, 13);
                                var inputname = 'input[name="_BORR_{0}"]'.format(nomfoto);
                                if ($(inputname).is(':checked')) {
                                    _self.bancoimg.actions.deleteFoto({helper: $('.btn-group.banco-acciones.'+nomfoto+' .deleteFoto')});
                                    break;
                                }
                            }
                        }
                    });
                },
                removeByNomFoto: function (nomfoto) {
                    $('#_galeria_prontus_view .foto-galeria').each(function () {
                        var num = $(this).attr("data-numfoto");

                        for (var x = 0; x < _self.galeria.tamanos.length; x++) {
                            var name = _self.galeria.tamanos[x].name;
                            name = name.replace('@@', num);
                            var val = $('input[name="' + name + '"]').val();
                            val = (val.split('/').pop()).substr(0, 13);

                            if (nomfoto == val) {
                                $(this).find('.botones button[data-method="galeria.actions.remove"]').trigger('click');
                                break;
                            }
                        }
                    });
                },
                fillDescCredList: function(ui) {
                    var numfoto = ui.helper.parents('.foto-galeria').attr("data-numfoto");
                    var desc = $('#txt_galeria_descripcion_foto' + numfoto).val();
                    var cred = $('#txt_galeria_credito_foto' + numfoto).val();
                    $('#_galeria_desc_temporal'+numfoto).val(desc);
                    $('#_galeria_credito_temporal'+numfoto).val(cred);

                    ProntusConf.mv.forEach(function(vista) {
                        $('#_galeria_desc_temporal'+numfoto + '_' + vista).val(desc);
                        $('#_galeria_credito_temporal'+numfoto + '_' + vista).val(cred);
                    });
                },
                showEditDescCred: function (ui) {
                    var numfoto = ui.helper.parents('.foto-galeria').attr("data-numfoto");
                    var desc = $('#txt_galeria_descripcion_foto' + numfoto).val();
                    var cred = $('#txt_galeria_credito_foto' + numfoto).val();

                    $('#btnGuardarDescCred').attr("data-numfoto", numfoto);

                    $('#_galeria_desc_temporal').val(desc);
                    $('#_galeria_credito_temporal').val(cred);
                    $('#_galeria_desc_temporal'+numfoto).val(desc);
                    $('#_galeria_credito_temporal'+numfoto).val(cred);

                    ProntusConf.mv.forEach(function(vista) {
                        desc = $('#txt_galeria_descripcion_foto' + numfoto  + '_' + vista).val();
                        cred = $('#txt_galeria_credito_foto' + numfoto  + '_' + vista).val();

                        $('#_galeria_desc_temporal_' + vista).val(desc);
                        $('#_galeria_credito_temporal_' + vista).val(cred);
                        $('#_galeria_desc_temporal'+numfoto + '_' + vista).val(desc);
                        $('#_galeria_credito_temporal'+numfoto + '_' + vista).val(cred);
                    });

                    $('#modal_edit_desccred').modal('show');
                },
                guardarDescCred: function (ui) {
                    var numfoto = ui.helper.attr("data-numfoto");
                    var desc = $('#_galeria_desc_temporal').val();
                    var cred = $('#_galeria_credito_temporal').val();

                    $('#txt_galeria_descripcion_foto' + numfoto).val(desc);
                    $('#txt_galeria_credito_foto' + numfoto).val(cred);

                    _self.galeria.descArr[numfoto - 1] = desc;
                    _self.galeria.credArr[numfoto - 1] = cred;

                    ProntusConf.mv.forEach(function(vista) {
                        desc = $('#_galeria_desc_temporal_' + vista).val();
                        cred = $('#_galeria_credito_temporal_' + vista).val();

                        $('#txt_galeria_descripcion_foto' + numfoto  + '_' + vista).val(desc);
                        $('#txt_galeria_credito_foto' + numfoto  + '_' + vista).val(cred);

                        _self.galeria.descArrMV[vista][numfoto - 1] = desc;
                        _self.galeria.credArrMV[vista][numfoto - 1] = cred;
                    });

                    _self.galeria.methods.updateDescCred();

                    $('#modal_edit_desccred').modal('hide');
                }
            },
            methods: {
                // Actualiza los campos con datos para la galeria.
                updateGaleria: function () {
                    var galeria_prontus_str = [];

                    for (var x = 0; x < _self.galeria.tamanos.length; x++) {
                        galeria_prontus_str.push(_self.galeria.tamanos[x].fotos.join('|'));
                        $('#_galeria_prontus_str' + (x + 1)).val(_self.galeria.tamanos[x].fotos.join('|'));

                    }

                    if (galeria_prontus_str.length === 0) {
                        $('#_galeria_prontus_str').val('');
                    } else {
                        $('#_galeria_prontus_str').val(galeria_prontus_str.join('@@'));
                    }
                },
                reordenaFotos: function () {
                    var orden = $('#_galeria_prontus_view .foto-galeria[data-numfoto]').map(function () {
                        return $(this).attr("data-numfoto");
                    }).get();

                    _self.galeria.methods.deleteAllInputs();

                    for (let x = 0; x < _self.galeria.tamanos.length; x++) {
                        var item = _self.galeria.tamanos[x];
                        var new_fotos = [];
                        var new_desc = [];
                        var new_cred = [];
                        var new_descMV = {};
                        var new_credMV = {};

                        ProntusConf.mv.forEach(function(vista) {
                            new_descMV[vista] = [];
                            new_credMV[vista] = [];
                        });

                        for (var y = 0; y < orden.length; y++) {
                            var id = orden[y];

                            new_fotos.push(item.fotos[id - 1]);

                            if (_self.galeria.tamanos[x].num == 1) {
                                new_desc.push(_self.galeria.descArr[id - 1]);
                                new_cred.push(_self.galeria.credArr[id - 1]);

                                ProntusConf.mv.forEach(function(vista) {
                                    new_descMV[vista].push(_self.galeria.descArrMV[vista][id - 1]);
                                    new_credMV[vista].push(_self.galeria.credArrMV[vista][id - 1]);
                                });
                            }
                        }

                        _self.galeria.tamanos[x].fotos = new_fotos;

                        if (_self.galeria.tamanos[x].num == 1) {
                            _self.galeria.total = new_fotos.length;
                            _self.galeria.descArr = new_desc;
                            _self.galeria.credArr = new_cred;

                            ProntusConf.mv.forEach(function(vista) {
                                _self.galeria.descArrMV = new_descMV;
                                _self.galeria.credArrMV = new_credMV;
                            });

                            _self.galeria.methods.addAllDescCred(_self.galeria.tamanos[x]);
                        }

                        _self.galeria.methods.addAllInputs(_self.galeria.tamanos[x]);
                    }

                    _self.galeria.methods.updateGaleria();
                    _self.galeria.methods.updateDescCred();

                    x = 1;

                    $('#_galeria_prontus_view .foto-galeria[data-numfoto]').each(function () {
                        $(this).attr("data-numfoto", x);
                        x++;
                    });
                },
                updateDescCred: function () {
                    let descMV = [];
                    let credMV = [];
                    ProntusConf.mv.forEach(function(vista) {
                        descMV.push(vista + _self.galeria.sepView + _self.galeria.descArrMV[vista].join(_self.galeria.sepTxt));
                        credMV.push(vista + _self.galeria.sepView + _self.galeria.credArrMV[vista].join(_self.galeria.sepTxt));
                    });

                    let desc = _self.galeria.descArr.join(_self.galeria.sepTxt) + _self.galeria.sepMV + descMV.join(_self.galeria.sepMV);
                    let cred = _self.galeria.credArr.join(_self.galeria.sepTxt) + _self.galeria.sepMV + credMV.join(_self.galeria.sepMV);

                    $('#_txt_galeria_description_total').val(desc);
                    $('#_txt_galeria_credito_total').val(cred);
                },
                addThumbnail: function (foto, foto_visor, numfoto) {
                    var template = _self.galeria.template_foto;
                    var ts2 = foto_visor.substr(13, 14);
                    var fechac2 = ts2.substr(0, 8);
                    var fullfoto2 = "/{0}/site/artic/{1}/imag/{2}".format(Admin.prontus_id, fechac2, foto_visor);

                    template = template.replace(/__img_src__/g, fullfoto2);
                    template = template.replace(/__img_src_full_/g, fullfoto2);
                    template = template.replace(/__name__/g, foto);
                    template = template.replace(/__numfoto__/g, numfoto);

                    $('#_galeria_prontus_view').append(template);
                },
                addAllInputs: function (item) {
                    for (var x = 1; x <= item.fotos.length; x++) {
                        var html = _self.galeria.template_foto_input;
                        var name = item.name;
                        var foto = item.fotos[x - 1];
                        var ts = foto.substr(13, 14);
                        var fechac = ts.substr(0, 8);
                        var fullfoto = "/{0}/site/artic/{1}/imag/{2}".format(Admin.prontus_id, fechac, foto);

                        name = name.replace('@@', x);
                        html = html.replace(/__inputname__/g, name);
                        html = html.replace(/__w__/g, item.w);
                        html = html.replace(/__h__/g, item.h);
                        html = html.replace(/__relfoto__/g, fullfoto);
                        html = html.replace(/__fit__/g, item.fit);

                        $('#_galeria_prontus_inputs').append(html);
                    }
                },
                deleteAllInputs: function () {
                    for (var id = 1; id <= _self.galeria.total; id++) {
                        _self.galeria.methods.deleteInput(id);
                    }
                },
                deleteInput: function (id) {
                    for (var x = 0; x < _self.galeria.tamanos.length; x++) {
                        var name = _self.galeria.tamanos[x].name;
                        name = name.replace('@@', id);

                        $('input[name="' + name + '"]').remove();
                        $('input[name="_maxw' + name + '"]').remove();
                        $('input[name="_maxh' + name + '"]').remove();
                        $('input[name="chk_cuadrar_' + name + '"]').remove();
                        $('#txt_galeria_descripcion_foto' + id ).remove();
                        $('#txt_galeria_credito_foto' + id ).remove();

                        ProntusConf.mv.forEach(function(vista) {
                            $('#txt_galeria_descripcion_foto' + id + '_' + vista).remove();
                            $('#txt_galeria_credito_foto' + id + '_' + vista).remove();
                        });
                    }
                },
                addInput: function (id, item, foto) {
                    var html = _self.galeria.template_foto_input;
                    var name = item.name;
                    var ts = foto.substr(13, 14);
                    var fechac = ts.substr(0, 8);
                    var fullfoto = "/{0}/site/artic/{1}/imag/{2}".format(Admin.prontus_id, fechac, foto);

                    name = name.replace('@@', id);
                    html = html.replace(/__inputname__/g, name);
                    html = html.replace(/__w__/g, item.w);
                    html = html.replace(/__h__/g, item.h);
                    html = html.replace(/__relfoto__/g, fullfoto);
                    html = html.replace(/__fit__/g, item.fit);

                    $('#_galeria_prontus_inputs').append(html);
                },
                addAllDescCred: function (item) {
                    for (var x = 0; x < item.fotos.length; x++) {
                        var html = _self.galeria.template_foto_desccred;

                        html = html.replace(/__idx__/g, (x + 1));
                        html = html.replace(/__desc__/g, _self.galeria.descArr[x]);
                        html = html.replace(/__cred__/g, _self.galeria.credArr[x]);

                        ProntusConf.mv.forEach(function(vista) {
                            let regexp = new RegExp('__desc_'+ vista + '__', 'g');
                            html = html.replace(regexp, _self.galeria.descArrMV[vista][x]);
                            regexp = new RegExp('__cred_'+ vista + '__', 'g');
                            html = html.replace(regexp, _self.galeria.credArrMV[vista][x]);
                        });

                        $('#_galeria_prontus_inputs').append(html);
                    }
                },
                addDescCred: function (idx) {
                    var html = _self.galeria.template_foto_desccred;

                    html = html.replace(/__idx__/g, idx);
                    html = html.replace(/__desc__/g,'');
                    html = html.replace(/__cred__/g, '');

                    $('#_galeria_prontus_inputs').append(html);
                },
                initDragAndDrop: function () {
                    var dropZone = document.getElementById('_galeria_prontus_dropzone');
                    dropZone.addEventListener('dragover',   function (evt) {
                        evt.stopPropagation();
                        evt.preventDefault();
                    }, false);

                    dropZone.addEventListener('drop',   function (evt) {
                        evt.stopPropagation();
                        evt.preventDefault();
                        showModalAlert({
                            title: ProntusL10n.get('global_error_title'),
                            type: 'blue',
                            msg: ProntusL10n.get('mediamanager_dragandrop_help')
                        });
                    }, false);
                    $('#_galeria_prontus_dropzone').droppable({
                        accept: '.fotodrag',
                        drop: function (e, ui) {
                            var nomfoto = $(ui.draggable).parent().find('img.fotodrag').attr("data-nomfoto");
                            var id = ++_self.galeria.total;

                            for (var x = 0; x < _self.galeria.tamanos.length; x++) {
                                if (_self.galeria.tamanos[x].num == 1) {
                                    _self.galeria.methods.addThumbnail(nomfoto, nomfoto, id);
                                    _self.galeria.descArr.push('');
                                    _self.galeria.credArr.push('');

                                    ProntusConf.mv.forEach(function(vista) {
                                        _self.galeria.descArrMV[vista].push('');
                                        _self.galeria.credArrMV[vista].push('');
                                    });

                                    _self.galeria.methods.addDescCred(id);
                                }

                                _self.galeria.tamanos[x].fotos.push(nomfoto);
                                _self.galeria.methods.addInput(id, _self.galeria.tamanos[x], nomfoto);
                                _self.galeria.methods.bindBotonesFoto();
                                _self.methods.bindEvents();
                                _self.galeria.methods.updateGaleria();
                            }
                        }
                    });
                },
                initSortable: function () {
                    $('#_galeria_prontus_view').sortable({
                        containment: 'parent',
                        stop: function () {
                            _self.galeria.methods.reordenaFotos();
                        }
                    });
                },
                bindBotonesFoto: function () {
                    $('#_galeria_prontus_view').find('.foto-galeria').off('hover').hover(
                        function () {
                            $(this).find('.botones').show();
                        },
                        function () {
                            $(this).find('.botones').hide();
                        }
                    );
                },
                prepararDescCred: function () {
                    _self.galeria.descArr = Array(_self.galeria.total).fill("");
                    _self.galeria.credArr = Array(_self.galeria.total).fill("");

                    let descArrMVTmp = {};
                    let credArrMVTmp = {};
                    ProntusConf.mv.forEach(function(vista) {
                        _self.galeria.descArrMV[vista] = Array(_self.galeria.total).fill("");
                        _self.galeria.credArrMV[vista] = Array(_self.galeria.total).fill("");
                        descArrMVTmp[vista] = Array(_self.galeria.total).fill("");
                        credArrMVTmp[vista] = Array(_self.galeria.total).fill("");
                    });

                    let descTmp = ($('#_txt_galeria_description_total').val()).split(_self.galeria.sepMV);
                    let credTmp = ($('#_txt_galeria_credito_total').val()).split(_self.galeria.sepMV)

                    let descArrTmp = _self.helper.cleanString(descTmp[0]).split(_self.galeria.sepTxt);
                    let credArrTmp = _self.helper.cleanString(credTmp[0]).split(_self.galeria.sepTxt);

                    for (let i = 1; i < descTmp.length; i++) {
                        let aux = (descTmp[i]).split(_self.galeria.sepView);
                        if (aux[1] != undefined) {
                            descArrMVTmp[aux[0]] = _self.helper.cleanString(aux[1]).split(_self.galeria.sepTxt);
                        }
                    }
                    for (let i = 1; i < credTmp.length; i++) {
                        let aux = credTmp[i].split(_self.galeria.sepView);
                        if (aux[1] != undefined) {
                            credArrMVTmp[aux[0]] = _self.helper.cleanString(aux[1]).split(_self.galeria.sepTxt);
                        }
                    }

                    for (let x = 0; x < _self.galeria.total; x++) {
                        if (typeof descArrTmp[x] !== 'undefined') {
                            _self.galeria.descArr[x] = descArrTmp[x];
                        }
                        if (typeof credArrTmp[x] !== 'undefined') {
                            _self.galeria.credArr[x] = credArrTmp[x];
                        }
                    }

                    ProntusConf.mv.forEach(function(vista) {
                        for (let x = 0; x < _self.galeria.total; x++) {
                            if (typeof descArrMVTmp[vista][x] !== 'undefined') {
                                _self.galeria.descArrMV[vista][x] = descArrMVTmp[vista][x];
                            }
                            if (typeof credArrMVTmp[vista][x] !== 'undefined') {
                                _self.galeria.credArrMV[vista][x] = credArrMVTmp[vista][x];
                            }
                        }
                    });
                }
            }
        },
        // Manejo de fotos fijas.
        fotofija: {
            draggableBanco: false,
            imgEditor: false,
            fotosFijas: [],
            // ---------------------------------------------------------------
            init: function () {
                _self.fotofija.methods.initDraggableBanco();

                // Verificar nombres de fotos duplicados.
                var duplicados = '';
                $('div[id^="recuadro_'+ Admin.const.fotoFijaTag + '"]').each(function() {
                    var id = $('div[id="'+this.id+'"]');
                    if (id.length>1 && id[0]==this) {
                        duplicados += this.id + "\n";
                    }
                });

                if (duplicados) {
                    showModalAlert({
                        title: ProntusL10n.get('global_error_title'),
                        type: 'red',
                        msg: ProntusL10n.get('mediamanager_duplicate_fields_warning', duplicados)
                    });
                }
            },
            // ---------------------------------------------------------------
            // Métodos varios.
            // ---------------------------------------------------------------
            methods: {
                // ---------------------------------------------------------------
                // Destruye drag & drop del banco de imagenes.
                // ---------------------------------------------------------------
                destroyDraggableBanco: function () {
                    if (_self.fotofija.draggableBanco === true) {
                        $('#banco-img .fotodrag').draggable("destroy");
                        _self.fotofija.draggableBanco = false;
                    }
                },
                // ---------------------------------------------------------------
                // Inicia drag & drop para VTXT
                // ---------------------------------------------------------------
                initDroppableVTXT: function (selector) {
                    $(selector).each(function () {
                        var id = $(this).attr('id');

                        $('#' + $(this).attr('id') + '_ifr').droppable({
                            drop: function (e, ui) {
                                var embedCode = '';
                                var player  = '';

                                if (ui.helper.hasClass('fotodrag') && !ui.helper.hasClass('size_limit_alert')) {
                                    embedCode = '<img src="' + ui.helper.attr("data-src") + '" class="responsive-img">';
                                } else if (ui.helper.hasClass('videodrag')) {
                                    player = '/prontus/front/player/video.html';
                                    if (typeof(ProntusConf["player-embed-video"]) !== 'undefined') {
                                        player = ProntusConf["player-embed-video"];
                                    }

                                    embedCode = '<iframe width="640" height="360" src="' + player + '?&amp;src=' +ui.helper.attr("data-src")+ '" frameborder="0" allow="autoplay; encrypted-media" allowfullscreen></iframe>';
                                } else if (ui.helper.hasClass('audiodrag')) {
                                    player = '/prontus/front/player/audio.html';
                                    if (typeof(ProntusConf["player-embed-audio"]) !== 'undefined') {
                                        player = ProntusConf["player-embed-audio"];
                                    }
                                    embedCode = '<iframe width="640" height="66" src="' + player + '?&amp;src=' +ui.helper.attr("data-src")+ '" frameborder="0" allow="autoplay; encrypted-media" allowfullscreen></iframe>';
                                } else if (ui.helper.hasClass('size_limit_alert')) {
                                    $('#' + id).parent('.form-group').addClass('size_limit_alert_shadow');
                                    $('#' + id).parent('.form-group').on('animationend', function () {
                                        $('#' + id).parent('.form-group').removeClass('size_limit_alert_shadow');
                                    });
                                }

                                if (embedCode != '') {
                                    var activeEditor = tinymce.get(id);
                                    // lo inserta donde este el cursor.
                                    activeEditor.dom.add(activeEditor.insertContent(embedCode));
                                }
                            }
                        });
                    });
                },
                // ---------------------------------------------------------------
                // Destruye drag & drop para VTXT
                // ---------------------------------------------------------------
                destroyDroppableVTXT: function () {
                    $('iframe[id^="vtxt_"].ui-droppable').droppable("destroy");
                },
                // ---------------------------------------------------------------
                // Crea una nueva instancia de un campo de foto.
                // ---------------------------------------------------------------
                newInstance: function (id, maxW, maxH, imgW, imgH) {
                    _self.fotofija.foto.init(id, maxW, maxH, imgW, imgH);
                },
                // ---------------------------------------------------------------
                // Inicia drag & drop desde banco de imagenes.
                // ---------------------------------------------------------------
                initDraggableBanco: function () {
                    $('#banco-img .fotodrag').draggable({
                        helper: "clone",
                        containment: "document",
                        zIndex: 9999,
                        iframeFix: true,
                        appendTo: "body"
                    });
                    _self.fotofija.draggableBanco = true;
                },
                // ---------------------------------------------------------------
                // Cambiar el estado de los botones.
                // ---------------------------------------------------------------
                toggleButtons: function (id, states) {
                    var $elem;
                    $.each(states, function (button, state) {
                        if (button == 'cuadrar') {
                            if (state == "on") {
                                $('input[name="' + Admin.const.chkCuadrarTag + Admin.const.fotoFijaTag + id + '"]').parent().show();
                            } else {
                                $('input[name="' + Admin.const.chkCuadrarTag + Admin.const.fotoFijaTag + id + '"]').parent().hide();
                            }
                        } else {
                            if (button == 'lupa') {
                                $elem = $('.botones_' + id).find('[data-method="actions.showImgViewer"]');
                            } else if (button == 'editar') {
                                $elem = $('.botones_' + id).find('[data-method="fotofija.actions.edit"]');
                            } else if (button == 'borrar') {
                                $elem = $('.botones_' + id).find('[data-method="fotofija.actions.remove"]');
                            } else if (button == 'link') {
                                $elem = $('.botones_' + id).find('[data-method="actions.copyUrlImg"]');
                            } else {
                                $elem = null;
                            }

                            if ($elem) {
                                if (state == 'on') {
                                    $elem.show();
                                } else {
                                    $elem.hide();
                                }
                            }
                        }
                    });
                },
                getFotosFijas: function () {
                    // se vacia.
                    _self.fotofija.fotosFijas = [];

                    $('div.fotofija-container').each(function() {
                        var $fotofija = $(this).find('.fotofija');
                        var id = $fotofija.attr("data-id");
                        var label = $(this).find('.fotofija-label').text();

                        // Se usan en la galeria. Se ignoran.
                        if (id && id.indexOf('temporal') == -1) {
                            if (label === '') label = id;

                            id = id.replace(Admin.const.fotoFijaTag, "");

                            var maxW = $fotofija.find('input[name="' + Admin.const.fotoFijaMaxWTag + id + '"]').val();
                            var maxH = $fotofija.find('input[name="' + Admin.const.fotoFijaMaxHTag + id + '"]').val();

                            _self.fotofija.fotosFijas.push({
                                id: id,
                                label: label,
                                maxw: maxW,
                                maxh: maxH
                            });
                        }

                    });
                }
            },
            // ---------------------------------------------------------------
            // Acciones
            // ---------------------------------------------------------------
            actions: {
                // ---------------------------------------------------------------
                // Eliminar/quitar una foto de un campo.
                // ---------------------------------------------------------------
                remove: function (ui) {
                    var id = ui.helper.attr("data-nomfoto");

                    $('input[name="'+ Admin.const.fotoFijaTag + id + '"]').val('');
                    $('input[name="' + Admin.const.fotoFijaWTag + id + '"]').val('');
                    $('input[name="' + Admin.const.fotoFijaHTag + id + '"]').val('');
                    $('div#recuadro_'+ Admin.const.fotoFijaTag + id).html('');

                    _self.fotofija.foto.unBindEvents(id);
                    _self.fotofija.foto.unset(id);
                    _self.fotofija.methods.toggleButtons(id, {lupa:'off',editar:'off',borrar:'off',cuadrar:'off',link:'off'});
                },
                edit: function (ui) {
                    var id = ui.helper.attr("data-nomfoto");
                    var relfoto = ui.helper.attr("data-relfoto");
                    var wfoto = ui.helper.attr("data-wfoto");
                    var hfoto = ui.helper.attr("data-hfoto");
                    var path;

                    if (id) {
                        path = $('input[name="'+ Admin.const.fotoFijaTag + id + '"]').val();
                    } else {
                        path = relfoto;
                        id = '';
                    }

                    var url = "/" + Admin.dir_cgi_cpn + "/prontus_editor_imag.cgi?&_prontus_id=" + Admin.prontus_id + "&_ts=" + mainFidJs.TS + "&_foto=" + path + "&_width=" + wfoto + "&_height=" + hfoto + "&_fotofija=" + id + "&_=" + Date.now();

                    $('#modal_editor_iframe').attr("src", url);

                    // Espera a que el iframe termine de cargar antes de mostrar el modal
                    // si no se genera un "parpadeo" con la edición anterior.
                    $('#modal_editor_iframe').off('load').on('load', function () {
                        // Muestra el modal siempre y cuando el iframe tenga src.
                        if ($(this).attr('src') != '') {
                            if (this.contentDocument.title == 'Error') {
                                showModalAlert({
                                    title: ProntusL10n.get('global_load_error'),
                                    type: 'red',
                                    msg: this.contentDocument.getElementById('msg_error').textContent
                                });
                            } else {
                                $('#modal_editor').modal({
                                    show: true,
                                    backdrop: 'static',
                                    keyboard: false
                                });
                            }
                        }
                    });

                    $('#modal_editor .close').off('click').on('click', function () {
                        var EditorImagObject = $('#modal_editor_iframe')[0].contentWindow.EditorImag;

                        if (typeof EditorImagObject != 'undefined') {
                            if (EditorImagObject.hasChanges) {
                                showModalConfirm({
                                    msg: ProntusL10n.get('mediamanager_cancel_warning'),
                                    type: "blue",
                                    icon: "glyphicon glyphicon-question-sign",
                                    btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextyellow nextyellow',
                                    okTitle: ProntusL10n.get('mediamanager_cancel_confirm'),
                                    cancelTitle: ProntusL10n.get('mediamanager_cancel_discard'),
                                    cbBtnOK: function () {
                                        $('#modal_editor').modal('hide');
                                    },
                                    cbBtnCancel: function () {
                                    }
                                });
                            } else {
                                $('#modal_editor').modal('hide');
                            }
                        } else {
                            $('#modal_editor').modal('hide');
                        }
                    });
                }
            },
            // ---------------------------------------------------------------
            // ---------------------------------------------------------------
            // Manejo de fotos.
            // ---------------------------------------------------------------
            foto: {
                // ---------------------------------------------------------------
                // Lista de instancias de fotos.
                // ---------------------------------------------------------------
                instances: {},
                // ---------------------------------------------------------------
                // Inicializa un campo de foto.
                // ---------------------------------------------------------------
                init: function (id, maxW, maxH, imgW, imgH) {
                    var currImgSrc = $('input[name="'+ Admin.const.fotoFijaTag + id + '"]').val();

                    _self.fotofija.foto.instances[id] = {
                        id: id,
                        maxW: parseInt(maxW),
                        maxH: parseInt(maxH),
                        imgW: parseInt(imgW),
                        imgH: parseInt(imgH),
                        src: currImgSrc
                    };

                    if (currImgSrc) {
                        var cuadrar = 'on';
                        var editar = 'on';

                        //foto_00000002201810212118
                        var fotofijaSizeHidden = '_b' + currImgSrc.substring(currImgSrc.indexOf('foto_'), currImgSrc.indexOf('foto_') + 13);
                        var fotoSizeBytes = $('input[name="' + fotofijaSizeHidden + '"]').val();
                        var sizeLimitClass = '';

                        if (Fid.vtxtImageSizeLimit > 0 && fotoSizeBytes > Fid.vtxtImageSizeLimit*1024) {
                            sizeLimitClass = 'size_limit_alert';
                        }

                        // Si es SVG no se puede cuadrar ni editar.
                        if (currImgSrc.substring(currImgSrc.length - 3) == 'svg') {
                            cuadrar = 'off';
                            editar = 'off';
                        }

                        $('div#recuadro_'+ Admin.const.fotoFijaTag + id).html('<img src="' + currImgSrc + '" class="fotodrag ' + sizeLimitClass + '"/>');
                        let link = 'off';
                        if (window.isSecureContext) {
                            link = 'on';
                        }
                        _self.fotofija.methods.toggleButtons(id, {lupa:'on',borrar:'on', editar: editar, cuadrar:cuadrar,link:link});
                        _self.fotofija.foto.bindEvents(id);

                    } else {
                        _self.fotofija.methods.toggleButtons(id, {lupa:'off',editar:'off',borrar:'off',cuadrar:'off',link:'off'});
                        _self.fotofija.foto.instances[id].src = ''; // fix
                    }

                    $('div#recuadro_'+ Admin.const.fotoFijaTag + id).droppable({
                        accept: '.fotodrag',
                        hoverClass: 'ui-state-active',
                        drop: function (event, ui) {
                            var $item   = ui.helper;
                            var imgSrc  = $item.attr('src');
                            var w    = $item.attr("data-w");
                            var h    = $item.attr("data-h");

                            _self.fotofija.foto.set(id, imgSrc, w, h);
                        }
                    });
                },
                // ---------------------------------------------------------------
                // Vacia una instancia de un campo de foto.
                // ---------------------------------------------------------------
                unset: function (id) {
                    _self.fotofija.foto.instances[id] = {
                        id: id,
                        maxW: '',
                        maxH: '',
                        imgW: '',
                        imgH: '',
                        src: ''
                    };
                },
                // ---------------------------------------------------------------
                // Inicia los eventos asociados a una foto.
                // ---------------------------------------------------------------
                bindEvents: function (id) {
                    $('div[data-id="'+ Admin.const.fotoFijaTag + id + '"]').hover(
                        function () {
                            $(this).find('.botones').show();
                            $(this).find('.cuadrar').show();
                        },
                        function () {
                            $(this).find('.botones').hide();
                            $(this).find('.cuadrar').hide();
                        }
                    );
                },
                // ---------------------------------------------------------------
                // Detiene los eventos asociados a una foto.
                // ---------------------------------------------------------------
                unBindEvents: function (id) {
                    $('div[data-id="'+ Admin.const.fotoFijaTag + id + '"]').off('mouseenter mouseleave');
                    $('div[data-id="'+ Admin.const.fotoFijaTag + id + '"]').find('.botones').hide();
                    $('div[data-id="'+ Admin.const.fotoFijaTag + id + '"]').find('.cuadrar').hide();
                },
                // ---------------------------------------------------------------
                // Setea una foto (fuente y tamaño) a una instancia.
                // ---------------------------------------------------------------
                set: function (id, imgSrc, imgW, imgH, mark_as_new) {

                    $('div#recuadro_'+ Admin.const.fotoFijaTag + id).html('<img src="' + imgSrc + '" />');

                    //cambia / por _ en nombre de foto por manejo interno
                    imgSrc = imgSrc.replace(/(.*\/foto_\d+)\/(.*)$/, "$1_$2");
                    $('input[name="'+ Admin.const.fotoFijaTag + id + '"]').val(imgSrc);
                    $('input[name="' + Admin.const.fotoFijaWTag + id + '"]').val(imgW);
                    $('input[name="' + Admin.const.fotoFijaHTag + id + '"]').val(imgH);

                    _self.fotofija.foto.instances[id].src = imgSrc;
                    _self.fotofija.foto.instances[id].imgW = parseInt(imgW);
                    _self.fotofija.foto.instances[id].imgH = parseInt(imgH);

                    if (typeof mark_as_new != 'undefined' && mark_as_new === true) {
                        $('div#recuadro_'+ Admin.const.fotoFijaTag + id).parents('.fotofija').prev('.fotofija-label').find('.is-new').show();
                    }

                    _self.fotofija.methods.toggleButtons(id, {lupa:'on',borrar:'on',cuadrar:'on'});
                    _self.fotofija.foto.bindEvents(id);
                },
                addHiddens: function (nomfoto, w, h) {
                    var html = [
                        '<input type="hidden" name="_w%%numfoto%%" value="%%wfoto%%">',
                        '<input type="hidden" name="_h%%numfoto%%" value="%%hfoto%%">'
                    ].join("").replace(/%%numfoto%%/g, nomfoto)
                    .replace(/%%wfoto%%/g, w)
                    .replace(/%%hfoto%%/g, h);

                    $("#_mainFidForm").prepend(html);
                }
            }
        },
        dam: {
            assetItemImagTpl: '',
            assetItemVideoTpl: '',
            assetItemAudioTpl: '',
            pagination: {},
            currentType: 'foto',
            imgFilter: '',
            clipboard: false,
            standAlone: false,
            tot_x_pag: 20,
            currentTop: 0,
            initStandAlone: function () {
                _self.dam.standAlone = true;
                _self.dam.assetItemImagTpl = $('#asset_box_tpl_imag').html();
                _self.dam.assetItemVideoTpl = $('#asset_box_tpl_video').html();
                _self.dam.assetItemAudioTpl = $('#asset_box_tpl_audio').html();

                $("input[id='dam_txt_search_input']").on("keyup", function (e) {
                    if (e.keyCode == 13) {
                        _self.dam.actions.buscar();
                    }
                });

                $("button[id='dam_txt_search_btn']").on("click", function () {
                    _self.dam.actions.buscar();
                });

                $("button[id='dam_txt_refresh_btn']").on("click", function () {
                    $("input[id='dam_txt_search_input']").val('');
                    _self.dam.actions.getAssetList({type: _self.dam.currentType, pag: 0, tot_x_pag: _self.dam.tot_x_pag});
                });

                $('#modal_embed_media').on('shown.bs.modal', function () {
                    $('#modal_embed_media .embedable-code').select();
                });

                _self.dam.tot_x_pag = 30;
                _self.dam.actions.getAssetList({type: 'foto', tot_x_pag: _self.dam.tot_x_pag, txt: $('#dam_txt_search_input').val()});
            },
            init: function () {
                // https://github.com/zenorocha/clipboard.js/issues/388
                // Problema con modal de boostrap y clipboardjs.
                $.fn.modal.Constructor.prototype.enforceFocus = function() {};

                $('#modal_dam > .modal-dialog').draggable({
                    cursor: 'move',
                    handle: '.modal-header'
                });
                $('#modal_dam > .modal-dialog > .modal-content > .modal-header').css('cursor', 'move');

                $('#modal_dam').on('show.bs.modal', function () {
                    // Se Guarda la pos actual del scroll para luego volver ahi mismo.
                    // Se pierde el scroll al agregar la clave de mas abajo (overflow: auto)
                    _self.dam.currentTop = $(document).scrollTop();
                    $('body').addClass('modal-open-woverflow');
                });

                $('#modal_dam').on('shown.bs.modal', function () {
                    // Se reestablece el scroll.
                    $(document).scrollTop(_self.dam.currentTop);
                });

                $('#modal_dam').on('hide.bs.modal', function () {
                    $('body').removeClass('modal-open-woverflow');
                });

                _self.dam.assetItemImagTpl = $('#asset_box_tpl_imag').html();
                _self.dam.assetItemVideoTpl = $('#asset_box_tpl_video').html();
                _self.dam.assetItemAudioTpl = $('#asset_box_tpl_audio').html();

                $("input[id='dam_txt_search_input']").on("keyup", function (e) {
                    if (e.keyCode == 13) {
                        _self.dam.actions.buscar();
                    }
                });

                $("button[id='dam_txt_search_btn']").on("click", function () {
                    _self.dam.actions.buscar();
                });
            },
            actions: {
                buscar: function () {
                    $('#asset_list').html('');
                    if (_self.dam.standAlone === false) { $('#modal_dam .loading').show(); }

                    var val = $("input[id='dam_txt_search_input']").val();
                    _self.dam.actions.getAssetList({type: _self.dam.currentType, pag: 0, txt: val, tot_x_pag: _self.dam.tot_x_pag, img_filter: _self.dam.imgFilter});
                },
                openModal: function () {
                    if (_self.dam.standAlone === false) {
                        $('#modal_dam > .modal-dialog').css({
                          top: 0,
                          right: 0
                        });

                        $('#modal_dam').modal({backdrop: false, show: true});
                    }

                    _self.dam.actions.getAssetList({type: 'foto', tot_x_pag: _self.dam.tot_x_pag});

                },
                closeModal: function () {
                    $('#modal_dam').modal('hide');
                    $('#modal_dam .loading').show();
                    $('#asset_list').html('');
                },
                getAssetList: function (new_options) {
                    var options = {_prontus_id: Admin.prontus_id};
                    options = $.extend(options, new_options);

                    if (_self.dam.standAlone === true) {
                        $('#asset_list').empty();
                        $('#asset_list_loading').show();
                    }

                    $.ajax({
                        url: '/{0}/dam/prontus_dam_asset_list.cgi'.format(Admin.dir_cgi_cpn),
                        data: options,
                        dataType: "json",
                        type: 'POST',
                        success: function (data) {
                            if (data.status == 1) {
                                if (_self.dam.standAlone === true) {
                                    $('#asset_list_loading').hide();
                                }

                                _self.dam.pagination = data.pagination;
                                var html = _self.dam.methods.addAssetsToModal(data.data, new_options.type);
                                $('#asset_list').html(html).show();
                                if (_self.dam.standAlone === false) {
                                    $('#modal_dam .loading').hide();
                                    _self.dam.methods.initDraggableDam();
                                }
                                _self.dam.methods.togglePagination();
                                _self.methods.bindEvents();
                                _self.dam.methods.initClipboard();
                                _self.actions.initPlayables();
                            } else {
                                if (_self.dam.standAlone === true) {
                                    $('#asset_list_loading').hide();
                                }
                            }
                        }
                    });
                },
                getAssetsFotos: function (ui) {
                    ui.helper.parent().find('button.active').removeClass('active');
                    ui.helper.addClass('active');
                    _self.dam.currentType = 'foto';
                    _self.dam.imgFilter  = ui.helper.data('filter');

                    $('#asset_list').html('');
                    if (_self.dam.standAlone === false) { $('#modal_dam .loading').show(); }

                    var val = $("input[id='dam_txt_search_input']").val();

                    _self.dam.actions.getAssetList({type: _self.dam.currentType, img_filter: _self.dam.imgFilter, txt: val, tot_x_pag: _self.dam.tot_x_pag});
                },
                getAssetsAudios: function (ui) {
                    ui.helper.parent().find('button.active').removeClass('active');
                    ui.helper.addClass('active');
                    _self.dam.currentType = 'audio';

                    $('#asset_list').html('');
                    if (_self.dam.standAlone === false) { $('#modal_dam .loading').show(); }

                    var val = $("input[id='dam_txt_search_input']").val();

                    _self.dam.actions.getAssetList({type: _self.dam.currentType, txt: val, tot_x_pag: _self.dam.tot_x_pag});
                },
                getAssetsVideos: function (ui) {
                    ui.helper.parent().find('button.active').removeClass('active');
                    ui.helper.addClass('active');
                    _self.dam.currentType = 'video';

                    $('#asset_list').html('');
                    if (_self.dam.standAlone === false) { $('#modal_dam .loading').show(); }

                    var val = $("input[id='dam_txt_search_input']").val();

                    _self.dam.actions.getAssetList({type: _self.dam.currentType, txt: val, tot_x_pag: _self.dam.tot_x_pag});
                },
                nextPage: function () {
                    $('#asset_list').html('');
                    if (_self.dam.standAlone === false) { $('#modal_dam .loading').show(); }

                    var val = $("input[id='dam_txt_search_input']").val();
                    _self.dam.actions.getAssetList({type: _self.dam.currentType, pag: _self.dam.pagination.next_pag, img_filter: _self.dam.imgFilter, size: _self.dam.currentSize, txt: val, tot_x_pag: _self.dam.tot_x_pag});
                },
                prevPage: function () {
                    $('#asset_list').html('');
                    if (_self.dam.standAlone === false) { $('#modal_dam .loading').show(); }

                    var val = $("input[id='dam_txt_search_input']").val();
                    _self.dam.actions.getAssetList({type: _self.dam.currentType, pag: _self.dam.pagination.prev_pag, img_filter: _self.dam.imgFilter, size: _self.dam.currentSize, txt: val, tot_x_pag: _self.dam.tot_x_pag});
                },
                lastPage: function () {
                    $('#asset_list').html('');
                    if (_self.dam.standAlone === false) { $('#modal_dam .loading').show(); }

                    var val = $("input[id='dam_txt_search_input']").val();
                    _self.dam.actions.getAssetList({type: _self.dam.currentType, pag: _self.dam.pagination.total_pags - 1, img_filter: _self.dam.imgFilter, size: _self.dam.currentSize, txt: val, tot_x_pag: _self.dam.tot_x_pag});
                },
                firstPage: function () {
                    $('#asset_list').html('');
                    if (_self.dam.standAlone === false) { $('#modal_dam .loading').show(); }

                    var val = $("input[id='dam_txt_search_input']").val();
                    _self.dam.actions.getAssetList({type: _self.dam.currentType, pag: 0, img_filter: _self.dam.imgFilter, size: _self.dam.currentSize, txt: val, tot_x_pag: _self.dam.tot_x_pag});
                },
                sizeFilter: function (ui) {
                    if (_self.dam.currentType != 'foto') { return; }
                    ui.helper.parent().children().removeClass('active');
                    ui.helper.addClass('active');
                    var size = ui.helper.attr("data-filtersize");
                    _self.dam.currentSize = size;

                    var val = $("input[id='dam_txt_search_input']").val();

                    $('#asset_list').html('');
                    if (_self.dam.standAlone === false) { $('#modal_dam .loading').show(); }

                    _self.dam.actions.getAssetList({type: _self.dam.currentType, pag: 0, img_filter: _self.dam.imgFilter, txt: val, size: size, tot_x_pag: _self.dam.tot_x_pag});
                },
                updateDamArt: function () {
                    $.ajax({
                        url: '/' + Admin.dir_cgi_cpn + '/dam/prontus_dam_update_art.cgi',
                        type: "post",
                        dataType: 'json',
                        data: {
                            ts: mainFidJs.TS,
                            _prontus_id: Admin.prontus_id
                        },
                        success: function (response) {
                            if (response.status != 1) {
                                showModalAlert({
                                    title: ProntusL10n.get('global_error_title'),
                                    type: 'red',
                                    msg: response.msg
                                });
                            }
                        },
                        error: function(XMLHttpRequest, textStatus, errorThrown) {
                            SubmitForm.handleError('/' + Admin.dir_cgi_cpn + '/dam/prontus_dam_update_art.cgi', XMLHttpRequest, textStatus, errorThrown);
                        }
                    });
                }
            },
            methods: {
                addAssetsToModal: function (data, type) {
                    var html = '';

                    for (var x = 0; x < data.length; x++) {
                        var tmp_tpl = _self.dam.assetItemImagTpl;

                        if (type == 'video') tmp_tpl = _self.dam.assetItemVideoTpl;
                        if (type == 'audio') tmp_tpl = _self.dam.assetItemAudioTpl;

                        tmp_tpl = tmp_tpl.replace(/__img__/g, data[x].relpath);
                        tmp_tpl = tmp_tpl.replace(/__index__/g, x);
                        tmp_tpl = tmp_tpl.replace(/__public_server_name__/g, data[x].public_server_name);
                        tmp_tpl = tmp_tpl.replace(/__titular__/g, data[x].titular);
                        tmp_tpl = tmp_tpl.replace(/__size__/g, data[x].size);
                        tmp_tpl = tmp_tpl.replace(/__nom_foto__/g, data[x].file);
                        tmp_tpl = tmp_tpl.replace(/__href__/g, data[x].edit_art);
                        tmp_tpl = tmp_tpl.replace(/__type__/g, data[x].type);
                        tmp_tpl = tmp_tpl.replace(/__path_friendly_img__/g, data[x].friendly);

                        if (typeof Fid != 'undefined' && Fid.vtxtImageSizeLimit > 0 && data[x].bytes > Fid.vtxtImageSizeLimit*1024) {
                            tmp_tpl = tmp_tpl.replace(/__size_limit_alert__/g, 'size_limit_alert');
                        } else {
                            tmp_tpl = tmp_tpl.replace(/__size_limit_alert__/g, '');
                        }

                        if (type == 'audio') {
                            if (/\.mp3$/.test(data[x].relpath)) tmp_tpl = tmp_tpl.replace(/__mime__/g, 'audio/mpeg');
                            if (/\.mp4$/.test(data[x].relpath)) tmp_tpl = tmp_tpl.replace(/__mime__/g, 'video/mp4');
                            if (/\.wav$/.test(data[x].relpath)) tmp_tpl = tmp_tpl.replace(/__mime__/g, 'audio/wav');
                            if (/\.ogg$/.test(data[x].relpath)) tmp_tpl = tmp_tpl.replace(/__mime__/g, 'audio/ogg');
                        }

                        tmp_tpl = tmp_tpl.replace(/__\w+__/g, '');

                        html += tmp_tpl;
                    }

                    return html;
                },
                initDraggableDam: function() {
                    $('#modal_dam .fotodrag').draggable({
                        helper: "clone",
                        containment: "document",
                        zIndex: 9999,
                        iframeFix: true,
                        appendTo: "body"
                    });

                    $('#modal_dam .videodrag').draggable({
                        helper: "clone",
                        containment: "document",
                        zIndex: 9999,
                        iframeFix: true,
                        appendTo: "body"
                    });

                    $('#modal_dam .audiodrag').draggable({
                        helper: "clone",
                        containment: "document",
                        zIndex: 9999,
                        iframeFix: true,
                        appendTo: "body"
                    });
                },
                togglePagination: function () {
                    if (_self.dam.pagination.prev_pag < 0) {
                        $('#dam_nav_prev').hide();
                    } else {
                        $('#dam_nav_prev').show();
                    }

                    if (_self.dam.pagination.next_pag == _self.dam.pagination.total_pags) {
                        $('#dam_nav_next').hide();
                    } else {
                        $('#dam_nav_next').show();
                    }

                    if (_self.dam.standAlone === false) {
                        $('#modal_dam .pager-info').text(ProntusL10n.get('mediamanager_showing_elems').format(_self.dam.pagination.reg_desde,_self.dam.pagination.reg_hasta,_self.dam.pagination.total_regs));
                    } else {
                        $('.pager-info').text(ProntusL10n.get('mediamanager_showing_elems').format(_self.dam.pagination.reg_desde, _self.dam.pagination.reg_hasta,_self.dam.pagination.total_regs));
                    }
                },
                initClipboard: function () {
                    $(".clipboard").off("click").on("click", function (e) {
                        e.preventDefault();
                    });

                    if (_self.dam.clipboard) _self.dam.clipboard.destroy();

                    _self.dam.clipboard = new ClipboardJS('.clipboard', {
                        text: function (trigger) {
                            return trigger.getAttribute("data-text");
                        }
                    });
                    _self.dam.clipboard.on('success', function(e) {
                        e.clearSelection();
                    });
                }
            }
        },
        methods: {
            // Bindea todos las acciones a sus respectivos metodos.
            bindEvents: function (force) {
                var selector;

                if (typeof force == 'undefined') force = 0;

                if (!force) {
                    selector = '[data-namespace="mediamanager"][data-event]:not([data-bind])';
                } else {
                    selector = '[data-namespace="mediamanager"][data-event]';
                }

                $(selector).each(function () {
                    var method = $(this).attr("data-method");
                    var event = $(this).attr("data-event");

                    // Validar si es un evento válido.
                    if ($.inArray(event, _self.validEvents) >= 0) {
                        $(this).attr("data-bind", "true");
                        $(this).off(event).on(event, function (e) {
                            e.preventDefault();
                            _self.helper.execFunction(method, MediaManager, {e: e, helper: $(this)});
                        });
                    }
                });
            },
            unBindEvents: function (methods) {
                for (var x = 0; x < methods.length; x++) {
                    // por ahora quita todos los eventos.
                    $('[data-method="' + methods[x] + '"]').off();
                    $('[data-method="' + methods[x] + '"]').removeAttr("data-bind");
                }
            }
        },
        actions: {
            uploadImg: function (idCampo, link, name, original) {
                var data = {
                    _prontus_id: Admin.prontus_id,
                    _ts: mainFidJs.TS,
                    _type: 'foto',
                    foto_name: name,
                    foto_path: link,
                    foto_original: original
                };
                $.ajax({
                    url: '/' + Admin.dir_cgi_cpn + '/prontus_art_sbmit_ajax.cgi',
                    data: data,
                    type: 'POST',
                    dataType: 'json',
                    success: function(response) {
                        if (response.status == 0 ) {
                            showModalAlert({
                                title: ProntusL10n.get('global_error_title'),
                                type: 'red',
                                msg: response.msg
                            });
                        } else {
                            var foto_datos = response.data.split(";");
                            MediaManager.bancoimg.methods.reloadBancoImagenes();
                            MediaManager.fotofija.foto.addHiddens(foto_datos[0], foto_datos[2], foto_datos[3]);
                            MediaManager.fotofija.foto.set(idCampo, foto_datos[1], foto_datos[2], foto_datos[3]);
                        }
                    }
                });
            },
            copyUrlImg: function (ui) {
                let relpath = ui.helper.attr("data-relpath");
                // Si no viene este parametro, saca la foto por el nombre del input hidden.
                if (!relpath) {
                    relpath = $('input[name="'+ Admin.const.fotoFijaTag + ui.helper.attr("data-nomfoto") + '"]').val();
                    relpath = relpath.replace(/(foto_\d+)_(.+)/,"$1/$2");
                }
                navigator.clipboard.writeText(ProntusConf['front-protocol'] +'://' + ProntusConf['public-host'] + relpath);
            },
            // Generico. Mostrar foto en modal.
            showImgViewer: function (ui) {
                var relpath = ui.helper.attr("data-relpath");
                var modaltitle = ui.helper.attr("data-modaltitle");
                var nomfoto = ui.helper.attr("data-nomfoto");

                // Si no viene este parametro, saca la foto por el nombre del input hidden.
                if (!relpath) {
                    relpath = $('input[name="'+ Admin.const.fotoFijaTag + nomfoto + '"]').val();
                }

                $('#modal_img_viewer').find('.img_viewer').attr("src", relpath);
                $('#modal_img_viewer').find('.modal-title').text(modaltitle);
                $('#modal_img_viewer').modal('show');
            },
            showShareMedia: function (ui) {
                var type = ui.helper.attr("data-type");
                var src = ui.helper.attr("data-src");
                var player = '/prontus/front/player/' + type +'.html';
                if (typeof(ProntusConf["player-embed-"+ type]) !== 'undefined') {
                    player = ProntusConf["player-embed-"+ type];
                }
                var height = 60;
                if (type == 'video') {
                    height = 480;
                }
                var code = '<iframe width="640" height="'+ height + '" src="' + Admin.publicHost + player +'?' + '&amp;src=' + src;
                code += '" frameborder="0" allowfullscreen></iframe>';

                $('#modal_embed_media .embedable-code').html(code);
                $('#modal_embed_media').modal('show');
            },
            // inicializa los items audio o video.
            initPlayables: function() {
                var allPlayables = $('#asset_list .playable-element');
                $(allPlayables).each(function() {
                    this.addEventListener('loadedmetadata', function() {

                        var duration = _self.helper.getTimeFromDuration(this.duration);
                        $(this).parents('.playable-box').find('span.totaltime').html(duration);
                    });
                    this.addEventListener('timeupdate', function() {
                        var currentTime = _self.helper.getTimeFromDuration(this.currentTime);
                        $(this).parents('.playable-box').find('span.playedtime').html(currentTime);
                    });
                });
            },

            // alterna el estado de un video o audio entre play y pause.
            togglePlayPause: function (ui) {
                var index = ui.helper.attr('id').match(/.*-(\d+)$/);
                if (!index) {
                    index = 0; // CAN'T HAPPEN. TODO: VER SI ESTA DEF. DEBE CAMBIAR.
                } else {
                    index = index[1];
                }
                var allPlayables = $('#asset_list .playable-element');

                // el elemento de video o audio.
                var thisPlayable = $('#playable-'+index)[0];
                var thisControl = $('#playpause-'+index);

                $(allPlayables).each(function() {
                    var otherPlayable = $(this)[0];
                    if ($(this).attr('id') != 'playable-'+index) {
                        otherPlayable.pause();
                        $(this).parents('#asset_list .playable-box').find('.controls .playpause i').addClass('fa-play').removeClass('fa-pause');
                    }
                });

                if (thisPlayable.paused || thisPlayable.ended) {
                    thisPlayable.play();
                    $(thisControl).find('i').addClass('fa-pause').removeClass('fa-play');
                } else {
                    thisPlayable.pause();
                    $(thisControl).find('i').addClass('fa-play').removeClass('fa-pause');
                }
            },

            // alterna el volumen de un video o audio entre mute y unmute.
            toggleMuteUnmute: function (ui) {
                var index = ui.helper.attr('id').match(/.*-(\d+)$/);
                if (!index) {
                    index = 0; // CAN'T HAPPEN. TODO: VER SI ESTA DEF. DEBE CAMBIAR.
                } else {
                    index = index[1];
                }
                var thisPlayable = $('#playable-'+index)[0]; // el elemento de video o audio.

                if (thisPlayable.muted) {
                    $(ui.helper).find('i').addClass('fa-volume-up').removeClass('fa-volume-off');
                    thisPlayable.muted = 0;
                } else {
                    $(ui.helper).find('i').addClass('fa-volume-off').removeClass('fa-volume-up');
                    thisPlayable.muted = 1;
                }
            }
        },
        helper: {
            // Ejecuta un metodo de manera dinamica.
            // https://stackoverflow.com/questions/359788/how-to-execute-a-javascript-function-when-i-have-its-name-as-a-string
            execFunction: function (functionName, context) {
                var args = Array.prototype.slice.call(arguments, 2);
                var namespaces = functionName.split(".");
                var func = namespaces.pop();

                for(var i = 0; i < namespaces.length; i++) {
                    context = context[namespaces[i]];
                }

                if (typeof context[func] == 'undefined') {
                    showModalAlert({
                        title: ProntusL10n.get('global_error_title'),
                        type: 'red',
                        msg: ProntusL10n.get('global_missing_method', functionName)
                    });
                    return;
                }

                return context[func].apply(context, args);
            },
            submitForm: function () {
                Fid.submitArt('save', '_self', true);
            },
            cleanString: function(text) {
                var texto = text;
                texto = texto.replace(/(['"])/g, "\\$1");
                texto =  texto.replace(/\\\'/g,"&#39;");
                texto =  texto.replace(/\\\"/g,"&quot;");
                return texto;
            },

            // util para formatear hh:mm:ss
            timePad: function(string, pad, length) {
                return (new Array(length+1).join(pad)+string).slice(-length);
            },
            // recibe un valor de segundos con decimales (e.g. audio.duration)
            // y devuelve el equivalente en [hh:]mm:ss.
            getTimeFromDuration: function(duration) {
                if (! Number.isNaN(duration)) {
                    var seconds = Math.floor(duration);
                    // calculamos las horas
                    var hours = Math.floor(seconds / 3600);
                    // calculamos los minutos restantes
                    seconds -= (hours * 3600);
                    var minutes = Math.floor(seconds / 60);
                    seconds -= (minutes * 60);
                    var formattedTime = '';
                    if (hours) {
                        formattedTime = _self.helper.timePad(hours, '0', 2) + ':';
                    }
                    if (minutes) {
                        formattedTime += _self.helper.timePad(minutes, '0', 2) + ':';
                    } else {
                        formattedTime += '00:';
                    }
                    formattedTime += _self.helper.timePad(seconds, '0', 2);
                    return formattedTime;
                }
                return '00:00';
            }
        }
    };
    window.MediaManager = MediaManager;
})(this);
