(function (window) {
    var _self = null;
    var Multimedia = {
        validEvents: ['click', 'hover'],
        init: function () {
            _self = this;
            _self.methods.bindEvents(); // bind global.
            _self.upload.init();
            $('.button-showcode-video').click(_self.showCodeV);
            $('.button-showcode-audio').click(_self.showCodeA);
        },
        installPlayerAudio: function(i, e) {
            var src = $(e).find('a').attr('href');
            if (/(mp3|mp4)$/i.test(src)) {
                var resp;
                if (resp = /multimedia_audio(\w+)/i.exec($(e).data('name'))) {
                    var playerId = 'prontusAudioPlayer'+ resp[1];
                    if (document.getElementById(playerId) == null) {
                        return true;
                    }
                    var config = {  "contentId": playerId,
                                    "audioId": $(e).data('name'),
                                    "mediaSrc": {
                                        "defaultSrc": src +'?_'+ Date.now()
                                    }
                                };
                    return prontusAudioPlayer.mediaController.install(config);
                }
            }
        },
        //muestra/oculta el codigo para embeber el video
        showCodeV: function() {
            var selector = '#' + $(this).data('container') + ' a';
            if ($(selector).length > 0) {
                var src = $(selector).attr('href');
                if (/\.\w+$/i.test(src)) {
                    var resp = /multimedia-container-video(\w+)/i.exec($(this).data('container'));

                    var player = '/prontus/front/player/video.html';
                    if (typeof(ProntusConf["player-embed-video"]) !== 'undefined') {
                        player = ProntusConf["player-embed-video"];
                    }

                    var code = '<iframe width="640" height="360" src="' + Admin.publicHost + player + '?' + '&amp;src=' + src;
                    code += '" frameborder="0" allowfullscreen></iframe>';

                    let sub_selector = '#embed-code_mvideo'+ resp[1] +' .embedable-code';
                    $(sub_selector).html(code);

                    if ($(sub_selector).hasClass('hide-element') ){
                        $(sub_selector).removeClass('hide-element');
                        $(sub_selector).select();
                    } else {
                        $(sub_selector).addClass('hide-element');
                    }
                }
            }
            return false;
        },
        // -------------------------------------------------------------------------
        //muestra/oculta el codigo para embeber el audio
        showCodeA: function() {
            var selector = '#' + $(this).data('container') + ' a';
            if ($(selector).length > 0) {
                var src = $(selector).attr('href');
                if (/\.\w+$/i.test(src)) {
                    var resp = /multimedia-container-audio(\w+)/i.exec($(this).data('container'));

                    var player = '/prontus/front/player/audio.html';
                    if (typeof(ProntusConf["player-embed-audio"]) !== 'undefined') {
                        player = ProntusConf["player-embed-audio"];
                    }

                    var code = '<iframe width="640" height="60" src="' + Admin.publicHost + player + '?' + '&amp;src=' + src;
                    code += '" frameborder="0" allowfullscreen></iframe>';

                    let sub_selector = '#embed-code_maudio'+ resp[1] +' .embedable-code';
                    $(sub_selector).html(code);

                    if ($(sub_selector).hasClass('hide-element') ){
                        $(sub_selector).removeClass('hide-element');
                        $(sub_selector).select();
                    } else {
                        $(sub_selector).addClass('hide-element');
                    }
                }
            }
            return false;
        },
        upload: {
            init: function () {
                // Habilitar botones de multimedia con archivos.
                $('.multimedia-container').each(function () {
                    var $elem = $(this);
                    var id = $elem.attr("id");
                    var multimedia_name = $elem.attr("data-name");

                    if (!mainFidJs.TS) {
                        $('#' + id + ' .selectMultimedia').off('click').on('click', function () {
                            $('#' + multimedia_name).click();
                            $('#' + multimedia_name).off('change').on('change', function () {
                               var localfile = $('#' + multimedia_name).val();
                               localfile = localfile.replace('C:\\fakepath\\', '');
                               $elem.find('.multimedia-filename').html(localfile);
                            });
                        });
                    } else {
                        var name = $elem.find('.multimedia-label').text();
                        var num_id = multimedia_name.toLowerCase();

                        var acceptedTypes = '';
                        if (/video/i.test(id)) {
                            acceptedTypes = '.avi, .flv, .mp4, .wmv, .mpg, .mpeg, .3gp, .mov';
                            num_id = num_id.replace('multimedia_video', '');
                        }
                        if (/audio/i.test(id)) {
                            acceptedTypes = '.wav, .ogg, .mp3, .mp4, .m4a, .mpeg, .3gp';
                            num_id = num_id.replace('multimedia_audio', '');
                        }
                        // carga multimedia
                        $elem.dropzone({
                            url: '/{0}/prontus_art_upload.cgi'.format(Admin.dir_cgi_cpn),
                            paramName: '_archivo',
                            previewTemplate: '',
                            clickable: '#' + id + ' .selectMultimedia',
                            autoProcessQueue: false,
                            autoQueue: true,
                            maxFiles: 1,
                            maxFilesize: Admin.maxFileSizeM,
                            timeout: null,
                            parallelUploads: 1,
                            acceptedFiles: acceptedTypes,
                            dictInvalidFileType: 'No puedes subir archivos de este tipo.',
                            params: {_ts: mainFidJs.TS, _type: 'multimedia', _prontus_id: Admin.prontus_id, _archivo_campo: multimedia_name},
                            success: function (data) {
                                if (data.status == 'success') {
                                    var response = JSON.parse(data.xhr.response);
                                    if (response.status == 1) {
                                        var info = response.msg.split(';');

                                        _self.actions.updateMultimedia(id, multimedia_name, info[0], info[1], data.size);

                                        $('#modal_upload_multimedia').find('[data-method="actions.closeModal"]').removeAttr("disabled");
                                        $('#modal_upload_multimedia').find('[data-method="upload.actions.processQueue"] span').removeClass('glyphicon-refresh spinning').addClass('glyphicon-upload');
                                        $('#modal_upload_multimedia').find('[data-method="upload.actions.processQueue"]').hide();
                                        if (/audio/i.test(id)) {
                                            Transcoding.recargarInstancia(num_id, 'audio');
                                        }
                                        if (/video/i.test(id)) {
                                            Transcoding.recargarInstancia(num_id, 'video');
                                        }
                                        Fid.clearS3Status();
                                    } else {
                                        showModalAlert({
                                            title: ProntusL10n.get('global_load_error'),
                                            type: 'red',
                                            msg: response.msg
                                        });
                                        _self.actions.closeModal();
                                    }
                                }
                            },
                            addedfile: function (file) {
                                var size = bytesToKbytes(file.size);
                                $('#modal_upload_multimedia').find('.upload-multimedia-label').text(name);
                                $('#modal_upload_multimedia').find('.upload-multimedia-filename .filename').text(file.name);
                                $('#modal_upload_multimedia').find('.upload-multimedia-filename .size').text(size);
                                $('#multimedia-id').val(id);

                                _self.methods.clearUploadProgress();

                                $('#modal_upload_multimedia').modal('show');
                            },
                            queuecomplete: function (data) {
                            },
                            totaluploadprogress: function (a, b) {
                                a = Math.round(a);

                                $('#modal_upload_multimedia').find('.upload-asocfile-progress').css('width', a + '%');
                                $('#modal_upload_multimedia').find('.upload-asocfile-progress').text(a + '%');

                                if (a == 100) {
                                    $('#modal_upload_multimedia').find('.upload-asocfile-progress').addClass('progress-bar-success');
                                }
                            },
                            error: function(file, errorMessage, xhrObject) {
                                var msg = ProntusL10n.get('global_upload_error');
                                if (xhrObject && xhrObject.status == '413') {
                                    msg = ProntusL10n.get('global_file_too_large');
                                } else if (this.options.maxFilesize && file.size > this.options.maxFilesize * 1048576) {
                                    msg = ProntusL10n.get('global_file_too_large');
                                } else if (file.status === 'error' && !file.accepted) {
                                    msg = ProntusL10n.get('global_supported_filetypes', this.options.acceptedFiles);
                                }
                                showModalAlert({
                                    title: ProntusL10n.get('global_load_error'),
                                    type: 'red',
                                    msg: msg
                                });
                                _self.actions.closeModal();
                            },
                            accept: function(file, done) {
                                var accept = this.options.acceptedFiles.replace(', ','|');
                                var regexp = new RegExp('('+accept+')$', 'i');
                                if (regexp.test(file)) {
                                    done(ProntusL10n.get('global_invalid_filetype'));
                                } else {
                                    done();
                                }
                            }
                        });

                        $elem.find('input[name^="_hidd_multimedia"]').each(function () {
                            if ($(this).val() !== '') {
                                if (window.isSecureContext) {
                                    $elem.find('.multimedia-botones button[data-method="actions.copyUrlMultimedia"]').show();
                                }
                                $elem.find('.multimedia-botones button[data-method="actions.downloadMultimedia"]').removeAttr("disabled");
                                $elem.find('.multimedia-botones button[data-method="actions.deleteMultimedia"]').removeAttr("disabled");
                            }
                        });
                    }
                });
            },
            actions: {
                setupCCUpload: function(elem){
                    var $elem = $(elem);
                    var num = $elem.attr("data-num");
                    var multimedia_name = "multimedia_video" + num + "_subtitle";

                    if (mainFidJs.TS) {
                        $elem.show();
                    }

                    $('#add_video_cc' + num + ' .button-add_cc').on('click', function (e) {
                        e.preventDefault();
                    })

                    $elem.dropzone({
                        url: '/{0}/prontus_art_upload.cgi'.format(Admin.dir_cgi_cpn),
                        paramName: '_archivo',
                        previewTemplate: '',
                        clickable: '#add_video_cc' + num + ' .button-add_cc',
                        autoProcessQueue: false,
                        autoQueue: true,
                        maxFiles: 1,
                        maxFilesize: Admin.maxFileSizeM,
                        timeout: null,
                        parallelUploads: 1,
                        acceptedFiles: '.vtt',
                        dictInvalidFileType: 'No puedes subir archivos de este tipo.',
                        params: {_ts: mainFidJs.TS, _type: 'subtitle', _prontus_id: Admin.prontus_id, _archivo_campo: multimedia_name},
                        success: function (data) {
                            if (data.status == 'success') {
                                var response = JSON.parse(data.xhr.response);
                                if (response.status == 1) {
                                    $('#modal_upload_subtitle').find('[data-method="actions.closeModal"]').removeAttr("disabled");
                                    $('#modal_upload_subtitle').find('[data-method="upload.actions.processQueue"] span').removeClass('glyphicon-refresh spinning').addClass('glyphicon-upload');
                                    $('#modal_upload_subtitle').find('[data-method="upload.actions.processQueue"]').hide();
                                } else {
                                    showModalAlert({
                                        title: ProntusL10n.get('global_load_error'),
                                        type: 'red',
                                        msg: response.msg
                                    });
                                    _self.actions.closeModal();
                                }
                            }
                        },
                        addedfile: function (file) {
                            var size = bytesToKbytes(file.size);
                            $('#modal_upload_subtitle').find('.upload-multimedia-label').text(name);
                            $('#modal_upload_subtitle').find('.upload-multimedia-filename .filename').text(file.name);
                            $('#modal_upload_subtitle').find('.upload-multimedia-filename .size').text(size);
                            $('#multimedia-id-subt').val('add_video_cc' + num);

                            _self.methods.clearSubtitleUploadProgress();

                            $('#modal_upload_subtitle').modal('show');
                        },
                        queuecomplete: function (data) {
                        },
                        totaluploadprogress: function (a, b) {
                            a = Math.round(a);

                            $('#modal_upload_subtitle').find('.upload-asocfile-progress').css('width', a + '%');
                            $('#modal_upload_subtitle').find('.upload-asocfile-progress').text(a + '%');

                            if (a == 100) {
                                $('#modal_upload_subtitle').find('.upload-asocfile-progress').addClass('progress-bar-success');
                            }
                        },
                        error: function(file, errorMessage, xhrObject) {
                            var msg = ProntusL10n.get('global_upload_error');
                            if (xhrObject && xhrObject.status == '413') {
                                msg = ProntusL10n.get('global_file_too_large');
                            } else if (this.options.maxFilesize && file.size > this.options.maxFilesize * 1048576) {
                                msg = ProntusL10n.get('global_file_too_large');
                            } else if (file.status === 'error' && !file.accepted) {
                                msg = ProntusL10n.get('global_supported_filetypes', this.options.acceptedFiles);
                            }
                            showModalAlert({
                                title: ProntusL10n.get('global_load_error'),
                                type: 'red',
                                msg: msg
                            });
                            _self.actions.closeModal();
                        },
                        accept: function(file, done) {
                            var accept = this.options.acceptedFiles.replace(', ','|');
                            var regexp = new RegExp('('+accept+')$', 'i');
                            if (regexp.test(file)) {
                                done(ProntusL10n.get('global_invalid_filetype'));
                            } else {
                                done();
                            }
                        }
                    });
                },
                processQueue: function () {
                    var id = $('#multimedia-id').val();

                    if (id) {
                        var mydz = Dropzone.forElement('#' + id);

                        if (mydz.getQueuedFiles().length > 0) {
                            $('#modal_upload_multimedia').find('.upload-asocfile-progress').css('width', '0%').text('0%');
                            $('#modal_upload_multimedia').find('.upload-asocfile-progress').removeClass('progress-bar-success');
                            $('#modal_upload_multimedia').find('[data-method="upload.actions.processQueue"]').attr("disabled", "disabled");
                            $('#modal_upload_multimedia').find('[data-method="actions.closeModal"]').attr("disabled", "disabled");
                            $('#modal_upload_multimedia').find('[data-method="upload.actions.processQueue"] span').removeClass('glyphicon-upload').addClass('glyphicon-refresh spinning');
                            mydz.processQueue();
                        }
                    } else {
                        console.log(ProntusL10n.get('global_missing_id'));
                    }
                },
                processQueueCC: function () {
                    var id = $('#multimedia-id-subt').val();

                    if (id) {
                        var mydz = Dropzone.forElement('#' + id);

                        if (mydz.getQueuedFiles().length > 0) {
                            $('#modal_upload_subtitle').find('.upload-asocfile-progress').css('width', '0%').text('0%');
                            $('#modal_upload_subtitle').find('.upload-asocfile-progress').removeClass('progress-bar-success');
                            $('#modal_upload_subtitle').find('[data-method="upload.actions.processQueue"]').attr("disabled", "disabled");
                            $('#modal_upload_subtitle').find('[data-method="actions.closeModal"]').attr("disabled", "disabled");
                            $('#modal_upload_subtitle').find('[data-method="upload.actions.processQueue"] span').removeClass('glyphicon-upload').addClass('glyphicon-refresh spinning');
                            mydz.processQueue();
                        }
                    } else {
                        console.log('ERROR: id not found.');
                    }
                }
            }
        },
        actions: {
            copyUrlMultimedia: function (ui) {
                navigator.clipboard.writeText(ProntusConf['front-protocol'] +'://' + ProntusConf['public-host'] + ui.helper.parents('.multimedia-box').find('.multimedia-filename a').attr("href"));
            },
            downloadMultimedia: function (ui) {
                window.open(ui.helper.parents('.multimedia-box').find('.multimedia-filename a').attr("href"));
            },
            deleteMultimedia: function (ui) {
                var $input_borr = ui.helper.parents('.multimedia-box').find('.multimedia-filename input[name^="_borr_"]');

                if ($input_borr.is(':checked')) {
                    $input_borr.removeAttr("checked");
                    ui.helper.removeClass('btn-danger').addClass('btn-default');
                } else {
                    $input_borr.attr("checked", "checked");
                    ui.helper.removeClass('btn-default').addClass('btn-danger');
                }

            },
            closeModal: function () {
                var id = $('#multimedia-id').val();
                $('#modal_upload_multimedia').modal('hide');
                $('#multimedia-id').val('');

                if (id) {
                    var mydz = Dropzone.forElement('#' + id);
                    mydz.files = [];
                    mydz.disable();
                    mydz.enable();
                }
            },
            closeSubtitleModal: function () {
                var id = $('#multimedia-id-subt').val();
                $('#modal_upload_subtitle').modal('hide');
                $('#multimedia-id-subt').val('');

                if (id) {
                    var mydz = Dropzone.forElement('#' + id);
                    mydz.files = [];
                    mydz.disable();
                    mydz.enable();
                }
            },
            updateMultimedia: function (elem_id, nom_campo, valor_campo, relpath, size) {
                var template = $('#multimedia_inputs').html();
                var $elem = $('#' + elem_id);

                template = template.replace(/__nom_campo__/g, nom_campo);
                template = template.replace(/__relpath_file__/g, relpath);
                template = template.replace(/__valor_campo__/g, valor_campo);
                template = template.replace(/__bytes__/g, size);
                template = template.replace(/__total__/g, size);

                size = bytesToKbytes(size);
                template = template.replace(/__tamano__/g, size);

                $elem.find('.multimedia-filename').html(template);

                if (window.isSecureContext) {
                    $elem.find('.multimedia-botones button[data-method="actions.copyUrlMultimedia"]').show();
                }
                $elem.find('.multimedia-botones button[data-method="actions.downloadMultimedia"]').removeAttr("disabled");
                $elem.find('.multimedia-botones button[data-method="actions.deleteMultimedia"]').removeAttr("disabled");
            }
        },
        methods: {
            clearUploadProgress: function () {
                $('#modal_upload_multimedia').find('.upload-asocfile-progress').css('width', '0%').text('0%');
                $('#modal_upload_multimedia').find('.upload-asocfile-progress').removeClass('progress-bar-success');
                $('#modal_upload_multimedia').find('[data-method="upload.actions.processQueue"]').removeAttr("disabled");
                $('#modal_upload_multimedia').find('[data-method="actions.closeModal"]').removeAttr("disabled");
                $('#modal_upload_multimedia').find('[data-method="upload.actions.processQueue"] span').removeClass('glyphicon-refresh spinning').addClass('glyphicon-upload');
                $('#modal_upload_multimedia').find('[data-method="upload.actions.processQueue"]').show();

            },
            clearSubtitleUploadProgress: function () {
                $('#modal_upload_subtitle').find('.upload-asocfile-progress').css('width', '0%').text('0%');
                $('#modal_upload_subtitle').find('.upload-asocfile-progress').removeClass('progress-bar-success');
                $('#modal_upload_subtitle').find('[data-method="upload.actions.processQueue"]').removeAttr("disabled");
                $('#modal_upload_subtitle').find('[data-method="actions.closeModal"]').removeAttr("disabled");
                $('#modal_upload_subtitle').find('[data-method="upload.actions.processQueue"] span').removeClass('glyphicon-refresh spinning').addClass('glyphicon-upload');
                $('#modal_upload_subtitle').find('[data-method="upload.actions.processQueue"]').show();

            },
            // Bindea todos las acciones a sus respectivos metodos.
            bindEvents: function (force) {
                var selector;

                if (typeof force == 'undefined') force = 0;

                if (!force) {
                    selector = '[data-namespace="multimedia"][data-event]:not([data-bind])';
                } else {
                    selector = '[data-namespace="multimedia"][data-event]';
                }

                $(selector).each(function () {
                    var method = $(this).attr("data-method");
                    var event = $(this).attr("data-event");

                    // Validar si es un evento válido.
                    if ($.inArray(event, _self.validEvents) >= 0) {
                        $(this).attr("data-bind", "true");
                        $(this).off(event).on(event, function (e) {
                            e.preventDefault();
                            _self.helper.execFunction(method, Multimedia, {e: e, helper: $(this)});
                        });
                    }
                });
            }
        },
        helper: {
            execFunction: function (functionName, context) {
                var args = Array.prototype.slice.call(arguments, 2);
                var namespaces = functionName.split(".");
                var func = namespaces.pop();

                for(var i = 0; i < namespaces.length; i++) {
                    context = context[namespaces[i]];
                }

                if (typeof context[func] == 'undefined') {
                    showModalAlert({
                        title: ProntusL10n.get('global_error_title'),
                        type: 'red',
                        msg: ProntusL10n.get('global_missing_method', functionName)
                    });
                    return;
                }

                return context[func].apply(context, args);
            }
        }
    };
    window.Multimedia = Multimedia;
})(this);
