(function(window) {
    var _self;
    var PortAdmin = {
        vars: {
            lastModInterval: false,
            idTplArticList: "tpl_artic_list",
            idTplArea: "tpl_area",
            idTplAreaItem: "tpl_area_item",
            idTplAreaItemEmpty: "tpl_area_item_empty",
            idTplAddToAreaMenu: "tpl_add_new_art_menu",
            idTplAddToAreaMenuItem: "tpl_add_new_art_menu_item",
            idTplAddToAreaLink: "tpl_add_new_art_link",
            idTplfilter: "tpl_filter",
            idTplFavoriteSearch: "tpl_favorite_search",
            idTplSendToAreaList: "tpl_send_to_area_list",
            idTplArticListNoNesult: "tpl_artic_list_no_result",
            mv: [],
            areas: false,
            areasProp: {},
            articAreas: {},
            articAreaCorruptos: {},
            articAreaVB: {},
            articAreaProntus: {},
            startDrag: false,
            startingMD5SUM: false,
            searchParams: { // parametros de busqueda por defecto.
                "diapubhasta": "",
                "alta": "",
                "diapub": "",
                "autor": "",
                "diaexp": "",
                "tipart": "",
                "seccion": "",
                "subtema": "",
                "multitag_s": "",
                "multitag_t": "",
                "multitag_st": "",
                "diahasta": "",
                "dia": "",
                "ts": "",
                "bajada": "",
                "titu": "",
                "tema": "",
                "_orden_lista": "C",
                "_filas_x_pag": "",
                "diaexphasta": ""
            },
            activeArea: false, // indica el area activa (al hacer dblclick sobre la cabecera)
            changes: false, // indica si la portada tiene cambios.
            prontus_id: null,
            clipboard: false,
            droppableArea: false,
            taxonomia: null,
            serverName: '',
            dataTable: {
                "paginate": {
                    "first":    '<span aria-hidden="true" class="glyphicon glyphicon-fast-backward"></span>',
                    "last":     '<span aria-hidden="true" class="glyphicon glyphicon-fast-forward"></span>',
                    "next":     '<span aria-hidden="true" class="glyphicon glyphicon-forward"></span>',
                    "previous": '<span aria-hidden="true" class="glyphicon glyphicon-backward"></span>',
                }
            },
            portVoboStatus: false,
        },
        ui: {
            selectors: {
                // Combo de edicion y portada.
                cmbPort: '#_port',
                cmbEdic: '#_edic',
                inputAllPorts: '#_all_ports',
                // Paneles y listas
                panelRecentArtics: '.admin-port .panel-recent-artics',
                panelPortAreas: '.admin-port .panel-port-areas',
                articList: '#artic-list',
                // Paginacion articulos recientes
                articListFirst: '#artic_list_first',
                articListPrev: '#artic_list_prev',
                articListNext: '#artic_list_next',
                articListLast: '#artic_list_last',
                // Informativo
                lastMod: '#lastmod'
            }
        },
        init: function () {
            _self = this;
            _self.vars.prontus_id = Admin.prontus_id;

            _self.port.actions.getPortsAndEdics(function () {
                _self.port.actions.initMultiEdic();
                _self.artics.init();
            });

            _self.search.init();
            _self.methods.initDatePicker();
            _self.methods.initCollapseAreas();
            _self.search.bindSearchOptions();
            _self.port.actions.bindPortButtons();
            _self.port.tools.bindToolsEvents();
            _self.port.tools.bindCounters();
            _self.methods.pingRecurso();
            $('[data-toggle="tooltip"]').tooltip();
            $.ajax({
                type: "GET",
                dataType: 'json',
                url: '/' + Admin.prontus_id + '/cpan/data4fids/taxs.json',
                cache: false,
                success: function (data) {
                    _self.vars.taxonomia = data;
                },
                error: function(_XMLHttpRequest, textStatus, errorThrown) {
                    console.log(ProntusL10n.get('portadmin_loading_tax_error', XMLHttpRequest, textStatus, errorThrown));
                }
            });

            $("#pip-select-arts").on("change", function (e) {
                var prontus_id = $("#pip-select-arts option:selected").val();
                if (Admin.prontus_id != prontus_id) {
                    $("#pip-select-arts").parent().parent().parent().removeClass('nextgray2').addClass('nextyellow');
                } else {
                    $("#pip-select-arts").parent().parent().parent().removeClass('nextyellow').addClass('nextgray2');
                }

                _self.artics.actions.loadArtics(0, {
                    _pip_prontus_id: prontus_id
                });
            });
        },
        methods: {
            pingRecurso: function () {
                var port = $(_self.ui.selectors.cmbPort).val();
                var edic = $(_self.ui.selectors.cmbEdic).val();

                if (edic === '' || edic == null) {
                    edic = 'base';
                }

                if (edic == null || port == null) {
                    setTimeout(PortAdmin.methods.pingRecurso, 1000);
                    return;
                }

                var nom_recurso =  edic + '-' + port;
                Admin.pingRecurso('port', nom_recurso, PortAdmin.methods.pingRecurso);
            },
            initDatePicker: function () {
                $(".datepicker").datetimepicker({
                    format: 'DD/MM/YYYY',
                    locale: ProntusL10n.getLocale(),
                    useCurrent: false
                });
            },
            initCollapseAreas: function () {
                $('#area_expandir').off('click').on('click', function (e) {
                    e.preventDefault();
                    $(this).hide();
                    $('#area_colapsar').show();
                    $('div[id^="collapseArea"]').collapse('show');
                    _self.helper.setValueLS('area_colapsar', 'si');
                });
                $('#area_colapsar').off('click').on('click', function (e) {
                    e.preventDefault();
                    $(this).hide();
                    $('#area_expandir').show();
                    $('div[id^="collapseArea"]').collapse('hide');
                    _self.helper.setValueLS('area_colapsar', 'no');
                });
            },
            initClipboard: function () {
                $(".clipboard").off("click").on("click", function (e) {
                    e.preventDefault();
                });

                if (_self.vars.clipboard) _self.vars.clipboard.destroy();

                _self.vars.clipboard = new ClipboardJS('.clipboard', {
                    text: function (trigger) {
                        return trigger.getAttribute("data-text");
                    }
                });

                _self.vars.clipboard.on('success', function(e) {
                    e.clearSelection();
                });
            },
            initDraggable: function () {
                $(_self.ui.selectors.articList + ' .list-group > li').draggable({
                    appendTo: _self.ui.selectors.panelRecentArtics,
                    helper: "clone",
                    handle: "span.handler",
                    connectToSortable: ".panel-port-areas .list-group",
                    cancel: ".fake-handler,.in_current_port",
                    stop: function (e) {
                        if (_self.vars.startDrag === false) {
                            _self.areas.actions.moveToAreaEvent($(e.target));
                        }
                    },
                    start: function (e, ui) {
                        _self.vars.startDrag = true;
                        ui.helper.css("width", $(e.currentTarget).width());
                    }
                }); //.disableSelection();

                $(_self.ui.selectors.articList + ' .list-group').droppable({
                    drop: function (_e, ui) {
                        var ts = ui.helper.attr("data-ts");
                        _self.vars.droppableArea = _self.areas.actions.findArticArea(ts);

                        var $areaItem = $(_self.ui.selectors.panelPortAreas + ' .list-group').find('[data-ts="' + ts + '"]');
                        var area = $areaItem.parent("ul").attr("data-area");

                        // En caso de que se arrastre un articulo a un area y luego nuevamente al listado de articulos sin soltarlo
                        // No se alcanza a asignar a un area, por lo tanto el area id no existe.
                        if (typeof area != 'undefined') {
                            $areaItem.remove();
                            _self.areas.actions.updateArticsArea(area);

                            _self.artics.actions.updateRecentArticState(ts);
                            _self.port.actions.setPortHasChanges();
                        }
                    }
                });
            },
            initSortable: function () {
                if ($(_self.ui.selectors.panelPortAreas + ' .list-group.ui-sortable').length) {
                    $(_self.ui.selectors.panelPortAreas + ' .list-group').sortable("destroy");
                }

                $(_self.ui.selectors.panelPortAreas + ' .list-group').sortable({
                    appendTo: ".panel-port-areas",
                    helper: "clone",
                    handle: "span.handler",
                    placeholder: 'area-dropzone',
                    connectWith: '.admin-port .panel-port-areas .list-group',
                    stop: function (_e, ui) {
                        var area = ui.item.parent().attr("data-area");
                        var ts = ui.item.attr("data-ts");

                        if (_self.vars.droppableArea) {
                            area = _self.vars.droppableArea;
                            _self.vars.droppableArea = false;
                        }

                        var $origItem = $("#artic-list .list-group li[data-ts='{0}']".format(ts));
                        var inArea = _self.areas.actions.checkArticInArea(ts, area);
                        var fromArea = _self.areas.actions.findArticArea(ts);

                        if (!inArea) { // El artículo no existe en el área.
                            // El campo data solo esta presente si el articulo está visible en la lista de recientes.
                            var data = {};

                            if (fromArea) {
                                data = _self.areas.actions.getArticDataFromArea(ts, fromArea);
                            } else {
                                var this_input = $("input[name='data_{0}']".format(ts));
                                this_input = $(this_input).val();

                                if (typeof this_input !== 'undefined') {
                                    data = JSON.parse($("input[name='data_{0}']".format(ts)).val());
                                } else {
                                    data.area = null;
                                    data.portadas = {};
                                }
                            }

                            if (_self.areas.actions.receiveInAreaEvent($origItem, ui.item, data, area)) {
                                _self.port.actions.setPortHasChanges();

                                if (fromArea) {
                                    _self.areas.actions.updateArticsArea(area);
                                    _self.areas.actions.updateArticsArea(fromArea);
                                    _self.areas.actions.changeArticFromArea(ts, fromArea, area, data);
                                }
                            } else {
                                if (fromArea) {
                                    return false;
                                }
                            }
                        } else {
                            // Se actualiza orden.
                            _self.areas.actions.updateArticsArea(area);
                            _self.port.actions.setPortHasChanges();
                        }
                    },
                    over: function (_e, ui) {
                        ui.item.parent().find('.area-dropzone').height(22);
                    },
                    start: function () {
                    }
                });
            },
            bindListsEvents: function() {
                $(_self.ui.selectors.panelRecentArtics + ' .pub-in-area').off("click").on("click", function (e) {
                    e.preventDefault();
                    e.stopPropagation();
                    var $item = $(this).closest(".list-group-item");

                    if ($item.hasClass("noedit")) return;

                    var ts = $item.attr("data-ts");
                    var data = JSON.parse($("input[name='data_{0}']".format(ts)).val());
                    var area = _self.vars.activeArea;
                    if (!area) {
                        var send_to = $(this).attr("data-send-to");
                        if (send_to) {
                            area = parseInt(send_to);
                        } else {
                            if ($(this).next('.send-to-area-dropdown').length) {
                                $(this).next('.send-to-area-dropdown').dropdown('toggle');
                            } else {
                                // TODO ERROR! sin area.
                                showModalAlert({
                                    title: ProntusL10n.get('global_error_title'),
                                    type:'red',
                                    msg: ProntusL10n.get('portadmin_no_areas')
                                });
                            }
                            return;
                        }
                    }

                    var $newLi = $();
                    $newLi = $newLi.add(_self.areas.actions.parseAreaItem(data));

                    $(_self.ui.selectors.panelPortAreas + ' .list-group[data-area="{0}"]'.format(area)).prepend($newLi);
                    if (_self.areas.actions.receiveInAreaEvent($item, $newLi, data, area)) {
                        _self.areas.actions.moveToAreaEvent($item);
                        _self.port.actions.setPortHasChanges();
                    }
                });

                $('.admin-port .list-group-item .dpub-from-area a').off("click").on("click", function (e) {
                    e.preventDefault();
                    var $item = $(this).closest(".list-group-item");

                    if ($item.hasClass("noedit")) return false;

                    var ts = $item.attr("data-ts");
                    var $areaItem = $(_self.ui.selectors.panelPortAreas + ' .list-group-item[data-ts="{0}"]'.format(ts));
                    var area = $areaItem.parent("ul").attr("data-area");

                    $areaItem.remove();
                    _self.areas.actions.updateArticsArea(area);

                    _self.artics.actions.updateRecentArticState(ts);
                    _self.port.actions.setPortHasChanges();
                });

                $('.admin-port .list-group-item .toggle-more-info').off("click").on("click", function (e) {
                    e.preventDefault();
                    var $item = $(this).closest(".list-group-item");

                    if ($item.hasClass('art-corrupto')) return false;

                    if ($(this).hasClass('toggle-more-info')) {
                        if ($(this).attr('data-toggle') == 'more') {
                            $(this).find('span.fa').removeClass('fa-minus');
                            $(this).find('span.fa').addClass('fa-plus');
                        } else {
                            $(this).find('span.fa').removeClass('fa-plus');
                            $(this).find('span.fa').addClass('fa-minus');
                        }
                    }

                    if ($(this).attr("data-toggle") == "more") {
                        $(this).text($(this).attr("data-less"));
                        $(this).attr("data-toggle", "less");
                        $item.find(".more-info").stop().slideUp('fast');
                    } else {
                        $(this).text($(this).attr("data-more"));
                        $(this).attr("data-toggle", "more");
                        $item.find(".more-info").stop().slideDown('fast');
                    }

                });

                $('.admin-port .list-group-item').off("dblclick").on("dblclick", function () {
                    $(this).find('.toggle-more-info').trigger('click');
                });

                $('.admin-port .btn-group').off("show.bs.dropdown").on("show.bs.dropdown", function () {
                    var $item = $(this).closest(".list-group-item.noedit");

                    if ($item.length > 0) {
                        var $ul = $(this).find("ul");
                        if ($ul.length > 0) {
                            $ul.remove();
                        }
                    }
                });

                $(".btn-remove-artic").off("click").on("click", function (e) {
                    e.preventDefault();

                    var $item = $(this).closest(".list-group-item");
                    var ts = $item.attr("data-ts");

                    var isDanger = $item.hasClass('list-group-item-danger');

                    $item.addClass("list-group-item-danger");
                    $item.find(".group-btns").hide();
                    $item.find(".row-loading").show();
                    var artData = JSON.parse($($item).children('input').val());
                    showModalConfirm({
                        msg: ProntusL10n.get('portadmin_article_delete_confirm', artData.titular,  artData.fid),
                        type: 'blue',
                        icon: "glyphicon glyphicon-question-sign",
                        okTitle: ProntusL10n.get('global_delete_title'),
                        btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                        cbBtnOK: function () {
                            Admin.borrarArticulo(ts, $item);
                        },
                        cbBtnCancel: function () {
                            if (!isDanger) {
                                $item.removeClass("list-group-item-danger");
                            }

                            $item.find(".group-btns").show();
                            $item.find(".row-loading").hide();
                        }
                    });
                });

                _self.methods.initClipboard();
                $('[data-toggle="tooltip"]').tooltip();
            }
        },
        // Manejo de lista de articulos
        artics: {
            init: function () {
                _self.artics.actions.loadArtics(0);
                _self.artics.actions.setupOrderBy();
                _self.artics.actions.setupNumArtics();
            },
            actions: {
                // aplica clase active a filtro creac./pub./tit.
                setupOrderBy: function() {
                    var order_by = _self.helper.getValueLS('_port_orden_lista');
                    if (order_by) {
                        $("#articles-order-by option").each(function() {
                            if($(this).val() == order_by) {
                                $(this).prop('selected', 'selected');
                            }
                        });
                    }
                },
                // aplica clase active a art_x_pag
                setupNumArtics: function() {
                    var num_artics = parseInt(_self.helper.getValueLS('_port_filas_x_pag'), 10);
                    if (num_artics) {
                        $(".search-options .show-items a").removeClass('active');
                        $(".search-options .show-items a").each(function() {
                            if ($(this).data('num') == num_artics) {
                                $(this).addClass('active');
                            }
                        });
                    }
                },
                loadArtics: function (first_value, extraOptions) {
                    if (!_self.vars.areas) {
                        $(_self.ui.selectors.panelPortAreas + ' #accordion').empty();
                        $(_self.ui.selectors.panelPortAreas + ' .loading').show();
                    }
                    if (typeof extraOptions === 'undefined') {
                        extraOptions = {};
                    }

                    $(_self.ui.selectors.panelRecentArtics + ' .list-group').empty();
                    $(_self.ui.selectors.panelRecentArtics + ' nav').hide();
                    $(_self.ui.selectors.panelRecentArtics + ' .info').hide();
                    $(_self.ui.selectors.panelRecentArtics + ' .loading').show();

                    var _port = $(_self.ui.selectors.cmbPort).val();
                    if (_port == null) {
                        _port = '';
                    }

                    var _edic = $(_self.ui.selectors.cmbEdic).val();
                    if (_edic == undefined) {
                        _edic = 'base';
                    }

                    // Si no viene el parametro se usa el valor en localStorage.
                    if (_port == '' || _edic == '') {
                        var _ls_port = _self.helper.getValueLS('_port');
                        var _ls_edic = _self.helper.getValueLS('_edic');

                        if (_ls_port) {
                            _port = _ls_port;
                            $(_self.ui.selectors.cmbPort).val(_port);
                        }

                        if (_ls_edic) {
                            _edic = _ls_edic;
                            $(_self.ui.selectors.cmbEdic).val(_edic);
                        }
                    }

                    var _orden_lista = _self.helper.getValueLS('_port_orden_lista');
                    if (typeof extraOptions['_orden_lista'] === 'undefined') {
                        extraOptions['_orden_lista'] = _orden_lista;
                    }

                    var _filas_x_pag = parseInt(_self.helper.getValueLS('_port_filas_x_pag'), 10);
                    if (typeof extraOptions['_filas_x_pag'] === 'undefined' && !isNaN(_filas_x_pag)) {
                        extraOptions['_filas_x_pag'] = _filas_x_pag;
                    }

                    if (document.getElementById('pip-select-arts')) {
                        extraOptions['_pip_prontus_id'] = $("#pip-select-arts option:selected").val();
                    }

                    var options = {
                        _prontus_id: _self.vars.prontus_id,
                        _first_value: first_value,
                        _port: _port,
                        _edic: _edic
                    };

                    $.extend(options, _self.vars.searchParams);
                    $.extend(options, extraOptions);

                    $.ajax({
                        url: "/{0}/prontus_port_art_list.cgi".format(Admin.dir_cgi_cpn),
                        type: "POST",
                        dataType: "json",
                        data: options,
                        success: function (response) {
                            if (response.areas.port != options._port) {
                                showModalAlert({
                                    title: ProntusL10n.get('global_error_occurred'),
                                    msg: ProntusL10n.get('portadmin_loading_port_error', response.areas.port, options._port),
                                    type: "red",
                                    icon: "glyphicon glyphicon-exclamation-sign",
                                    cbBtnOK: function () {
                                        // terminó de cargar el contenido, ocultamos el modal.
                                        PortAdmin.helper.hideLoadingModal();
                                    }
                                });
                                _self.vars.areas = undefined;
                                _self.vars.articAreaVB = {};
                                _self.vars.articAreas = {};
                                _self.vars.articAreaCorruptos = {};
                                _self.port.actions.disableButtons();
                                return;
                            }
                            if (response.md5sum) {
                                PortAdmin.vars.startingMD5SUM = response.md5sum;
                            }

                            if (response.port_is_pub == 0) {
                                _self.vars.portVoboStatus = true;
                                $('#toggle_port_vobo').bootstrapToggle('off');
                            } else {
                                _self.vars.portVoboStatus = true;
                                $('#toggle_port_vobo').bootstrapToggle('on');
                            }

                            if (!response.areas) {
                                PortAdmin.helper.hideLoadingModal();
                                return;
                            }

                            // de acuerdo al tipo de portada, ocultamos o mostramos el botón de SEO:
                            let nomPort = $(_self.ui.selectors.cmbPort).val();
                            if (nomPort == null) {
                                nomPort = '';
                            }
                            if (nomPort.startsWith('_m') || nomPort.startsWith('_p')) {
                                $('#port_seo').hide();
                            } else {
                                $('#port_seo').show();
                            }

                            if (!_self.vars.areas) {
                                _self.vars.areas = response.areas;
                                // Guarda propiedades de cada area de la plantilla.
                                $.each(_self.vars.areas.info, function (_i, v) {
                                    _self.vars.areasProp[v.area] = {"fids": v.fids, "limite": v.limite};
                                });

                                _self.areas.actions.buildAreaList(response.areas);

                                _self.vars.articAreaVB = {};
                                _self.vars.articAreaProntus = {};

                                $.each(_self.vars.areas.data, function (i, v) {
                                    if (typeof _self.vars.articAreas[i] == 'undefined') {
                                        _self.vars.articAreas[i] = [];
                                    }

                                    $.each(v, function (_key, val) {
                                        _self.vars.articAreas[i].push(parseInt(val.ts));
                                        _self.vars.articAreaProntus[val.ts] = val.prontus_id;

                                        if (val.corrupto == 1) {
                                            _self.vars.articAreaCorruptos[val.ts] = i;
                                        }

                                        if (val.vb) {
                                            _self.vars.articAreaVB[val.ts] = 1;
                                        } else {
                                            _self.vars.articAreaVB[val.ts] = 0;
                                        }
                                    });
                                });
                            }

                            _self.helper.initLastMod(response.modtime);

                            // Actualiza los parametros de busqueda.
                            _self.vars.searchParams = response.search_params;

                            _self.artics.actions.buildList(response);

                            // buscamos si hay un área activa, y pintamos los botones "Enviar a área" para dejarlo en claro.
                            if (_self.vars.activeArea !== false) {
                                _self.artics.actions.marcarEnviarArea();
                            }

                            _self.artics.actions.buildPagination(response.pagination, first_value);

                            _self.methods.initDraggable();
                            _self.methods.initSortable();

                            // terminó de cargar el contenido, ocultamos el modal.
                            PortAdmin.helper.hideLoadingModal();
                        },
                        error: function (XMLHttpRequest, textStatus, errorThrown) {
                            console.error(XMLHttpRequest, textStatus);
                            showModalAlert({
                                title: ProntusL10n.get('global_error_occurred'),
                                msg: ProntusL10n.get('portadmin_loading_art_list_error', errorThrown),
                                type: "red",
                                icon: "glyphicon glyphicon-exclamation-sign",
                                cbBtnOK: function () {
                                }
                            });
                        }
                    });
                },
                marcarEnviarArea: function() {
                    var $items_area = [];
                    $('#collapseArea'+_self.vars.activeArea+' ul li').each(function() {
                        $items_area.push($(this).attr('data-ts'));
                    });

                    $('#artic-list li.list-group-item .artic-list-btns button.pub-in-area').removeClass('panel-info-success');
                    $('#artic-list li.list-group-item').each(function() {
                        if ($items_area.indexOf($(this).attr('data-ts')) === -1) {
                            $(this).find('.artic-list-btns button.pub-in-area').addClass('panel-info-success');
                        }
                    });
                },
                updateRecentArticState: function (ts) {
                    var $item = $(_self.ui.selectors.panelRecentArtics + ' .list-group li[data-ts="{0}"]'.format(ts));

                    if ($item.length > 0) {
                        $item.removeClass("in_current_port").removeClass("list-group-item-info");
                        $item.find(".glyphicon.fake-handler").removeClass("fake-handler").addClass("handler");

                        $item.find('.pub-in-area').show();
                        $item.find('.send-to-area').show();
                        $item.find('.dpub-from-area').hide();
                        $item.removeClass("in_current_port").removeClass("list-group-item-info");
                        $item.find(".glyphicon.fake-handler").removeClass("fake-handler").addClass("handler");
                    }
                },
                buildList: function (data) {
                    var html = document.getElementById(_self.vars.idTplArticList).textContent;
                    var $output = $();

                    var total = data.list.length;
                    if (data.list.length > 0) {
                        for (var i = 0; i < total; i++) {
                            var clone = html;
                            var v = data.list[i];
                            var aux = v.titular;
                            aux = aux.replace(/%/g, '&#37;');
                            clone = clone.replace(/%%titulo%%/g, aux);
                            clone = clone.replace(/%%fechapub%%/g, v.fechapub);
                            clone = clone.replace(/%%fechaexp%%/g, v.fechaexp);
                            clone = clone.replace(/%%fid%%/g, v.fid);
                            clone = clone.replace(/%%fidplt%%/g, v.fidplt);
                            clone = clone.replace(/%%edit_url%%/g, v.edit_url.replace(/&/g,'&amp;'));
                            clone = clone.replace(/%%ts%%/g, v.ts);
                            clone = clone.replace(/%%id%%/g, v.id);
                            clone = clone.replace(/%%area%%/g, v.current_area);
                            clone = clone.replace(/%%prontus_id%%/g, v.prontus_id);

                            if (data.open_newtab == 'SI') {
                                clone = clone.replace(/%%open_newtab%%/g, 'open_newtab_artic');
                            } else {
                                clone = clone.replace(/%%open_newtab%%/g, '');
                            }

                            if (!v.nom_seccion) v.nom_seccion = ProntusL10n.get('global_unassigned');
                            clone = clone.replace(/%%nom_seccion%%/g, v.nom_seccion);

                            if (v.corrupto == 1) {
                                clone = clone.replace(/%%status%%/g, "list-group-item-danger");
                                clone = clone.replace(/%%corrupto_msg%%/g, v.corrupto_msg);
                            }

                            var inArea = _self.areas.actions.checkArticInArea(v.ts, v.current_area);

                            if (inArea == 1) {
                                clone = clone.replace(/%%status%%/g, "list-group-item-info");
                                clone = clone.replace(/%%in_current_port%%/g, "in_current_port");
                                clone = clone.replace(/%%handler%%/g, "fake-handler");
                            }

                            if (v.editable === 0) {
                                clone = clone.replace(/%%editable%%/g, "noedit list-group-item-warning");
                                clone = clone.replace(/%%handler%%/g, "fake-handler");
                            } else {
                                clone = clone.replace(/%%editable%%/g, "edit-art");
                                clone = clone.replace(/%%handler%%/g, "handler");
                            }

                            if (v.tiene_vista != 1) {
                                clone = clone.replace(/<!--LINK-->.*?<!--\/LINK-->/g, '');
                                clone = clone.replace(/<!--NOLINK-->/g, '');
                                clone = clone.replace(/<!--\/NOLINK-->/g, '');
                            }

                            if (v.st_pub == 1) {
                                clone = clone.replace(/%%alta%%/g, ProntusL10n.get('global_label_yes'));
                                clone = clone.replace(/%%class_estado%%/g, "ok");
                                clone = clone.replace(/%%class_estado_glyph%%/g, "check");
                                clone = clone.replace(/%%title_estado%%/g, ProntusL10n.get('global_published'));
                                clone = clone.replace(/%%art_url%%/g, v.art_url);
                                clone = clone.replace(/<!--NOLINK-->.*?<!--\/NOLINK-->/g, '');
                                clone = clone.replace(/<!--LINK-->/g, '');
                                clone = clone.replace(/<!--\/LINK-->/g, '');
                            } else {
                                clone = clone.replace(/%%alta%%/g, ProntusL10n.get('global_label_no'));
                                clone = clone.replace(/%%class_estado%%/g, "nok");
                                clone = clone.replace(/%%class_estado_glyph%%/g, "check");
                                clone = clone.replace(/%%title_estado%%/g, ProntusL10n.get('global_unpublished'));
                                clone = clone.replace(/<!--LINK-->.*?<!--\/LINK-->/g, '');
                                clone = clone.replace(/<!--NOLINK-->/g, '');
                                clone = clone.replace(/<!--\/NOLINK-->/g, '');
                            }

                            if (v.tiene_fotos == 1) {
                                clone = clone.replace(/%%tiene_fotos%%/g, "");
                            } else {
                                clone = clone.replace(/%%tiene_fotos%%/g, "hidden");
                            }

                            if (Object.keys(v.portadas).length >= 1) {
                                clone = clone.replace(/%%tiene_portadas%%/g, "");
                                var portadas = "";

                                $.each(v.portadas, function (edic, ports) {
                                    portadas += ProntusL10n.get('portadmin_edic_ports', edic,Object.keys(ports).join(','));
                                });

                                portadas = portadas.substring(0, portadas.length-2);

                                clone = clone.replace(/%%art_portadas%%/g, portadas);
                            } else {
                                clone = clone.replace(/%%tiene_portadas%%/g, "hidden");
                                clone = clone.replace(/%%art_portadas%%/g, "");
                            }

                            if (v.fechaexp === "") {
                                clone = clone.replace(/%%hidden_fechaexp%%/, "hidden");
                            } else {
                                clone = clone.replace(/%%hidden_fechaexp%%/, "");
                            }

                            clone = clone.replace(/%%status%%/g, "");
                            clone = clone.replace(/%%in_current_port%%/g, "");

                            var tpl = document.getElementById(_self.vars.idTplSendToAreaList).textContent;
                            var area_list_output = '';

                            for (var x = 0; x < _self.vars.areas.info.length;  x++) {
                                var tmp_tpl = tpl;

                                tmp_tpl = tmp_tpl.replace(/%%area_num%%/g, _self.vars.areas.info[x].area);

                                if (_self.vars.areas.info[x].nom === null) {
                                    tmp_tpl = tmp_tpl.replace(/%%area_nom%%/g, ProntusL10n.get('portadmin_areas', _self.vars.areas.info[x].area));
                                } else {
                                    tmp_tpl = tmp_tpl.replace(/%%area_nom%%/g, ProntusL10n.get('portadmin_areas', _self.vars.areas.info[x].area, _self.vars.areas.info[x].nom));
                                }

                                area_list_output += tmp_tpl;
                            }

                            clone = clone.replace(/%%send_to_area_list%%/g, area_list_output);
                            clone = clone.replace(/%%.*?%%/g, "");

                            var $clone = $(clone);

                            if (inArea) {
                                $clone.find('.pub-in-area').hide();
                                $clone.find('.send-to-area').hide();
                            } else {
                                $clone.find('.dpub-from-area').hide();
                            }

                            if (v.corrupto === 0) {
                                $clone.find(".art-corrupto").remove();
                            } else {
                                if (v.corrupto_num === 0) {
                                    $clone.find(".col-btns.btn-corrupto .btn-edit-artic").remove();
                                }

                                $clone.find(".col-btns.btn-corrupto").removeClass('hidden');
                                $clone.find(".titulo").remove();
                                $clone.find(".more-info").remove();
                                $clone.find(".toggle-more-info").remove();
                                $clone.find(".col-btns.btn-real").remove();
                                $clone.find(".handler").removeClass("handler").addClass("fake-handler");
                            }

                            $clone.find("input[name='data_{0}']".format(v.ts)).val(JSON.stringify(v));
                            $output = $output.add($clone);
                        }
                    } else {
                        html = document.getElementById(_self.vars.idTplArticListNoNesult).textContent;
                        $output = $output.add(html);
                    }

                    $(_self.ui.selectors.panelRecentArtics + ' .list-group').hide().html($output).fadeIn('fast');
                    $(_self.ui.selectors.panelRecentArtics + ' .loading').hide();

                    _self.methods.bindListsEvents();

                    $('.open_newtab_artic').off('click').on('click', function(e) {
                        e.preventDefault();

                        var href = $(this).attr("href");
                        window.open(href);
                    });

                },
                buildPagination: function (data, first_value) {
                    if (data.next < 0) {
                        $(_self.ui.selectors.articListNext).addClass("disabled");
                        $(_self.ui.selectors.articListLast).addClass("disabled");
                    } else {
                        $(_self.ui.selectors.articListNext).removeClass("disabled");
                        $(_self.ui.selectors.articListLast).removeClass("disabled");
                    }

                    if (data.prev < 0) {
                        $(_self.ui.selectors.articListFirst).addClass("disabled");
                        $(_self.ui.selectors.articListPrev).addClass("disabled");
                    } else {
                        $(_self.ui.selectors.articListFirst).removeClass("disabled");
                        $(_self.ui.selectors.articListPrev).removeClass("disabled");
                    }

                    first_value = first_value + 1;
                    var next = data.next;

                    if (next == -1) next = data.total;
                    if (next == 1 && next == first_value) {
                        next = data.total;
                    }

                    $(_self.ui.selectors.panelRecentArtics + ' .info').html(ProntusL10n.get('global_list_pagination', first_value, next, data.total));

                    _self.artics.actions.bindPagination(data);

                    $(_self.ui.selectors.panelRecentArtics + ' nav').show();
                    $(_self.ui.selectors.panelRecentArtics + ' .info').show();
                },
                bindPagination: function (data) {
                    $(_self.ui.selectors.articListLast + ' > a').off("click").on("click", function (e) {
                        e.preventDefault();

                        if (data.last > 0) {
                            _self.artics.actions.loadArtics(data.last);
                        }
                    });
                    $(_self.ui.selectors.articListNext + ' > a').off("click").on("click", function (e) {
                        e.preventDefault();

                        if (data.next > 0) {
                            _self.artics.actions.loadArtics(data.next);
                        }
                    });
                    $(_self.ui.selectors.articListPrev + ' > a').off("click").on("click", function (e) {
                        e.preventDefault();

                        if (data.prev >= 0) {
                            _self.artics.actions.loadArtics(data.prev);
                        }
                    });
                    $(_self.ui.selectors.articListFirst + ' > a').off("click").on("click", function (e) {
                        e.preventDefault();

                        if (data.first >= 0) {
                            _self.artics.actions.loadArtics(data.first);
                        }
                    });
                }
            }
        },
        // Manejo de areas
        areas:  {
            actions: {
                checkPubDirectLimit: function (area, href, newtab) {
                    var currentArticNums = 0;

                    if (typeof _self.vars.articAreas[area] != 'undefined') {
                        currentArticNums = _self.vars.articAreas[area].length + 1; // se el actual.
                    }

                    // Chequea limite de articulos por area si es que existe.
                    if (_self.vars.areasProp[area].limite && currentArticNums > _self.vars.areasProp[area].limite) {
                        showModalAlert({
                            title: ProntusL10n.get('portadmin_area_info_label'),
                            msg: ProntusL10n.get('portadmin_max_arts_warning', _self.vars.areasProp[area].limite),
                            type: "orange"
                        });
                    } else {
                        if (_self.vars.changes) {
                            showModalAlert({
                                title: ProntusL10n.get('portadmin_area_info_label') ,
                                msg: ProntusL10n.get('portadmin_area_changed_warning'),
                                type: "orange"
                            });
                        } else {
                            if (newtab === true) {
                                window.open(href);
                            } else {
                                window.location.href = href;
                            }
                        }
                    }
                },
                // actualiza el estado de los articulos de la portada que se guardó
                loadArticsPortAreas: function (extraOptions) {
                    var options = {
                        _prontus_id: _self.vars.prontus_id,
                        _port: $(_self.ui.selectors.cmbPort).val(),
                        _edic: $(_self.ui.selectors.cmbEdic).val(),
                        _solo_artic_areas: 1
                    };

                    if (options._edic == undefined) {
                        options._edic = 'base';
                    }

                    if (typeof extraOptions !== 'undefined' && typeof extraOptions['version'] !== 'undefined') {
                        options['_version'] = extraOptions['version'];
                    }

                    $(_self.ui.selectors.panelPortAreas + ' #accordion').empty();
                    $(_self.ui.selectors.panelPortAreas + ' .loading').show();

                    $.ajax({
                        url: "/" + Admin.dir_cgi_cpn + "/prontus_port_art_list.cgi",
                        type: "POST",
                        dataType: "json",
                        data: options,
                        success: function (response) {
                            _self.vars.areas = response;
                            _self.areas.actions.buildAreaList(response);
                            _self.vars.articAreaVB = {};
                            _self.vars.articAreas = {};
                            _self.vars.articAreaProntus = {};
                            _self.vars.articAreaCorruptos = {};

                            if (response.port_is_pub == 0) {
                                _self.vars.portVoboStatus = true;
                                $('#toggle_port_vobo').bootstrapToggle('off');
                            } else {
                                _self.vars.portVoboStatus = true;
                                $('#toggle_port_vobo').bootstrapToggle('on');
                            }

                            $.each(_self.vars.areas.data, function (i, v) {
                                if (typeof _self.vars.articAreas[i] == 'undefined') {
                                    _self.vars.articAreas[i] = [];
                                }

                                $.each(v, function (_key, val) {
                                    _self.vars.articAreas[i].push(parseInt(val.ts));
                                    _self.vars.articAreaProntus[val.ts] = val.prontus_id;

                                    if (val.corrupto == 1) {
                                        _self.vars.articAreaCorruptos[val.ts] = i;
                                    }

                                    if (val.vb) {
                                        _self.vars.articAreaVB[val.ts] = 1;
                                    } else {
                                        _self.vars.articAreaVB[val.ts] = 0;
                                    }
                                });
                            });

                            _self.methods.initDraggable();
                            _self.methods.initSortable();
                            _self.methods.bindListsEvents();
                        },
                        error: function (XMLHttpRequest, textStatus, errorThrown) {
                            console.error(XMLHttpRequest, textStatus);
                            showModalAlert({
                                title: ProntusL10n.get('global_error_occurred'),
                                msg: ProntusL10n.get('portadmin_loading_art_list_error', errorThrown),
                                type: "red",
                                icon: "glyphicon glyphicon-exclamation-sign",
                                cbBtnOK: function () {
                                }
                            });
                        }
                    });
                },
                bindAreaListEvents: function () {
                    $(_self.ui.selectors.panelPortAreas + ' .pub-directa').off("click").on("click", function (e) {
                        e.preventDefault();

                        var $parent = $(this).closest(".panel-heading");
                        var area = $parent.attr("data-area");
                        var href = $(this).attr("href");

                        _self.areas.actions.checkPubDirectLimit(area, href, false);
                    });

                    $(_self.ui.selectors.panelPortAreas + ' .btn-area-remove').off("click").on("click", function (e) {
                        e.preventDefault();

                        var $listItem = $(this).closest(".list-group-item");
                        var $parent = $listItem.closest(".list-group");

                        $listItem.fadeOut('fast', function () {
                            $(this).remove();
                            // Se elimina el articulo del arreglo local.
                            _self.areas.actions.updateArticsArea($parent.attr("data-area"));
                        });
                       var ts = $listItem.attr("data-ts");

                       _self.artics.actions.updateRecentArticState(ts);
                    });

                    $(_self.ui.selectors.panelPortAreas + ' .list-group-item.edit-art .toggle-vobo').off("click").on("click", function (e) {
                        e.preventDefault();

                        var $listItem = $(this).closest(".list-group-item");
                        var $vb = $(this).find("span");
                        var ts = $listItem.attr("data-ts");

                        //  Cambiar estado del VB en hash.
                        if ($vb.hasClass("glyphicon-eye-open")) {
                            $vb.removeClass("glyphicon-eye-open").addClass("glyphicon-eye-close");
                            _self.vars.articAreaVB[ts] = 0;
                        } else {
                            $vb.removeClass("glyphicon-eye-close").addClass("glyphicon-eye-open");
                            _self.vars.articAreaVB[ts] = 1;
                        }

                        _self.port.actions.setPortHasChanges(); // TODO
                    });

                    $("div[id^='area_heading']").off('dblclick').on('dblclick', function (e) {
                        var $parent = $(this).parents('.panel-area');
                        var $area_id = parseInt($(this).attr("data-area"));
                        // tomamos los items contenidos en esta area para cambiar su estado en la lista de publicados / no publicados
                        var $items_area = [];
                        $('#collapseArea'+$area_id+' ul li').each(function() {
                            $items_area.push($(this).attr('data-ts'));
                        });
                        if ($(e.target).hasClass('panel-heading')) {
                            if ($parent.hasClass('panel-info-success')) {
                                $parent.removeClass('panel-info-success').addClass('panel-info-area');
                                _self.vars.activeArea = false;
                                $('#artic-list li.list-group-item').each(function() {
                                    if ($items_area.indexOf($(this).attr('data-ts')) === -1) {
                                        $(this).find('.artic-list-btns button.pub-in-area').removeClass('panel-info-success');
                                    }
                                });
                            } else {
                                $(_self.ui.selectors.panelPortAreas + ' .panel-area').removeClass('panel-info-success').addClass('panel-info-area');
                                $parent.removeClass('panel-info-area').addClass('panel-info-success');
                                _self.vars.activeArea = $area_id;
                                $('#artic-list li.list-group-item .artic-list-btns button.pub-in-area').removeClass('panel-info-success');
                                $('#artic-list li.list-group-item').each(function() {
                                    if ($items_area.indexOf($(this).attr('data-ts')) === -1) {
                                        $(this).find('.artic-list-btns button.pub-in-area').addClass('panel-info-success');
                                    }
                                });
                            }
                        }
                    });

                    $('div[id^="collapseArea"]').off('shown.bs.collapse').on('shown.bs.collapse', function () {
                        var area = $(this).attr("data-area");
                        var collapseList = _self.helper.getValueLS('collapseList');
                        var arr;
                        if (collapseList) {
                            arr = JSON.parse(collapseList);
                            arr[area] = 1;
                        } else {
                            arr = {};
                            arr[area] = 1;
                        }

                        _self.helper.setValueLS('collapseList', JSON.stringify(arr));
                    });

                    $('div[id^="collapseArea"]').off('hidden.bs.collapse').on('hidden.bs.collapse', function () {
                        var area = $(this).attr("data-area");
                        var collapseList = _self.helper.getValueLS('collapseList');
                        var arr;
                        if (collapseList) {
                            arr = JSON.parse(collapseList);
                            arr[area] = 0;
                        } else {
                            arr = {};
                            arr[area] = 0;
                        }

                        _self.helper.setValueLS('collapseList', JSON.stringify(arr));
                    });

                },
                addArticToArea: function (ts, prontus_id, area) {
                    var $ul = $(_self.ui.selectors.panelPortAreas + ' .list-group[data-area="{0}"]'.format(area));
                    _self.vars.articAreas[area] = []; // Se comienza de nuevo, para obtener el nuevo orden y artics.

                    $ul.find("li.list-group-item").each(function () {
                        var ts_item = $(this).attr("data-ts");
                        _self.vars.articAreas[area].push(parseInt(ts_item));
                        _self.vars.articAreaProntus[ts] = prontus_id;

                        if (ts == ts_item) {
                            var $vb = $(this).children().children('.col-btns.port-list-btns').children('.toggle-vobo').children(); // .col-btns .port-list-btns
                            $vb.removeClass("glyphicon-eye-close").addClass("glyphicon-eye-open");
                            _self.vars.articAreaVB[ts] = 1; // Por defecto lo deja con vobo activo.
                        }
                    });


                    $ul.removeClass('area-empty');
                },
                updateArticsArea: function (area) {
                    var $ul = $(_self.ui.selectors.panelPortAreas + ' .list-group[data-area="{0}"]'.format(area));
                    _self.vars.articAreas[area] = []; // Se comienza de nuevo, para obtener el nuevo orden y artics.

                    $ul.find("li.list-group-item").each(function () {
                        var ts = $(this).attr("data-ts");
                        _self.vars.articAreas[area].push(parseInt(ts));
                    });

                    // El area quedo vacia.
                    if ($ul.find("li.list-group-item").length === 0) {
                        $ul.addClass('area-empty');
                    }
                },
                parseAreaItem: function (data) {
                    var html = document.getElementById(_self.vars.idTplAreaItem).textContent;

                    if (!data.nom_seccion) data.nom_seccion = ProntusL10n.get('global_unassigned');

                    html = html.replace(/%%ts%%/g, data.ts);
                    html = html.replace(/%%id%%/g, data.id);
                    html = html.replace(/%%titular%%/g, data.titular);
                    html = html.replace(/%%edit_url%%/g, data.edit_url.replace(/&/g,'&amp;'));
                    html = html.replace(/%%fechapub%%/g, data.fechapub);
                    html = html.replace(/%%fechaexp%%/g, data.fechaexp);
                    html = html.replace(/%%fid%%/g, data.fid);
                    html = html.replace(/%%fidplt%%/g, data.fidplt);
                    html = html.replace(/%%nom_seccion%%/g, data.nom_seccion);
                    html = html.replace(/%%area%%/g, data.area);
                    html = html.replace(/%%prontus_id%%/g, data.prontus_id);

                    if (data.open_newtab == 'SI') {
                        html = html.replace(/%%open_newtab%%/g, 'open_newtab_artic');
                    } else {
                        html = html.replace(/%%open_newtab%%/g, '');
                    }

                    if (data.corrupto == 1) {
                        html = html.replace(/%%corrupto%%/g, "list-group-item-danger art-corrupto");
                        html = html.replace(/%%es_corrupto%%/g, "art-corrupto hide");
                        html = html.replace(/%%corrupto_msg%%/g, data.corrupto_msg);
                    } else {
                        html = html.replace(/%%toggle_corrupto%%/g, "hide");
                    }

                    if (data.tiene_vista != 1) {
                        html = html.replace(/<!--LINK-->.*?<!--\/LINK-->/g, '');
                        html = html.replace(/<!--NOLINK-->/g, '');
                        html = html.replace(/<!--\/NOLINK-->/g, '');
                    }

                    if (data.st_pub == 1) {
                        html = html.replace(/%%alta%%/g, "Sí");
                        html = html.replace(/%%class_estado%%/g, "ok");
                        html = html.replace(/%%class_estado_glyph%%/g, "check");
                        html = html.replace(/%%title_estado%%/g, ProntusL10n.get('global_published'));
                        html = html.replace(/%%art_url%%/g, data.art_url);
                        html = html.replace(/<!--NOLINK-->.*?<!--\/NOLINK-->/g, '');
                        html = html.replace(/<!--LINK-->/g, '');
                        html = html.replace(/<!--\/LINK-->/g, '');

                        if (data.newInArea == 1) {
                            html = html.replace(/%%vobo%%/g, "open");
                        }

                    } else {
                        html = html.replace(/%%alta%%/g, "No");
                        html = html.replace(/%%class_estado%%/g, "nok");
                        html = html.replace(/%%class_estado_glyph%%/g, "check");
                        html = html.replace(/%%title_estado%%/g, ProntusL10n.get('global_unpublished'));
                        html = html.replace(/<!--LINK-->.*?<!--\/LINK-->/g, '');
                        html = html.replace(/<!--NOLINK-->/g, '');
                        html = html.replace(/<!--\/NOLINK-->/g, '');

                        if (data.newInArea == 1) {
                            html = html.replace(/%%vobo%%/g, "close");
                        }
                    }

                    if (data.tiene_fotos == 1) {
                        html = html.replace(/%%tiene_fotos%%/g, "");
                    } else {
                        html = html.replace(/%%tiene_fotos%%/g, "hidden");
                    }

                    if (Object.keys(data.portadas).length >= 1) {
                        html = html.replace(/%%tiene_portadas%%/g, "");
                        var portadas = "";

                        $.each(data.portadas, function (edic, ports) {
                            portadas += ProntusL10n.get('portadmin_edic_ports',edic , Object.keys(ports).join(','));
                        });

                        portadas = portadas.substring(0, portadas.length-2);

                        html = html.replace(/%%art_portadas%%/g, portadas);
                    } else {
                        html = html.replace(/%%tiene_portadas%%/g, "hidden");
                        html = html.replace(/%%art_portadas%%/g, "");
                    }

                    if (data.editable === 0) {
                        html = html.replace(/%%editable%%/g, "noedit list-group-item-warning");
                        html = html.replace(/%%handler%%/g, "fake-handler");
                    } else {
                        html = html.replace(/%%editable%%/g, "edit-art");
                        html = html.replace(/%%handler%%/g, "handler");
                    }

                    if (data.fechaexp === "") {
                        html = html.replace(/%%hidden_fechaexp%%/, "hidden");
                    } else {
                        html = html.replace(/%%hidden_fechaexp%%/, "");
                    }

                    if (data.vb == 1) {
                        html = html.replace(/%%vobo%%/g, "open");
                    } else {
                        html = html.replace(/%%vobo%%/g, "close");
                    }

                    html = html.replace(/%%.*?%%/g, "");

                    return html;
                },
                buildAreaList: function (data) {
                    var htmlArea = document.getElementById(_self.vars.idTplArea).textContent;
                    var htmlItemAreaEmpty = document.getElementById(_self.vars.idTplAreaItemEmpty).textContent;
                    var htmlAddToAreaMenu = document.getElementById(_self.vars.idTplAddToAreaMenu).textContent;
                    var htmlAddToAreaLink = document.getElementById(_self.vars.idTplAddToAreaLink).textContent;
                    var htmlAddToAreaLinkItem = document.getElementById(_self.vars.idTplAddToAreaMenuItem).textContent;
                    var output = "";

                    var areasPort = document.getElementById("accordion");
                    if (Object.keys(data.info).length == 0) {
                        $('.admin-port .panel-port-areas .loading').hide();
                        areasPort.insertAdjacentHTML('beforeend', htmlItemAreaEmpty);
                        return false;
                    }

                    $.each(data.info, function (i, v) {
                        var clone = htmlArea;
                        output = "";

                        var areaNom = v.nom;

                        if (areaNom) {
                            areaNom = ": " + areaNom;
                        } else {
                            areaNom = "";
                        }

                        var _edic = $(_self.ui.selectors.cmbEdic).val();
                        if (_edic == null) {
                            _edic = 'base';
                        }

                        var fid_list = '';
                        var menu = '';
                        for (const fid in v.fids) {
                            if (v.fids[fid] != null) {
                                var aux = htmlAddToAreaLinkItem;
                                aux = aux.replace(/%%fid_type%%/g, fid);
                                aux = aux.replace(/%%fid_label%%/g, v.fids[fid]);
                                menu = menu + aux;
                                fid_list = fid_list + ', ' + v.fids[fid];
                            }
                        }
                        fid_list = fid_list.substring(2);
                        if (fid_list != '') { // límite de fid
                            clone = clone.replace(/%%add_new_art_menu%%/g, htmlAddToAreaMenu);
                            clone = clone.replace(/%%add_new_art_menu_item%%/g, menu);
                        } else {
                            clone = clone.replace(/%%add_new_art_menu%%/g, htmlAddToAreaLink);
                        }

                        if (v.limite > 0 && fid_list != '') { // límite de fid y numero
                            clone = clone.replace(/%%hide_limit_artics%%/g, '');
                            clone = clone.replace(/%%area_limit_artics%%/g, ProntusL10n.get('portadmin_type_max', fid_list, v.limite));
                        } else if (v.limite <= 0 && fid_list != '') { // límite de fid
                            clone = clone.replace(/%%hide_limit_artics%%/g, '');
                            clone = clone.replace(/%%area_limit_artics%%/g, ProntusL10n.get('portadmin_type', fid_list));
                        } else if (v.limite > 0 && fid_list == '') { // límite de numero
                            clone = clone.replace(/%%hide_limit_artics%%/g, '');
                            clone = clone.replace(/%%area_limit_artics%%/g,ProntusL10n.get('portadmin_max', v.limite));
                        } else { // sin límite
                            clone = clone.replace(/%%hide_limit_artics%%/g, 'hidden');
                            clone = clone.replace(/%%area_limit_artics%%/g, '');
                        }

                        clone = clone.replace(/%%nom_area%%/g, areaNom);
                        clone = clone.replace(/%%num_area%%/g, v.area);
                        clone = clone.replace(/%%_prontus_id%%/g, Admin.prontus_id);
                        clone = clone.replace(/%%_edicion%%/g, _edic);
                        clone = clone.replace(/%%_portada%%/g, $(_self.ui.selectors.cmbPort).val());

                        if (data.open_newtab == 'SI') {
                            clone = clone.replace(/%%open_newtab%%/g, 'open_newtab_directub');
                        } else {
                            clone = clone.replace(/%%open_newtab%%/g, '');
                        }

                        if (i === 0) {
                            clone = clone.replace(/%%collapse_in%%/, "in");
                            clone = clone.replace(/%%collapsed%%/, "");
                        } else {
                            clone = clone.replace(/%%collapsed%%/, "collapsed");
                        }
                        $.each(data.data[v.area], function (_key, val) {
                            val.area = v.area;
                            val.open_newtab = data.open_newtab;
                            output += _self.areas.actions.parseAreaItem(val);
                        });

                        if (output === '') {
                            clone = clone.replace(/%%area_empty%%/, 'area-empty');
                        }

                        clone = clone.replace(/%%list_area_items%%/g, output);
                        clone = clone.replace(/%%.*?%%/g, "");

                        areasPort.insertAdjacentHTML('beforeend',clone);
                    });

                    $(".admin-port .panel-port-areas #accordion").show();

                    $('.open_newtab_directub').off('click').on('click', function(e) {
                        e.preventDefault();

                        var $parent = $(this).closest(".panel-heading");
                        var area = $parent.attr("data-area");
                        var href = $(this).attr("href");

                        _self.areas.actions.checkPubDirectLimit(area, href, true);
                    });

                    var area_colapsar = _self.helper.getValueLS('area_colapsar');

                    if (area_colapsar == null || area_colapsar == 'si') {
                        $('#area_colapsar').show();
                        $('#area_expandir').hide();
                        $('div[id^="collapseArea"]').collapse('show');
                    } else if (area_colapsar == 'no') {
                        $('#area_expandir').show();
                        $('#area_colapsar').hide();
                        $('div[id^="collapseArea"]').collapse('hide');
                    }

                    // Expading o colapsar segun corresponda (opcion del usuario)
                    var collapseList = _self.helper.getValueLS('collapseList');

                    if (collapseList) {
                        var arr = JSON.parse(collapseList);
                        $.each(arr, function (area, estado) {
                            if (estado == 1) {
                                $('div[id="collapseArea' + area + '"]').collapse('show');
                            } else {
                                $('div[id="collapseArea' + area + '"]').collapse('hide');
                            }
                        });

                    }

                    $('.admin-port .panel-port-areas .loading').hide();
                    _self.areas.actions.bindAreaListEvents();
                },
                receiveInAreaEvent: function ($item, $dest, data, area) {
                    $item.attr("data-area", area);
                    $item.find('.areanum').text(area);

                    data.area = area;
                    data.newInArea = 1;

                    var currentArticNums = 0;

                    if (typeof _self.vars.articAreas[area] != 'undefined') {
                        currentArticNums = _self.vars.articAreas[area].length + 1; // se el actual.
                    }

                    // Chequea limite de articulos por area si es que existe.
                    if (_self.vars.areasProp[area].limite && currentArticNums > _self.vars.areasProp[area].limite) {
                        showModalAlert({
                            title: ProntusL10n.get('portadmin_area_info_label'),
                            msg: ProntusL10n.get('portadmin_max_arts_warning', _self.vars.areasProp[area].limite),
                            type: "orange"
                        });

                        $dest.remove();
                        _self.methods.initSortable();

                        return false;
                    }

                    // Chequea limitacion de fid por area.
                    if (Object.keys(_self.vars.areasProp[area].fids).length) {

                        if (!_self.vars.areasProp[area].fids[data.fidplt]) {
                            var fids = Object.keys(_self.vars.areasProp[area].fids).map(function(x) { return x; }).join(', ');
                            showModalAlert({
                                title: ProntusL10n.get('portadmin_area_info_label'),
                                msg: ProntusL10n.get('portadmin_area_wrong_fid', data.fidplt, fids),
                                type: "orange"
                            });

                            $dest.remove();
                            _self.methods.initSortable();

                            return false;
                        }
                    }

                    var output = _self.areas.actions.parseAreaItem(data);

                    // Se debe quitar el li.
                    var $elem = $(output);
                    output = $elem.html();

                    $dest.html(output);

                    // Quitar style al li.
                    $dest.removeAttr("style");
                    $dest.removeAttr("data-area");
                    $dest.removeClass('ui-draggable');

                    _self.areas.actions.addArticToArea(data.ts, data.prontus_id, area);
                    _self.vars.startDrag = false;

                    _self.areas.actions.bindAreaListEvents();
                    _self.methods.bindListsEvents();

                    // Si estoy arrastrando hacia Artículos Recientes, no debo ocultar los botones de publicación.
                    if (!$item.parents('#artic-list')) {
                    $item.find('.pub-in-area').hide();
                        $item.find('.send-to-area').hide();
                    $item.find('.dpub-from-area').show();
                    } else {
                        $item.find('.pub-in-area').show();
                        $item.find('.send-to-area').hide();
                        $item.find('.dpub-from-area').hide();
                    }

                    if (!$dest.parents('.panel-collapse').hasClass('in')) {
                        $dest.parents('.panel-collapse').addClass('in');
                    }

                    _self.methods.initSortable();

                    return true;
                },
                moveToAreaEvent: function ($elem) {
                    $elem.addClass("list-group-item-info in_current_port");
                    $elem.find(".handler").removeClass("handler").addClass("fake-handler");
                    _self.methods.initDraggable();
                    $elem.find('.group-btns').removeClass('open');
                    $elem.find('.send-to-area-dropdown').attr('aria-expanded', "false");
                },
                checkArticInArea: function (ts, area) {
                    var si = 0;

                    if (!area) return si;

                    $.each(_self.vars.articAreas[area], function (_key, v) {
                        if (v == ts) {
                            si = 1;
                            return false;
                        }
                    });

                    return si;
                },
                findArticArea: function (ts) {
                    var area = null;

                    $.each(_self.vars.articAreas, function (key, val) {
                        $.each(val, function (_k, v) {
                            if (v == ts) {
                                area = key;
                                return false;
                            }
                        });
                    });

                    return area;
                },
                getArticDataFromArea: function (ts, area)  {
                    var data = null;

                    if (typeof _self.vars.areas.data[area] != 'undefined') {
                        $.each(_self.vars.areas.data[area], function (i, arr) {
                            if (arr.ts == ts) {
                                data = _self.vars.areas.data[area][i];
                                return false;
                            }
                        });
                    }

                    return data;
                },
                changeArticFromArea: function (ts, current_area, new_area) {
                    if (typeof _self.vars.areas.data[current_area] != 'undefined') {
                        var data;

                        for (let x = 0; x < _self.vars.areas.data[current_area].length; x++) {
                            if (_self.vars.areas.data[current_area][x].ts == ts) {
                                data = _self.vars.areas.data[current_area][x];
                                _self.vars.areas.data[current_area].splice(x, 1);
                                break;
                            }
                        }

                        var existe = 0;

                        if (typeof _self.vars.areas.data[new_area] != 'undefined') {
                            for (let x = 0; x < _self.vars.areas.data[new_area].length; x++) {
                                if (_self.vars.areas.data[new_area][x].ts == ts) {
                                    existe = 1;
                                    break;
                                }
                            }
                        }

                        if (!existe) {
                            if (typeof _self.vars.areas.data[new_area] == 'undefined') {
                                _self.vars.areas.data[new_area] = [];
                            }
                            _self.vars.areas.data[new_area].push(data);
                        }
                    }
                }
            }
        },
        // Manejo de las portadas
        port: {
            edics: [],
            ports: {},
            all_ports: [],
            actions: {
                getCurrentEdic: function () {
                    var _ls_edic = _self.helper.getValueLS('_edic');
                    var edic = $(_self.ui.selectors.cmbEdic).val();

                    // hay selector de ediciones, se le da prioridad al valor guardado anteriormente
                    if (($(_self.ui.selectors.cmbEdic)).length > 0 && _ls_edic !== null) {
                        return _ls_edic;
                    } else if (edic !== undefined) {
                        return edic;
                    } else {
                        return 'base';
                    }
                },
                getCurrentPort: function () {
                    var _ls_port = _self.helper.getValueLS('_port');

                    if (_ls_port !== null) {
                        return _ls_port;
                    }
                    return '';
                },
                initMultiEdic: function () {
                    // Recolectar todas las portadas del prontus.
                    if ($(_self.ui.selectors.cmbEdic).is(":visible")) {
                        _self.port.actions.loadEdicPorts();
                    }
                },
                checkPortHasChanges: function (callback) {
                    if (_self.vars.changes) {
                        showModalConfirm({
                            msg: ProntusL10n.get('portadmin_port_changed'),
                            type: "blue",
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            cbBtnOK: function () {
                                $("#port_changed").hide();
                                _self.vars.changes = false; // reset.
                                callback();
                            },
                            cbBtnCancel: function () {
                                PortAdmin.helper.hideLoadingModal();
                                $(_self.ui.selectors.panelPortAreas + ' #accordion').show();
                                $(_self.ui.selectors.panelPortAreas + ' .loading').hide();
                                _self.port.actions.enableButtons();
                            }
                        });
                    } else {
                        callback();
                    }
                },
                setPortHasChanges: function () {
                    showWarningAlert("#alert-port-area", ProntusL10n.get('portadmin_save_changes'), "port_changed");
                    _self.vars.changes = true;
                },
                getPortsAndEdics: function (callback) {
                    $.ajax({
                        url: "/{0}/prontus_cfg_get.cgi".format(Admin.dir_cgi_cpn),
                        data: { _prontus_id: _self.vars.prontus_id },
                        dataType: 'json',
                        type: 'POST',
                        success: function (response) {
                            if (response.status == 1) {
                                _self.port.edics = response.edics;
                                _self.port.all_ports = response.all_ports.sort(function(a, b) {return a.name.localeCompare(b.name); });
                                _self.vars.serverName = response.serverName;
                                _self.vars.mv = response.mv;

                                var _ls_port = _self.port.actions.getCurrentPort();
                                var _ls_edic = _self.port.actions.getCurrentEdic();

                                if (_self.port.edics.length > 1) {
                                    for (var x = 0; x < _self.port.edics.length; x++) {
                                        if (_ls_edic == _self.port.edics[x]) {
                                            $(_self.ui.selectors.cmbEdic).append('<option value="{0}" selected="selected">{1}</option>'.format(_self.port.edics[x], _self.port.edics[x]));
                                        } else {
                                            $(_self.ui.selectors.cmbEdic).append('<option value="{0}">{1}</option>'.format(_self.port.edics[x], _self.port.edics[x]));
                                        }
                                    }
                                } else {
                                    _ls_edic = 'base';
                                }

                                var port_modulos = $(_self.ui.selectors.cmbPort + ' optgroup#_modulos');
                                var port_portadas = $(_self.ui.selectors.cmbPort + ' optgroup#_portadas');
                                for (var i = 0; i < _self.port.all_ports.length; i++) {
                                    if ( (_ls_edic == 'base' && !_self.port.all_ports[i].base) || (_ls_edic != 'base' && _self.port.all_ports[i].base)) {
                                        continue;
                                    }
                                    if (_self.port.all_ports[i].plt.match(/^_(?:m|p)_/i)) {
                                        if (_self.port.all_ports[i].plt == _ls_port) {
                                            $(port_modulos).append('<option value="{0}" selected="selected">{1}</option>'.format(_self.port.all_ports[i].plt, _self.port.all_ports[i].name));
                                        } else {
                                            $(port_modulos).append('<option value="{0}">{1}</option>'.format(_self.port.all_ports[i].plt, _self.port.all_ports[i].name));
                                        }
                                    } else {
                                        if (_self.port.all_ports[i].plt == _ls_port) {
                                            $(port_portadas).append('<option value="{0}" selected="selected">{1}</option>'.format(_self.port.all_ports[i].plt, _self.port.all_ports[i].name));
                                        } else {
                                            $(port_portadas).append('<option value="{0}">{1}</option>'.format(_self.port.all_ports[i].plt, _self.port.all_ports[i].name));
                                        }
                                    }
                                }

                                callback(response.data);
                            } else {
                                showModalAlert({
                                    title: ProntusL10n.get('global_server_msg'),
                                    msg: response.msg,
                                    type: "red",
                                    icon: "glyphicon glyphicon-exclamation-sign",
                                    cbBtnOK: function () {
                                    }
                                });
                            }
                        },
                        error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                            showModalAlert({
                                title: ProntusL10n.get('admin_error'),
                                msg: ProntusL10n.get('portadmin_ports_edics_unavailable', errorThrown),
                                type: "red",
                                icon: "glyphicon glyphicon-exclamation-sign",
                                cbBtnOK: function () {
                                }
                            });
                        }
                    });
                },
                loadEdicPorts: function () {
                    var edic = _self.port.actions.getCurrentEdic();
                    var port = _self.port.actions.getCurrentPort();

                    $(_self.ui.selectors.cmbPort + ' option').remove();
                    var port_modulos = $(_self.ui.selectors.cmbPort + ' optgroup#_modulos');
                    var port_portadas = $(_self.ui.selectors.cmbPort + ' optgroup#_portadas');
                    for (var x = 0; x < _self.port.all_ports.length; x++) {
                        if ((edic == 'base' && !_self.port.all_ports[x].base) || (edic != 'base' && _self.port.all_ports[x].base)) {
                            continue;
                        }
                        if (_self.port.all_ports[x].plt.match(/^_(?:m|p)_/i)) {
                            if (_self.port.all_ports[x].plt == port) {
                                $(port_modulos).append('<option value="{0}" selected="selected">{1}</option>'.format(_self.port.all_ports[x].plt, _self.port.all_ports[x].name));
                            } else {
                                $(port_modulos).append('<option value="{0}">{1}</option>'.format(_self.port.all_ports[x].plt, _self.port.all_ports[x].name));
                            }
                        } else {
                            if (_self.port.all_ports[x].plt == port) {
                                $(port_portadas).append('<option value="{0}" selected="selected">{1}</option>'.format(_self.port.all_ports[x].plt, _self.port.all_ports[x].name));
                            } else {
                                $(port_portadas).append('<option value="{0}">{1}</option>'.format(_self.port.all_ports[x].plt, _self.port.all_ports[x].name));
                            }
                        }
                    }
                    $(_self.ui.selectors.cmbPort).select2({dropdownAutoWidth:true});
                },
                bindPortButtons: function () {
                    $("#port_refresh").off("click").on("click", function (e) {
                        e.preventDefault();
                        PortAdmin.helper.showLoadingModal();

                        _self.port.actions.checkPortHasChanges(function () {
                            _self.vars.areas = false;
                            _self.vars.articAreas = {};
                            $("input[name='input-search']").val("");
                            //  Mensaje si hay cambios.
                            _self.artics.init();
                        });
                    });

                    $("#port_seo").off("click").on("click", function (e) {
                        e.preventDefault();

                        // Cargar datos de la portada.
                        var data = {
                            _prontus_id: _self.vars.prontus_id,
                            _port: $(_self.ui.selectors.cmbPort).val()
                        };

                        $.ajax({
                            url: "/"+Admin.dir_cgi_cpn+"/seo/prontus_port_seo_get.cgi",
                            data: data,
                            success: function (response) {
                                if (response.status == 1) {
                                    let port_parts = data._port.split('.');
                                    const nombre_portada = _self.port.tools.capitalizeFirstLetter(port_parts[0])
                                    $('#port_seo_name').text(nombre_portada);
                                    $("#port_seo_title").val(response.title);
                                    $("#port_seo_description").val(response.description);
                                    $("#port_seo_robots").val(response.robots);
                                    $("#port_seo_fotofija").val(response.fotofija);
                                    $("#port_seo_multimedia_video").val(response.multimedia_video);
                                    $("#port_seo_multimedia_audio").val(response.multimedia_audio);
                                    $("#port_seo_url").val(response.url);

                                    _self.vars.mv.forEach(function(vista) {
                                        $('#port_seo_title_' + vista).val(response['title_' + vista]);
                                        $('#port_seo_description_' + vista).val(response['description_' + vista]);
                                    });

                                    _self.port.tools.fillCounters();
                                    _self.port.tools.bindCounters();
                                    _self.port.tools.bindURLCheck();
                                    $("#modal_port_seo").modal();
                                } else {
                                    showModalAlert({
                                        title: ProntusL10n.get('global_server_msg'),
                                        type:'red',
                                        msg: ProntusL10n.get('global_error_int', response.msg)
                                    });
                                }
                            }
                        });

                    });

                    $(_self.ui.selectors.cmbPort).off("change").on("change", function () {
                        PortAdmin.helper.showLoadingModal();
                        _self.vars.areas = false;
                        _self.vars.articAreas = {};
                        _self.helper.setValueLS('_port', $(this).val());

                        // Cargar articulos.
                        _self.artics.actions.loadArtics(0);
                    });

                    if ($(_self.ui.selectors.cmbEdic).is(":visible")) {
                        $(_self.ui.selectors.cmbEdic).off("change").on("change", function () {
                            _self.vars.areas = false;
                            _self.vars.articAreas = {};
                            _self.helper.setValueLS('_edic', $(this).val());
                            _self.port.actions.loadEdicPorts();
                            _self.artics.actions.loadArtics(0);
                        });
                    }

                    $("#port_save").off("click").on("click", function () {
                        PortAdmin.helper.showLoadingModal();
                        if (_self.port.actions.checkAreaLimits()) {
                            _self.port.actions.savePortArtics();
                        }
                    });

                    $("#port_preview").off("click").on("click", function () {
                        _self.preview.actions.generar();
                    });

                    $("#port_view").off("click").on("click", function () {
                        var edic = $(_self.ui.selectors.cmbEdic).val();
                        if (edic == null) {
                            edic = 'base';
                        }

                        if ($('#toggle_port_vobo').length > 0 && $('#toggle_port_vobo').prop('checked') == false) {
                            showModalAlert({
                                title: ProntusL10n.get('global_server_msg'),
                                msg: ProntusL10n.get('portadmin_port_unpublished'),
                                type: "orange",
                                icon: "glyphicon glyphicon-exclamation-sign",
                                cbBtnOK: function () {
                                    $(".panel-port-areas #accordion").show();
                                    $('.panel-port-areas .loading').hide();
                                }
                            });

                            return false;
                        }

                        var url = _self.vars.serverName + "/{0}/site/edic/{1}/port/{2}".format(_self.vars.prontus_id, edic, $(_self.ui.selectors.cmbPort).val());
                        window.open(url, "_blank");
                    });

                    $("#port_admin_port").off("click").on("click", function () {
                        $("#modal_admin_port").modal('show');
                        $('#port_duplicar_nombre').val('');
                        $('#port_duplicar_desc').val('');
                    });
                    $("#modal_admin_port").on("show.bs.modal", function () {
                        _self.port.tools.actions.loadPortHistory();
                    });

                    $("#port_admin_edic").off("click").on("click", function () {
                        var options = {
                            destroy: true,
                            ordering:  false,
                            searching: false,
                            pageLength: 7,
                            pagingType: 'simple',
                            language: l10nProntus.dataTableLang
                        };
                        options.language.paginate = _self.vars.dataTable.paginate;

                        $('#tabla_edic_ultimas').DataTable(options);
                        $('#tabla_edic_anteriores').DataTable(options);
                        $('#tabla_edic_ultimas_length').hide();
                        $('#tabla_edic_anteriores_length').hide();
                        $("#modal_admin_edic").modal('show');
                    });

                    $('#toggle_port_vobo').on('change', function () {
                        var $check = $(this);
                        var status = $check.prop('checked');

                        if (_self.vars.portVoboStatus) {
                            _self.vars.portVoboStatus = false;
                        } else {
                            if (status === false) {
                                showModalConfirm({
                                    msg: ProntusL10n.get('portadmin_unpublish_port'),
                                    type: 'orange',
                                    icon: "glyphicon glyphicon-warning-sign",
                                    btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                                    cbBtnOK: function () {
                                        PortAdmin.helper.showLoadingModal();

                                        if (_self.port.actions.checkAreaLimits()) {
                                            _self.port.actions.savePortArtics();
                                        }
                                    },
                                    cbBtnCancel: function () {
                                        _self.vars.portVoboStatus = true;
                                        $('#toggle_port_vobo').bootstrapToggle('on');
                                    }
                                });
                            } else {
                                showModalConfirm({
                                    msg: ProntusL10n.get('portadmin_publish_port'),
                                    type: 'orange',
                                    icon: "glyphicon glyphicon-warning-sign",
                                    btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                                    cbBtnOK: function () {
                                        PortAdmin.helper.showLoadingModal();

                                        if (_self.port.actions.checkAreaLimits()) {
                                            _self.port.actions.savePortArtics();
                                        }
                                    },
                                    cbBtnCancel: function () {
                                        _self.vars.portVoboStatus = true;
                                        $('#toggle_port_vobo').bootstrapToggle('off');
                                    }
                                });
                            }
                        }
                    });
                },
                disableButtons: function () {
                    $("#port_save").attr("disabled", "disabled").addClass("disabled");
                    $("#port_refresh").attr("disabled", "disabled").addClass("disabled");
                    $("#port_view").attr("disabled", "disabled").addClass("disabled");
                    $("#port_preview").attr("disabled", "disabled").addClass("disabled");
                    $(_self.ui.selectors.cmbPort).attr("disabled", "disabled");
                    $(_self.ui.selectors.cmbEdic).attr("disabled", "disabled");
                },
                enableButtons: function () {
                    $("#port_save").removeAttr("disabled").removeClass("disabled");
                    $("#port_refresh").removeAttr("disabled").removeClass("disabled");
                    $("#port_view").removeAttr("disabled").removeClass("disabled");
                    $("#port_preview").removeAttr("disabled").removeClass("disabled");
                    $(_self.ui.selectors.cmbEdic).removeAttr("disabled");
                    $(_self.ui.selectors.cmbPort).removeAttr("disabled");
                },
                checkAreaLimits: function () {
                    var wrongfid = {};
                    var artlimit = {};

                    $.each(_self.vars.articAreas, function (area, array) {

                        // Limitación por fids.
                        if (Object.keys(_self.vars.areasProp[area].fids).length) {
                            var fids = _self.vars.areasProp[area].fids;

                            $.each(array, function (_pos, ts) {
                                $.each(_self.vars.areas.data[area], function (_index, data) {
                                    if (data.ts == ts) {
                                        if (!fids[data.fidplt]) {
                                            if (typeof wrongfid[area] == 'undefined') wrongfid[area] = [];

                                            wrongfid[area].push({
                                                ts: ts,
                                                fidplt: data.fidplt,
                                                titular: data.titular
                                            });
                                        }
                                    }
                                });
                            });
                        }

                        // Limitacion por numero de articulos.
                        if (_self.vars.areasProp[area].limite && array.length > _self.vars.areasProp[area].limite) {
                            artlimit[area] = {
                                limite: _self.vars.areasProp[area].limite,
                                artics: array.length
                            };
                        }
                    });

                    if (Object.keys(wrongfid).length || Object.keys(artlimit).length) {
                        var msg = ProntusL10n.get('portadmin_area_restrictions');
                        var msgProps = "";

                        $.each(_self.vars.areasProp, function (area, data) {
                            // si no hay articulos de fid incorrecto y no hay sobrepublicacion no se hace nada para el area
                            if (typeof (wrongfid[area]) === 'undefined' && typeof artlimit[area] === 'undefined') { return; }

                            var fids = Object.keys(data.fids).map(function(x) { return x; }).join(', ');
                            if ((fids || data.limite) && typeof _self.vars.articAreas[area] !== 'undefined') {
                                if (!fids) fids = ProntusL10n.get('global_label_all_m');
                                if (!data.limite) data.limite = ProntusL10n.get('global_label_unlimited');
                                var tmp = "<li>"+ProntusL10n.get('portadmin_fids_allowed', fids) + "</li>" + "<li>" +ProntusL10n.get('portadmin_art_limits', data.limite) + "</li>";
                                var numArtic = _self.vars.articAreas[area].length;

                                if (!isNaN(data.limite) && numArtic > data.limite) {
                                    numArtic = "<span class='text-danger'>"+ProntusL10n.get('portadmin_limit_breached', numArtic)+"</span>";
                                }

                                tmp += "<li>" +ProntusL10n.get('portadmin_arts_in_area', numArtic) + "</li>";

                                if (typeof (wrongfid[area]) !== 'undefined' && wrongfid[area].length) {
                                    var tmp2 = "";
                                    $.each(wrongfid[area], function (_index, value) {
                                        tmp2 += "<li>{0} ({1})</li>".format(value.titular, value.fidplt);
                                    });

                                    if (tmp2) {
                                        tmp += "<li>"+ProntusL10n.get('portadmin_incompatible_arts')+"<ul>{0}</ul></li>".format(tmp2);
                                    }
                                }

                                msgProps += "<dt><strong>"+ProntusL10n.get('portadmin_areas', area)+"</strong></dt><dd><ul class='list-conflictos'>{0}</ul></dd>".format(tmp);
                            }
                        });

                        msg += "<dl>{0}</dl>".format(msgProps);
                        msg += "<p>"+ProntusL10n.get('portadmin_depub_warning')+"</p>";
                        msg += "<ul><li>"+ProntusL10n.get('portadmin_remove_incompatible_arts') +"</li>";
                        msg += "<li>"+ ProntusL10n.get('portadmin_remove_max_artics') +"</li></ul>";

                        showModalAlert({
                            title: ProntusL10n.get('portadmin_error_save_port_title'),
                            msg: msg,
                            type: "red",
                            icon: "glyphicon glyphicon-exclamation-sign",
                            buttons: {
                                continuar: {
                                    text: ProntusL10n.get('portadmin_depub_save_txt'),
                                    btnClass: "btn-xs btn-red",
                                    action: function () {
                                        $.each(wrongfid, function (area, wronglist) {
                                            $.each(wronglist, function (_index, value) {
                                                var pos = $.inArray(value.ts, _self.vars.articAreas[area]);
                                                if (pos >= 0) { // Se encontro el articulo.
                                                    _self.vars.articAreas[area].splice(pos, 1); // Se hace igual para actualizar de inmediato el arreglo de articulos y evitar carrera critica.
                                                }
                                            });
                                        });

                                        $.each(artlimit, function (area, value) {
                                            _self.vars.articAreas[area] = _self.vars.articAreas[area].slice(0, value.limite);
                                        });

                                        // Guardar portada.
                                        _self.port.actions.savePortArtics();
                                    }
                                },
                                solodepub: {
                                    text: ProntusL10n.get('portadmin_depub_txt'),
                                    btnClass: "btn-green",
                                    action: function () {
                                        $.each(wrongfid, function (area, wronglist) {
                                            $.each(wronglist, function (_index, value) {
                                                var pos = $.inArray(value.ts, _self.vars.articAreas[area]);
                                                if (pos >= 0) { // Se encontro el articulo.
                                                    $(".panel-port-areas .list-group").find(".list-group-item[data-ts='" + value.ts + "'] .dpub-from-area a").trigger("click");
                                                    _self.vars.articAreas[area].splice(pos, 1); // Se hace igual para actualizar de inmediato el arreglo de articulos y evitar carrera critica.
                                                }
                                            });
                                        });

                                        $.each(artlimit, function (area, value) {
                                            var quitar = _self.vars.articAreas[area].slice(value.limite, _self.vars.articAreas[area].length); // Trunca el array al limite establecido.
                                            for (var x = 0; x < quitar.length; x++) {
                                                $(".panel-port-areas .list-group").find(".list-group-item[data-ts='" + quitar[x] + "'] .dpub-from-area a").trigger("click");

                                            }

                                            _self.areas.actions.updateArticsArea(area); // Actualiza el array de articulos en areas.
                                        });
                                        PortAdmin.helper.hideLoadingModal();
                                    }
                                },
                                ok: {
                                    text: ProntusL10n.get('portadmin_manual_solution_txt'),
                                    btnClass: "btn-gray",
                                    action: function() {
                                        PortAdmin.helper.hideLoadingModal();
                                    }
                                }
                            }
                        });

                        return false;
                    }

                    return true;
                },
                invocarAjaxSave: function(data) {
                    $.ajax({
                        url: "/{0}/prontus_port_guardar.cgi".format(Admin.dir_cgi_cpn),
                        data: data,
                        dataType: "json",
                        type: "POST",
                        success: function (response) {
                            showSuccessAlert("#alert-port-area", ProntusL10n.get('portadmin_save_port_ok') + '<span class="far fa-smile-wink"></span>', "port_save_alert");
                            _self.areas.actions.loadArticsPortAreas();
                            _self.port.actions.enableButtons();
                            _self.vars.changes = false;
                            _self.helper.initLastMod(response.modtime);
                            _self.activeArea = false;
                            PortAdmin.vars.startingMD5SUM = response.md5_xml;
                            PortAdmin.helper.hideLoadingModal();
                        },
                        error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                            showModalAlert({
                                title: ProntusL10n.get('global_server_msg'),
                                msg: ProntusL10n.get('portadmin_port_cant_save', errorThrown),
                                type: "red",
                                icon: "glyphicon glyphicon-exclamation-sign",
                                cbBtnOK: function () {
                                    $(".panel-port-areas #accordion").show();
                                    $('.panel-port-areas .loading').hide();
                                }
                            });
                        }
                    });
                },
                savePortArtics: function () {
                    var no_write = 0;

                    if ($('#toggle_port_vobo').prop('checked') == false) {
                        no_write = 1;
                    }

                    var data = {
                        _prontus_id: _self.vars.prontus_id,
                        _port: $(_self.ui.selectors.cmbPort).val(),
                        _edic: $(_self.ui.selectors.cmbEdic).val(),
                        _accion: "update",
                        _no_write: no_write
                    };

                    $.each(_self.vars.articAreas, function (area, array) {
                        $.each(array, function (index, ts) {
                            data["_area_"  + ts] = area;
                            data["_orden_" + ts] = (index+1); // para no partir de cero.
                            data["_vb_" + ts] = _self.vars.articAreaVB[ts];
                            data["_prontus_" + ts] = _self.vars.articAreaProntus[ts];

                            if (_self.vars.articAreaCorruptos[ts]) {
                                data["_corrupt_" + ts] = 1;
                            }
                        });
                    });

                    _self.port.actions.disableButtons();

                    $(_self.ui.selectors.panelPortAreas + ' #accordion').hide();
                    $(_self.ui.selectors.panelPortAreas + ' .loading').show();

                    // chequeamos el md5sum de la portada ahora mismo contra el de la portada al cargar, para ver si alguien más editó al mismo tiempo.
                    $.ajax({
                        url: "/{0}/prontus_port_check_md5sum.cgi".format(Admin.dir_cgi_cpn),
                        data: data,
                        dataType: "json",
                        type: "POST",
                        success: function (response) {
                            if (typeof response.md5sum !== 'undefined' && response.md5sum !== '' && response.port == $(_self.ui.selectors.cmbPort).val()) {
                                // si la portada fue guardada por otro usuario desde que este comenzó a editar, avisamos.
                                if (response.md5sum != 0 && PortAdmin.vars.startingMD5SUM != response.md5sum) {
                                    showModalConfirm({
                                        msg: ProntusL10n.get('portadmin_overwrite_confirm'),
                                        type: 'blue',
                                        icon: "glyphicon glyphicon-question-sign",
                                        btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                                        cbBtnOK: function () {
                                            _self.port.actions.invocarAjaxSave(data, response);
                                        },
                                        cbBtnCancel: function () {
                                            PortAdmin.helper.hideLoadingModal();
                                            $(_self.ui.selectors.panelPortAreas + ' #accordion').show();
                                            $(_self.ui.selectors.panelPortAreas + ' .loading').hide();
                                            _self.port.actions.enableButtons();
                                        }
                                    });
                                } else {
                                    _self.port.actions.invocarAjaxSave(data, response);
                                }
                            } else {
                                showModalAlert({
                                    title: ProntusL10n.get('global_error_occurred'),
                                    msg: ProntusL10n.get('portadmin_loading_port_error', response.areas.port, data._port),
                                    type: "red",
                                    icon: "glyphicon glyphicon-exclamation-sign",
                                    cbBtnOK: function () {
                                        PortAdmin.helper.hideLoadingModal();
                                        $(_self.ui.selectors.panelPortAreas + ' #accordion').show();
                                        $(_self.ui.selectors.panelPortAreas + ' .loading').hide();
                                        _self.port.actions.enableButtons();
                                    }
                                });
                            }
                        },
                        error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                            showModalAlert({
                                title: ProntusL10n.get('global_server_msg'),
                                msg: ProntusL10n.get('portadmin_port_cant_save', errorThrown),
                                type: "red",
                                icon: "glyphicon glyphicon-exclamation-sign",
                                cbBtnOK: function () {
                                    $(".panel-port-areas #accordion").show();
                                    $('.panel-port-areas .loading').hide();
                                }
                            });
                        }
                    });
                }
            },
            tools: {
                capitalizeFirstLetter: function([ first, ...rest ], locale = navigator.language) {
                    return first.toLocaleUpperCase(locale) + rest.join('');
                },
                bindToolsEvents: function () {
                    $('#port_duplicar_nombre').on('keyup blur', function(e) {
                        e.target.value = e.target.value.toLowerCase();
                        e.target.value = e.target.value.replace(/[^a-z_0-9\.]/,'');
                    });

                    $('form[name="frmPortDuplicar"]').off('submit').on('submit', function (e) {
                        e.preventDefault();
                        _self.port.tools.actions.validarDuplicarPortada($(this));
                    });

                    $('#_copiar_contenido_port').on('click', function () {
                        $('#_edicion_selecionada').val($('#_edic').val());
                    });

                    $('form[name="frmPortIntercambiar"]').off('submit').on('submit', function (e) {
                        e.preventDefault();
                        _self.port.tools.actions.validarIntercambiarPortada($(this));
                    });

                    $('form[name="frmPortEliminar"]').off('submit').on('submit', function (e) {
                        e.preventDefault();
                        _self.port.tools.actions.validarEliminarPortada($(this));
                    });

                    $('form[name="frmNuevaEdicion"]').off('submit').on('submit', function (e) {
                        e.preventDefault();
                        _self.port.tools.actions.guardarNuevaEdicion($(this));
                    });

                    $('#edicBase').off('change').on('change', function () {
                        var selected = $('#edicBase option:selected').val();
                        _self.port.tools.actions.showEdicPorts(selected);
                    });

                    $('.edic-borrar').off('click').on('click', function (e) {
                        e.preventDefault();
                        var $tr = $(this).parents('tr');
                        var edic = $tr.attr('data-edic');

                        _self.port.tools.actions.borrarEdicion(edic, $tr);
                    });

                    $('.edic-toogle-vigencia').off('click').on('click', function (e) {
                        e.preventDefault();
                        var edic = $(this).parents('tr').attr('data-edic');
                        _self.port.tools.actions.toggleVigenciaEdicion($(this), edic);
                    });

                    $('#recover_port').on('click', function (e) {
                        e.preventDefault();
                        var selected = $('#port_recovery_version_select').val();
                        if (selected != '') {
                            _self.areas.actions.loadArticsPortAreas({version: selected});
                        }
                    });

                },
                // devuelve el largo del texto ingresado en un input.
                getCounterValues: function(inputFieldID) {
                    return $(inputFieldID).val().length;
                },
                // rellena los contadores de caracteres según el texto ingresado en los inputs respectivos.
                fillCounters: function() {
                    $('.port_counter').each(function() {
                        $(this).text(_self.port.tools.getCounterValues($(this).parent().siblings('input, textarea')));
                    });
                },
                // hace bind del evento keyup para los inputs de texto del modal SEO, para contar caracteres a medida que se tipea.
                bindCounters: function () {
                    $('.port_counter').each(function() {
                        let myself = this;
                        let inputField = $(this).parent().siblings('input, textarea');
                        $(inputField).on('keyup', function() {
                            $(myself).text(_self.port.tools.getCounterValues('#'+$(this).attr('id')));
                        });
                    });
                },
                // enlaza el evento onchange del campo de URL a imagen|multimedia, para quitar el schema y dominio si vienen.
                bindURLCheck: function() {
                    $('#port_seo_fotofija,#port_seo_multimedia_video,#port_seo_multimedia_audio').on('change', function() {
                        let urlPath = $(this).val();
                        /**
                        Explicación de la regex: ^(?:[a-z]+:)?//
                        ^ - beginning of the string
                        (?: - beginning of a non-captured group
                        [a-z]+ - any character of 'a' to 'z' 1 or more times
                        : - string (colon character)
                        )? - end of the non-captured group. Group appearing 0 or 1 times
                        // - string (two forward slash characters)
                        'i' - non case-sensitive flag
                         */
                        let relPath = urlPath;
                        let pattern = new RegExp('^(?:[a-z]+:)?//', 'i');
                        if (pattern.test(urlPath)) {
                            let theURL = new URL(urlPath);
                            relPath = theURL.toString().substring(theURL.origin.length)
                        }
                        $(this).val(relPath);
                    });
                },
                actions: {
                    borrarEdicion: function (edic, $elem) {
                        showModalConfirm({
                            msg: ProntusL10n.get('portadmin_delete_edic_confirm'),
                            type: 'blue',
                            icon: "glyphicon glyphicon-question-sign",
                            okTitle: ProntusL10n.get('global_delete_title'),
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            cbBtnOK: function () {
                                $.ajax({
                                    url: "/{0}/prontus_edi_borrar.cgi".format(Admin.dir_cgi_cpn),
                                    type: 'POST',
                                    dataType: 'json',
                                    data: {_edic: edic, _prontus_id: _self.vars.prontus_id},
                                    success: function (response) {
                                        if (response.status == 1) {
                                            showModalAlert({
                                                title: ProntusL10n.get('global_server_msg'),
                                                msg: response.msg,
                                                type: "green",
                                                icon: "glyphicon glyphicon-ok",
                                                cbBtnOK: function () {
                                                    $elem.remove();
                                                }
                                            });
                                        } else {
                                            showModalAlert({
                                                title: ProntusL10n.get('global_server_msg'),
                                                msg: response.msg,
                                                type: "red",
                                                icon: "glyphicon glyphicon-exclamation-sign",
                                                cbBtnOK: function () {}
                                            });
                                        }
                                    },
                                    error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                                        console.log(XMLHttpRequest, textStatus, errorThrown);
                                        showModalAlert({
                                            title: ProntusL10n.get('admin_error'),
                                            msg: ProntusL10n.get('portadmin_delete_edic_error', errorThrown),
                                            type: "red",
                                            icon: "glyphicon glyphicon-exclamation-sign",
                                            cbBtnOK: function () {}
                                        });
                                    }
                                });
                            },
                            cbBtnCancel: function () {}
                        });
                    },
                    loadPortHistory: function(port) {
                        var port = $(_self.ui.selectors.cmbPort).val();
                        var edic = $(_self.ui.selectors.cmbEdic).val();

                        if (edic === undefined || edic === '') {
                            edic = 'base';
                        }

                        var dataForm = {
                            _prontus_id : Admin.prontus_id,
                            _port: port,
                            _edic: edic
                        }
                        $.ajax({
                            url: '/' + Admin.dir_cgi_cpn + '/prontus_port_get_versions.cgi',
                            type: 'POST',
                            dataType: 'json',
                            data: dataForm,
                            success: function (response) {
                                if (response.status == 1) {
                                    const options = { weekday: 'long', year: 'numeric', month: 'long', day: 'numeric', hour: 'numeric', minute: 'numeric', second: 'numeric'};
                                    var combo_ver = document.getElementById('port_recovery_version_select');
                                    combo_ver.options.length = 0;
                                    combo_ver.options[0] = new Option(ProntusL10n.get('portadmin_select_port_version'), '');
                                    combo_ver.options[0].selected = true;
                                    for (let i = 0; i < response.data.length; i++) {
                                        let mod = new Date(response.data[i].modtime * 1000);
                                        combo_ver.options[i+1] = new Option(mod.toLocaleDateString(ProntusL10n.getLocaleDate(), options) + ' - ' + response.data[i].artic_count + " " + ProntusL10n.get('portadmin_port_article_count'), response.data[i].file);
                                    }
                                } else {
                                    showModalAlert({
                                        title: ProntusL10n.get('global_error_occurred'),
                                        msg: response.msg,
                                        type: "red",
                                        icon: "glyphicon glyphicon-exclamation-sign",
                                        cbBtnOK: function () {
                                        }
                                    });
                                }
                            },
                            error: function (XMLHttpRequest, textStatus, errorThrown) {
                                console.log(XMLHttpRequest, textStatus, errorThrown);
                                showModalAlert({
                                    title: ProntusL10n.get('global_server_msg'),
                                    msg: ProntusL10n.get('global_error_int', errorThrown),
                                    type: "red",
                                    icon: "glyphicon glyphicon-exclamation-sign",
                                    cbBtnOK: function () {
                                    }
                                });
                            }
                        });
                    },
                    showEdicPorts: function (edic) {
                        if (edic) {
                            $('#selPortsToCopy').show();
                        } else {
                            $('input[name^="selPorts-"]').prop("checked", false);
                            $('#selPortsToCopy').hide();
                        }
                    },
                    toggleVigenciaEdicion: function ($elem, edic) {
                        var status = parseInt($elem.attr('data-vigencia'));
                        var new_status, old_class, new_class, msg;
                        var $span = $elem.find('.glyphicon');

                        if (status === 0) {
                            new_status = 1;
                            old_class = 'btn-default';
                            new_class = 'btn-success';
                            msg = 'Vigente';
                        }

                        if (status == 1) {
                            new_status = 0;
                            old_class = 'btn-success';
                            new_class = 'btn-default';
                            msg = 'No vigente';
                        }

                        $span.removeClass('glyphicon-ok').addClass('glyphicon-refresh spinning');

                        showModalConfirm({
                            msg: ProntusL10n.get('portadmin_edic_swap_confirm', msg),
                            type: 'blue',
                            icon: "glyphicon glyphicon-question-sign",
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextgreen nextgreen',
                            cbBtnOK: function () {
                                $.ajax({
                                    url: "/{0}/prontus_edi_toggle_vigencia.cgi".format(Admin.dir_cgi_cpn),
                                    type: 'POST',
                                    dataType: 'json',
                                    data: {_edic: edic, _new_status: new_status, _prontus_id: _self.vars.prontus_id},
                                    success: function (response) {
                                        if (response.status == 1) {
                                            $elem.removeClass(old_class);
                                            $elem.addClass(new_class);
                                            $elem.attr('data-vigencia', new_status);
                                            $elem.attr('title', 'La edición está: ' + msg);
                                            $span.removeClass('glyphicon-refresh spinning').addClass('glyphicon-ok');
                                        } else {
                                            showModalAlert({
                                                title: ProntusL10n.get('global_server_msg'),
                                                msg: response.msg,
                                                type: "red",
                                                icon: "glyphicon glyphicon-exclamation-sign",
                                                cbBtnOK: function () {
                                                    $span.removeClass('glyphicon-refresh spinning').addClass('glyphicon-ok');
                                                }
                                            });
                                        }
                                    },
                                    error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                                        showModalAlert({
                                            title: ProntusL10n.get('admin_error'),
                                            msg: ProntusL10n.get('portadmin_edic_swap_error', errorThrown),
                                            type: "red",
                                            icon: "glyphicon glyphicon-exclamation-sign",
                                            cbBtnOK: function () {
                                                $span.removeClass('glyphicon-refresh spinning').addClass('glyphicon-ok');
                                            }
                                        });
                                    }
                                });
                            },
                            cbBtnCancel: function () {
                                $span.removeClass('glyphicon-refresh spinning').addClass('glyphicon-ok');
                            }
                        });
                    },
                    validarDuplicarPortada: function ($form) {
                        $.ajax({
                            url: "/{0}/prontus_pltport_duplicar.cgi".format(Admin.dir_cgi_cpn),
                            type: 'POST',
                            dataType: 'json',
                            data: $form.serialize() + '&validate=1',
                            success: function (response) {
                                if (response.status == 1) {
                                    _self.port.tools.actions.duplicarPortada($form);
                                } else {
                                    showModalAlert({
                                        title: ProntusL10n.get('global_server_msg'),
                                        msg: response.msg,
                                        type: "red",
                                        icon: "glyphicon glyphicon-exclamation-sign",
                                        cbBtnOK: function () {}
                                    });
                                }
                            },
                            error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                                showModalAlert({
                                    title: ProntusL10n.get('admin_error'),
                                    msg: ProntusL10n.get('portadmin_port_duplicate_error', errorThrown),
                                    type: "red",
                                    icon: "glyphicon glyphicon-exclamation-sign",
                                    cbBtnOK: function () {}
                                });
                            }
                        });
                    },
                    duplicarPortada: function ($form) {
                        showModalConfirm({
                            msg: ProntusL10n.get('portadmin_port_duplicate_confirm'),
                            type: 'blue',
                            icon: "glyphicon glyphicon-question-sign",
                            okTitle: ProntusL10n.get('portadmin_port_duplicate_ok'),
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextgreen nextgreen',
                            cbBtnOK: function () {
                                $.ajax({
                                    url: "/{0}/prontus_pltport_duplicar.cgi".format(Admin.dir_cgi_cpn),
                                    type: 'POST',
                                    dataType: 'json',
                                    data: $form.serialize(),
                                    success: function (response) {
                                        if (response.status == 1) {
                                            showModalAlert({
                                                title: ProntusL10n.get('global_server_msg'),
                                                msg: response.msg,
                                                type: "green",
                                                icon: "glyphicon glyphicon-ok",
                                                cbBtnOK: function () {
                                                    window.location.reload();
                                                }
                                            });
                                        } else {
                                            showModalAlert({
                                                title: ProntusL10n.get('global_server_msg'),
                                                msg: response.msg,
                                                type: "red",
                                                icon: "glyphicon glyphicon-exclamation-sign",
                                                cbBtnOK: function () {}
                                            });
                                        }
                                    },
                                    error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                                        showModalAlert({
                                            title: ProntusL10n.get('admin_error'),
                                            msg: ProntusL10n.get('portadmin_port_duplicate_error', errorThrown),
                                            type: "red",
                                            icon: "glyphicon glyphicon-exclamation-sign",
                                            cbBtnOK: function () {}
                                        });
                                    }
                                });
                            },
                            cbBtnCancel: function () {
                            }
                        });
                    },
                    validarIntercambiarPortada: function ($form) {
                        if ($form.find('#port_intercambiar_origen').val() == $form.find('#port_intercambiar_destino').val()) {
                            showModalAlert({
                                title: ProntusL10n.get('admin_error'),
                                msg: ProntusL10n.get('portadmin_port_duplicate_equal'),
                                type: "red",
                                icon: "glyphicon glyphicon-exclamation-sign",
                                cbBtnOK: function () {}
                            });
                            return false;
                        }
                        $.ajax({
                            url: "/{0}/prontus_pltport_intercambiar.cgi".format(Admin.dir_cgi_cpn),
                            type: 'POST',
                            dataType: 'json',
                            data: $form.serialize() + '&validate=1',
                            success: function (response) {
                                if (response.status == 1) {
                                    _self.port.tools.actions.intercambiarPortada($form);
                                } else {
                                    showModalAlert({
                                        title: ProntusL10n.get('global_server_msg'),
                                        msg: response.msg,
                                        type: "red",
                                        icon: "glyphicon glyphicon-exclamation-sign",
                                        cbBtnOK: function () {}
                                    });
                                }
                            },
                            error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                                showModalAlert({
                                    title: ProntusL10n.get('admin_error'),
                                    msg: ProntusL10n.get('portadmin_port_duplicate_error', errorThrown),
                                    type: "red",
                                    icon: "glyphicon glyphicon-exclamation-sign",
                                    cbBtnOK: function () {}
                                });
                            }
                        });
                    },
                    intercambiarPortada: function ($form) {
                        showModalConfirm({
                            msg: ProntusL10n.get('portadmin_port_swap_confirm'),
                            type: 'blue',
                            icon: "glyphicon glyphicon-question-sign",
                            okTitle: ProntusL10n.get('portadmin_port_swap_ok'),
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            cbBtnOK: function () {
                                $.ajax({
                                    url: "/{0}/prontus_pltport_intercambiar.cgi".format(Admin.dir_cgi_cpn),
                                    type: 'POST',
                                    dataType: 'json',
                                    data: $form.serialize(),
                                    success: function (response) {
                                        if (response.status == 1) {
                                            showModalAlert({
                                                title: ProntusL10n.get('global_server_msg'),
                                                msg: response.msg,
                                                type: "green",
                                                icon: "glyphicon glyphicon-ok",
                                                cbBtnOK: function () {
                                                    window.location.reload();
                                                }
                                            });
                                        } else {
                                            showModalAlert({
                                                title: ProntusL10n.get('global_server_msg'),
                                                msg: response.msg,
                                                type: "red",
                                                icon: "glyphicon glyphicon-exclamation-sign",
                                                cbBtnOK: function () {}
                                            });
                                        }
                                    },
                                    error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                                        showModalAlert({
                                            title: ProntusL10n.get('admin_error'),
                                            msg: ProntusL10n.get('portadmin_port_swap_error', errorThrown),
                                            type: "red",
                                            icon: "glyphicon glyphicon-exclamation-sign",
                                            cbBtnOK: function () {}
                                        });
                                    }
                                });
                            },
                            cbBtnCancel: function () {}
                        });
                    },
                    guardarNuevaEdicion: function ($form) {
                        showModalConfirm({
                            msg: ProntusL10n.get('portadmin_edic_save_confirm'),
                            type: 'blue',
                            icon: "glyphicon glyphicon-question-sign",
                            okTitle: ProntusL10n.get('global_save_label'),
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextgreen nextgreen',
                            cbBtnOK: function () {
                                $.ajax({
                                    url: "/{0}/prontus_edi_guardar.cgi".format(Admin.dir_cgi_cpn),
                                    type: 'POST',
                                    dataType: 'json',
                                    data: $form.serialize(),
                                    success: function (response) {
                                        if (response.status == 1) {
                                            showModalAlert({
                                                title: ProntusL10n.get('global_server_msg'),
                                                msg: response.msg,
                                                type: "green",
                                                icon: "glyphicon glyphicon-ok",
                                                cbBtnOK: function () {
                                                    window.location.reload();
                                                }
                                            });
                                        } else {
                                            showModalAlert({
                                                title: ProntusL10n.get('global_server_msg'),
                                                msg: response.msg,
                                                type: "red",
                                                icon: "glyphicon glyphicon-exclamation-sign",
                                                cbBtnOK: function () {}
                                            });
                                        }
                                    },
                                    error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                                        showModalAlert({
                                            title: ProntusL10n.get('admin_error'),
                                            msg: ProntusL10n.get('portadmin_edic_save_error', errorThrown),
                                            type: "red",
                                            icon: "glyphicon glyphicon-exclamation-sign",
                                            cbBtnOK: function () {}
                                        });
                                    }
                                });
                            },
                            cbBtnCancel: function () {}
                        });
                    },
                    validarEliminarPortada: function ($form) {
                        $.ajax({
                            url: "/{0}/prontus_pltport_borrar.cgi".format(Admin.dir_cgi_cpn),
                            type: 'POST',
                            dataType: 'json',
                            data: $form.serialize() + '&validate=1',
                            success: function (response) {
                                if (response.status == 1) {
                                    _self.port.tools.actions.eliminarPortada($form);
                                } else {
                                    showModalAlert({
                                        title: ProntusL10n.get('global_server_msg'),
                                        msg: response.msg,
                                        type: "red",
                                        icon: "glyphicon glyphicon-exclamation-sign",
                                        cbBtnOK: function () {}
                                    });
                                }
                            },
                            error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                                showModalAlert({
                                    title: ProntusL10n.get('admin_error'),
                                    msg: ProntusL10n.get('portadmin_port_duplicate_error', errorThrown),
                                    type: "red",
                                    icon: "glyphicon glyphicon-exclamation-sign",
                                    cbBtnOK: function () {}
                                });
                            }
                        });
                    },
                    eliminarPortada: function ($form) {
                        showModalConfirm({
                            msg: ProntusL10n.get('portadmin_delete_port_confirm'),
                            type: 'blue',
                            icon: "glyphicon glyphicon-question-sign",
                            okTitle: ProntusL10n.get('global_delete_title'),
                            btnClassOk: 'hovwhite radius15 noborder txtnextwhite pad-top-bot7 pad-lef-rig20 int-nextred nextred',
                            cbBtnOK: function () {
                                $.ajax({
                                    url: "/{0}/prontus_pltport_borrar.cgi".format(Admin.dir_cgi_cpn),
                                    type: 'POST',
                                    dataType: 'json',
                                    data: $form.serialize(),
                                    success: function (response) {
                                        if (response.status == 1) {
                                            showModalAlert({
                                                title: ProntusL10n.get('global_server_msg'),
                                                msg: response.msg,
                                                type: "green",
                                                icon: "glyphicon glyphicon-ok",
                                                cbBtnOK: function () {
                                                    window.location.reload();
                                                }
                                            });
                                        } else {
                                            showModalAlert({
                                                title: ProntusL10n.get('global_server_msg'),
                                                msg: response.msg,
                                                type: "red",
                                                icon: "glyphicon glyphicon-exclamation-sign",
                                                cbBtnOK: function () {}
                                            });
                                        }
                                    },
                                    error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                                        showModalAlert({
                                            title: ProntusL10n.get('admin_error'),
                                            msg: ProntusL10n.get('portadmin_delete_port_error', errorThrown),
                                            type: "red",
                                            icon: "glyphicon glyphicon-exclamation-sign",
                                            cbBtnOK: function () {}
                                        });
                                    }
                                });
                            },
                            cbBtnCancel: function () {}
                        });
                    }
                }
            }
        },
        // Manejo de la busqueda.
        search: {
            busquedas: {},
            ordenActual: false, // para evitar problemas con chrome en onblur del selector de orden de articulos.
            init: function () {
                $("#button-refresh").off("click").on("click", function (e) {
                    e.preventDefault();
                    var visibility = $("#input-visible").val();
                    _self.artics.actions.loadArtics(0, {visible: visibility});
                });

                PortAdmin.search.ordenActual = $('#articles-order-by').val();

                $("#button-search").off("click").on("click", function (e) {
                    e.preventDefault();
                    _self.search.basicSearch();
                });

                _self.search.setupVisibilityFilter();

                $("#button-search-visible").off("click").on("click", function (e) {
                    e.preventDefault();
                    _self.search.filterVisibleArticles();
                });

                $("input[name='input-search']").on("keyup", function (e) {
                    if (e.keyCode == 13) {
                        _self.search.basicSearch();
                    }
                });

                _self.search.bindFilterSearch();
                $("#modal_search").off("show.bs.modal").on("show.bs.modal", function () {
                    _self.search.bindFilterSearch();
                });

                $("#modal_favorite_search").off("show.bs.modal").on("show.bs.modal", function () {
                    _self.search.handleFavoriteModal();
                });
            },
            handleFavoriteModal: function () {
                var html = document.getElementById(_self.vars.idTplFavoriteSearch).textContent;
                var output = "";

                $.ajax({
                    url: "/{0}/prontus_port_carga_busquedas.cgi".format(Admin.dir_cgi_cpn),
                    dataType: "json",
                    data: { _prontus_id: _self.vars.prontus_id },
                    type: 'POST',
                    success: function (response) {
                        if (response.status == 1) {
                            $.each(response.data, function (_index, value) {
                                var tmp = html;
                                tmp = tmp.replace(/%%nombre%%/g, value.info.nombre);
                                tmp = tmp.replace(/%%id%%/g, value.info.ts); // ts no tiene nada que ver con articulos.

                                output += tmp;

                                _self.search.busquedas[value.info.ts] = value.params;
                            });

                            $("#favorite_search_list").html(output);
                            _self.search.bindBusquedaFav();
                        } else {
                            showModalAlert({
                                title: ProntusL10n.get('global_server_msg'),
                                msg: repsonse.msg,
                                type: "red",
                                icon: "glyphicon glyphicon-exclamation-sign",
                                cbBtnOK: function () {}
                            });
                        }
                    },
                    error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                        showModalAlert({
                            title: ProntusL10n.get('admin_error'),
                            msg: ProntusL10n.get('list_unable_load_search_result', errorThrown),
                            type: "red",
                            icon: "glyphicon glyphicon-exclamation-sign",
                            cbBtnOK: function () {}
                        });
                    }
                });
            },
            resetSearchParams: function () {
                $.each(_self.vars.searchParams, function (index) {
                    _self.vars.searchParams[index] = "";
                });

                $("select[name='filter_subtema']").find('option').remove().end().append('<option value="">Subtema</option>');
                $("select[name='filter_tema']").find('option').remove().end().append('<option value="">Tema</option>');

                $("select[name='filter_visibilidad']").val('');
                $("select[name='filter_multitag_s']").val('');
                $("select[name='filter_multitag_t']").val('');
                $("select[name='filter_multitag_st']").val('');

                $("input[name='filter_save']").removeAttr("checked").prop('checked', false);
                $("input[name='filter_name']").attr("disabled", "disabled").val('');
                $("input[name='input-search']").val('');
            },
            rellenaFilterForm: function (data) {
                for (var prop in data) {
                    $("[name='filter_{0}']".format(prop)).val(data[prop]);
                }
                $("[name='filter_seccion']").val(data.seccion);
                $("[name='filter_seccion']").trigger('change');

                $("[name='filter_tema']").val(data.tema).trigger('change');
                $("[name='filter_subtema']").val(data.subtema);
            },
            bindBusquedaFav: function () {
                $(".aplica-busqueda-fav").off("click").on("click", function (e) {
                    e.preventDefault();

                    var id = $(this).attr("data-id");

                    if (typeof _self.search.busquedas[id]) {
                        _self.artics.actions.loadArtics(0, _self.search.busquedas[id]);
                        _self.search.rellenaFilterForm(_self.search.busquedas[id]);
                        _self.search.showFilters();
                        _self.search.bindEliminaFiltros();

                        $("#modal_favorite_search").modal("toggle");
                    } else {
                        // !! ERROR.
                    }
                });

                $(".elimina-busqueda-fav").off("click").on("click", function (e) {
                    e.preventDefault();
                    var id = $(this).attr("data-id");
                    var $item = $(this).parent();
                    var data = {
                        _prontus_id: _self.vars.prontus_id,
                        _id_busqueda: id
                    };

                    $item.addClass("disabled");

                    $.ajax({
                        url: "/{0}/prontus_port_borra_busqueda.cgi".format(Admin.dir_cgi_cpn),
                        dataType: "json",
                        data: data,
                        success: function (response) {
                            if (response.status == 1) {
                                $.each(response.data, function (_index, value) {
                                    _self.search.busquedas[value.info.ts] = value.params;
                                });
                                $item.remove();
                            } else {
                                showModalAlert({
                                    title: ProntusL10n.get('global_server_msg'),
                                    msg: response.msg,
                                    type: "red",
                                    icon: "glyphicon glyphicon-exclamation-sign",
                                    cbBtnOK: function () {
                                        $item.removeClass("disabled");
                                    }
                                });
                            }
                        },
                        error: function (_XMLHttpRequest, _textStatus, errorThrown) {
                            showModalAlert({
                                title: ProntusL10n.get('admin_error'),
                                msg: ProntusL10n.get('list_unable_delete_search', errorThrown),
                                type: "red",
                                icon: "glyphicon glyphicon-exclamation-sign",
                                cbBtnOK: function () {
                                    $item.removeClass("disabled");
                                }
                            });
                        }
                    });
                });
            },
            bindFilterSearch: function () {
                // desmarcamos el checkbox de guardar búsqueda y vaciamos el posible nombre de la búsqueda al abrir el modal.
                // Este checkbox no debe guardarse como parte de la búsqueda.
                $('#filter_save').prop('checked', false);
                $('#filter_name').val('').attr("disabled", "disabled");

                $("select[name='filter_seccion']").off("change").on("change", function () {
                    var combo_temas = $("select[name='filter_tema']")[0];
                    combo_temas.options.length = 0;
                    var combo_subtemas = $("select[name='filter_subtema']")[0];
                    combo_subtemas.options.length = 0;
                    var id_seccion = $("select[name='filter_seccion']").val();
                    if (typeof _self.vars.taxonomia[id_seccion] !== "undefined") {
                        var i = 1;
                        var temas = _self.vars.taxonomia[id_seccion]['temas'];
                        for (var id_tema in temas) {
                            combo_temas.options[i] = new Option(temas[id_tema]['nombre'], id_tema);
                            i++;
                        }
                        if (i > 1) {
                            combo_temas.options[0] = new Option('Tema', '0');
                            combo_temas.options[0].selected = true;
                        }
                    }
                });

                $("select[name='filter_tema']").off("change").on("change", function () {
                    var id_tema = $("select[name='filter_tema']").val();
                    var combo_subtemas = $("select[name='filter_subtema']")[0];
                    combo_subtemas.options.length = 0;

                    if (id_tema !== 0) {
                        var id_seccion = $("select[name='filter_seccion']").val();

                        if (typeof _self.vars.taxonomia[id_seccion] !== "undefined" && typeof _self.vars.taxonomia[id_seccion]['temas'][id_tema] !== "undefined") {
                            var i = 1;
                            var subtemas = _self.vars.taxonomia[id_seccion]['temas'][id_tema]['subtemas'];
                            for (var id_subtema in subtemas) {
                                combo_subtemas.options[i] = new Option(subtemas[id_subtema]['nombre'], id_subtema);
                                i++;
                            }
                            if (i > 1) {
                                combo_subtemas.options[0] = new Option('Subtema', '0');
                                combo_subtemas.options[0].selected = true;
                            }
                        }
                    }
                });

                $("input[name='filter_save']").off("click").on("click", function () {
                    if ($(this).is(":checked")) {
                        $("input[name='filter_name']").removeAttr("disabled");
                    } else {
                        $("input[name='filter_name']").attr("disabled", "disabled");
                    }
                });

                $("button[name='port_seo_guardar']").off("click").on("click", function () {
                    var data = {
                        _prontus_id: _self.vars.prontus_id,
                        _port: $(_self.ui.selectors.cmbPort).val(),
                        url: $("#port_seo_url").val(),
                        title: document.getElementById('port_seo_title').value,
                        description: document.getElementById('port_seo_description').value,
                        robots: document.getElementById('port_seo_robots').value,
                        fotofija: document.getElementById('port_seo_fotofija').value,
                        multimedia_video: document.getElementById('port_seo_multimedia_video').value,
                        multimedia_audio: document.getElementById('port_seo_multimedia_audio').value
                    };

                    _self.vars.mv.forEach(function(vista) {
                        data['title_' + vista] = $('#port_seo_title_' + vista).val();
                        data['description_' + vista] = $('#port_seo_description_' + vista).val();
                    });

                    $.ajax({
                        url: "/" + Admin.dir_cgi_cpn + "/seo/prontus_port_seo_save.cgi",
                        data: data,
                        method: "POST",
                        success: function (response) {
                            if (response.status == 1) {
                                showModalAlert({
                                    title: ProntusL10n.get('global_server_msg'),
                                    type:'green',
                                    msg: response.msg
                                });

                                $("#modal_port_seo").modal('hide');
                            } else {
                                showModalAlert({
                                    title: ProntusL10n.get('global_server_msg'),
                                    type:'red',
                                    msg: ProntusL10n.get('global_error_int', response.msg)
                                });
                            }
                        }
                    })
                });

                $("button[name='aplicar_filter']").off("click").on("click", function () {
                    _self.artics.actions.loadArtics(0, {
                        tipart:         $("select[name='filter_tipart']").val(),
                        seccion:        $("select[name='filter_seccion']").val(),
                        tema:           $("select[name='filter_tema']").val(),
                        subtema:        $("select[name='filter_subtema']").val(),
                        visible:        $("select[name='filter_visibilidad']").val(),
                        multitag_s:     $("select[name='filter_multitag_s']").val(),
                        multitag_t:     $("select[name='filter_multitag_t']").val(),
                        multitag_st:    $("select[name='filter_multitag_st']").val(),
                        autor:          $("input[name='filter_autor']").val(),
                        titu:           $("input[name='filter_titu']").val(),
                        bajada:         $("input[name='filter_bajada']").val(),
                        alta:           $("select[name='filter_alta']").val(),
                        dia:            $("input[name='filter_dia']").val(),
                        diahasta:       $("input[name='filter_diahasta']").val(),
                        diapub:         $("input[name='filter_diapub']").val(),
                        diapubhasta:    $("input[name='filter_diapubhasta']").val(),
                        diaexp:         $("input[name='filter_diaexp']").val(),
                        diaexphasta:    $("input[name='filter_diaexphasta']").val(),
                        save_search:    $("input[name='filter_save']").is(':checked'),
                        name_search:    $("input[name='filter_name']").val(),
                        ts         : ''
                    });

                    $("input[name='input-search']").val($("input[name='filter_titu']").val());
                    $("#modal_search").modal("toggle");

                    _self.search.showFilters();
                    _self.search.bindEliminaFiltros();
                });
            },
            bindEliminaFiltros: function () {
                $("button[name='elimina-filtros']").off("click").on("click", function () {
                    $(".admin-port .search-filters li").not(".button-elimina-filtros").remove();

                    $("[name^='filter_']").each(function () {
                        $(this).val("");
                    });

                    $(_self.ui.selectors.panelRecentArtics + ' .button-elimina-filtros').addClass("hidden");
                    _self.search.resetSearchParams();

                    var visibility = $("#input-visible").val();
                    _self.artics.actions.loadArtics(0, {visible: visibility});
                });
            },
            showFilters: function () {
                var html = document.getElementById(_self.vars.idTplfilter).textContent;
                var output = "";
                var val, ignore, nom_filtro;

                $(".admin-port .search-filters li").not(".button-elimina-filtros").remove();

                $("[name^='filter_']").each(function () {
                    var tmp = html;

                    if ($(this)[0].nodeName == "SELECT") {
                        val = $(this, 'option:selected').val();
                        ignore = $(this).attr("data-ignore");

                        if (val && !ignore) {
                            if (val == 0) {
                                return;
                            }
                            // El primer elemento se considera como el nombre/titulo
                            nom_filtro = $(this).find("option:first-child").text();
                            var nom_option = $(this).find("option:selected").text();

                            if (nom_filtro) {
                                tmp = tmp.replace(/%%filter_name%%/g, nom_filtro);
                                tmp = tmp.replace(/%%filter_value%%/g, nom_option);

                                output += tmp;
                            }
                        }
                    } else if ($(this)[0].nodeName == "INPUT") {
                        val = $(this).val();
                        ignore = $(this).attr("data-ignore");

                        if (val && !ignore) {
                            nom_filtro = $(this).attr("placeholder");

                            if (nom_filtro) {
                                tmp = tmp.replace(/%%filter_name%%/g, nom_filtro);
                                tmp = tmp.replace(/%%filter_value%%/g, val);

                                output += tmp;
                            }
                        }
                    }
                });

                if (output) {
                    $(".admin-port .search-filters").prepend(output);
                    $(_self.ui.selectors.panelRecentArtics + ' .button-elimina-filtros').removeClass("hidden");
                }
            },
            /** Asegura durante la carga de la página que el botón refleje el estado del filtro de visibilidad.
             * A veces, al recargar, el botón queda en un estado incorrecto.
             */
            setupVisibilityFilter: function() {
                var filter_state = $('#input-visible').val();
                if (filter_state == 1) {
                    $('#button-search-visible span').removeClass("fa-eye").addClass('fa-eye-slash');
                } else {
                    $('#button-search-visible span').removeClass('fa-eye-slash').addClass("fa-eye");
                }
            },
            /** Aplica la búsqueda excluyendo o incluyendo artículos sin vista. */
            filterVisibleArticles: function() {
                var filter_state = $('#input-visible').val();

                // configuramos apariencia del botón de filtro y seteamos valor de búsqueda.
                if (filter_state == 1) { // pasa a mostrar todo
                    $('#button-search-visible span').removeClass('fa-eye-slash').addClass("fa-eye");
                    $('#input-visible').val(0);
                } else { // pasa a excluir artículos sin vista
                    $('#button-search-visible span').removeClass("fa-eye").addClass('fa-eye-slash');
                    $('#input-visible').val(1);
                }
                // finalmente ejecutamos la búsqueda nuevamente.
                _self.search.basicSearch(true);
            },
            basicSearch: function (notShowFilterRemove) {
                var inputValue = $("input[name='input-search']").val();
                var regxp = /^\d{14}$/;

                if (!inputValue && !notShowFilterRemove) return false;

                var visibility = $("#input-visible").val();

                if(regxp.test(inputValue)) {
                    _self.artics.actions.loadArtics(0, {ts: inputValue, titu: '', visible: visibility});

                } else {
                    _self.artics.actions.loadArtics(0, {ts: '', titu: inputValue, visible: visibility});
                }

                if (!notShowFilterRemove) {
                    $(_self.ui.selectors.panelRecentArtics + ' .button-elimina-filtros').removeClass("hidden");
                    _self.search.bindEliminaFiltros();
                }
            },
            bindSearchOptions: function () {
                $(".search-options #articles-order-by").on('change', function (e) {
                    e.preventDefault();
                    var orden = $(this).val();
                    if (orden == PortAdmin.search.ordenActual) {
                        // en chrome hacer click fuera del combo gatilla la búsqueda nuevamente, por lo que chequeamos que efectivamente haya cambiado el orden.
                        return false;
                    } else {
                        PortAdmin.search.ordenActual = orden;
                    }

                    $(this).attr('selected', 'selected');

                    _self.helper.setValueLS('_port_orden_lista', orden);
                    _self.artics.actions.loadArtics(0, {_orden_lista: orden});
                });

                $(".search-options .show-items a").click(function (e) {
                    e.preventDefault();
                    var num = $(this).attr("data-num");
                    if (num < 25) {
                        num = 25;
                    }

                    $(this).closest(".show-items").find("a").removeClass("active");
                    $(this).addClass("active");
                    _self.helper.setValueLS('_port_filas_x_pag', num);

                    _self.artics.actions.loadArtics(0, {_filas_x_pag: num});
                });
            }
        },
        // Preview de la portada.
        preview: {
            currentZoom: 80,
            actions: {
                generar: function () {
                    var data = {
                        _prontus_id: _self.vars.prontus_id,
                        _port: $(_self.ui.selectors.cmbPort).val(),
                        _edic: $(_self.ui.selectors.cmbEdic).val(),
                        _fecha_preview: $("input[name='preview_fecha']").val(),
                        _hora_preview: $("input[name='preview_hora']").val(),
                        _vista: $("select[name='preview_vista']").val()
                    };

                    $.each(_self.vars.articAreas, function (area, array) {
                        $.each(array, function (index, ts) {
                            data["_area_"  + ts] = area;
                            data["_orden_" + ts] = (index+1); // para no partir de cero.
                            data["_vb_" + ts]    = _self.vars.articAreaVB[ts];

                            if (_self.vars.articAreaCorruptos[ts]) {
                                data["_corrupt_" + ts] = 1;
                            }
                        });
                    });

                    $("#modal_preview").modal('show');

                    $("#modal_preview").on("show.bs.modal", function () {
                        $("#iframe_preview").attr("src", "about:blank");
                        $("#iframe_preview").hide();
                    });

                    $("#iframe_preview").on("load", function () {
                        $("#iframe_preview").show();
                        var zoom_factor = _self.preview.currentZoom / 100;
                        iframe_preview.document.body.style.zoom = zoom_factor;
                        var body = iframe_preview.document.body;
                        var html = iframe_preview.document.documentElement;
                        var h = Math.max(body.scrollHeight, body.offsetHeight, html.clientHeight, html.scrollHeight, html.offsetHeight);

                        $(this).height(h * zoom_factor);
                        $(this).show();
                    });

                    $("#modal_preview .loading").show();

                    $.ajax({
                        url: "/{0}/prontus_port_preview.cgi".format(Admin.dir_cgi_cpn),
                        type: 'POST',
                        dataType: 'json',
                        data: data,
                        success: function (response) {
                            // Carga contenido en el iframe.
                            $("#modal_preview .loading").hide();
                            $("#iframe_preview").hide().removeAttr("style").attr("src", response.msg);
                            _self.preview.bindPreviewButtons();
                        }
                    });
                }
            },
            bindPreviewButtons: function () {
                $("button[name='preview_zoom_in']").off("click").on("click", function () {
                    if (_self.preview.currentZoom >= 100) {
                        _self.preview.currentZoom = 100;
                        return;
                    }

                    _self.preview.currentZoom += 10;
                    var zoom_factor = _self.preview.currentZoom / 100;
                    iframe_preview.document.body.style.zoom = zoom_factor;
                });

                $("button[name='preview_zoom_out']").off("click").on("click", function () {
                    if (_self.preview.currentZoom <= 20) {
                        _self.preview.currentZoom = 20;
                        return;
                    }

                    _self.preview.currentZoom -= 10;
                    var zoom_factor = _self.preview.currentZoom / 100;
                    iframe_preview.document.body.style.zoom = zoom_factor;
                });

                $("button[name='preview_refresh']").off("click").on("click", function () {
                    _self.preview.actions.generar();
                });

                $("button[name='preview_newwin']").off("click").on("click", function () {
                    window.open($("#iframe_preview").attr("src"));
                });

                $("select[name='preview_vista']").off("change").on("change", function () {
                    _self.preview.actions.generar();
                });
            }
        },
        helper: {
            getHora: function(thetime, sinsegundos) {
                var date = new Date(thetime); // milisegundos.
                var h = date.getHours();

                h = (h <= 9 ? '0' + h : h);

                var m = date.getMinutes() + 1;
                m = (m <= 9 ? '0' + m : m);

                var s = date.getSeconds();
                s = (s <= 9 ? '0' + s : s);

                if (sinsegundos) {
                    return h + ':' + m;
                } else {
                    return h + ':' + m + ':' + s;
                }
            },
            setValueLS: function (name, value) {
                localStorage.setItem(name, value);
            },
            getValueLS: function (name) {
                return localStorage.getItem(name);
            },
            getFecha: function(thetime, human) {
                var date = new Date(thetime);
                var d = date.getDate();
                var m = date.getMonth();
                var y = date.getFullYear();
                var fecha;

                if (human) {
                    var arr = ProntusL10n.getMonths();
                    fecha = ProntusL10n.get('global_date_format', d, arr[m], y);

                } else {
                    d = (d <= 9 ? '0' + d : d);
                    m = m + 1;
                    m = (m <= 9 ? '0' + m : m);
                    fecha = d + '/' + m + '/' + y;
                }
                return fecha;
            },
            initLastMod: function (modtime) {
                _self.helper.setLastMod(modtime);
                clearInterval(_self.vars.lastModInterval);
                _self.vars.lastModInterval = setInterval(function () {
                    _self.helper.setLastMod(modtime);
                }, 5000);
            },
            setLastMod: function (modtime) {
                var str = ProntusL10n.get('portadmin_mod_no_info');

                if (modtime) {
                    var now = Date.now() /1000;

                    if (modtime > now) {
                        // La fecha de ahora es mas antigua
                        return;
                    }

                    var diff = now - modtime;
                    if (diff < 60) {
                        str = ProntusL10n.get('portadmin_mod_seconds_ago');
                    } else if(diff < 3600) {
                        diff = Math.round(diff/60);

                        if (diff == 1) {
                            str = ProntusL10n.get('portadmin_mod_minute_ago');
                        } else {
                            str = ProntusL10n.get('portadmin_mod_minutes_ago', diff);
                        }
                    } else {
                        var mod = new Date(modtime * 1000);
                        var fechamod = mod.getYear() + '-' + mod.getMonth() + '-' + mod.getDate();

                        var dnow = new Date();
                        var fechahoy = dnow.getYear() + '-' + dnow.getMonth() + '-' + dnow.getDate();

                        var dyesterday = new Date(dnow.getTime() - 86400000);
                        var fechaayer = dyesterday.getYear() + '-' + dyesterday.getMonth() + '-' + dyesterday.getDate();

                        var hora;
                        if (fechamod == fechahoy) {
                            hora = _self.helper.getHora(modtime, true);
                            str = ProntusL10n.get('portadmin_mod_today', hora);
                        } else if(fechamod == fechaayer) {
                            hora = _self.helper.getHora(modtime, true);
                            str = ProntusL10n.get('portadmin_mod_yesterday', hora);
                        } else {
                            var fecha = _self.helper.getFecha(modtime * 1000, true);
                            str = ProntusL10n.get('portadmin_mod_date', fecha);
                        }
                    }
                }

                $(_self.ui.selectors.lastMod).text(str);
            },
            showLoadingModal: function() {
                $('#modal-loading-mensaje').html(ProntusL10n.get('portadmin_loading_port'));
                $('#modal-loading').modal({backdrop: 'static', keyboard: false});
            },
            hideLoadingModal: function() {
                $('#modal-loading').modal('hide');
            },
            breakString: function (string, size) {
                var aux = '';
                while ( string.length > 0 ) {
                    var index = string.indexOf(' ');
                    if (index < 0 && string.length > size || index > size) {
                        aux = aux + string.substring(0, size) + '- ';
                        string = string.substring(size);
                    } else if (index < 0) {
                        aux = aux + string.substring(0, string.length);
                        string = '';
                    } else {
                        index++;
                        aux = aux + string.substring(0, index);
                        string = string.substring(index);
                    }
                }
                return aux;
            }
        }
    };

    window.PortAdmin = PortAdmin;
})(window);

$(document).ready(function () {
    // mostramos un modal para evitar que el usuario intente modificar datos mientras carga la portada.
    // este modal se cierra al final de artics.actions.init()
    PortAdmin.helper.showLoadingModal();

    PortAdmin.init();
});
