var SubmitForm = {
    // -------------------------------------------------------------------
    submitGenericAjax: function (config, opts) {
        // Requiere jquery.form.js
        // https://github.com/jquery-form/form

        if ((typeof config.formSelector === 'undefined')) {
            return;
        }

        if ((typeof config.actionURL === 'undefined')) {
            config.actionURL = $(config.formSelector).attr('action');
        }

        // Url a la que se debe redireccionar de vuelta del post, opcional
        config.redirURL = (typeof config.redirURL === 'undefined') ? '' : config.redirURL;

        // Msg de confirmacion, opcional
        config.okMsg = (typeof config.okMsg == 'undefined') ? '' : config.okMsg;

        // Peticion ajax
        var options = {
            url: config.actionURL,         // override for form's 'action' attribute
            dataType: 'json',        // 'xml', 'script', or 'json' (expected server response type)
            complete: function () {
                //alert('complete interno... ');
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                SubmitForm.handleError(config.actionURL, XMLHttpRequest, textStatus, errorThrown);
            },
            success: function (json, statusText) {   // post-submit callback
                if (json.status == '0') {
                    showModalAlert({
                        title: ProntusL10n.get('global_error_title'),
                        type: 'red',
                        msg: unescape(json.msg)
                    });
                } else {
                    if (config.okMsg !== '') {
                        showModalAlert({
                            title: 'Éxito',
                            type: 'green',
                            msg: config.okMsg
                        });
                    }
                    // Si se seteo una url dsde la cgi (debe venir con urlencode()!!), direcciona a ella
                    // Sino, ve si se seteo una por js y direcciona a ella
                    var redirURLFromServer = (typeof json.redirURL === 'undefined') ? '' : json.redirURL;
                    redirURLFromServer = unescape(redirURLFromServer);
                    if (redirURLFromServer !== '') {
                        window.location.href = redirURLFromServer;
                    } else if (config.redirURL == '_self') {
                        window.location.reload();
                    } else if (config.redirURL !== '') {
                        window.location.href = config.redirURL;
                    }
                }
                return false;
            } // success
        }; // options

        if (typeof opts != 'undefined') {
            $.extend(options, opts);
        }
        $(config.formSelector).ajaxSubmit(options);
    },

    // -------------------------------------------------------------------
    handleError: function (url, XMLHttpRequest, textStatus, errorThrown) {
        var msg = "URL invocada: " + url + "\ntextStatus: " + textStatus +
            "\nerrorThrown: " + errorThrown + "\nXMLHttpRequest.status: " +
            XMLHttpRequest.status + "-" + XMLHttpRequest.statusText +
            "\nXMLHttpRequest.responseText: " + XMLHttpRequest.responseText +
            "\nResponseHeaders: " + XMLHttpRequest.getAllResponseHeaders();

        showModalAlert({
            type: "red",
            title: ProntusL10n.get('admin_request_error'),
            icon: "glyphicon glyphicon-exclamation-sign",
            msg: '<pre>' + msg + '</pre>',
            cbBtnOK: function () {
            }
        });
    }
};
