// -----------------------------------------------------------------------------
// Objeto que sirve para la transcodificación
function crearInstanciaTranscoding(id, $container, tipo) {
    var _self;
    var TranscodingObject = {
        id: id,
        container: $container,
        tipo: tipo,
        player: null,
        panelStatus: '#panelStatus',
        s3: 0,
        hiddLabel: '_hidd_',

        dirCgi: '/xcoding/',
        cgiCode: 'prontus_videoxcode.cgi',
        cgiStatus: 'prontus_videoxcodestatus.cgi',
        cgiSnap: 'prontus_videogetsnapshot.cgi',
        cgiCut: 'prontus_videocut.cgi',
        cgiQt: 'prontus_qtfaststart_check.cgi',
        cgiCheckAudio: 'prontus_audio_check.cgi',
        cgiStatusAudio: 'prontus_audio_xcode_status.cgi',
        cgiCodeAudio: 'prontus_audio_xcode.cgi',
        cgiDownload: 'prontus_s3_download.cgi',
        cgiDownloadCheck: 'prontus_s3_download_check.cgi',

        videoExtension: '.mp4',
        audioExtension: '.mp3',
        imageExtension: '.jpg',

        timeStatus: 2000,
        linkMedia: '',
        linkExt: '',
        linkImagen: '',
        linkImagenB: '',
        transcoding: false,

        begin: function () {
            _self = this;
            return this;
        },
        // -------------------------------------------------------------------------
        init: function () {
            _self.panelStatus = _self.panelStatus + '_m' + _self.tipo + _self.id;
            _self.s3 = $(_self.container).find('.multimedia-container .multimedia-filename .s3').val();
            if (_self.tipo == 'video') {
                _self.checkVideosFid();
            } else {
                _self.checkAudiosFid();
            }

            return this;
        },
        // -------------------------------------------------------------------------
        bindEvents: function () {
            // Botones fid
            $(_self.container).find('.button-get_screenshot').click(function() {
                _self.generaScreenshot();
                return false;
            });
            $(_self.container).find('.button-marker_A').click(function() {
                _self.player.callbacks.setMarkerA();
                return false;
            });
            $(_self.container).find('.button-marker_B').click(function() {
                _self.player.callbacks.setMarkerB();
                return false;
            });
            $(_self.container).find('.button-cut_selection').click(function() {
                _self.cortarVideo();
                return false;
            });
            if (_self.s3 == 1) {
                $(_self.container).find('.button-download-video').click(function() {
                    _self.downloadVideoFromCloud();
                    return false;
                });
            }
            Multimedia.upload.actions.setupCCUpload($(_self.container).find('.add_video_cc')[0]);
        },
        // -------------------------------------------------------------------------
        downloadVideoFromCloud: function () {
            $.ajax({
                url: '/' + Admin.dir_cgi_cpn + '/' + _self.cgiDownload,
                type: "post",
                dataType: 'json',
                data: {
                    marca: $(_self.container).find('.multimedia-container').data('name'),
                    ts: mainFidJs.TS,
                    prontus_id: Admin.prontus_id
                },
                success: function (data) {
                    console.log(data);
                    if (typeof data !== 'undefined' && typeof data.status !== 'undefined') {
                        if (data.status == '1') {
                            Msg.setStatusMessage(ProntusL10n.get('transcod_download_videos'), _self.panelStatus);
                            setTimeout(function () {
                                _self.checkDownloadVideo();
                            }, 1000);

                        } else {
                            Msg.setAlertMessage(ProntusL10n.get('transcod_error_start') + data.msg, _self.panelStatus);
                        }
                    } else {
                        Msg.setAlertMessage(ProntusL10n.get('transcod_critical_error_start') + data, _self.panelStatus);
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    Msg.setAlertMessage(ProntusL10n.get('transcod_error_processing') + textStatus, _self.panelStatus);
                }
            });
        },
        // -------------------------------------------------------------------------
        checkDownloadVideo: function () {
            $.ajax({
                url: '/' + Admin.dir_cgi_cpn + '/' + _self.cgiDownloadCheck,
                type: "post",
                dataType: 'json',
                data: {
                    marca: $(_self.container).find('.multimedia-container').data('name'),
                    ts: mainFidJs.TS,
                    prontus_id: Admin.prontus_id
                },
                success: function (data) {
                    if (typeof data !== 'undefined' && typeof data.status !== 'undefined') {
                        if (data.status == '1') {
                            if (data.msg == 'BUSY') {
                                Msg.setStatusMessage(ProntusL10n.get('transcod_download_videos'), _self.panelStatus);
                                setTimeout(function () {
                                    _self.checkDownloadVideo();
                                }, 2000);
                            } else if (data.msg == 'OK') {
                                Msg.setInfoMessage(ProntusL10n.get('transcod_download_complete'), _self.panelStatus);
                                _self.s3 = 0;
                                $(_self.container).find('.multimedia-container .multimedia-filename .s3').val('');
                                $('.video-actions'+ id).show();
                                $(_self.container).find('.button-download-video').hide();
                                _self.loadVideoPlayer();
                            } else if (data.msg == 'ERROR') {
                                Msg.setAlertMessage(ProntusL10n.get('transcod_error_process') + data.msg, _self.panelStatus);
                            }
                        } else {
                            Msg.setAlertMessage(ProntusL10n.get('transcod_error_process') + data.msg, _self.panelStatus);
                        }
                    } else {
                        Msg.setAlertMessage(ProntusL10n.get('transcod_critical_error_start') + data, _self.panelStatus);
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    Msg.setAlertMessage(ProntusL10n.get('transcod_error_processing') + textStatus, _self.panelStatus);
                }
            });
        },
        // -------------------------------------------------------------------------
        checkAudiosFid: function() {
            _self.linkMedia = $(_self.container).find('.multimedia-audio .multimedia-filename a:first').attr("href");
            if (_self.linkMedia == undefined) {
                return;
            }
            _self.linkExt = _self.linkMedia.substr(_self.linkMedia.lastIndexOf('.'));
            _self.player = Multimedia.installPlayerAudio(0, $(_self.container).find('.multimedia-audio')[0]);

            if (_self.s3 == 1) {
                _self.loadAudioPlayer();
                return;
            }

            if (_self.linkExt !== '.mp3') {
                Msg.setStatusMessage(ProntusL10n.get('transcod_check_audio_status'), _self.panelStatus);
                _self.checkStatusAudio();
            } else {
                _self.checkMp3();
            }

        },
        // -------------------------------------------------------------------------
        checkVideosFid: function() {
            _self.linkMedia = $(_self.container).find('.multimedia-video .multimedia-filename a:first').attr("href");
            if (_self.linkMedia == undefined) {
                return;
            }
            _self.linkExt = _self.linkMedia.substr(_self.linkMedia.lastIndexOf('.'));
            _self.linkImagen = _self.linkMedia.substr(0, _self.linkMedia.lastIndexOf('.')) + _self.imageExtension;

            var nameImg = _self.linkImagen.substr(_self.linkImagen.lastIndexOf('/') + 1);
            _self.linkImagenB = '/' + Admin.prontus_id + '/cpan/procs/imgedit/' + nameImg;

            _self.player = crearInstanciaPlayer(id, $container, _self.linkMedia);
            _self.player.clearPlayer();

            if (_self.s3 == 1) {
                $('.video-actions'+ id).hide();
                $('.download-video'+ id).show();
                _self.loadVideoPlayer();
                return;
            }

            if (_self.linkExt !== _self.videoExtension) {
                Msg.setStatusMessage(ProntusL10n.get('transcod_check_status'), _self.panelStatus);
                _self.checkStatus();
            } else {
                _self.checkMp4();
            }

        },
        // -------------------------------------------------------------------------
        checkMp3: function () {
            $.ajax({
                url: '/' + Admin.dir_cgi_cpn + _self.dirCgi + _self.cgiCheckAudio,
                type: "post",
                dataType: 'json',
                data: {
                    audio: _self.linkMedia,
                    prontus_id: Admin.prontus_id
                },
                success: function (data) {
                    if (typeof data !== 'undefined' && typeof data.status !== 'undefined') {
                        if (data.status == '1') {
                            if (data.msg == 'OK') {
                                Msg.setInfoMessage(ProntusL10n.get('transcod_set_audio'), _self.panelStatus);
                                setTimeout(function () {
                                    _self.loadAudioPlayer();
                                }, 250);
                            } else if (data.msg == 'XCODING') {
                                _self.checkStatusAudio();
                            } else if (data.msg == 'RECODE') {
                                Msg.setStatusMessage(ProntusL10n.get('transcod_high_bitrate_audio'), _self.panelStatus);
                                _self.procesarAudio();
                            } else {
                                Msg.setAlertMessage(ProntusL10n.get('transcod_invalid_response'), _self.panelStatus);
                            }
                        } else {
                            Msg.setAlertMessage(ProntusL10n.get('transcod_error_check_audio') + data.msg, _self.panelStatus);
                        }
                    } else {
                        Msg.setAlertMessage(ProntusL10n.get('transcod_critical_error_audio') + data, _self.panelStatus);
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    Msg.setAlertMessage(ProntusL10n.get('transcod_error_processing') + textStatus, _self.panelStatus);
                }
            });
        },
        // -------------------------------------------------------------------------
        checkMp4: function () {
            $.ajax({
                url: '/' + Admin.dir_cgi_cpn + _self.dirCgi + _self.cgiQt,
                type: "post",
                dataType: 'json',
                data: {
                    video: _self.linkMedia,
                    prontus_id: Admin.prontus_id
                },
                success: function (data) {
                    if (typeof data !== 'undefined' && typeof data.status !== 'undefined') {
                        if (data.status == '1') {
                            if (data.msg == 'FIX' || data.msg == 'Busy') {
                                Msg.setStatusMessage(ProntusL10n.get('transcod_set_video_wait'), _self.panelStatus);
                                setTimeout(function () {
                                    _self.checkMp4();
                                }, _self.timeStatus);
                            } else if (data.msg == 'OK') {
                                Msg.setInfoMessage(ProntusL10n.get('transcod_set_video'), _self.panelStatus);
                                setTimeout(function () {
                                    _self.loadVideoPlayer();
                                }, 250);
                            } else if (data.msg == 'XCODE') {
                                Msg.setStatusMessage(ProntusL10n.get('transcod_generate_versions'), _self.panelStatus);
                                _self.procesarVideo(1);
                            } else if (data.msg == 'Xcoding') {
                                _self.checkStatus();
                            } else if (data.msg == 'RECODE') {
                                Msg.setStatusMessage(ProntusL10n.get('transcod_high_bitrate_video'), _self.panelStatus);
                                _self.procesarVideo();
                            } else {
                                Msg.setAlertMessage(ProntusL10n.get('transcod_invalid_response'), _self.panelStatus);
                            }
                        } else {
                            Msg.setAlertMessage(ProntusL10n.get('transcod_error_set_video') + data.msg, _self.panelStatus);
                        }
                    } else {
                        Msg.setAlertMessage(ProntusL10n.get('transcod_critical_error_video') + data, _self.panelStatus);
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    Msg.setAlertMessage(ProntusL10n.get('transcod_error_processing') + textStatus, _self.panelStatus);
                }
            });
        },
        // -------------------------------------------------------------------------
        checkStatusAudio: function () {
            $.ajax({
                url: '/' + Admin.dir_cgi_cpn + _self.dirCgi + _self.cgiStatusAudio,
                type: "post",
                dataType: 'json',
                data: {
                    audio: _self.linkMedia,
                    prontus_id: Admin.prontus_id
                },
                success: function (data) {
                    if (typeof data !== 'undefined' && typeof data.status !== 'undefined') {
                        if (data.status == '1') {
                            if (data.msg == 'none') {
                                Msg.setStatusMessage(ProntusL10n.get('transcod_process_audio'), _self.panelStatus);
                                _self.procesarAudio();
                            } else if (data.msg == 'busy') {
                                _self.transcoding = true;
                                Msg.setStatusMessage(ProntusL10n.get('transcod_process_audio'), _self.panelStatus);
                                setTimeout(function () {
                                    _self.checkStatusAudio();
                                }, _self.timeStatus);

                            } else if (data.msg == 'ready') {
                                _self.transcoding = false;
                                Msg.setInfoMessage(ProntusL10n.get('transcod_converted_audio'), _self.panelStatus);
                                setTimeout(function () {
                                    _self.updateFileSize();
                                    _self.loadAudioPlayer();
                                }, 250);
                            }
                        } else {
                            if (data.msg != '') {
                                Msg.setAlertMessage(ProntusL10n.get('transcod_error_occurred') + data.msg, _self.panelStatus);
                            } else {
                                Msg.setAlertMessage(ProntusL10n.get('transcod_invalid_response'), _self.panelStatus);
                            }
                        }
                    } else {
                        Msg.setAlertMessage(ProntusL10n.get('transcod_invalid_response'), _self.panelStatus);
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    Msg.setAlertMessage(ProntusL10n.get('transcod_error_processing') + textStatus, _self.panelStatus);
                }
            });
        },
        // -------------------------------------------------------------------------
        checkStatus: function () {
            $.ajax({
                url: '/' + Admin.dir_cgi_cpn + _self.dirCgi + _self.cgiStatus,
                type: "post",
                dataType: 'json',
                data: {
                    video: _self.linkMedia,
                    prontus_id: Admin.prontus_id
                },
                success: function (data) {
                    if (typeof data !== 'undefined' && typeof data.status !== 'undefined') {
                        if (data.status == '1') {
                            if (data.msg == 'none') {
                                Msg.setStatusMessage(ProntusL10n.get('transcod_process_video'), _self.panelStatus);
                                _self.procesarVideo();
                            } else if (data.msg == 'busy') {
                                _self.transcoding = true;
                                Msg.setStatusMessage(ProntusL10n.get('transcod_process_video'), _self.panelStatus);
                                setTimeout(function () {
                                    _self.checkStatus();
                                }, _self.timeStatus);

                            } else if (data.msg == 'ready') {
                                _self.transcoding = false;
                                Msg.setInfoMessage(ProntusL10n.get('transcod_converted_video'), _self.panelStatus);
                                setTimeout(function () {
                                    _self.loadVideoPlayer();
                                }, 250);
                            }
                        } else {
                            if (data.msg != '') {
                                Msg.setAlertMessage(ProntusL10n.get('transcod_error_occurred') + data.msg, _self.panelStatus);
                            } else {
                                Msg.setAlertMessage(ProntusL10n.get('transcod_invalid_response'), _self.panelStatus);
                            }
                        }
                    } else {
                        Msg.setAlertMessage(ProntusL10n.get('transcod_invalid_response'), _self.panelStatus);
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    Msg.setAlertMessage(ProntusL10n.get('transcod_error_processing') + textStatus, _self.panelStatus);
                }
            });
        },
        // -------------------------------------------------------------------------
        updateFileSize: function () {
            let marca = 'multimedia_' + _self.tipo + _self.id;
            $.ajax({
                url: '/' + Admin.dir_cgi_cpn + '/prontus_art_get_data.cgi',
                type: 'get',
                dataType: 'json',
                data: {
                    _prontus_id: Admin.prontus_id,
                    _ts: mainFidJs.TS,
                    _campo: marca + '.bytes,' + marca + '.total'
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    //console.log(XMLHttpRequest, textStatus, errorThrown)
                },
                success: function (resp, textStatus) {
                    let container = $(_self.container).find('.multimedia-' + _self.tipo +' .multimedia-filename');
                    container.find('.bytes').val(resp['artics'][mainFidJs.TS][marca + '.bytes']);
                    container.find('.total').val(resp['artics'][mainFidJs.TS][marca + '.total']);
                }
            });
        },
        // -------------------------------------------------------------------------
        procesarAudio: function () {
            $.ajax({
                url: '/' + Admin.dir_cgi_cpn + _self.dirCgi + _self.cgiCodeAudio,
                type: "post",
                dataType: 'json',
                data: {
                    audio: _self.linkMedia,
                    prontus_id: Admin.prontus_id
                },
                success: function (resp) {
                    if (typeof resp !== 'undefined' && typeof resp.status !== 'undefined') {
                        if (resp.status == '1') {
                            Msg.setStatusMessage(ProntusL10n.get('transcod_process_audio'), _self.panelStatus);
                            _self.transcoding = true;
                            setTimeout(function () {
                                _self.checkStatusAudio();
                            }, _self.timeStatus);

                        } else {
                            Msg.setAlertMessage(ProntusL10n.get('transcod_audio_conversion') + resp.msg, _self.panelStatus);
                        }

                    } else {
                        Msg.setAlertMessage(ProntusL10n.get('transcod_critical_audio_conversion'), _self.panelStatus);
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    Msg.setAlertMessage(ProntusL10n.get('transcod_error_response') + textStatus, _self.panelStatus);
                }
            });
        },
        // -------------------------------------------------------------------------
        procesarVideo: function (generar_versiones) {
            var opciones = {
                video: _self.linkMedia,
                prontus_id: Admin.prontus_id,
                generar_versiones: 0
            };

            if (typeof generar_versiones != 'undefined') {
                opciones.generar_versiones = 1;
            }

            $.ajax({
                url: '/' + Admin.dir_cgi_cpn + _self.dirCgi + _self.cgiCode,
                type: "post",
                dataType: 'json',
                data: opciones,
                success: function (resp) {
                    if (typeof resp !== 'undefined' && typeof resp.status !== 'undefined') {
                        if (resp.status == '1') {
                            Msg.setStatusMessage(ProntusL10n.get('transcod_process_video'), _self.panelStatus);
                            _self.transcoding = true;
                            setTimeout(function () {
                                _self.checkStatus();
                            }, _self.timeStatus);

                        } else {
                            Msg.setAlertMessage(ProntusL10n.get('transcod_video_conversion') + resp.msg, _self.panelStatus);
                        }

                    } else {
                        Msg.setAlertMessage(ProntusL10n.get('transcod_critical_video_conversion'), _self.panelStatus);
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    Msg.setAlertMessage(ProntusL10n.get('transcod_error_response') + textStatus, _self.panelStatus);
                }
            });
        },
        // -------------------------------------------------------------------------
        loadAudioPlayer: function () {
            if (_self.linkExt !== _self.audioExtension) {
                _self.linkMedia = _self.linkMedia.substr(0, _self.linkMedia.lastIndexOf('.')) + _self.audioExtension;
                _self.linkExt = _self.linkMedia.substr(_self.linkMedia.lastIndexOf('.'));
                $(_self.container).find('.multimedia-audio .multimedia-filename a:first').attr('href', _self.linkMedia);

                var nameAudio = _self.linkMedia;
                nameAudio = nameAudio.substr(_self.linkMedia.lastIndexOf('/') + 1);
                $(_self.container).find('.multimedia-audio .multimedia-filename input[name^="'+ _self.hiddLabel+'"]').val(nameAudio);
                $(_self.container).find('.multimedia-audio .multimedia-filename a:first').html(nameAudio);
            }

            $(_self.container).find('.panel-audio-player').show();

            _self.player = Multimedia.installPlayerAudio(0, $(_self.container).find('.multimedia-audio')[0]);
            if (_self.player != null) {
                _self.player.config.mediaSrc.defaultSrc = _self.linkMedia + '?_'+ Date.now();
                _self.player.initPlayer();
            }
        },
        // -------------------------------------------------------------------------
        loadVideoPlayer: function () {
            if (_self.player == null) {
                return;
            }
            if (_self.linkExt !== _self.videoExtension) {
                _self.linkMedia = _self.linkMedia.substr(0, _self.linkMedia.lastIndexOf('.')) + _self.videoExtension;
                _self.linkExt = _self.linkMedia.substr(_self.linkMedia.lastIndexOf('.'));
                $(_self.container).find('.multimedia-video .multimedia-filename a:first').attr('href', _self.linkMedia);

                var nameVideo = _self.linkMedia;
                nameVideo = nameVideo.substr(_self.linkMedia.lastIndexOf('/') + 1);
                $(_self.container).find('.multimedia-video .multimedia-filename input[name^="'+ _self.hiddLabel+'"]').val(nameVideo);
                $(_self.container).find('.multimedia-video .multimedia-filename a:first').html(nameVideo);
            }
            $(_self.container).find('.panel-xcode').show();
            _self.player.init(_self.linkMedia);
            _self.bindEvents();
        },
        // -------------------------------------------------------------------------
        generaScreenshot: function () {
            try {
                Msg.setStatusMessage('Generando la captura', _self.panelStatus);
                var time = _self.player.callbacks.getPlayPoint();

                if (typeof time === 'undefined') {
                    if (_self.transcoding === true) {
                        Msg.setAlertMessage(ProntusL10n.get('transcod_wait_extract'), _self.panelStatus);

                    } else if (_self.linkMedia === '') {
                        Msg.setAlertMessage(ProntusL10n.get('transcod_load_video'), _self.panelStatus);

                    } else {
                        Msg.setAlertMessage(ProntusL10n.get('transcod_not_read_time'), _self.panelStatus);
                    }
                } else {
                    $.ajax({
                        url: '/' + Admin.dir_cgi_cpn + _self.dirCgi + _self.cgiSnap,
                        type: "post",
                        data: {
                            t: time,
                            video: _self.linkMedia,
                            prontus_id: Admin.prontus_id
                        },
                        success: function (data) {
                            if (data.status) {
                                Msg.setInfoMessage(ProntusL10n.get('transcod_capture_finish'), _self.panelStatus);
                                // screenshot no se considera original ya que se extrae de un video
                                MediaManager.actions.uploadImg('multimedia_video' + _self.id, _self.linkImagenB, 'screenshot', 0);
                            } else {
                                Msg.setAlertMessage(ProntusL10n.get('transcod_capture_error') + data.msg, _self.panelStatus);
                            }
                        },
                        error: function(XMLHttpRequest, textStatus, errorThrown) {
                            Msg.setAlertMessage(ProntusL10n.get('transcod_capture_error') + textStatus, _self.panelStatus);
                        }

                    });
                }
            } catch (e) {
                Msg.setAlertMessage(ProntusL10n.get('transcod_capture_error') + e, _self.panelStatus);
            }
        },
        // -------------------------------------------------------------------------
        cortarVideo: function () {
            try {
                Msg.setStatusMessage(ProntusL10n.get('transcod_cut_video'), _self.panelStatus);
                var marcas = _self.player.callbacks.getMarkers();

                if (typeof marcas === 'undefined') {

                    if (_self.transcoding === true) {
                        Msg.setAlertMessage(ProntusL10n.get('transcod_wait_conversion_video'), _self.panelStatus);

                    } else if (_self.linkMedia === '') {
                        Msg.setAlertMessage(ProntusL10n.get('transcod_load_video_edit'), _self.panelStatus);

                    } else {
                        Msg.setAlertMessage(ProntusL10n.get('transcod_not_marks_cut'), _self.panelStatus);
                    }
                } else {

                    if (marcas.length !== 2) {
                        Msg.setAlertMessage(ProntusL10n.get('transcod_invalid_marks'), _self.panelStatus);
                        return;
                    }
                    if (marcas[0] === 0 && marcas[1] === 0) {
                        Msg.setAlertMessage(ProntusL10n.get('transcod_enter_marks'), _self.panelStatus);
                        return;
                    }

                    $.ajax({
                        url: '/' + Admin.dir_cgi_cpn + _self.dirCgi + _self.cgiCut,
                        type: "post",
                        data: {
                            t1: marcas[0],
                            t2: marcas[1],
                            video: _self.linkMedia,
                            prontus_id: Admin.prontus_id
                        },
                        success: function (response) {
                            if (response.status == 1) {
                                Msg.setInfoMessage(ProntusL10n.get('transcod_cut_video_success'), _self.panelStatus);
                                _self.checkVideosFid();
                            } else {
                                Msg.setAlertMessage(ProntusL10n.get('transcod_cut_video_error') + response.msg, _self.panelStatus);
                            }
                        },
                        error: function(XMLHttpRequest, textStatus, errorThrown) {
                            Msg.setAlertMessage(ProntusL10n.get('transcod_cut_video_error') + textStatus, _self.panelStatus);
                        }
                    });
                }
            } catch (e) {
                Msg.setAlertMessage(ProntusL10n.get('transcod_cut_video_error') + e, _self.panelStatus);
            }
        }
    };

    return TranscodingObject.begin();
}

// Inicializador de instancias.
var Transcoding = {
    instanciasXcode: {},
    init: function () {
        Transcoding.generarInstancias();
    },
    // -------------------------------------------------------------------------
    recargarInstancia: function (id, tipo) {
        Transcoding.instanciasXcode[id+tipo] = crearInstanciaTranscoding(id, $('.xcoding-container-' + tipo + '[data-id="' + id + '"]'), tipo);
        Transcoding.instanciasXcode[id+tipo].init();
    },
    // -------------------------------------------------------------------------
    generarInstancias: function () {
        $('.xcoding-container-video').each(function () {
            var tipo = 'video';
            var id = $(this).attr("data-id");
            if (typeof Transcoding.instanciasXcode[id+tipo] == 'undefined') {
                Transcoding.instanciasXcode[id+tipo] = crearInstanciaTranscoding(id, $(this), tipo);
                Transcoding.instanciasXcode[id+tipo].init();
            }
        });

        $('.xcoding-container-audio').each(function () {
            var tipo = 'audio';
            var id = $(this).attr("data-id");
            if (typeof Transcoding.instanciasXcode[id+tipo] == 'undefined') {
                Transcoding.instanciasXcode[id+tipo] = crearInstanciaTranscoding(id, $(this), tipo);
                Transcoding.instanciasXcode[id+tipo].init();
            }
        });
    }
};

// -----------------------------------------------------------------------------
//  Objeto encargado de mostrar los mensajes
var Msg = {
    // Funciones para los Estados y Mensajes
    setInfoMessage: function (msg, panelStatus) {
        $(panelStatus).html('<div><span class="glyphicon glyphicon-ok icon-btn ok"></span>  ' + msg + '</div>');
    },
    setStatusMessage: function (msg, panelStatus) {
        var img = '<img src="/prontus/cpan/imag/loader/gears.svg" alt="' + ProntusL10n.get('global_load') + '" width="32" height="32" />';
        $(panelStatus).html( ' <div>' + img + '  ' + msg + '</div>');
    },
    setAlertMessage: function (msg, panelStatus) {
        $(panelStatus).html('<div><span class="glyphicon glyphicon-remove icon-btn nok"></span>  ' + msg + '</div>');
    }
};

var PlayerEmbedConfig = {};
