let s3_browser = {
    reloadList: 0,
    init: function (path) {
        let elem = document.getElementById('filemanager');
        let initpath = [
            [ Admin.prontus_id, Admin.prontus_id, { canmodify: false } ]
        ];

        if (path) {
            let parts = path.split("/");

            parts.forEach(function (item) {
                initpath.push([item, item]);
            });
        }

        let options = {
            initpath: initpath,
            onrefresh: function(folder, required) {
                let path = folder.GetPathIDs().join("/");
                let $this = this;
                let xhr = new this.PrepareXHR({
                    url: '/cgi-cpn/prontus_s3_list.cgi',
                    params: {
                        _prontus_id: Admin.prontus_id,
                        path: path,
                        reload: s3_browser.reloadList
                    },
                    onsuccess: function(e) {
                        var data = JSON.parse(e.target.response);
                        s3_browser.reloadList = 0;

                        if (data.status == 1) {
                            folder.SetEntries(data.data);
                        } else {
                            folder.SetEntries([]);
                            $this.SetNamedStatusBarText('folder', ProntusL10n.get('s3_browser_folder_not_loaded'));
                        }

                    },
                    onerror: function(e) {
                    }
                });

                xhr.Send();
            },
            onopenfile: function (_folder, entry) {
                // console.log("onopenfile", folder.GetPath(), entry);

                if (entry.ext == "pdf" || entry.ext == "jpg" || entry.ext == "jpeg" || entry.ext == "png" || entry.ext == "svg") {
                    $("#previewIframe").attr("src", entry.path);
                    $("#modalPreview").modal("show");
                } else if (entry.ext == "mp4") {
                    $("#modalPreviewVideo").modal("show");

                    $("#modalPreviewVideo").off("shown.bs.modal").on("shown.bs.modal", function (e) {
                        let html = $("#pplpayer").html();

                        $("#modalPreviewVideoContenido").html(html);

                        prontusPlayer5.install({
                            videoTagId: "video-pp",
                            video: {
                                autoplay: true,
                                muted: true,
                                src: entry.path,
                            }
                        });
                    });

                    $("#modalPreviewVideo").off("hide.bs.modal").on("hide.bs.modal", function (e) {
                        prontusPlayer5.destroy("video-pp");
                    });
                }
            },
            langmap: {
                "Download": ProntusL10n.get('s3_browser_download'),
                "Delete": ProntusL10n.get('global_delete_label'),
                "Loading...": ProntusL10n.get('global_load') + '...',
                "{0} items": ProntusL10n.get('s3_browser_item', '{0}'),
                "{0} items selected {1}": ProntusL10n.get('s3_browser_items_selected', '{0}'),
                "1 item selected {0}": ProntusL10n.get('s3_browser_one_item_selected', '{0}'),
                "{0} items selected": ProntusL10n.get('s3_browser_select_elements', '{0}'),
                "1 item selected": ProntusL10n.get('s3_browser_one_selected'),
                "This folder is empty.": ProntusL10n.get('s3_browser_empty_folder'),
                "Back (Alt + Left Arrow)": ProntusL10n.get('s3_browser_back'),
                "Back to \"{0}\" (Alt + Left Arrow)": ProntusL10n.get('s3_browser_back_to', '{0}'),
                "Forward (Alt + Right Arrow)": ProntusL10n.get('s3_browser_forward'),
                "Forward to \"{0}\" (Alt + Right Arrow)": ProntusL10n.get('s3_browser_forward_to', '{0}'),
                "Up (Alt + Up Arrow)": ProntusL10n.get('s3_browser_up'),
                "Up to \"{0}\" (Alt + Up Arrow)": ProntusL10n.get('s3_browser_up_to', '{0}'),
                "1 item": ProntusL10n.get('s3_browser_one_item'),
                "Recent locations": ProntusL10n.get('s3_browser_recent_locations')
            }
        };

        let fe = new window.FileExplorer(elem, options);

        $("#feRefresh").off("click").on("click", function (e) {
            e.preventDefault();

            s3_browser.reloadList = 1;
            fe.RefreshFolders(true);
        });
    }
};
