<?php
define('PRONTUS', true);
/**
 * Author: EGL <egarcia.usm@gmail.com> & CVI <cvasquez@altavoz.net>
 * Historial:
 *  2009-01-26 - EGL - Primera Versión
 *  2009-01-26 - CVI - Correcciones y Optimizaciones
 *  2014-03-25 - CVI - Nueva versión para trabajar con la Prontus Function
 *  2014-09-05 - EAG - Modifica para carga de videos pesados a youtube, se modifica el logeo para que sea mas util
 *  2014-11-18 - EAG - Corrige bug de cargas duplicadas, ya que es una pf se abre varias veces el proceso,
 *                     se agrega creacion de xml al inicio, y se agrega chequeo de estado en lib_custom
 *  2018-07-25 - AVP - Implementa en Prontus 12 con muchos cambios, aprovechando el trabajo de SCT de port a la API nueva.
 */

/**
 * @param $argv[1] valor de ts (id elementos de un artículo)
 * @param $argv[2] prontus_id que hace el llamado
 * @param $argv[3] ruta al video (luego se subirlo, se borrará)
 * @param $argv[4] ruta a la carpeta del script (usado para almacenar el log de archivos subidos. (modificable a libertad))
 **/

if (sizeof($argv) < 2) {
    exit;
}

$input = array();
$input['ts']            = $argv[1];
$input['prontus_id']    = $argv[2];
$input['ruta_video']    = $argv[3];

//se define nombre del modulo para el logeo
define('MODULOLOG', 'youtube_status');

require_once('config.php');
require_once('Utiles.class.php');
require_once('PostingYoutube.class.php');
set_include_path($CONFIG_YOUTUBE['DOCUMENT_ROOT']. '/prontus/cpan/youtube_post/google-api-php-client-2.2.2_PHP54/vendor/');
require_once 'autoload.php';

// se definen los ticks para poder capturar las senales
declare(ticks = 1);

//se define para los mensajes de log
define('TSART', $input['ts']);

//registramos el garbage del cierre
register_shutdown_function('garbage');
//registramos una funcion para capturar por si se cierra el script con kill
pcntl_signal(SIGINT, 'sigint');
pcntl_signal(SIGTERM, 'sigint');
$utiles = new Utiles($CONFIG_YOUTUBE);

$input['ruta_xml']      = $utiles->getRutaXml($input['prontus_id'], $input['ts']);
$input['ruta_youtube']  = $utiles->getRutaYoutube($input['prontus_id']);
$video_final = "";

$postingYoutube = new PostingYoutube($CONFIG_YOUTUBE);

$video_final = $postingYoutube->publish($input);
print $video_final;

// Funciones del script
/* funcion de garbage para ejecutar al salir */
function garbage() {
    global $input;
    global $utiles;
    // Se elimina el video, ya que es una copia
    if(is_file($input['ruta_video'])) {
        $utiles->printErrorLog("Borrando archivo temporal ". $input['ruta_video'], 'debug');
        unlink($input['ruta_video']);
    }
}

/* funcion al ejecutar kill */
function sigint($signal) {
    global $utiles;
    $utiles->printErrorLog("Terminado por señal externa [$signal]", 'debug');
    exit;
}
